      subroutine allplo 
C     PROGRAM ALLPLO BATCH - VERSION FUER VAX/VMS
C
C     M. Alflen  1.3.1990 modified spiering 2003
C
c     Johannes Gutenberg Universitaet
c     Institut fuer Anorg. und Analyt. Chemie
c     Staudinger Weg 9
c     6500 Mainz  

      implicit none
      include 'comalp.for'


      character*80 user,logname,date,hostid,host,net,disksize,
     &             hepath,utpath,term,edt,shell,colfile,workdir*132
      common/info/ user,logname,date,hostid,host,net,disksize,
     &             hepath,utpath,term,edt,shell,colfile,workdir

      real         version,a_version
      common /ver/ a_version
      character    version_date*9
      parameter    (version=3.0, version_date='9-Mar-07')

      character    sessfile*132,exten*16,filetype*32,
     &             plobat*80,plotout*80
      common/bat/  plobat,plotout

      integer       MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &              N2MAX,ICAR,NMMAX,NCMAX
      COMMON/BENBUF/MBUF,IBUF,IP,JUP,LGMIN,ICR,ILF,NTAPE,
     &              N2MAX,ICAR,NMMAX,NCMAX 

      logical       l_ask,l_run,l_bat,l_allplo,l_effi,b_exist,l_open
      
      character*1   CTEXT,CXTEXT,CYTEXT  
      COMMON /TXT/  CTEXT(132),CXTEXT(80),CYTEXT(80)

      CHARACTER     ploben*12,defcolor*24,tabcolor*24,TXTZEL*80,
     &              querytype(2)*132,chstr(2)*132,chcom*132,wrb*1
      INTEGER       BENBUF,NPLO,ipen,i,idate,ilogn,
     &              k,lfn,nbat,nbloc,i_run,j,nbuf
      real          y_maxorg,xorgs,yorgs,cinet,dum,h,forben,forbeni
      dimension     forbeni(9,20),defcolor(16),tabcolor(64),forben(9)

      logical      l_newsym
      integer      news,old_sym,new_sym
      common/sym/  news,old_sym(20),new_sym(20),l_newsym
      
C     file: BUFFER FOR BENSON PLOT
      parameter (ploben='allplo.ben  ')
      data defcolor
     & /'black                   ','white                   ', 
     &  'red                     ','green                   ', 
     &  'blue                    ','yellow                  ',  
     &  'magenta                 ','cyan                    ',  
     &  'orange                  ','gold                    ',  
     &  'brown                   ','violet                  ',  
     &  'purple                  ','lavender                ',  
     &  'Cornsilk                ','Ivory                   '/  

      call inilogical
      inquire(file='allplo.ben',exist=b_exist)
      if(b_exist)call benson
      call infouser(cinet)

      do k=1,16
       tabcolor(k)=defcolor(k)
       i=index(tabcolor(k),' ')
       tabcolor(k)(i:i)=char(0)
      end do 
      if(colfile.ne.' ')then
       inquire(file=colfile,exist=b_exist)
       if(b_exist) then
        open(unit=2,file=colfile
     &            ,status='old'
     &            ,access='sequential'
     &            ,form='formatted')

        do k=6,64
         read(2,'(a)',end=40) tabcolor(k)
         i=index(tabcolor(k),' ')
         if(i.eq.1) goto 40
         tabcolor(k)(i:i)=char(0)
        end do
 40     continue
       end if 
       close(unit=2)
      end if      
      do i=k-1,64
       tabcolor(i)='black'//char(0)
      end do
c      write(6,'(8a12)')(tabcolor(i),i=1,k)

      MBUF=0
      IP=0
      JUP=0
c     OPEN (UNIT=9,FILE='compare.txt',STATUS='unknown')
C     UNITS FOR INPUT/OUTPUT
C
C     NRD = INPUT FROM CONSOLE
C     NWR = OUTPUT ON CONSOLE
C     LPR = INPUT FROM FILE
C     NBA = INPUT FROM BATCH FILE
C     NPL = LINE LENGTH OF TERMINAL
c
      NRD=5           ! input from console
      NWR=6           ! output on console
      LPR=4           ! input file
      NPLO=1          ! benson file
      NBA=2           ! batch file
      NPL=80
      NIN=10          ! INPUT FROM FILE 

C     DIMENSION OF DATA ARRAYS
C
      MAXN=1024
c
c     maximal y-range
c
      y_maxorg=0.
      xoff_l=0.
      xoff_r=0.
C     BUFFER SPACE FOR BENSON FILE
C     NBUF = DIM(BENBUF) =128 FOR OFF LINE USE
C     NBUF = 0 FOR ON LINE USE
C
      NBUF=128
      BENBUF=0
C     BENSON PLOT
C
      IPEN=0
      XORGS=0.
      YORGS=0.
c
c	inquire user name
c
c       call infouser(cinet)
C
c      write(6,'(a)')colfile
c      write(6,'(a)')workdir
      i=1
      do while(ichar(date(i:i)).ne.0)
       i=i+1
      end do
      idate=i-1
      i=1
      do while(ichar(logname(i:i)).ne.0)
       i=i+1
      end do
      ilogn=i-1

C     INITIALIZE ARRAYS
      do i=1,80
       CXTEXT(i)=' '    
       CYTEXT(i)=' '
      end do
      DO  K=1,MAXN
       XX(1,K)=0.
       XX(2,K)=0.
       YY(1,K)=0.
       YY(2,K)=0.
       NSYM(K)=0
      end do
c
c     set logicals
c
      l_new=.true.      ! new data set
      l_more=.false.
      l_scal=.true.     ! calculate scale
      l_bat=.false.
C     INPUT SECTION

      if(plobat(1:1).eq.'1') then
       write(NWR,'(a)')
       sessfile='allplo.bat'
       lfn=10
       chcom='allplo/batfile'
       filetype='batch file for allplo'
       exten='bat'
 80    call readfile(filetype,sessfile,exten,lfn,
     &                                     chcom,NPL,NRD,NWR)
       i=index(sessfile,'/')
       if(i.gt.1) then
        if(sessfile(i+1:i+1).eq.'.') sessfile(i+1:)='allplo.bat' 
       end if
       plobat=sessfile
      end if

      inquire (file=plobat,exist=b_exist)
      if(b_exist)l_bat=.true.
      IF (l_bat) THEN
       OPEN (UNIT=NBA,FILE=PLOBAT,STATUS='OLD')
c       write(6,'(l4,3x,a)')b_exist,PLOBAT(:20)
       NRD=NBA
       l_inter=.false.                             ! batch run
       read(nrd,5050)txtzel
       a_version=2.3
       NWR=3
       OPEN (UNIT=NWR,FILE='allplo.log',STATUS='unknown')
       write(NWR,'(a,a12,a,a12)')'    ***ALLPLO log file ***  ',
     &       date(1:idate),'    user: ',logname(1:ilogn)
      ELSE
       WRITE (NWR,1000) char(27),char(27),version,version_date
 
       OPEN (UNIT=NBA,FILE=PLOBAT,STATUS='NEW')
       l_inter=.true.                              ! interactive run
       NBAT=3
       a_version=version

       write(nba,5401)date(1:idate),logname(1:ilogn)
 5401  format(1h ,'    ***ALLPLO command file ***  ',
     &  a12,5x,'user : ',a12)
c       use default settings   [n]
       wrb='b'
       querytype(1)='    use default settings   ['
       chstr(1)='n'
       chcom='batchfile'
       call ask1string(querytype(1),chstr(1),chcom,NPL,NRD,NWR,NBA,wrb)
       if(chstr(1)(1:1).eq.'y') then
        l_def=.true.
       else
        l_def=.false.
       end if

      END IF

      l_ask=.not. (l_def .and. l_inter)
c
c     open benson-file
c 
      inquire (file=PLOBEN,exist=b_exist)
      if(b_exist) then
       OPEN (UNIT=NPLO,FILE=PLOBEN,STATUS='old')
      else
       OPEN (UNIT=NPLO,FILE=PLOBEN,STATUS='new')
      end if
      CALL IBENA(BENBUF,NBUF,NPLO)
      NBLOC=0
c
      CALL PNUMA (0.,0.,NBLOC,0.,0.)        ! initialize
c
cc     plot 
c
      i_run=0
      l_run=.true.      
c
 
      do while (l_run)
       if(i_run.gt.0)then
        if(l_inter)then
         write(nwr,'(i4,a)')i_run+1,'. drawing'
         write(NBA,'(a,i4,a)')'command list for ',i_run+1,'. drawing'
        else
         read(nrd,'(a)')
        end if
       end if
       i_run=i_run+1
       if (l_scal) then
        call frame(tabcolor,i_run)                          ! plot frame
        dum=yorg+yrand+gy+yoff_t+yoff_b+12.*hy
        if (dum .gt. y_maxorg) y_maxorg=dum  ! maximal x-value
       end if

       call datin(l_allplo,l_effi,TXTZEL)               ! input of data

        plotout=TXTZEL
        i=index(plotout,'.')
        if(i.eq.0) then
         i=80
         do while(plotout(i:i).eq.' ')
          i=i-1
         end do
         plotout(i+1:)='.ps'//char(0)
        else
         plotout(i+1:)='ps'//char(0)
        end if
       if (.not. l_fraon) then   ! plot frame + data
       call modxy
       end if

       nplotsub=1
c########################################################
       l_new=.false.             ! no new data file 
       l_open=.false.
       if(l_more) then
         OPEN (UNIT=11,FILE='common.dat'
     &            ,status='unknown'
     &            ,access='sequential'
     &            ,form='formatted')
        l_open=.true.
        write(11,'(2i6,l3)')NCOUNT,MAXN,l_error
        do i=1,NCOUNT
         write(11,'(4f15.5,i6)')XX(1,i),XX(2,i),YY(1,i),YY(2,i),NSYM(i)
        end do
       end if 

       do while (l_more)         ! plot all data points
        nplotsub=nplotsub+1
        call datinmore(l_allplo,l_effi)
        call modxy
        write(11,'(2i6,l3)')NCOUNT,MAXN,l_error
        do i=1,NCOUNT
         write(11,'(4f15.5,i6)')XX(1,i),XX(2,i),YY(1,i),YY(2,i),NSYM(i)
        end do
c        write(6,'(a,L5)') ' 1allplo l_more=',l_more
c        read(5,'(a)')
       end do
       if(l_open) then
        write(11,'(a)')'ende'      
        rewind(unit=11)
       end if
c       write(6,'(a,L3,a)')'if (l_scal=',l_scal,') then call axscl'

        call instruction               ! plot instructions
        call axscl                     ! test axis and inscription
        call dothebenplot

        if(l_open)close(unit=11)
c        write(6,'(80a1)')(itext(i),i=1,80)
c
       call addtxt               ! plot additional text
c
       l_def=.false.
c
cmore                   y/n [n]    use old frame/scaling [n]
       if (.not.l_inter.and.l_ask)wrb='r' 
       if (l_inter.and.l_ask)wrb='w'
       if (l_inter.and..not.l_ask)wrb='d' 
       querytype(1)='more                    y/n ['
       querytype(2)='     use old frame/scaling ['
       chstr(1)='n'
       chstr(2)='n'
       chcom='more/old'
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       if(chstr(1)(1:1).eq.'y') then
         l_new=.true.
       else 
         l_new=.false.
       end if
       if (l_new) then
        if(chstr(2)(1:1).eq.'y') then
         l_scal=.false.
        else 
         l_scal=.true. 
        end if

        if (.not. l_inter) then      ! look for end of file
         read(nrd,5000,end=100)txtzel
         read(nrd,5000,end=100)txtzel
         read(nrd,5000,end=100)txtzel
         backspace nba
         backspace nba
         backspace nba
        end if        
         go to 110
 100    continue
         l_inter=.true.
         nrd=5
 110    continue

       else
        l_run=.false.            ! stop program
       end if
       call forbenfile(forben)
       do i=1,9
        forbeni(i,i_run)=forben(i)
       end do
c       write(6,'(a,4f10.3)') ' for ben xanf,xend,yanf,yend=',
c     &                                 xanf,xend,yanf,yend
c       write(6,'(a,6f10.3)')'for ben xb,xe,yb,ye,benoffset=',
c     &      a_xanf,a_xend,a_yanf,a_yend,benf

      end do
c
c     finish plot
c
c      NBLOC=9999
      CALL PNUMA (y_maxorg,0.,NBLOC,0.,0.)
      h=100.
      k=0
      do j=1,i_run 
       if(forbeni(1,j).lt.h)then
        h=forbeni(1,j)
        k=j
       end if
      end do
      if(k.gt.1) then
       do i=1,9
        forben(i)=forbeni(i,k)
       end do
       do i=1,9
        forbeni(i,k)=forbeni(i,1)
       end do
       do i=1,9
        forbeni(i,1)=forben(i)
       end do
      end if
      do j=1,i_run
       write(NPLO,'(a,10f12.4)') 'P', (forbeni(i,j),i=1,8)
c       write(6,'(a,10f12.4)') 'P', (forbeni(i,j),i=1,8)
      end do
      write(NPLO,'(a,10f12.4)') 'P', forbeni(9,1),0.0
c      write(6,'(a,10f12.4)') 'P', forbeni(9,1)
      close(unit=NPLO)
      write(nwr,6000)
      IF (l_bat) close(unit=NWR)
      close(unit=NBA)
      return
C
 5000 FORMAT(80A1)
 5001 FORMAT(1H ,80a1)
 5050 FORMAT(A31)
 5300 FORMAT(1H ,79A1)
 5400 format(1h ,'  ***   command file for program ALLPLO  ***',
     &           '  user : ',a12,'  ***',/,
     &       1h ,'      creation date : ',a9,3x,a8,/,
     &           '   Version ',f5.2)
C
 1000 FORMAT(1x,a1,'[2J',a1,'[0;0H',//
     &  ,'  ********************************************************',/
     &  ,'  *                                                      *',/
     &  ,'  *               A  L  L  P  L  O                       *',/
     &  ,'  *                                                      *',/
     &  ,'  *                 VERSION  ',f3.1,  
     &                                   '                         *',/
     &  ,'  *                                                      *',/
     &  ,'  *                   ',a9,'                          *',/
     &  ,'  *                                                      *',/
     &  ,'  ********************************************************',/
     &  ,/)     
 1500 format(1h ,a1,'      ** warning - batch-file produced by version'
     &           ,f3.1,' ** ',/)
 2000 format(1h ,'   use default settings for plot?  [def: n]')
 3000 FORMAT(1H ,'   more? (Y/N)   [def: n]')
 4000 format(1h ,'   use old frame and scaling? [def: n]')
 6000 FORMAT(1H ,'   ***** ALLPLO TERMINATED PROPERLY *****')
C
      END


       subroutine inilogical
       logical logo
       common /log/logo(16)
       do i=1,16
        logo(i)=.false.
       end do
       return
       end
       subroutine forbenfile(forben)
       real ben,forben(9)
       common /scl/ben(13)
       do i=1,9
        forben(i)=ben(i)
       end do
       return
       end
