      subroutine datin(l_allplo,l_effi,filnam)
      implicit none
c     subroutine datin liest Daten ein  und bestimmt Extrema
c
c     M. Alflen  21.9.89
c
c	modifiziert fuer Dateneingabe vom Terminal 
c	M. Alflen 16.3.1990  (Version > 1.3)
c       MOSFUN- Bearbeitung modifiziert 14.8.90 (V>=2.0)
c       count-axis modifiziert V>=2.2
c     H. Spiering  modifiziert fuer effi, string Bearbeitung
      include 'comalp.for'

      character*80 user,logname,date,hostid,host,net,disksize,
     &             hepath,utpath,term,edt,shell,colfile,workdir*132
      common/info/ user,logname,date,hostid,host,net,disksize,
     &             hepath,utpath,term,edt,shell,colfile,workdir

      character*1   CTEXT,CXTEXT,CYTEXT  
      COMMON /TXT/  CTEXT(132),CXTEXT(80),CYTEXT(80)

      real           dum,penfill
      COMMON /BENBUF/dum(12),penfill 

      logical    l_allplo,l_effi,l_term,l_ask,b_file

      real       a_version 
      common/ver/a_version
C
      CHARACTER     xtext*80,ytext*80,filnam*80
      character*132 chin,querytype(2),chcom,chstr(2)
      character     wrb*1,wtext*80,formatd*64,CIN*80
      real          OUT,g1,g2,g3,g4
      dimension     OUT(32)
      integer       i,j,n_datsym,n_theocol,n_subplot,mcom,
     &              k,nn,ierr,id,it,iout
c
C     UNITS FOR INPUT/OUTPUT
C
C     NRD = INPUT FROM CONSOLE
C     NWR = OUTPUT ON CONSOLE
C     NIN = INPUT FROM FILE
C     NBA = INPUT FROM BATCH FILE
C     NPL = LINE LENGTH OF TERMINAL
c
c     Input :
c     l_new = true  :  neuer Eingabefile
c             false :  alten File lesen
c     l_scal = true :  neue skalieren
c     l_def  = default-Werte uebernehmen
c
c     Output :
c     l_more = true  : File nicht komplett gelesen
c              false : File komplett gelesen
c     l_error = true : Fehlerbalken zeichnen
c     l_cou   = true : count-axis ( bei Moessbauer-Daten )
c     l_fraon = true : nur Rahmen malen ( ncount=0 )
c
      l_ask= .not. (l_inter .and. l_def)
      do i=2,132
       CTEXT(i)=' '
      end do
      do i=2,80
       CXTEXT(i)=' '
       CYTEXT(i)=' '
      end do
      if (l_new) then     !  initialize
       l_error=.true.
       n_datsym=9
       n_theocol=0
       n_subplot=0
       xmin=0.
       xmax=1.
       ymin=0.
       ymax=1.
       l_fraon=.false.
       CTEXT(1)=' '
       CXTEXT(1)='x'
       CYTEXT(1)='y'
      end if

       l_allplo=.false. 
       l_effi=.false.   
      
       if (.not.l_inter.and.l_ask)wrb='r' 
       if (l_inter.and.l_ask)wrb='w'
       if (l_inter.and..not.l_ask)wrb='w' 

       querytype(1)='data             file name ['
       chstr(1)='effi.dat'
       chcom='data/file'
 10    call askdstring(querytype(1),chstr(1),
     &                              chcom,NPL,NRD,NWR,NBA,wrb)
       filnam=chstr(1)
       call stringlength(chstr(1),k)
       inquire(FILE=filnam,exist=b_file)
       if(.not.b_file) then
         write(*,'(2a,2(/,a))')'file:',filnam(:k),
     &   ' does not exist in the working directory:',workdir
         goto 10
       end if
       if ( a_version .ge. 1.3 .and. 
     &    (chstr(1)(1:3).eq.'TT:'.or.chstr(1)(1:3).eq.'tt:'))then
        l_term=.true.
        l_fraon=.true.
        l_more=.false.
        l_word=.true.
       else
        l_term=.false.
        querytype(1)=
     & '    structure                                (allplo,effi) ['
        chstr(1)='effi'
        chcom='data/structure'
        call ask1string(querytype(1),chstr(1),
     &                             chcom,NPL,NRD,NWR,NBA,wrb)
        if(chstr(1)(1:1).eq.'a') l_allplo=.true. 
        if(chstr(1)(1:1).eq.'e') l_effi=.true.   
       end if
       if (l_inter.and..not.l_ask)wrb='d' 
       close (UNIT=NIN)
       IF (.not. l_term) THEN

c      error bars (y/n)       [y]           clipping (y/n) [y]
       querytype(1)='    error bars (y/n)        ['
       querytype(2)='            clipping (y/n) ['
       chstr(1)='y'
       chstr(2)='y'
       chcom='error bars/clipping'
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       if(chstr(1)(1:1).eq.'y') then
        l_error=.true. 
       else
        l_error=.false.
       end if

       if(chstr(2)(1:1).eq.'y') then
        l_clip=.true. 
       else
        l_clip=.false.
       end if
     

        OPEN (UNIT=NIN,FILE=filnam,STATUS='OLD',FORM='FORMATTED',
     &     ACCESS='SEQUENTIAL')

c       title (*...=no, #=fdf) [Alex 71, 293K, 25.03.03] 
        READ (NIN,'(a)',err=9000) chstr(2)
c       write(6,'(a)') chstr(2)

        chstr(1)=chstr(2)
        querytype(1)='    title (*...=no, #=fdf) ['
        chcom='title'
        call ask1string(querytype(1),chstr(1),
     &                              chcom,NPL,NRD,NWR,NBA,wrb)
         if(chstr(1)(1:1).eq.'*'.or.chstr(1).eq.' ') then
          l_word=.false.            ! no wordcard
         else
          l_word=.true.             ! wordcard
         end if
        if(chstr(1)(1:1).eq.'#') chstr(1)=chstr(2)
       else
        chstr(1)='terminal input'
       END IF ! (.not. l_term)
       j=132         
       call stringend(chstr(1),j)
       do i=1,j
        CTEXT(i)=chstr(1)(i:i)
       end do 
      

c 
c      plot only frame or data from terminal
       if (l_term) then
        IF (l_scal) THEN       ! axis inscrition for new scale only
c
c        x-axis name
         xtext='x-axis'

c        y-axis name
         ytext='y-axis'
c
c        wordcard
         wtext='title'
c
        END IF             ! end of axis inscription
       end if ! l_term

       if ( l_term ) then
        mcom=0
        ncount=0
        read(nrd,'(a)')CIN
        if ( l_inter ) write(nba,'(a)')CIN
        do while (CIN(1:1).ne.'*')
         if (CIN(1:1).eq.'#') then                  !  comment line
          if (mcom.EQ.0) WRITE (NWR,3100) NCOUNT+1
          mcom=mcom+1
          CIN(1:1)=' '
          WRITE(NWR,'(a)') CIN
         else
          chin=CIN
          call trlch(NPL,chin,NN,OUT)               !  data input
          if (NN.gt.0) then
           NCOUNT=NCOUNT+1
           if (nn .le. 2) then
             XX(2,NCOUNT)=0.
             YY(2,NCOUNT)=0.
             NSYM(NCOUNT)=9
            if (nn .eq. 2) then
             XX(1,NCOUNT)=OUT(1)
             YY(1,NCOUNT)=OUT(2)
            else
             XX(1,NCOUNT)=NCOUNT
             YY(1,NCOUNT)=OUT(1)
            end if
           else
            NSYM(NCOUNT)=OUT(1)
             XX(1,NCOUNT)=OUT(2)
            if (nn .gt. 3) then
             XX(2,NCOUNT)=ABS(OUT(3))
              YY(1,NCOUNT)=OUT(4)
             YY(2,NCOUNT)=ABS(OUT(5))
            else
             XX(2,NCOUNT)=0.
             YY(1,NCOUNT)=OUT(3)
             YY(2,NCOUNT)=0.
            end if
           end if
          end if
         end if 
         read(nrd,'(a)')CIN
         if (ncount .eq. maxn) CIN(1:1)='*'
         if ( l_inter ) write(nba,'(a)')CIN
        end do
        if (ncount .gt. 0) l_fraon=.false.   
        goto 500
       end if ! ( l_term )

c      input from file

       l_fraon=.false.
c    
c      input of ALLPLO / EFFI data
c    
       if( l_effi ) then

        read(NIN,'(a)')xtext
        i=index(xtext,')')
        formatd=xtext(1:i)

        ierr=index(xtext,'err')+index(xtext,'dy')+index(xtext,'dz')
        id=ierr+index(xtext,'res')+index(xtext,'d(')
        id=id+index(xtext,'x,y')+index(xtext,'x y')
     &        +index(xtext,'xd,yd')+index(xtext,'xd yd')
c        write(6,'(a,i4)') xtext(1:30),id
        it=index(xtext,'yt')+index(xtext,'su')
         read(NIN,'(a)')xtext
        i=index(xtext,'=')
        chin=xtext(i+1:i+15)
        call trlch(20,chin,iout,OUT)
        ncount=OUT(1)                                  ! data points
c      write(6,'(a,i6,2x,a)')'number of channels=',ncount,formatd
        if(id.gt.0) then
         do i=1,ncount
          XX(2,i)=0.
          NSYM(i)=9
         end do
         if(ierr.gt.0) then
c          l_error=.true.
          do i=1,ncount
           read(NIN,formatd) XX(1,i),YY(1,i),YY(2,i)
          end do
         else
          l_error=.false.
          do i=1,ncount
           YY(2,i)=0.
          end do
          do i=1,ncount
           read(NIN,formatd) XX(1,i),YY(1,i)
          end do
         end if
        else if(it.gt.0) then
         do i=1,ncount
          XX(2,i)=0.
          YY(2,i)=0.
          NSYM(i)=0
         end do
         do i=1,ncount
          read(NIN,formatd) XX(1,i),YY(1,i)
         end do
         NSYM(1)=34
        end if
c       name of x-axis (#=fdf) [mm/s]                               
        READ (NIN,'(a)',err=9000) xtext
        chstr(1)=xtext
        querytype(1)='    name of x-axis (#=fdf) ['
        chcom='x-axis/name'
        call ask1string(querytype(1),chstr(1),
     &                              chcom,NPL,NRD,NWR,NBA,wrb)
        if(chstr(1)(1:1).eq.'#') chstr(1)=xtext
c        CXTEXT=chstr(1)
        j=80                   
        call stringend(chstr(1),j)
        do i=1,j
         CXTEXT(i)=chstr(1)(i:i)
        end do
 
c       name of y-axis (#=fdf) [relative transmission]  
        READ (NIN,'(a)',err=9000) chstr(2)
        chstr(1)=chstr(2)
        querytype(1)='    name of y-axis (#=fdf) ['
        chcom='y-axis/name'
        call ask1string(querytype(1),chstr(1),
     &                              chcom,NPL,NRD,NWR,NBA,wrb)
        if(chstr(1)(1:1).eq.'#') chstr(1)=chstr(2)
c        CYTEXT=chstr(1)
        j=80                 
        call stringend(chstr(1),j)
        do i=1,j
         CYTEXT(i)=chstr(1)(i:i)
        end do
c y   symbol sw,sh [0.04,0.04]               pen width [0.05]
       querytype(1)='    symbol sw,sh            ['
       querytype(2)='         pen width [' 
       chstr(1)='0.04,0.04'
       chstr(2)='0.03'
       chcom='symbol-width,hight/pen'
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       call trlch(20,chstr(1),iout,OUT)
       if ( OUT(1) .gt. 0.) sw=OUT(1)
       if ( OUT(2) .gt. 0.) sh=OUT(2)
       call trlch(20,chstr(2),iout,OUT)
       if ( OUT(1) .gt. 0.03) pen =OUT(1)
       penfill=pen
        read(NIN,'(a)',end=113) ytext
c       write(6,'(a)') 'line for z-axes'//ytext(1:50)
        read(NIN,'(a)',end=113) ytext
c        write(6,'(a)') 'line for z-axes'//ytext(1:50)
        if(ytext(1:2).eq.'##')goto 113 
        backspace(NIN) 
        l_more=.true.
        goto 114
 113    continue
c        write(6,'(a)')
c     &    ' missing last line (provided for z-axes) (corrected)' 
        l_more=.false.
         
 114    continue
       end if! ( l_effi )
      
       IF ( l_allplo) then

c       standart allplo format       
        ncount=0                                  !  counter for data points
        mcom=0                                     !  counter for comment
c     

c       name of x-axis (#=fdf) [mm/s]                               
        READ (NIN,'(a)',err=9000) xtext
        chstr(1)=xtext
        querytype(1)='    name of x-axis (#=fdf) ['
        chcom='x-axis/name'
        call ask1string(querytype(1),chstr(1),
     &                              chcom,NPL,NRD,NWR,NBA,wrb)
        if(chstr(1)(1:1).eq.'#') chstr(1)=xtext
        j=80                   
        call stringend(chstr(1),j)
        do i=1,j
         CXTEXT(i)=chstr(1)(i:i)
        end do

c       name of y-axis (#=fdf) [relative transmission]  
        READ (NIN,'(a)',err=9000) chstr(2)
        chstr(1)=chstr(2)
        querytype(1)='    name of y-axis (#=fdf) ['
        chcom='y-axis/name'
        call ask1string(querytype(1),chstr(1),
     &                              chcom,NPL,NRD,NWR,NBA,wrb)
        if(chstr(1)(1:1).eq.'#') chstr(1)=chstr(2)
c        CYTEXT=chstr(1)
        j=80                 
        call stringend(chstr(1),j)
        do i=1,j
         CYTEXT(i)=chstr(1)(i:i)
        end do

c    symbol sw,sh [0.40,0.40]               pen width [0.05]
       querytype(1)='    symbol sw,sh            ['
       querytype(2)='         pen width [' 
       chstr(1)='0.40,0.40'
       chstr(2)='0.03'
       chcom='symbol-width,hight/pen'
       call ask2strings(querytype,chstr,chcom,NPL,NRD,NWR,NBA,wrb)
       call trlch(20,chstr(1),iout,OUT)
       if ( OUT(1) .gt. 0.) sw=OUT(1)
       if ( OUT(2) .gt. 0.) sh=OUT(2)
       call trlch(20,chstr(2),iout,OUT)
       if ( OUT(1) .gt. 0.03) pen =OUT(1)
       penfill=pen

        do while ( ncount .lt. maxn )     
         read (NIN,'(a)',end=100,err=9000) CIN
    
         if (CIN(1:1).eq.'#') then                  !  comment line
          if (mcom.EQ.0) WRITE (NWR,3100) NCOUNT+1
          mcom=mcom+1
          CIN(1:1)=' '
          WRITE (NWR,'(a)')  CIN
         else
          chin=CIN
          call trlch(NPL,chin,NN,OUT)                 !  data input
          if(index(chin,'f').gt.0)OUT(1)=OUT(1)+100000
          if (NN.ne.0) then
           mcom=0
           NCOUNT=NCOUNT+1
           if (NN .le. 2) then
             XX(2,NCOUNT)=0.
             YY(2,NCOUNT)=0.
             YY(2,NCOUNT)=0.
            if(NN .eq.2)then
             XX(1,NCOUNT)=OUT(1)
             YY(1,NCOUNT)=OUT(2)
            else
             XX(1,NCOUNT)=NCOUNT
             YY(1,NCOUNT)=OUT(1)
            end if
           else
            NSYM(NCOUNT)=OUT(1)
            XX(1,NCOUNT)=OUT(2)
            if (NN .gt. 3) then
             XX(2,NCOUNT)=ABS(OUT(3))
             YY(1,NCOUNT)=OUT(4)
             YY(2,NCOUNT)=ABS(OUT(5))
            else
             XX(2,NCOUNT)=0.
             YY(1,NCOUNT)=OUT(3)
             YY(2,NCOUNT)=0.
            end if
           end if
          end if
         end if

c        write(6,'(a,2i4,2f10.2)')'allplo format  NCOUNT,xx,yy=',
c     &       NCOUNT,NSYM(NCOUNT),XX(1,NCOUNT),YY(1,NCOUNT)
        end do

        read(NIN,'(a)',end=100) ytext
        BACKSPACE NIN
        BACKSPACE NIN                       !  last point = first new point
        l_more=.true.
        write(nwr,3000)
       end if  ! (l_allplo  )  standart allplo format      

       goto 200
   
 100   continue                            !  end of file found
       close (unit = NIN)
c       write(6,'(a,10i6)')'datin NSYM=',(NSYM(i),i=1,10)
       l_more= .false.   
       if ( ncount .eq. 0) return

  200  continue

    
 500    continue
c
c*************************************************************************
c
c      calculate extrema
c
c*************************************************************************
c
        xmin=xx(1,1)
        xmax=xmin
        if (l_error) then
         do i=1,ncount
          g1=xx(1,i)
          g2=xx(2,i)
          g3=g1-g2
          g4=g1+g2
          if ( g4 .gt. xmax) xmax=g4
          if ( g3 .lt. xmin) xmin=g3
         end do
        else
         do i=1,ncount
          g1=xx(1,i)
          if (g1 .gt. xmax) then
           xmax=g1
          else if ( g1 .lt. xmin) then
           xmin=g1
          end if
         end do
        end if

        ymin=yy(1,1)
        ymax=ymin
        if (l_error) then
         do i=1,ncount
          g1=yy(1,i)
          g2=yy(2,i)
          g3=g1-g2
          g4=g1+g2
          if ( g4 .gt. ymax) ymax=g4
          if ( g3 .lt. ymin) ymin=g3
         end do
        else
         do i=1,ncount
          g1=yy(1,i)
          if (g1 .gt. ymax) then
           ymax=g1
          else if (g1 .lt. ymin) then
           ymin=g1
          end if
         end do
        end if
      return

c     error- label
c
 9000 continue
      write(nwr,9999)char(7)
      l_more= .false.
      RETURN
c
c     format statements
c
 1000 FORMAT(1H ,'   data file (dev:/dir/file.ext)',
     1           ' (TT:= Terminal)')
 1020 FORMAT(1H ,A1,/,
     1       1H ,'   **  WARNING - NO DATA FILE SPECIFIED **',/,
     2       1H ,'   press <CR> to confirm or enter filename')
 2000 FORMAT(1H ,'   input format of data file is ALLPLO ')
 2100 FORMAT(1H ,'   input format of data file is MOSFUN ')
 2200 FORMAT(1h ,/,1H ,'     no data file specified ')
 2300 format(1h ,'   plot error bars? (y/n)  [def: ',a1,']')
c
 3000 FORMAT(5x,' **** warning : more than 1024 data points ****',/,
     &'  * default values for',
     &' scaling calculated using 1024 data points *')
 3100 format(1h ,'   comment before data point',i5,': ')
c
 4000 format(1h ,'   name of x-axis?   [def: energy  [eV]  ]')
 4050 format(1h ,'   plot data?       (*:no, nn: symbol select )',
     &           '[def: ',i2,']')
 4100 format(1h ,'   count-scaling for y-axis? (y/n) [def: n]')
 4110 format(1h ,'   count-scaling for y-axis? (y/n) [def: n]'
     &          ,'  not available in ESCA or full-period mode!')
 4150 format(1h ,'     plot theory?     (*:no, >= 0:pen select)',
     &           '[def: ',i2,']')
 4160 format(1h ,i10)
 4200 format(1h ,'   plot subspectra coloured? (y/n) [def: n]')
 4250 format(1h ,
     1     '     plot subspectra? (*:none , no. of pen? )',
     &           ' def: ',/,i4,29i2)
 4260 format(1h ,35i2)
c
 5000 format(80a1)
 5001 format(1h ,80a1)
 5010 format(40a2)
 5050 format(1a75)
 5051 format(1h ,1a75)
c
 9999 format(1h ,'     ***  error reading data file  *** ',a1)
c
      END


      subroutine datinmore(l_allplo,l_effi)
      implicit none
      logical    l_allplo,l_effi

c     subroutine datin liest Daten ein  und bestimmt Extrema
c
c     M. Alflen  21.9.89
c
c	modifiziert fuer Dateneingabe vom Terminal 
c	M. Alflen 16.3.1990  (Version > 1.3)
c       MOSFUN- Bearbeitung modifiziert 14.8.90 (V>=2.0)
c       count-axis modifiziert V>=2.2
c     H. Spiering  modifiziert fuer effi, string Bearbeitung
c      mosfun geloescht
      include 'comalp.for'

      character*80 user,logname,date,hostid,host,net,disksize,
     &             hepath,utpath,term,edt,shell,colfile,workdir*132
      common/info/ user,logname,date,hostid,host,net,disksize,
     &             hepath,utpath,term,edt,shell,colfile,workdir

      CHARACTER   xtext*80,ytext*80,chin*132,chstr*132
      character   formatd*64,CIN*80
      real        OUT,g1,g2,g3,g4
      dimension   OUT(32),chstr(2)
      integer     i,nn,ierr,id,it,itu,icol,iout,mcom

       NIN=10

       if( l_effi ) then        
        read(NIN,'(a)')xtext   ! wordcard
        read(NIN,'(a)')xtext
c        write(6,'(a)')xtext
        i=index(xtext,')')
        formatd=xtext(1:i)
        ierr=index(xtext,'err')+index(xtext,'dy')+index(xtext,'dz')
        id=ierr+index(xtext,'yd')+index(xtext,'res')+index(xtext,'d(')
        it=index(xtext,'yt')
        itu=index(xtext,'su')
        icol=0
        if(itu.gt.0) icol=ichar(xtext(itu+2:itu+2))-ichar('0')
        read(NIN,'(a)')xtext
        i=index(xtext,'=')
        chin=xtext(i+1:i+15)
        call trlch(20,chin,iout,OUT)
        ncount=OUT(1)                                  ! data points
        if(id.gt.0) then
         do i=1,ncount
          XX(2,i)=0.
          NSYM(i)=9
         end do
         if(ierr.gt.0) then
c          l_error=.true.
          do i=1,ncount
           read(NIN,formatd) XX(1,i),YY(1,i),YY(2,i)
          end do
         else 
          l_error=.false.
          do i=1,ncount
           YY(2,i)=0.
          end do
          do i=1,ncount
           read(NIN,formatd) XX(1,i),YY(1,i)
          end do
         end if
        else if(it.gt.0) then
         do i=1,ncount
          XX(2,i)=0.
          YY(2,i)=0.
          NSYM(i)=0
         end do
         do i=1,ncount
          read(NIN,formatd) XX(1,i),YY(1,i)
         end do
         NSYM(1)=34
        else if(itu.gt.0) then
c        write(6,'(a,i6)') ' color icol=',icol
c        the choice of color line in allplo requires NSYM > 1000
         do i=1,ncount
          XX(2,i)=0.
          YY(2,i)=0.
          NSYM(i)=(icol+1)*1000           ! icolor definition
         end do
         do i=1,ncount
          read(NIN,formatd) XX(1,i),YY(1,i)
         end do
         NSYM(1)=34
        end if

c       name of x-axis (#=fdf) [mm/s]                               
        READ (NIN,'(a)',err=9000) xtext

c       name of y-axis (#=fdf) [relative transmission]  
        READ (NIN,'(a)',err=9000) chstr(2)
        read(NIN,'(a)',end=213) ytext
        read(NIN,'(a)',end=213) ytext
        if(ytext(1:2).eq.'##')goto 213
        backspace(NIN)

        goto 214
 213    continue
c        write(6,'(a)')
c     &    'empty line for name of a z-axes' 
        l_more=.false.
        return 
 214    continue
        l_more=.true.
       end if! ( l_effi )

c      input from ALLPLO- file
c  
       if (l_allplo )  then      
         ncount=0                                  !  counter for data points
         mcom=0                                    !  counter for comment
c   
         do while ( ncount .lt. maxn )
C   
          read (NIN,'(a)',end=300) CIN
          if (CIN(1:1).eq.'#') then                  !  comment line
           if (mcom.EQ.0) WRITE (NWR,3100) NCOUNT+1
 3100      format(1h ,'   comment before data point',i5,': ')
           mcom=mcom+1
           CIN(1:1)=' '
           WRITE (NWR,'(a)') CIN
          else
           chin=CIN
           call trlch(NPL,chin,NN,OUT)                          !  data input
           if(index(chin,'f').gt.0)OUT(1)=OUT(1)+100000
           if (NN.ne.0) then
            mcom=0
            NCOUNT=NCOUNT+1
            NSYM(NCOUNT)=OUT(1)
            XX(1,NCOUNT)=OUT(2)
            if (nn .gt. 3) then
             XX(2,NCOUNT)=ABS(OUT(3))
             YY(1,NCOUNT)=OUT(4)
             YY(2,NCOUNT)=ABS(OUT(5))
            else
             XX(2,NCOUNT)=0.
             YY(1,NCOUNT)=OUT(3)
             YY(2,NCOUNT)=0.
            end if
           end if
          end if
c 
         end do

         READ (NIN,'(a)',END=300)CIN           !  test for end of file 
c        write(6,'(a)') ' READ (NIN,5000,END=300)   '
         BACKSPACE NIN
         BACKSPACE NIN                       !  last point = first new point
         l_more=.true.
c
  300   continue                            !  end of file found
c
        if (ncount.eq.0.or.ncount.lt.maxn) then     !  no data found
         l_more=.false.
         close (unit = NIN)
         return
        end if  
       end if        ! end of ALLPLO-input
c*************************************************************************
c
c      calculate extrema
c
c*************************************************************************
c
        if (l_error) then
         do i=1,ncount
          g1=xx(1,i)
          g2=xx(2,i)
          g3=g1-g2
          g4=g1+g2
          if ( g4 .gt. xmax) xmax=g4
          if ( g3 .lt. xmin) xmin=g3
         end do
        else
         do i=1,ncount
          g1=xx(1,i)
          if (g1 .gt. xmax) then
           xmax=g1
          else if ( g1 .lt. xmin) then
           xmin=g1
          end if
         end do
        end if

        if (l_error) then
         do i=1,ncount
          g1=yy(1,i)
          g2=yy(2,i)
          g3=g1-g2
          g4=g1+g2
          if ( g4 .gt. ymax) ymax=g4
          if ( g3 .lt. ymin) ymin=g3
         end do
        else
         do i=1,ncount
          g1=yy(1,i)
          if (g1 .gt. ymax) then
           ymax=g1
          else if (g1 .lt. ymin) then
           ymin=g1
          end if
         end do
        end if

      return

 9000 continue
      write(nwr,9999)char(7)
 9999 format(1h ,'     ***  error reading data file  *** ',a1)
      l_more= .false.
      RETURN
      END

