c     author : h. spiering
c              institut f. anorg. u. anal. chemie
c              johannes gutenberg-universitaet
c              d-55099 mainz
c              last version october 2006
      
      subroutine fr_mossbauer(cmch,iss,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'
      include 'comdas.for'
      include 'comcvm.for'
      integer     iss,info
      integer     ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,ipLG,
     &            jpolsource,jpolabsorber,
     &            iflag_basis,l_Poincare,nLG,nAS,nSC,idum2,ak8,sk8
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),   !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              ipLG,iaddr(3),jpolsource,jpolabsorber,ifrth(6),          
     &              iflag_basis,l_Poincare,nLG,nAS,nSC,idum2,
     &              ak8,sk8,srw8,idex(7)

      real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dum,flag_basis,
     &              flag_misfit,om_samp,Dsource,Dabsorber,
     &              sc2absorber,sc2aperture,dumcs
      common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,
     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,
     &              flag_misfit,om_samp,Dsource,Dabsorber,
     &              sc2absorber,sc2aperture,dumcs(icstrf-17)

      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs(ivstrf-14)
      
      integer ibm,km,mode_drive,lstruct1,lstruct2,lstruct3,
     &        nstorTH2,nstorLG

      parameter (km=256,ibm=2*(maxn-km))
      character cmch*4,ch1*1,text(3)*40,ch132*132,cp132*132

      integer mi,k1,k2,isub,ak2,sk2,kzl,kzla,kzls,ib,ib2,nchansp,
     &        nstorint    

c*****************************************************************************
c
      if(cmch.eq.'thna') then
       theoryname='Mossbauer radioactive source        v=100'
       thfrcase(1)='Mossbauer transmission_vA(1)       v=100'         
       thfrcase(2)='Mossbauer transmission_vB(3)       v=100' 
       thfrcase(4)='Mossbauer reemission_vA(2)'
       thfrcase(5)='Mossbauer reemission_vB(4)' 
       thfrcase(3)='Mossbauer transmission_vC(5)'            
       thfrcase(6)='Mossbauer transmission_vD(3)'            
c      thfrcase(7)='Mossbauer resonance reflection(6)' 
       return
      end if        
c*****************************************************************************

      nchansp=channels
      if(cmch.eq.'arr0') then
c        write(6,'(a,i5)')' fr_moss ipLG=',nuofdatas
        ipLG=nuofdatas
        l_Poincare=1
c       standard Mossbauer absorber needs Poincare decomposition of rho
        iflag_basis=flag_basis
c        if(ifrcase.eq.5)then
c         l_Poincare=0
c        subroutine optic needs rho_mn       
c        end if
        ifrsto=0
        ib=convol
        if (ib.gt.ibm) ib=ibm
        ib2=ib*2
        if(abs(v_max).gt.0.0) then
         kzl=int(km*vm_SC/abs(v_max))
        else
         kzl=km
        end if
c        write(6,'(a,i5,2f10.2)') 'frame01 kzl=',kzl,vm_SC,v_max
        if(kzl.gt.0) then
         kzls=2*km
         kzla=kzl*2
         if(kzla.gt.2*km) kzla=2*km
        else
         kzla=2*km
         kzls=abs(kzl)*2
         if(kzls.gt.2*km) kzls=2*km
        end if
      
        sk2=kzls
        ak2=kzla
        sk8=sk2*4
        ak8=ak2*4
      
        if(kzla.gt.kzls) then
         nAS=sk2+ak2+ib2
         nSC=sk2+ib2
        else
         nSC=sk2+ak2+ib2
         nAS=ak2+ib2
        end if
  
        nLG=4*(nAS+nSC)
      
c        write(6,'(i2,a,4i5)')ifrcase,
c     &     '=ifrcase fr_mossbauer kzla,kzls,nSC,nAS=',
c     &                           kzla,kzls,nSC,nAS
c        srw8=abs(v_max)/float(km)/8.
        
        nstorTH1=1               ! base
        nstorTH2=km+1            ! norm spectrum
        nstorLG=ipLG+5+(nLG+1)+(nLG+2*mGa+1)+mGa+1    ! Lorentz-Gauss curves

        ifrsto=nstorLG+nstorTH1+nstorTH2+nchansp/2+maxsub*(1+maxthss)
       
        nstorTH=nstorLG
        nstorTHyy=nstorTH+nstorTH1+nstorTH2
        nstorSI=nstorTHyy+nchansp/2
        jpolsource=0
        jpolabsorber=0

c       lstuct1case is assigned in the main routine mossbauer during execution
        je_a=0
        jg_a=0
c       reset of common/sym3j/  in include file comnuc.for
        return
       else if(cmch.eq.'arri') then 
        ifrsto=0
        call l_structure(iss,lstruct1,lstruct2,lstruct3)
      
        if(nu_device(lstruct1).eq.1.and.lstruct3.gt.0) then
c         write(6,'(a,i1,a2,a)')'c3_prp(',lstruct3,')=',c3_prp(lstruct3)      
         if(c3_prp(lstruct3).eq.'plrs') jpolsource=1
        end if

        if(nu_device(lstruct1).eq.2) then          ! absorber
         if(lstruct2.gt.0) then
          if(lstruct3.eq.0) then

           if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1) then
c           storage for a layer with more than 1 site (storage for
c           a polarized layer ) 
            ifrsto=4*(nAS+1)
           end if
          else
           if(c3_prp(lstruct3).eq.'plrs') jpolabsorber=1
          end if
         else
c         storage for each device
          ifrsto=4*(nAS+1)+(km+1) 
c         if there are more than one absorber (incoherent) the unweighted
c         spectrum of each absorber is stored
c          if(ifrcase.eq.5)ifrsto=ifrsto+(km+1) 
         end if 
        end if

        if(nu_device(lstruct1).eq.3.and.lstruct3.gt.0) then
c        detector is always assumed to be unpolarized
         ifrsto=nSC+1
        end if
       return
      else if(cmch.eq.'arre') then
       return
      end if ! arr0,i,e

      if(.not.b_theory) then
c       absolute address of nstorSI is known here
        nstorint=maxsub*(1+maxthss)
        do k1=1,nstorint
         array_fr(nstorSI+k1)=(0.,0.)
        end do
      end if

       srw8=abs(v_max)/float(km)/8.
       mode_drive=drive_mode
       if(mode_drive.lt.1.or.mode_drive.gt.3)mode_drive=1

       mi=istruct2(istruct1(mstruct1))
c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100) 
       mfpt=2*(iarray_sp+nstorFR)  ! y data
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
       mxpt=mfpt+2*nchansp        ! x data (velocity) drive_mode=3
c       write(6,'(a,5i7)')' mfpt,mxpt=',mfpt,mxpt,iarray_sp,nstorFR
c*****************************************************************************
      if(cmch.eq.'dstr') then
       k1=1
      else if(cmch.eq.'data') then
       k1=2
      else if(cmch.eq.'ecic') then
       k1=3
      else if(cmch.eq.'test') then
       k1=4
      else if(cmch.eq.'dfdp') then
       k1=5
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=6
      else if(cmch(1:3).eq.'ple') then
       k1=7
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=8
      else if(cmch.eq.'punc')then
       k1=9
      end if
      
      goto (100,110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
       call moss_plot(cmch)
       data_str=formdata(mode_drive)
       call data2dread(0,info)
       return
 110   continue
       k1=iss
       call data2dread(k1,info)
      return
 120   call excinc2d(info)
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer
      
  200 continue
      
c      write(6,'(a)') ' before moss_the2exp  test'
      k1=1 
      if(cmch.eq.'ecic') k1=0
      call moss_the2exp(k1,info)
c      write(6,'(a)') ' after moss_the2exp  test'
      
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      call moss_the2exp(k1,info)
      return
c*****************************************************************************
c     subs, subt
  400 continue
      text(1)='           source'
      text(2)='         absorber'
      text(3)='  detector window'
      if(cmch.eq.'subt') goto 450
      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncl)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncl)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncl),ch132(:ncl)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncl)
      write(nwr,'(/,a)') ch132(:ncl)
      call moss_selsubspect(text)
      return
c*************************************************************
c  call of moss_subtract
 450  continue
      print *,' '
      print *,' '
      print *,'                     subtraction of subspectra'
      call moss_selsubtract(text,isub)
      call drive(mode_drive)
      call moss_subtract('moss',mi,isub,info)
      k1=1
      call moss_the2exp(k1,info)
      call moss_plot(cmch)
      k1=0
      k2=0
      if(b_theory) k1=1
      call xmosplo(k1,k2)
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

       k2=1  ! 0: only plot and return, 1: interactive plot
       call xmosplo(k1,k2)
       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
      if(cmch.eq.'dmod') then
       call moss_plot(cmch)
      else
       call drive(mode_drive)

       if(b_theory) then
        k1=3
        call moss_the2exp(k1,info)

        if(n_subset.gt.0) 
     &   call moss_subspect('moss',mi,isub,info)
       end if
       call moss_plot(cmch)
      end if

      return
c**************************************************************************
c     punch data and theory
 700  continue
       k1=iss
       call punch2d(k1,info)
      return

      end
      
      subroutine sel_the2exp(cmch,n1,info)
      character cmch*4
      integer n1,info

      if(cmch.eq.'moss') then
        call moss_the2exp(n1,info)
      else if(cmch.eq.'stro') then
        call strob_the2exp(n1,info)
      end if
      return
      end 


      
      subroutine moss_the2exp(n1,info)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory without mapping by the transformation 
c            matrices by EFFI (important for subspectra)
c *****************************************************************
      
      include 'comglb.for'
      include 'compar.for' 
      include 'comdat.for'
      include 'comdas.for' 
      include 'comthe.for'
      
      integer km,n1,info
      parameter (km=256)

       integer    iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,idum1,nstorTHyy
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),    !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,idum1,nstorTHyy,iaddr(5),
     &              idex(24)

      real         acsp,uthick_w,unit_chi,channels,vm_SC,convol,th_dum,
     &             drive_mode,channels_vmax,flag_basis,flag_misfit,
     &             om_samp,dumcs,dum
      common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,
     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,
     &              flag_misfit,om_samp,dumcs(icstrf-13)

      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
     &        Daperture,d_absorber,d_source,dumvs(ivstrf-14)
      logical b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,
     &        b_channel_v0,b_v_max2,b_vphase2,b_v_max3,b_vphase3,
     &        b_geo,b_Daperture,b_dabsorber,b_dsource,b_dumvs
      common/bvstrf/b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,
     &        b_channel_v0,b_v_max2,b_vphase2,b_v_max3,b_vphase3,
     &        b_geo,b_Daperture,b_dabsorber,b_dsource,b_dumvs(ivstrf-14)
      
      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      real      yth,cosa,a_r 
      dimension yth(-maxn:maxn),cosa(1320),a_r(1320)

      integer jsum,icase,N_S,N_B,nTHyy2
      real    r_B,r_S,sumi0,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF
      common/geomet/icase,N_S,N_B,r_B,r_S,sumi0,
     &                SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF
      
      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      logical b_total,b_fresonant,b_nonlinear,b_scale,b_drive,b_misfit,
     &        b_residual,b_align
 

c------------------------------------------------------------------
      call mapsub(0,0,0) 
c-------------------------------------------------------------------

      icase=0
      if(base.eq.0.) then
        info=1
        infotext(1)='<Mossbauer_spectrum>/parameter/global/base0'
        infotext(2)='**error** base = 0 '
        infotext(3)=' '
        return
      end if

      nomsamp=om_samp+1
      mode_drive=drive_mode
      nchansp=channels
      h=abs(channel_v0/channels_vmax-1.0)*10
      if(h.gt.1.0.or.nchansp.gt.maxn) then
        write(infotext(3),'(a,i5,2(a,f8.2))')
     & 'nchansp=',nchansp,' channels_vmax=',channels_vmax,
     &  ' channel_v0=',channel_v0
        info=10*h
        if(info.le.0) info=1
        infotext(1)='<Mossbauer_spectrum>/global_pa/ch_vmax/ch_v0'
        infotext(2)='**error** with one of the size of'//
     &      ' channels,channels_vmax,channel_v0'
        return
       end if
c     write(6,'(a,f10.3)')' frame01 moss_the2exp fresonant=',fresonant

c      write(6,'(i8,5f12.3)')48799,(real(array_fr(48799+j)),j=1,256,64)
c      write(6,'(i8,5f12.3)')84632,(real(array_fr(84632+j)),j=1,256,64)


      ka=nstorTH+2
      nTHyy2=nstorTHyy*2

      b_align=b_Daperture.or.b_dabsorber.or.b_dsource
      b_nonlinear=b_v_max2.or.b_vphase2
     &                    .or.b_v_max3.or.b_vphase3
      b_scale=b_v_max.or.b_channel_v0.or.b_nonlinear.or.b_align

      b_fresonant=b_f_factor.or.b_bg_fraction
      fresonant=f_factor*(1.0-bg_fraction)
      if(fresonant.gt.1.) write(nwr,'(2a)')
     &      '**warning** fresonant larger than 1'
      
      
      b_drive=b_geo.or.b_scale
      call mossbauer_tmre(b_total,info)
 
      k1=n1
      goto (100,200,300),k1
      
 100   continue
c      calculation of thfk
c       write(6,'(5L5)')b_geo,b_bg_fraction,b_channel_v0,b_base,b_total   
       ibmisfit=0
       if(b_base.or.b_fresonant.or.b_drive.or.b_total.or.b_align)then
        call drive(mode_drive)
        dv=abs(v_max)/float(km)

        if(flag_misfit.eq.1) then
         ibmisfit=1
         b_misfit=.true.
        end if

        if(nomsamp.gt.1) then
c        cosine smearing and aperture effects for scalar index of 
c        refraction- Absorber perpendicular to the optical axis.
c         write(6,'(a)')' nomsamp.gt.1'
         do j =0,km
          yth(j)=alog(-(real(array_fr(ka+j))-1.))
          yth(-j)=alog(-(aimag(array_fr(ka+j))-1.))
         end do
         do k=1,km/4
          yth(-km-k)=yth(-km)
          yth(km+k) =yth(km)
         end do
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           call geometry(j,cosa,a_r,jsum)
           ff=0.0
c          if(j.eq.100.or.j.eq.256)then
c           write(6,'(i4,a,2f10.3)')jsum,'=jsum cosa,a_R:'
c           write(6,'(8f10.3)')(cosa(i),i=1,jsum)
c          end if
           do l=1,jsum
            vn=velocity(j)*cosa(l)
            sumcosal=sumcosal+a_r(l)
            hi=vn/dv
            i=int(hi)
c           thickness increases with 1/cos
            y1=exp(yth(i-1)/cosa(l))
            y2=exp(yth(i)/cosa(l))
            y3=exp(yth(i+1)/cosa(l))
            hi=hi-float(i)
            fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
            ff=ff+(1.-fa*fresonant)*a_r(l)
           end do
           thfk(j)=base*ff
           ff=0.
           if(b_misfit)then
            do l=1,jsum 
             ff=ff+base*a_r(l)
            end do
            dfdp(j)=ff
           end if
          end do
         end do
        else 
c        no cosine smearing
         do j =0,km
          yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
          yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
         end do
         do k=1,km/4
          yth(-km-k)=yth(-km)
          yth(km+k) =yth(km)
         end do
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           vn=velocity(j)
           hi=vn/dv
           i=int(hi)
c           if(abs(i).gt.256)then
c             write(6,'(a,2i8,3x,4f10.3)')' i,j,vn,dv=',i,j,vn,dv
c             write(6,'(8f10.2)')velocity
c           end if
           y1=yth(i-1)
           y2=yth(i)
           y3=yth(i+1)
           hi=hi-float(i)
           ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
           thfk(j)=ff*geof(j)
           if(b_misfit)then
            dfdp(j)=base*geof(j)
           end if
          end do
         end do
        end if
        do j=1,nchansp
         real_fr(nTHyy2+j)=thfk(j)
        end do
c       write(6,'(a,4f15.1)') 'getthinf array_fr(1,2) =',
c    &  (array_fr(iarray_sp-1)),array_fr(iarray_sp)
       else
        do j=1,nchansp
         thfk(j)=real_fr(nTHyy2+j)
        end do
       end if
       b_theory=.true.
c      write(6,'(i8,2x,e8.2,L5,5f12.3)')
c     &             ka,geo,b_geo,real(array_fr(ka+1)),yth(1),thfk(1)
      return
      
 200  continue
c     derivatives
c     write(6,'(a,f15.5)') ' derivative step=',ddpk

      call drive(mode_drive)
      dv=abs(v_max)/float(km)

      ib_df=0
      kana=0
      do j=1,nchansp
       thfk(j)=real_fr(nTHyy2+j)
      end do
c     parameter pl(j)

c     variable pl(1)
      if(b_base) then
       b_residual=b_geo.or.b_scale.or.b_fresonant
       if(b_residual) then
        goto 240
       else
c        write(6,'(a,f10.1)')  'derivative of base -----base=',base
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          dfdp(j)=thfk(j)/base
         end do
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
c     variable pl(3)
      if(b_geo) then
       b_residual=b_base.or.b_scale.or.b_fresonant
       if(b_residual) then
        goto 240
       else
c       write(6,'(a)')  '   derivative of geo ------------'
c       in case of cosine smearing this derivation is approximate
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          dfdp(j)=dfdgeo(j)*thfk(j)
         end do
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      if(b_fresonant) then
       if(b_bg_fraction.and.b_f_factor) then
        write(nwr,'(a)')
     &  '**warning parameters:bg_fraction,f_factor are correlated by 1'
       end if
       if(b_bg_fraction) then
c       variable pl(2)
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          dfdp(j)=-(thfk(j)-base*geof(j))/(1.0-bg_fraction)
         end do
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      
       if(b_f_factor) then
c      variable pl(2)
        b_residual=b_base.or.b_geo.or.
     &                            b_scale.or.b_bg_fraction
        if(b_residual) then
         goto 240
        else
c        write(6,'(a)')  '   derivative of f_factor ------------'
c        in case of cosine smearing this derivation is approximate
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           dfdp(j)=(thfk(j)-base*geof(j))/f_factor
          end do
         end do
         kana=1
         ib_df=1
         goto 250
        end if
       end if
      end if

 240  kana=0 
      if(nomsamp.gt.1) then
c      cosine smearing and aperture effects
       do j =0,km
        yth(j)=alog(-(real(array_fr(ka+j))-1.))
        yth(-j)=alog(-(aimag(array_fr(ka+j))-1.))
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
        end do
    
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          call geometry(j,cosa,a_R,jsum)
          ff=0.0
          do l=1,jsum
           vn=velocity(j)*cosa(l)
           hi=vn/dv
           i=int(hi)
           y1=exp(yth(i-1)/cosa(l))
           y2=exp(yth(i)/cosa(l))
           y3=exp(yth(i+1)/cosa(l))
           hi=hi-float(i)
           fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
           ff=ff+(1.-fa*fresonant)*a_r(l)
          end do      
          dfdp(j)=(base*ff-thfk(j))/ddpk 
         end do 
        end do       ! j=1,nchansp

       else 
c       no cosine smearing
        do j =0,km
         yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
         yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
        end do
        do k=1,km/4
         yth(-km-k)=yth(-km)
         yth(km+k) =yth(km)
        end do
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          vn=velocity(j)
          hi=vn/dv
          i=int(hi)
          y1=yth(i-1)
          y2=yth(i)
          y3=yth(i+1)
          hi=hi-float(i)
          ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
          dfdp(j)=(ff*geof(j)-thfk(j))/ddpk
         end do 
        end do       ! j=1,nchansp
       
       end if
       ib_df=1
c      write(6,'(4e15.6)') (dfdp(i),i=1,nchansp,32)
 250  continue
c      write(6,'(4e15.6)') (dfdp(i),i=1,nchansp,32)
      return
      
 300  continue
      if(.not.b_theory) goto 310
        call drive(mode_drive)
        dv=abs(v_max)/float(km)
c     this label address is used for the calculation of subspectra      

      if(nomsamp.gt.1) then
c      cosine smearing and aperture effects
       do j =0,km
        yth(j)=alog(-(real(array_fr(ka+j))-1.))
        yth(-j)=alog(-(aimag(array_fr(ka+j))-1.))
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
       end do
        do j=1,nchansp
         call geometry(j,cosa,a_R,jsum)
         ff=0.0
         do l=1,jsum
          vn=velocity(j)*cosa(l)
          hi=vn/dv
          i=int(hi)
          y1=exp(yth(i-1)/cosa(l))
          y2=exp(yth(i)/cosa(l))
          y3=exp(yth(i+1)/cosa(l))
          hi=hi-float(i)
          fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
          ff=ff+(1.-fa*fresonant)*a_r(l)
         end do
         thfk(j)=base*ff
        end do
      else 
c      no cosine smearing
       do j =0,km
        yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
        yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
       end do
        do j=1,nchansp
         vn=velocity(j)
         hi=vn/dv
         i=int(hi)
         y1=yth(i-1)
         y2=yth(i)
         y3=yth(i+1)
         hi=hi-float(i)
         ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2))
         thfk(j)=ff*geof(j)
        end do
      end if

 310  return
      end
      
           

  

c     H. Spiering January,1995 Mainz
c                 oktober 2004 budapest, dezember Christcurch
c                 june Mainz 2005
c     moving absorber or moving source
c
      subroutine mossbauer_tmre(b_total,info)
      
      implicit none
      include 'comglb.for'
      include 'comcvm.for'
      include 'comthe.for'

      logical     b_total
      integer     info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,idum,nAS,nSC
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,iaddr(7),             
     &              ifrth(8),idum(3),nAS,nSC,idex(11)

      real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dumcs,dum
      common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dumcs(icstrf-11)
      

      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)
      
      real            avfr1,devfactor, devHext,devthetaHe,devphiHe,
     &                dvfr1
      common/avfr1trf/avfr1,devfactor,devHext,devthetaHe,devphiHe,
     &                dvfr1(ivfr1trf-5)
      logical         b_vfr1,b_devfactor,b_devHext,b_devthetaHe,
     &                b_devphiHe,b_dvfr1
      common/bvfr1trf/ b_vfr1,b_devfactor,b_devHext,b_devthetaHe,
     &                 b_devphiHe,b_dvfr1(ivfr1trf-5)
 
      real            acfr2,dumcfr2
      common/acfr2trf/acfr2,dumcfr2(icfr2trf-1)

c                     phi,theta,psi are not directly assigned
c                     but by arry_fr via the routine orientation 
      real            avfr2,th_factor,dumx,Hext,thetaHe,phiHe,
     &                phi,theta,psi,dumvfr2
      common/avfr2trf/avfr2,th_factor,dumx(4),Hext,thetaHe,phiHe,
     &                phi,theta,psi,dumvfr2(ivfr2trf-12)
      logical         b_vfr2,b_thfactor,b_dumx,b_phi,b_theta,b_psi,
     &                b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thfactor,b_dumx(7),b_phi,b_theta,b_psi,
     &                b_dumvfr2(ivfr2trf-12)
       
      real            vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical         b_vsstrf,b_not_sftr
      common/bvsstrf/ b_vsstrf(ivsstrf)
      

      integer     km,mAS,idumscrd
      parameter  (km=256,mAS=4*maxn,idumscrd=maxscrd-10*(2*mAS+1)
     &                                       -2*(km+1))
      real        sP1,sP2,sP3,aP1,aP2,aP3,sTr,aTr,sa,detector,dumscrd
      complex     yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),detector(-mAS:mAS),dumscrd(idumscrd)
      
      logical   b_source,b_absorber,b_detector,b_module,b_device,
     &          b_lay,b_polisite,
     &          b_polabsorber,b_polsource,b_absdetector,
     &          b_reemission
      integer   issa,isse,idt,i,j,n,nn,n8,n2,mfr1,nspdv,
     &          k,lay,layb,layl,nabs0,nabs1,nabs2,nabs3,
     &          iscn_nr,npolSCAS,iyout,isubthe,
     &          lstruct1,lstruct2,lstruct3,iget,isite,isource_sp
      real      wi,satrexpr,factor_thickness,areafrac
      dimension areafrac(maxfr1),b_device(maxfr1),
     &          b_module(maxfr2),wi(maxthss),b_polisite(0:maxthss)
      complex   hc1,hci,app,apm,amp,satraceh,
     &          aam(4,maxfr2),aa(4),bb(4),dd(4)
      complex*16 daa(4),dbb(4),dcc(4)

      do i=1,maxthss
       wi(i)=0.
      end do
c     ch_case='source','absorber','detector',
c     ifrcase=3 transmission, 4 reemission
c     ifrcase=5   incoherent absorber

      b_reemission=.false.
      if(ifrcase.eq.2.or.ifrcase.eq.4) b_reemission=.true. 
      b_polsource  =.false.
      b_polabsorber=.false.
            
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      
      
       b_source =.false.
       b_absorber=.false.
       b_detector=.false.
       b_absdetector=.false.      

c     write(6,'(a,10L4)')'b_vsp(4),b_v_max=',b_vsp,b_v_max 
      b_total=b_v_max

      isubthe=1
      call get_theory(isubthe,info)
      if(info.gt.0) return
      b_total= b_total.or.(isubthe.gt.0) 
c      write(6,'(a,i3)')'ifrcase=',ifrcase
c      write(6,'(a,i3)')'mstruct1=',mstruct1
c      write(6,'(a,10i3)')'istruct1=',(istruct1(i),i=0,5)
c      write(6,'(a,10i3)')'istruct2=',(istruct2(i),i=0,5)

      do lstruct1=1,mstruct1
        b_device(lstruct1)=.false.

       call mapsub(lstruct1,0,0) 

       isubthe=1                      ! frame
       call get_theory(isubthe,info)
       if(info.gt.0) return
       b_total= b_total.or.(isubthe.gt.0)     

       if(nu_device(lstruct1).eq.1) then 
        lstr1case=1     ! entry for the source is transferred by the 
c                         common block  'common/struct/' to the 
c                         the routine called by get_theory
c                         the subroutine th_..index..() branches to
c                         source,absorber,detector by the command
c                         goto (100,200,300),lstr1case
c      -----------------------------------------------------------------
c      layer 1 = moving source
c      ------------------------------------------------------------------
c      Sums of source curves at the positions Eagd. For the convolution
c      integral the stepwidth is still srw2. The stepwidth srw8 of the
c      source function guarantees that the source line is exact
c      within 1/8 channel.
c
c      ----0--------------------------nLG
c       nLG--------------------------0-------------        srw8
c        nSC------------0------------nSC                    srw2
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         call mapsub(lstruct1,lstruct2,0)
         isubthe=1
         call get_theory(isubthe,info)
         if(info.gt.0) return

         if(isubthe.eq.0) then
          b_phi=.false.
          phi=0.0
          theta=0.0
          psi=0.0
         else
          iget=l2_get(lstruct2)
          b_phi=aimag(array_fr(iget+2)).gt.0.0      !    
          phi  =real(array_fr(iget+2))
          theta=real(array_fr(iget+3))
          psi  =real(array_fr(iget+4))
         end if
         b_lay=(isubthe.gt.0).or.b_phi
         
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)
          call mapsub(lstruct1,lstruct2,lstruct3)

          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs'
          if(b_polisite(lstruct3)) b_polsource=.true.

          wi(lstruct3)=vsstrf(2)

          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
          b_source=b_source.or.b_lay.or.(isubthe.gt.0)

         end do
        end do
        b_device(1)=b_source
       end if  ! (nu_device(lstruct1)=1 source
       

       if(nu_device(lstruct1).eq.2) then
c       ----------------------------------------------------------------
c       layer lay2,3 ... mlay of  absorber at rest
c       ----------------------------------------------------------------
c       The Lorentz curve of the absorber in npq is 1 at resonance so that
c       for a singl line the exponent at resonance is just -teff (effective
c       thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c       normalizes ( to area 1) the Lorentz curve.
      
c       Sums of absorber curves at the positions Eagd. For the convolution
c       integral the stepwidth is still srw4. The stepwidth srw8 of the
c       absorber function guarantees that the absorbtion line is exact
c       within 1/4 channel.
c
c       ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nAS------------0------------nAS                    srw2

        lstr1case=2       ! device=absorber
        if(ifrcase.eq.5)then
         areafrac(lstruct1)=devfactor
         b_device(lstruct1)=b_devfactor
c        rotation of the absorber, the same for all layers
         call mapsub(lstruct1,0,0)
         isubthe=1
         call get_theory(isubthe,info)
         if(info.gt.0) return
         if(isubthe.eq.0) then
          b_phi=.false.
         else
          iget=l1_get(lstruct1)
          b_phi=aimag(array_fr(iget+2)).gt.0.0      !    
          phi  =real(array_fr(iget+2))
          theta=real(array_fr(iget+3))
          psi  =real(array_fr(iget+4))
         end if    
c         write(6,'(2i6,a,3f10.2)')lstruct2,iget,
c     &    '  mossbauer phi,theta,psi=',phi,theta,psi

c        the external field is the same for all layers of device2=absorber
c        for all mosaic parts of the absorber -> transfer of variables
c        and logical from common/uvfr1trf/ to common/uvfr2trf/ (u=a,b).
         Hext=devHext
         thetaHe=devthetaHe
         phiHe=devphiHe
         b_dumx(5)=b_devHext
         b_dumx(6)=b_devthetaHe
         b_dumx(7)=b_devphiHe
        end if
      
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         b_lay=.false.
          call mapsub(lstruct1,lstruct2,0)
          isubthe=1
          call get_theory(isubthe,info)
          if(info.gt.0) return
         
         if(ifrcase.ne.5)then    
          if(isubthe.eq.0) then
           b_phi=.false.
          else
c          write(6,'(a,i1,a2,i6)') 
c     &     'l2_get(',lstruct2,')=',l2_get(lstruct2)           
           iget=l2_get(lstruct2)
           b_phi=aimag(array_fr(iget+2)).gt.0.0      !    
           phi  =real(array_fr(iget+2))
           theta=real(array_fr(iget+3))
           psi  =real(array_fr(iget+4))
c          write(6,'(2i6,a,3f10.2)')lstruct2,iget,
c     &    '  mossbauer phi,theta,psi=',phi,theta,psi
          end if    
          b_lay= b_lay.or.b_phi.or.(isubthe.gt.0)
         end if
       
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs'
          if(b_polisite(lstruct3)) b_polabsorber=.true.

      
          call mapsub(lstruct1,lstruct2,lstruct3)

          sftr=vsstrf(2) 
c         logical of the thickness sftr is at b_vsstrf(2)
          if(ifrcase.eq.3.or.ifrcase.eq.5) then
           factor_thickness=real(array_fr(iget+1))
           wi(lstruct3)=sftr*uthick_w*factor_thickness
           if(th_factor.gt.0.000001) then 
            wi(lstruct3)=wi(lstruct3)*th_factor
            b_lay=b_lay.or.b_thfactor
           end if
          else
           wi(lstruct3)=sftr*uthick_w
           if(th_factor.gt.0.000001) then 
            wi(lstruct3)=wi(lstruct3)*th_factor
            b_lay= b_lay.or.b_thfactor
           end if
          end if
          
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return
c          write(6,'(a)')' th_mossbauer absorber 2'
c          write(6,'(10f10.3)')(vsstrf(i),i=1,10)
          b_lay= b_lay.or.b_vsstrf(2).or.(isubthe.gt.0)
         end do
          b_module(lstruct2)=b_lay
          b_device(lstruct1)=b_device(lstruct1).or.b_lay
        end do
       end if  !  nu_device(lstruct1)=2 absorber
       b_absorber=b_absorber.or.b_device(lstruct1)

      
       if(nu_device(lstruct1).eq.3) then
        lstr1case=3    
c      ----------------------------------------------------------------
c      layer lay=mlay of detector
c      ----------------------------------------------------------------
        do n=-nSC,nSC
         detector(n)=0.
        end do
        b_absdetector=.true.
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)

         lay=lstruct2
      
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

          call mapsub(lstruct1,lstruct2,lstruct3)
          j=vsstrf(1)
          do k=3,j+1
           b_not_sftr=b_not_sftr.or.b_vsstrf(k)
          end do

          sftr=vsstrf(2)
          wi(lstruct3)=sftr*uthick_w
           
          isubthe=0
          call get_theory(isubthe,info)
          if(info.gt.0) return

          b_detector=b_not_sftr
     &                   .or.b_vsstrf(2).or.(isubthe.gt.0)

          idt=l3_get(lstruct3)+1
c         write(6,'(a,i6)') 'iget=idt=',idt
          do n=0,nSC
           detector(n)=detector(n)+real(array_fr(idt+n))*wi(lstruct3)
           detector(-n)=detector(-n)+aimag(array_fr(idt+n))*wi(lstruct3)
          end do ! n=0,nSC
          do n=-nSC,nSC
           detector(n)=exp(-2.*detector(n))
          end do  ! n=0,nSC

         end do
        end do
        b_device(lstruct1)=b_detector
       end if  !  nu_device(lstruct1)=3 detector
      end do
      b_total=b_total.or.b_source.or.b_absorber.or.b_detector
c-----------------------------------------------------------------------
c      here the matrix R for the absorber are given :
c      satrace(n)*1 +  (sapp(n)  sapm(n))
c                      (samp(n) -sapp(n))
c
c      calculation of the transmittivity matrix T for all channels n
c      by   T = exp(iR)*rho*exp(-iR+)
c      exp(-2*Sum;lay sattrlay(lay)) is a common factor, which is the
c      only one for an unpolarized sample
      
c-----------------------------------------------------------------------
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
c
c      calculation of the transmittivity matrix T for all channels n
c      by   T = exp(iR)*rho*exp(-iR+)
c      exp(-2*Sum;lay sattrilay(lay)) is a common factor, which is the
c      only one for an unpolarized sample
c      if(mstrut1.eq.3) then the last layer (detector) does not move relative
c      to the source. The detector window is treated as an unpolarized absorber.
      
c       write(6,'(a,2l5)')'moss b_absorber,b_total=',b_absorber,b_total
      iyout=nstorTH+2
c      write(6,'(a,L5,i8)')' b_total,iyout=', b_total,iyout 
      if(.not.b_total) goto 1000

      iyout=nstorTH+2 
      do k=0,km
       array_fr(iyout+k)=cmplx(1.,1.)
      end do 

      mfr1=mstruct1
      if(nu_device(mstruct1).eq.3)mfr1=mfr1-1

      do lstruct1=2,mfr1
       if(b_device(lstruct1)) then

        do n=-nAS,nAS
         n2=2*abs(n)+1
         if(n.ge.0) n2=n2-1
         n8=4*n2
      
         satraceh=cmplx(0.,0.)
         do lay=istruct1(lstruct1-1)+1,istruct1(lstruct1)
          issa=istruct2(lay-1)+1
          isse=istruct2(lay)
          app=cmplx(0.,0.)
          apm=cmplx(0.,0.)
          amp=cmplx(0.,0.)
          if(isse.gt.issa) then
           do isite=issa,isse
c           if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')
c     &     ' --1-lay,isite,wi(isite)=',lay,isite,wi(isite)
            if(b_polisite(isite)) then
             nn=l3_get(isite)+n8 
c            if(n.eq.0)write(6,'(a,2i6)') 'iget=',l3_get(isite),nAS
             app=app+array_fr(nn+2)*wi(isite)
             apm=apm+array_fr(nn+3)*wi(isite)
             amp=amp+array_fr(nn+4)*wi(isite)
            else
             nn=l3_get(isite)+n2
c             if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)
            end if
            satraceh=satraceh+array_fr(nn+1)*wi(isite)
c            if(abs(n).lt.2) write(6,'(2i6,11f8.3)')
c     &        n,nn,wi(isite),satraceh*1000
           end do     ! isite loop
          else
c          if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')
c     &    ' --2-lay,issa,wi(issa)=',lay,issa,wi(issa)
           if(b_polisite(issa)) then
            nn=l3_get(issa)+n8
            app   =  array_fr(nn+2)*wi(issa)
            apm   =  array_fr(nn+3)*wi(issa)
            amp   =  array_fr(nn+4)*wi(issa)
c           if(n.eq.0)write(6,'(a ,2i8,3i4,2x,f10.4)')
c     &     '1-lay,issa,wi(issa)=',l3_get(issa),l3_get(issa)+8*nAS,
c     &      lstruct1,lay,issa,wi(issa)
           else
            nn=l3_get(issa)+n2
           end if
           satraceh=satraceh+array_fr(nn+1)*wi(issa)
c            if(abs(n).lt.8) write(6,'(i6,10f12.3)')
c     &        nn,wi(issa),satraceh*1000/wi(issa)
          end if  ! isse.gt.issa
          
          if(b_polabsorber) then
           if(b_reemission) then
            aa(1)=cmplx(1.0,0.0)+app
            aa(3)=apm
            aa(2)=amp
            aa(4)=cmplx(1.0,0.0)-app
           else
            call expo_22(app,apm,amp,aa)
           end if
           do k=1,4
            aam(k,lay)=aa(k)
           end do
          end if

         end do   ! lay

         
         if(b_reemission) then
          satrexpr=1.0+2.*aimag(satraceh)
c          satrexpr=1.0+2.*aimag(satraceh)/(2.*aimag(satraceh)+1.)
         else
          satrexpr=exp(-aimag(satraceh))
          satrexpr=satrexpr**2
         end if

c         if(abs(n).le.5) write(6,'(i2,2f12.6,5x,L5)') 
c     &            n,aimag(satraceh),satrexpr,b_polabsorber
      
         layl=istruct1(lstruct1)
         layb=istruct1(lstruct1-1)+1
         if(b_polabsorber) then
          do k=1,4
           dd(k)=aam(k,layl)
          end do
      
c         multiplication of the matrices exp(iR(layl))*...*exp(iR(2))
          if(layl.gt.2) then
          do k=1,4
           dcc(k)=dd(k)
          end do
           do lay=layl-1,layb,-1
            do k=1,4
             daa(k)=dcc(k)
             dbb(k)=aam(k,lay)
            end do
            call matproD(daa,dbb,dcc)
           end do
           do k=1,4
            dd(k)=dcc(k)
           end do

          end if
c          if(n.eq.0) write(6,'(a,11f8.3)')' dd=',dd      
c         trace (dd+*dd*rho) is the intensity
c         bb=cc+
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))


          call matprof(bb,dd,aa)
c         aa=cc*cc+ is a Hermitian matrix
c         aa=1/2*trace(aa)*1 + aP*sv(Pauli)
          aa(1)=aa(1)*satrexpr
          aa(2)=aa(2)*satrexpr
          aa(4)=aa(4)*satrexpr
          aTr(n)= 0.5*real(aa(1)+aa(4))-1.
          aP1(n)=   real(aa(2))
          aP2(n)= aimag(aa(2))
          aP3(n)= 0.5*real(aa(1)-aa(4))
      
         else
          aTr(n)= satrexpr-1.
          aP1(n)=0.0
          aP2(n)=0.0
          aP3(n)=0.0
         end if
        end do ! n
        nabs0=l1_put(lstruct1)+1              ! 25.7.06
        if(b_polabsorber.and.b_polsource) then
         nabs1=nabs0+nAS+1
         nabs2=nabs1+nAS+1
         nabs3=nabs2+nAS+1
         do n=0,nAS
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
          array_fr(nabs1+n)=cmplx(aP1(n),aP1(-n))
          array_fr(nabs2+n)=cmplx(aP2(n),aP2(-n))
          array_fr(nabs3+n)=cmplx(aP3(n),aP3(-n))
         end do
        else
         do n=0,nAS
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n))
         end do
        end if

c       write(6,'(a,4f15.1)') 'th_mossbauer array_fr(1,2) =',
c     &  (array_fr(iarray_sp-1)),array_fr(iarray_sp)
        
       else  ! b_device(lstruct1)
        nabs0=l1_put(lstruct1)+1              ! 25.7.06
        if(b_polabsorber.and.b_polsource) then
         nabs1=nabs0+nAS+1
         nabs2=nabs1+nAS+1
         nabs3=nabs2+nAS+1
         do n=0,nAS
          aTr(n) = real(array_fr(nabs0+n))
          aTr(-n)=aimag(array_fr(nabs0+n))
          aP1(n) = real(array_fr(nabs1+n))
          aP1(-n)=aimag(array_fr(nabs1+n))
          aP2(n) = real(array_fr(nabs2+n))
          aP2(-n)=aimag(array_fr(nabs2+n))
          aP3(n) = real(array_fr(nabs3+n))
          aP3(-n)=aimag(array_fr(nabs3+n))
         end do
        else
         do n=0,nAS
          aTr(n) = real(array_fr(nabs0+n))
          aTr(-n)=aimag(array_fr(nabs0+n))
         end do
        end if
       end if  ! b_device(lstruct1)

       nspdv=l1_put(lstruct1)+4*(nAS+1)+1    
       do k=0,km
        array_fr(nspdv+k)=(0.,0.)
       end do

       lay=1
       issa=istruct2(lay-1)+1
       isse=istruct2(lay)

       do isite=issa,isse
c       sum over all source sites
        isource_sp=l3_get(isite)                 
c       write(6,'(a,2i6)') 'isite,iget=isource_sp=',isite,isource_sp
      
        if(b_absdetector) then
c        ----------------------------------------------------------
c        b_absdetector=.true.  detector at rest relative to the source
c        -----------------------------------------------------------
         do n=0,nSC
         if(b_polisite(isite)) then
          nn=isource_sp+4*n
          sTr(n) =aimag(array_fr(nn+1))*detector(n)
          sTr(-n)=aimag(array_fr(nn+3))*detector(-n)
         else
          nn=isource_sp+2*n
          sTr(n) =aimag(array_fr(nn+1))*detector(n)
          sTr(-n)=aimag(array_fr(nn+2))*detector(-n)
         end if
         end do
         if(b_polabsorber.and.b_polsource) then
          do n=0,nSC
           nn=isource_sp+4*n
           sP1(n)=  real(array_fr(nn+2))*detector(n)
           sP2(n)=aimag(array_fr(nn+2))*detector(n)
           sP3(n)=  real(array_fr(nn+1))*detector(n)
           sP1(-n)=  real(array_fr(nn+4))*detector(-n)
           sP2(-n)=aimag(array_fr(nn+4))*detector(-n)
           sP3(-n)=  real(array_fr(nn+3))*detector(-n)
c          if(abs(n).le.5) write(6,'(a1,i4,4f15.6)')'x',n,sTr(n),sP3(n)
          end do
         end if  ! b_polabsorber.and.b_polsource
        else  ! b_absdetector=.true.
     
         do n=0,nSC
          if(b_polisite(isite)) then
           nn=isource_sp+4*n
           sTr(n) =aimag(array_fr(nn+1))
           sTr(-n)=aimag(array_fr(nn+3))
          else
           nn=isource_sp+2*n
           sTr(n) =aimag(array_fr(nn+1))
           sTr(-n)=aimag(array_fr(nn+2))
          end if
         end do

c        write(6,'(a,2i6)')'mossbau nSC,isource_sp=',nSC,isource_sp
c        write(6,'(8f10.3)') (sTr(n),n=0,64)
     
         if(b_polabsorber.and.b_polsource) then
          do n=0,nSC
           nn=isource_sp+4*n
           sP1(n)=  real(array_fr(nn+2))
           sP2(n)=aimag(array_fr(nn+2))
           sP3(n)=  real(array_fr(nn+1))
           sP1(-n)=  real(array_fr(nn+4))
           sP2(-n)=aimag(array_fr(nn+4))
           sP3(-n)=  real(array_fr(nn+3))
c          if(abs(n).le.5) write(6,'(a1,i4,4f15.6)')'x',n,sTr(n),sP3(n)
          end do
         end if   ! b_polabsorber.and.b_polsource
        end if   !  b_absdetector
     
        npolSCAS=0
        if (b_polsource.and.b_polabsorber) npolSCAS=1
c       write(6,'(a,i5)') ' npolSCAS=',npolSCAS
        i=2
        if(b_polisite(isite))i=4
        iscn_nr=isource_sp+(nSC+1)*i+1
c        write(6,'(a,4i6)') '---------isource,iscn_nr,iput=',
c     &       isource_sp,iscn_nr,isite
     
        if(nAS.gt.nSC) then
         call convolutionAS(iscn_nr,nSC,npolSCAS)
        else
         call convolutionSC(iscn_nr,nAS,npolSCAS)
        end if
        factor_thickness=wi(isite)
c        write(6,'(a,f10.4,i4)')'thickness,isite=',factor_thickness,isite  
c        write(6,'(6f10.4)')(yout(k),k=1,km,8)
        do k=0,km
         array_fr(nspdv+k)=array_fr(nspdv+k)+yout(k)*factor_thickness
        end do
       end do     ! isite source loop
      end do     ! incoherent fraction
c     store yout(k)*factor_thickness for each absorber device (lstruct1)

      nspdv=l1_put(2)+4*(nAS+1)+1 
      if(mfr1.gt.2)then
       do lstruct1=2,mfr1
        nspdv=l1_put(lstruct1)+4*(nAS+1)+1 
        do k=0,km
         array_fr(iyout+k)=array_fr(iyout+k)+
     &                     array_fr(nspdv+k)*areafrac(lstruct1)
        end do
       end do     ! mfr1
      else
       do k=0,km
        array_fr(iyout+k)=array_fr(iyout+k)+array_fr(nspdv+k)
       end do      
c      do k=0,km,8
c       write(6,'(f12.5)') array_fr(nspdv+k)
c      end do      
      end if
c-------------------------------------------------------------
c     end of calculation of absorber function
      
 1000  continue
     
      return
      end


      subroutine convolutionAS_(iscn_nr,nSC,npolSCAS)
      
      include 'comglb.for'
      include 'comthe.for'
      
      integer npolSCAS,iscn_nr,nSC,idumscrd,km,mAS
      parameter (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                      -2*(km+1))
      real      aP1,aP2,aP3,sP1,sP2,sP3,sTr,aTr,sa,dumscrd
      complex   yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)
      
c-----------------------------------------------------------------------
c      convolution with the absorber function
c
c     -nAS-------k2--------------0---------k----k2--------nAS
c     -nSC---k2--0--k2---nSC  -nSC---k2--0--k2---nSC
c
      
c     this convolution is calculated with stepwidth srw2
c         write(6,'(a,i8)') '  -conAS--, iscn=',iscn
      
c       do j=-nSC/8,nSC/8
c        write(6,'(i4,8e10.3)') j,(aTr((j-1)*8+i),i=1,8)
c       end do
c       write(6,'(a,2i6)') 'convolutionAS kzlm,nSC=',kzlm,nSC
c       write(6,'(a,i8)') 'convolutionAS iscn_nr=',iscn_nr
c       write(6,'(a,i8)') 'convolutionAS iscn_fr=',iscn_fr
c       write(6,'(a,i8)') 'convolutionAS npolSCAS=',npolSCAS
c       write(6,'(a,2f15.5)')'array_fr(iscn_nr)=',array_fr(iscn_nr)
c      write(6,'(4f10.3)') (sTR(i),i=-2,1)
c      write(6,'(4g15.5)') (cLG(i),i=-2,1)
c       write(6,'(i4,a,2f15.6)')
c     &    (k,' sTr(k),aTr(k)=',sTr(k),aTr(k),k=-5,5)
      
      snorm=3.*real(array_fr(iscn_nr))
c     write(6,'(a,f10.5)') '  snorm =',snorm

      do i=0,2*km,2
       h1=0.
       h2=0.
        do j=-nSC+1,nSC-1,2
        h1=h1+ sTr(j)*aTr(i+j)*2.
        h2=h2+ sTr(j)*aTr(-i+j)*2.
        end do
        do j=-nSC+2,nSC-2,2
        h1=h1+ sTr(j)*aTr(i+j)
        h2=h2+ sTr(j)*aTr(-i+j)
        end do
        h1=h1*2.+ sTr(-nSC)*aTr(-nSC+i)+sTr(nSC)*aTr(nSC+i)
        h2=h2*2.+ sTr(-nSC)*aTr(-nSC-i)+sTr(nSC)*aTr(nSC-i)
      
      if (npolSCAS.eq.1) then
c     product   sP * aP  , Poincare vector of the source sP is already
c     weighted by the intensity sTr
      
        do j=-nSC+1,nSC-1,2
        h1=h1+ (sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j))*4.
        h2=h2+ (sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j))*4.
        end do
        do j=-nSC+2,nSC-2,2
        h1=h1+ (sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j))*2.
        h2=h2+ (sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j))*2.
        end do
        k=-nSC+i
        h1=h1+ sP1(-nSC)*aP1(k)+sP2(-nSC)*aP2(k)+sP3(-nSC)*aP3(k)
        k=nSC+i
        h1=h1+ sP1(nSC)*aP1(k)+sP2(nSC)*aP2(k)+sP3(nSC)*aP3(k)
        k=-nSC-i
        h2=h2+ sP1(-nSC)*aP1(k)+sP2(-nSC)*aP2(k)+sP3(-nSC)*aP3(k)
        k=nSC-i
        h2=h2+ sP1(nSC)*aP1(k)+sP2(nSC)*aP2(k)+sP3(nSC)*aP3(k)
       end if     ! if polarized- condition
       yout(i/2)=cmplx(h1,h2)/snorm
      end do
      
c       write(6,'(i4,i8,2x,2f15.6)')
c     &          (k,iyout,array_fr(iyout+k),k=-5,5)
      
      return
      end
      
      subroutine convolutionSC(iscn_nr,nAS,npolSCAS)
       include 'comglb.for'
       include 'comthe.for'
      
      integer npolSCAS,iscn_nr,nAS,idumscrd,km,mAS
      parameter (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                      -2*(km+1))
      real      aP1,aP2,aP3,sP1,sP2,sP3,sTr,aTr,sa,dumscrd
      complex   yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)

c      write(6,'(a,i4)') 'convolutionSC sTR,aTR,npolSCAS=',npolSCAS
c       write(6,'(a,2i8)') 'convolutionSC nAS=',nAS
c      do j=-nSC/8,nSC/8
c       write(6,'(i4,8e10.3)') j,(sTr((j-1)*8+i),i=1,8)
c      end do
c      do j=-nAS/8,nAS/8
c       write(6,'(i4,8e11.3)') j,(aTr((j-1)*8+i),i=1,8)
c      end do
c       write(6,'(8f10.3)') (aTr(i),i=-nAS,nAS,8),aTr(nAS)
c       nSC=256
c       write(6,'(8f11.3)') (sP3(i)*100,i=-nSC,nSC,16)
      
      iin=iscn_nr
      
      do i=0,2*km,2
       do j=-nAS,nAS
        sa(j)=aTr(j)*sTr(i+j)
       end do
       h1=0.
       do j=-nAS+1,nAS-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nAS+2,nAS-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nAS)+sa(nAS)
       h2=0.
       do j=-nAS+3,nAS-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nAS+2,nAS-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &      +7.*(sa(-nAS+1)+sa(nAS-3))
       hr=h1-h2/30.       

       do j=-nAS,nAS
        sa(j)=aTr(j)*sTr(-i+j)
       end do
       h1=0.
       do j=-nAS+1,nAS-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nAS+2,nAS-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nAS)+sa(nAS)
       h2=0.
       do j=-nAS+3,nAS-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nAS+2,nAS-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &      +7.*(sa(-nAS+1)+sa(nAS-3))
       hi=h1-h2/30.       

       if (npolSCAS.eq.1) then
c       product   aP * sP  , Poincare vector of the source sP is already
c       weighted by the intensity sTr
        do j=-nAS,nAS
         sa(j)=aP1(j)*sP1(i+j)+aP2(j)*sP2(i+j)+aP3(j)*sP3(i+j)
        end do
        h1=0.
        do j=-nAS+1,nAS-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nAS+2,nAS-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nAS)+sa(nAS)
        h2=0.
        do j=-nAS+3,nAS-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nAS+2,nAS-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &       +7.*(sa(-nAS+1)+sa(nAS-3))
        hr=hr+h1-h2/30.       
  
        do j=-nAS,nAS
         sa(j)=aP1(j)*sP1(-i+j)+aP2(j)*sP2(-i+j)+aP3(j)*sP3(-i+j)
        end do
        h1=0.
        do j=-nAS+1,nAS-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nAS+2,nAS-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nAS)+sa(nAS)
        h2=0.
        do j=-nAS+3,nAS-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nAS+2,nAS-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nAS)+sa(nAS-2))
     &       +7.*(sa(-nAS+1)+sa(nAS-3))
        hi=hi+h1-h2/30.       
       end if     ! if polarized- condition
       k=i/2
       hr=hr/real(array_fr(iin+k))/3.
       hi=hi/aimag(array_fr(iin+k))/3.
       yout(k)=cmplx(hi,hr)
      end do
c       write(6,'(a,6i6)')'mossbau iin,nAS=',iin,nAS
      return
      end
      
      subroutine convolutionAS(iscn_nr,nSC,npolSCAS)
      
      include 'comglb.for'
      include 'comthe.for'
      
      integer npolSCAS,iscn_nr,nSC,idumscrd,km,mAS
      parameter (km=256,mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     &                                      -2*(km+1))
      real      aP1,aP2,aP3,sP1,sP2,sP3,sTr,aTr,sa,dumscrd
      complex   yout
      common/scrd/sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),
     &            aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),
     &            sTr(-mAS:mAS),aTr(-mAS:mAS),sa(-mAS:mAS),
     &            yout(0:km),dumscrd(idumscrd)
      
c-----------------------------------------------------------------------
c      convolution with the absorber function
c
c     -nAS-------k2--------------0---------k----k2--------nAS
c     -nSC---k2--0--k2---nSC  -nSC---k2--0--k2---nSC
c
      
c     this convolution is calculated with stepwidth srw2
c         write(6,'(a,i8)') '  -conAS--, iscn=',iscn
      
c       do j=-nSC/8,nSC/8
c        write(6,'(i4,8e10.3)') j,(aTr((j-1)*8+i),i=1,8)
c       end do
c       write(6,'(a,2i6)') 'convolutionAS kzlm,nSC=',kzlm,nSC
c       write(6,'(a,i8)') 'convolutionAS iscn_nr=',iscn_nr
c       write(6,'(a,i8)') 'convolutionAS iscn_fr=',iscn_fr
c       write(6,'(a,i8)') 'convolutionAS npolSCAS=',npolSCAS
c       write(6,'(a,2f15.5)')'array_fr(iscn_nr)=',array_fr(iscn_nr)
      
      snorm=3.*real(array_fr(iscn_nr))
c     write(6,'(a,f10.5)') '  snorm =',snorm
      
      do i=0,2*km,2

       do j=-nSC,nSC
        sa(j)=sTr(j)*aTr(i+j)
       end do
       h1=0.
       do j=-nSC+1,nSC-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nSC+2,nSC-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nSC)+sa(nSC)
       h2=0.
       do j=-nSC+3,nSC-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nSC+2,nSC-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &      +7.*(sa(-nSC+1)+sa(nSC-3))
       hr=h1-h2/30.       

       do j=-nSC,nSC
        sa(j)=sTr(j)*aTr(-i+j)
       end do
       h1=0.
       do j=-nSC+1,nSC-1,2
        h1=h1+ sa(j)*4.
       end do
       do j=-nSC+2,nSC-2,2
        h1=h1+ sa(j)*2
       end do
       h1=h1+ sa(-nSC)+sa(nSC)
       h2=0.
       do j=-nSC+3,nSC-5,2
        h2=h2+ sa(j)*8.
       end do
       do j=-nSC+2,nSC-4,2
        h2=h2- sa(j)*8.
       end do
       h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &      +7.*(sa(-nSC+1)+sa(nSC-3))
       hi=h1-h2/30.       

       if (npolSCAS.eq.1) then
c      product   sP * aP  , Poincare vector of the source sP is already
c      weighted by the intensity sTr
        do j=-nSC,nSC
         sa(j)=sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j)
        end do
        h1=0.
        do j=-nSC+1,nSC-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nSC+2,nSC-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nSC)+sa(nSC)
        h2=0.
        do j=-nSC+3,nSC-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nSC+2,nSC-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &       +7.*(sa(-nSC+1)+sa(nSC-3))
        hr=hr+h1-h2/30.       
  
        do j=-nSC,nSC
         sa(j)=sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j)
        end do
        h1=0.
        do j=-nSC+1,nSC-1,2
         h1=h1+ sa(j)*4.
        end do
        do j=-nSC+2,nSC-2,2
         h1=h1+ sa(j)*2
        end do
        h1=h1+ sa(-nSC)+sa(nSC)
        h2=0.
        do j=-nSC+3,nSC-5,2
         h2=h2+ sa(j)*8.
        end do
        do j=-nSC+2,nSC-4,2
         h2=h2- sa(j)*8.
        end do
        h2=h2-4.*(sa(-nSC)+sa(nSC-2))
     &       +7.*(sa(-nSC+1)+sa(nSC-3))       
        hi=hi+h1-h2/30.       
       end if     ! if polarized- condition
       k=i/2
       yout(k)=cmplx(hr,hi)/snorm
      end do
      
      return
      end

