c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              december 2009 

      subroutine fr_syndoubleSC(cmch,jss,info)
c     synchrotron
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'
      include 'comdas.for'

      integer    jss,info,
     &           ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &           l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &           nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,nTH2,nsrw,
     &           nstore,iflag_basis,l_Poincare,nLG,ipLG,nTH,
     &           ith_channels,nsampling,ak8,nomega,nstrob_order,jt0_ch,
     &           iT_max,nvch,nhyperfine
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),      
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              ipLG,iaddr(3),nTH1,nCP,nTH2,nsrw,nstore,ifrth(3),           
     &              iflag_basis,l_Poincare,nLG,nTH,ith_channels,
     &              nsampling,ak8,nomega,srw8,nstrob_order,jt0_ch,
     &              iT_max,nvch,nhyperfine,idex(2)
c      1+4*maxfr1+4+4*maxfr2+1+3*maxthss+32+8+8+16             

      real          acsp,wavelength,uthick,uthick_A,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
     &              th_channels,th_sampling, 
     &              strob_order,omega,dumcsp
      common/acstrf/acsp,wavelength,uthick,uthick_A,
     &              unit_chi,aiT_max,v_max,                           ! 6
     &              ak_extension,T_bunch,scale,channels,              ! 10
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,    ! 15
     &              th_channels,th_sampling,                          ! 17
     &              strob_order,omega,dumcsp(icstrf-20)

      real      avsp,counts,background,Pxsi,Peta,Pzeta,
     &          PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,phi_z,
     &          detekt_eff,counts_bunch,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &          PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,phi_z,
     &          detekt_eff,counts_bunch,dumvsp(ivstrf-15)

      integer mscale,nchansp,moschannel,k_extension,
     &        iT_max2,lstruct1,lstruct2,lstruct3,ncloc,
     &        nstorLG,i,k1,k2,m1,m3,jshift
      real    pi,rad,vector_k,cv_ET,schrw
c**************** user defined common block and definitions ******************
      character cmch*4,text(3)*40,ch1*1
c      ichall array contains the non eqidistant channel numbers for integra-
c      tion over the stroboscopic windows (important for computation time)
c*****************************************************************************

      if(cmch.eq.'thna') then
       theoryname='Synchrotron source-double scattering  v=001'
       thfrcase(1)='Nuclear double FG scattering(11)     v=001'
       thfrcase(2)='Nuclear double GF scattering(12)     v=001'
c      index <= 8
       return
      end if 
      if(cmch.eq.'dstr') goto 100       
c*****************************************************************************
      ncloc=ncl
      if(ncloc.gt.132)ncloc=132
c      if(cmch.eq.'plot') then
c        write(6,'(a,a)') ' fr_synmos cmch=',cmch
c      end if
      nchansp=channels
      if(cmch.eq.'arr0') then
c      ++++++++++++++++++++++++ arr0 +++++++++++++++++++++++++++++++++
       ipLG=nuofdatas
c       write(6,'(a,i8)')' frame ipLG=',ipLG
       k_extension=ak_extension
       pi=atan(1.)*4.
       rad=pi/180.
       vector_k=2*pi/wavelength    ! /Angstroem
       cv_ET=100.*wavelength       ! mm/s*ns
       iflag_basis=nint(flag_basis)
       l_Poincare=1
       nsampling=8
 
       iT_max=nint(aiT_max)
        iT_max2=2**iT_max
        schrw=cv_ET/abs(T_bunch*iT_max2)
        i=2*v_max/schrw+1
        moschannel=1
        do while(i.gt.0)
         i=i/2
         moschannel=moschannel*2
        end do

        schrw=schrw*(moschannel-1)/moschannel
        v_max=schrw/2.0*(moschannel-1)

        nTH=moschannel*2**k_extension
        ak8=8*moschannel

        jt0_ch=t0_norm*moschannel/abs(T_bunch)
        ith_channels=moschannel

        if(enwr(6)(1:1).eq.'y') then
         write(nwr,'(a,f10.3,a,i4,/,a,/a,i3)')
     &     'actual used v_max=',v_max,
     &   '  and number of channels of the theory=',moschannel,
     &   '(in order to fulfil the FFT-conditions)',
     &   '  and number of channels for t0_norm=',jt0_ch
        end if

c       write(6,'(a,2f15.5,3i6)')
c     & 'T_bunch,aiT_max,iT_max,iT_max2,nth=',
c     &  T_bunch,aiT_max,iT_max,iT_max2,nth
c        write(6,'(a,4i6)') 'jt0_ch,nTH,nth,moschannel=',
c     &          jt0_ch,nTH,nth,moschannel
        

        if(nTH.gt.2*maxn) then
         info=nTH
         infotext(1)='<Synchrotron-time_differential>/synmos/channels'
         infotext(2)=' number of channels too large'
         infotext(3)=' '
         return
        end if

         nCP=nTH
         nsrw=1
         do while(2*nCP.gt.maxn)
          nCP=nCP/2
          nsrw=nsrw*2
         end do
c        write(6,'(a,3i4)')'frame02 nTH,nCP,nsrw=',nTH,nCP,nsrw

         jshift=abs(t_shift/T_bunch*2.*moschannel)+1
         if(jshift.gt.maxn/4) then
          info=jshift/4
          infotext(1)='<Synchrotron-time_differential>/synmos/timeshift'
          infotext(2)='t_shift channels too large'
          infotext(3)=' '
          return
         end if

c        write(6,'(a,2f10.1)')'ch_angle=',ch_angle
         srw8=schrw/8.
         nLG=(nTH+moschannel)*8

         nTH1=nTH/iT_max2
         if(nTH1.gt.512) nTH1=512
c        nTH2=8*(nCP+1)
         nTH2=16*maxn                             ! storage for POCG
c                                                   and 8*(nCP+1) 
         nstorLG=5+(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves


c      nTH+1 is the out of synmos , nchansp/2 for thyy in syn_the2exp
c      both on array_fr, yth is calculated from nTH+1 -> nchansp/2
c      and linear t_scale with tshift=0

       nstore=0
       ifrsto=ipLG+nstorLG+nTH1+nTH2+nstore+(nchansp+1)/2
c       write(6,'(a,8i8)')
c     & 'fr_synmoss ifrsto,ipLG,nstorLG,nTH1,nTH2,nstore,nchansp=',
c     &             ifrsto,ipLG,nstorLG,nTH1,nTH2,nstore,nchansp

c      the relativ addresses are stored after finishing
c      the entries arr0,i,e
       nstorTH=ipLG+nstorLG
       nstorTH1=nstorTH+nTH1
       nstorTHyy=nstorTH1+nTH2+nstore       ! calculated values (nchansp/2) 
c                                             for each measured point  
       nstorSI=0 
c      nstorSI=nstorTHyy+(nchansp+1)/2          ! the maxsub*(1+maxthss)*2
c                                             are needed for i_int in routine
c                                             select.f of subspectra

c      the relativ addresses are reloaded before entering fr_theoryxx
c      and changed to absolute addresses which are temporarily stored 
c      the 8 integers following c3_prp(maxthss) are considered to be 
c      relative addresses which during reloading are changed to absolute
c      addresses of the complex array  'array_fr(1:marray_sp). 
       je_a=0
       jg_a=0
c      reset of common/sym3j/  in include file comnuc.for
       return

      else if(cmch.eq.'arri')then
c      ++++++++++++++++++++++++++ arri +++++++++++++++++++++++++++++++++
       ifrsto=0
       call l_structure(jss,lstruct1,lstruct2,lstruct3)
c       ifrsto=100+jss
       if(lstruct3.eq.0) then
        if(lstruct2.eq.0) then
c        lstruct1#0 , incoherent sum over mstruct1 members
         if(mstruct1.gt.1) ifrsto=maxn
        else
         if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
          ifrsto=8*(nTH+1)
         end if
        end if
       end if

       return
      else if(cmch.eq.'arre')then
c       +++++++++++++++++++++++++++ arre ++++++++++++++++++++++++++++++++

       ifrsto=0
       return
      end if   ! arr0,i,e 
      mscale=scale

c      write(6,'(a,/,8i8)')
c     &'iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI=',
c     & iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI

c      write(6,'(a,/,6i8,f12.3)')
c     & 'nTH,nTH1,ak8,nLG,nsampling,mscale,srw8=',
c     &                   nTH,nTH1,ak8,nLG,nsampling,mscale,srw8

      m1=mstruct1
      m3=istruct2(istruct1(mstruct1))
c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100)
      mfpt=2*(iarray_sp+nstorFR)  ! measured (function) data
      mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
      mxpt=mfpt+2*nchansp        ! x data (angle) mscale=3
c     write(6,'(a,5i7)')' mfpt,mxptmscale=',mfpt,mxpt,mscale
c*****************************************************************************
c      write(6,'(i4,a,a)') ifrcase,' frame02 entered with=',cmch
      if(cmch.eq.'data') then
       k1=1
      else if(cmch.eq.'ecic') then
       k1=2
      else if(cmch.eq.'test') then
       k1=3
      else if(cmch.eq.'dfdp') then
       k1=4
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=5
      else if(cmch(1:3).eq.'ple') then
       k1=6
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=7
      else if(cmch.eq.'punc')then
       k1=8
      end if
      
      goto (110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
      call syn_plot(cmch)
      mscale=scale 
      if(mscale.lt.1.or.mscale.gt.2) mscale=1
      data_str=formdata(mscale)
      call data2dread(0,info)      
      return
 110  continue
      k1=jss 
      call data2dread(k1,info)      
      return
 120  continue
      call excinc2d(info)      
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer

  200 continue
      k1=1
      call syn_doublethe2exp(k1,info)
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      call syn_doublethe2exp(k1,info)
      return

c****************************************************************************
c     subs, subt
  400 continue
      text(1)='       scatterer'
      text(2)=' incoherent part'
      text(3)='                '
      if(info.eq.-1.and.n_subset.ne.0) return
      if(cmch.eq.'subt') goto 450
      print *,' '
      print *,'      no subspectra calculated '
      print *,' subspectra are not additive in the time domain'
      ch1=' '
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,'          subtraction of subspectra'
      print *,'      has no meaning in the time domain'
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

c              0,1    2d standard plot, 2,3 3d-plot
c              0,2: plot and return;  1,3: interactive plot
       k2=1
       call xmosplo(k1,k2)
       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
      if(cmch.eq.'dmod') then
        call syn_plot(cmch)
      else  ! cmch='plot'
       if(b_theory)then
        k1=3
        call syn_doublethe2exp(k1,info)
       end if
c       write(6,'(a,a4,4i6)')' fr_synmoss cmch,ifrcase,scale=',
c     &                                cmch,ifrcase,int(scale)
        k1=4
        call syn_doublethe2exp(k1,info)
        call syn_plot(cmch)
      end if
      return
c**************************************************************************
c     punch data and theory
 700  continue
      k1=jss 
      call punch2d(k1,info)
      return

      end



c     ################################################################
c               connection between experiment and theory
c               (also called by the fit routine)

      subroutine syn_doublethe2exp(n1,info)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comthe.for'
      include 'comdas.for'
      include 'complt.for'

      integer     info,ifrth,idex,istr,dstr,iaddr,
     &            nstorTH,idum1,nstorTHyy,nTH1
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),nstorTH,idum1,nstorTHyy,iaddr(5),        !13.9.05 
     &              nTH1,ifrth(7),idex(16)

      real          acsp,wavelength,uthick,uthick_A,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick,uthick_A,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-14)

      real          avsp,counts,background,Pdum,t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pdum(6),
     &              t_shift,dumvsp(ivstrf-10)

      logical       b_vs,b_counts,b_background,b_Pdum,
     &              b_t_shift,b_graz_min,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pdum(6),
     &              b_t_shift,b_graz_min,b_dumvsp(ivstrf-11)

      logical b_total,b_residual

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      real      yth
      dimension yth(-maxn:2*maxn)


      real    x_exp,countsy,dx_the,dx_exp,xb_the,xb_exp,
     &        y1,y2,yi,ff,hi
      integer nexp,nthe,iT_max,iT_max2,invers,jshift,
     &        ji,i,k,k1,n1,nn,j,mscale

      common/ascale/x_exp(max8),nexp,xb_exp,dx_exp,nthe,xb_the,dx_the

c      write(6,'(a,5i6)')'syngl n1,ifrcase,scale=',
c     &                         n1,ifrcase,mscale
      ibmisfit=0

      nexp=channels
      nthe=nTH1*2
      dx_the=abs(T_bunch)/nthe
      dx_exp=abs(T_bunch)/channels
      xb_the=t_shift
      xb_exp=0.0
      invers=0
      if(T_bunch.lt.0) invers=nexp+1
      xb_the=t_shift
      jshift=abs(xb_the/dx_the)+1

c     warning** xb_exp is not correct if x-data are read from file
c     it is correct after calling x_scale()
      mscale=1                    ! if no data 
      if(b_data)mscale=scale
      call x_scale(mscale)
c     write(6,'(6f12.4)') (x_exp(i),i=1,nexp,16)
      if(n1.eq.4)goto 310


      countsy=counts-background*channels
c      integral 0-inf is normalized to 1
c      write(6,'(a,4f10.2)') 'syndoubleSC counts,background,channels=',
c     &    counts,background,channels
      iT_max=aiT_max
      iT_max2=2**iT_max  
c     write(6,'(a,i6,f15.5)') 'iT_max2=',2**iT_max
c     write(6,'(8f10.5)') (yth(i)*100.,i=-2,nthe,16)
c     write(6,'(8f12.2)') (yth(i)*countsy,i=1,nTH1)
c     write(6,'(4(a,f10.5),a,i4)') ' ***synchrotron*** backgr=',
c    &         background,' aiT_max=',aiT_max,' dx_the=',dx_the,
c    &         '  t_shift=',t_shift,'  nexp=',nexp
c      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',
c     &             b_total, b_background,b_counts,b_t_shift

      call syn_doubleSC(b_total,info)

      k1=n1
      goto (100,200,300),k1

 100  continue
c     calculation of thfk


      nn=nstorTH*2
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do

c      write(6,'(a,/,2i5,2f10.3,i5,2f10.3)')
c     & 'frame mscale,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the=',
c     &        mscale,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the 
c      write(6,'(6g12.3)') (yth(k),k=1,2*nTH1,16)
c      write(6,'(8f10.5)') (yth(k)*100.,k=1,100)


      ji=abs(invers-1)
      hi=(x_exp(ji)-xb_the)/dx_the
      i=int(hi)
c     write(6,'(a,4i6,f10.3)')'ji,i,nthe,jshift,hi=',ji,i,nthe,jshift,hi

       do k=0,jshift+abs(i)
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1+4)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
c       y2=yth(i-2)+yth(i+2)
c       y1=yth(i-1)+yth(i+1)
c       aa=(2.0*y2-y1-yth(i))/14.0
c       bb=(-2.0*(yth(i-2)-yth(i+2))-yth(i-1)+yth(i+1))/10.0
c       cc=(-3.0*y2+12.0*y1+17*yth(i))/35.0
c       yi=cc+hi*(aa*hi+bb)
       y1=yth(i)
       y2=yth(i+1)
       yi=y1+hi*(y2-y1)
       thfk(j)=yi*countsy+background
      end do


      nn=nstorTHyy*2
      do j=1,nexp
       real_fr(nn+j)=thfk(j)
      end do
c      write(6,'(6g12.2)') (thfk(i),i=1,6)
      b_theory=.true.

      return

 200  continue
      ib_df=0

c     derivatives
c     ib_df=1: derivative calculated
c     ib_df=0 happens if a parameter of a set, wich is not currently 
c     fitted, is free. It will be fixed in the routine fit. 

c     analytical and numerical derivatives are handled fdifferently
c     integer kana (k analytical) = 1 indicates an analytical derivative

c     (the fact that a parameter x can mix up variables type 
c      complicates the situation. An analytical derivative of a variale 
c      can only be calculated, if it is not connected to a different 
c      parameter by the transformation matrix)  

c     variable background, counts are analytically derived 
c     the total number of variables of the set is contained in b_total
c     (for all variables of synchrotron, synrock) and the glabal 
c     variables of this routine: counts,background,t_shift
c     t_shift is numerically derived (enters x_scale by xb_the)

c      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
c     &          PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,
c                phi_z,dumvsp(idumvsp)

      b_total=b_total.or.b_t_shift

      b_residual=.not.(b_total.or.b_counts)
c     all variables unchanged but background

      if(b_background.and.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
      end if
c     for background derivative the last theory values were not neccessary
      nn=nstorTHyy*2
      do j=1,nexp
       thfk(j)=real_fr(nn+j)
      end do
c     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)

      b_residual=.not.(b_total.or.b_background)
c     all variables but counts
      if(b_counts.and.b_residual) then
c       write(6,'(a)')  '   derivative of counts ------------'
        do j=1,nexp
         dfdp(j)=(thfk(j)-background)/countsy
        end do
        kana=1
        ib_df=1
        goto 250
      end if


c     numerical derivatives
      b_residual=.not.(b_total.or.b_background.or.b_counts.or.
     &                b_graz_min)
c     (b_residual=.true.: parameter is connected only to variables 
c     of other sets 
c      write(6,'(a,l5,g15.3)')'fr_synmoss b_resid.,ddpk=',b_residual,ddpk
      if(b_residual) goto 250  

      kana=0
      nn=nstorTH*2
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do
      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if

c      call x_scale(mscale)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       y1=yth(i)
       y2=yth(i+1)
       ff=y1+hi*(y2-y1)
       dfdp(j)=(ff*countsy+background-thfk(j))/ddpk
      end do   ! j=1,nexp
      ib_df=1

 250  continue
      return

 300  continue
c     calculation of thfk

      if(.not.b_theory) goto 310

      nn=nstorTH*2 
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1,8)

      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if
      
      if(ndisplay_mode.gt.1) then
c       call x_scale(mscale)
       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        y1=yth(i)
        y2=yth(i+1)
        yi=y1+hi*(y2-y1)
        thfk(j)=yi*countsy+background
       end do
      else
       do j=1,nthe
        thfk(j)=yth(j)*countsy+background
       end do
      end if
 310  return
      end

c     #################### calculation of theory ########################

      subroutine syn_doubleSC(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for' 

c     ifrcase=1  ! forward scattering geometry
c     ifrcase=2  ! grazing incidence geometry,time differential

      logical     b_total
      integer     info,ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,iduma,nCP,idumb,nsrw,
     &            iflag_basis,l_Poincare,idumc,nTH,ith_channels,idumd,
     &            ak8,jt0_ch,iT_max,idum3
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),   !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,iaddr(6),
     &              iduma,nCP,idumb,nsrw,ifrth(4),                   
     &              iflag_basis,l_Poincare,idumc,nTH,ith_channels,idumd,
     &              ak8,idum3(3),jt0_ch,iT_max,idex(4)

c     &              iflag_basis,l_Poincare,nLG,nTH,ith_channels,nsampling,
c     &              ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,idex(4)

      real          acsp,wavelength,uthick,uthick_A,unit_chi,dumcsp
      common/acstrf/acsp,wavelength,uthick,uthick_A,unit_chi,
     &              dumcsp(icstrf-5)


      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,
     &              dumvsp(ivstrf-12)

      logical       b_avsp,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_PAxsi,b_PAeta,b_PAzeta,b_t_shift,b_graz_angle,
     &              b_phi_z,b_dumvsp
      common/bvstrf/b_avsp,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_PAxsi,b_PAeta,b_PAzeta,b_t_shift,b_graz_angle,
     &              b_phi_z,b_dumvsp(ivstrf-12)

      real            avfr1,pvfr1,dumvfr1
      common/avfr1trf/avfr1,pvfr1,dumvfr1(ivfr1trf-2)
      logical         b_vfr1,b_pvfr1,b_dumvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_dumvfr1(ivfr1trf-2)

      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
       common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(ivfr2trf-5)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(ivfr2trf-5)

      real           vsstrf,sftr
      common/avsstrf/vsstrf(ivsstrf)
      logical        b_vsstrf,b_sftr
      common/bvsstrf/b_vsstrf(ivsstrf)

      logical  b_lay,b_isgt1,b_sites,b_fo
      real      winc,wi,vkd
      dimension winc(maxfr1),wi(maxthss),vkd(maxfr2),
     &          b_sites(maxfr2)

      integer isubthe,nt,inc_pos,
     &        lstruct1,lstruct2,lstruct3,iset,is_a,is_e,
     &        i,ii,j,jj,ij,l,n,nn,jftau,jt0,
     &        k,ll,lay,mlay,layb,laye,isctp,
     &        iposlay,npos,lays,mlays,laysites,laystr

      real pi,rad,grazing,vector_k,h1,h2,sqrt2,
     &     sing,sum,relthick,thicklayer,roughlay

      dimension thicklayer(maxfr2),roughlay(maxfr2),
     &          iposlay(maxfr2),
     &          laystr(2*maxfr2),laysites(maxfr2)


      complex hc,hc1,hci,hc0,app,apm,amp,trace,
     &        satraceh,R_oo,
     &        aam(4,maxfr2),bb(4),cc(4),dd(4),rho(4),Arho(4),
     &        satrexp,Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2),trv(2,2),TSPCA(2,2),sph(2,2)
      complex*16 daa(4),dbb(4),dcc(4)

      integer   mFF,mAL,mcLG,idumscrd
      parameter (mFF=16*maxn,mAL=mFF+8,mcLG=2*maxn,
     &          idumscrd=maxscrd/2-mFF-mAL-2*mcLG-1-2*maxn-1)
      complex   carray,cLG,POC,dumscrd
      real      yth
      common/scrd/POC(mFF),carray(mAL),cLG(-mcLG:mcLG),yth(-1:4*maxn),
     &            dumscrd(idumscrd)

C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MGRP,GEOSTR(0:2*maxfr2)
      logical b_first,b_ew,b_Poincare
C ****                                                       ***     
c       thfrcase(1)='Nuclear double FG scattering(11)     v=001'
c       thfrcase(2)='Nuclear double GF scattering(12)     v=001'
c       write(6,'(a,4i8)')' syndoubleSC ifrcase=',ifrcase
 
       b_ew=.false.
       b_total=.false.
c------------------------------------------------------------------
c      L_poincare =0 is used for theories calling optics
c-------------------------------------------------------------------

      call mapsub(0,0,0)
      isubthe=1
      call get_theory(isubthe,info)
      b_total= b_total.or.(isubthe.gt.0) 

      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

      pi=atan(1.)*4.
      rad=pi/180.
      vector_k=2.0*pi/wavelength    ! /Angstroem

c     fortran notation 
      rho(1)=cmplx(1.+Pzeta,0.)/2.
      rho(3)=cmplx(Pxsi,-Peta)/2.
      rho(2)=cmplx(Pxsi,Peta)/2.
      rho(4)=cmplx(1.-Pzeta,0.)/2.

      Arho(1)=cmplx(1.+PAzeta,0.)/2.
      Arho(3)=cmplx(PAxsi,-PAeta)/2.
      Arho(2)=cmplx(PAxsi,PAeta)/2.
      Arho(4)=cmplx(1.-PAzeta,0.)/2.
c     write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)
c-----------------------------------------------------------
       if(iflag_basis.eq.0) then
c      linear polarization basis
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)

       sph(1,1)=rho(1)
       sph(1,2)=rho(3)
       sph(2,1)=rho(2)
       sph(2,2)=rho(4)
       do i=1,2
       do k=1,2
        hc=(0.,0.)
        do j=1,2
        do l=1,2
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
        end do
        end do
        trv(i,k)=hc
       end do
       end do
       rho(1)=trv(1,1)
       rho(3)=trv(1,2)
       rho(2)=trv(2,1)
       rho(4)=trv(2,2)

       sph(1,1)=Arho(1)
       sph(1,2)=Arho(3)
       sph(2,1)=Arho(2)
       sph(2,2)=Arho(4)
       do i=1,2
       do k=1,2
        hc=(0.,0.)
        do j=1,2
        do l=1,2
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
        end do
        end do
        trv(i,k)=hc
       end do
       end do
       Arho(1)=trv(1,1)
       Arho(3)=trv(1,2)
       Arho(2)=trv(2,1)
       Arho(4)=trv(2,2)
       end if
c-----------------------------------------------------------

      lstruct1=0
 1000 continue
      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2500

      if(ifrcase.eq.11) b_Poincare=lstruct1.eq.1
      if(ifrcase.eq.12) b_Poincare=lstruct1.eq.2
      l_Poincare=0
      relthick=uthick_A
      if(b_Poincare)then
       l_Poincare=1
       relthick=uthick
      end if
      call mapsub(lstruct1,0,0)

c      b_fo change of external field and scatterer orientation
       b_fo=.false.
       do i=1,6
        b_fo=b_fo.or.b_dumvfr1(i)
       end do

      winc(lstruct1)=pvfr1
      b_total=b_total.or.b_pvfr1.or.b_fo
c      write(6,'(a,i1,a2,i8,L5)')
c     &       'synmos l1_put(',lstruct1,')=',l1_put(lstruct1),b_pvfr1  
      inc_pos=l1_put(lstruct1)

c      write(6,'(a,i4,a,g12.4)')' synmos case=',ifrcase,
c     &     ' graz_angle=',graz_angle
      if(b_Poincare) then
       grazing=0.001*graz_angle
       sing=sin(grazing)
      end if

       layb=istruct1(lstruct1-1)
       laye=istruct1(lstruct1)
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nTH------------0------------nTH                    srw
        lay=lstruct2-layb

        call mapsub(lstruct1,lstruct2,0)
c        write(6,'(a,3g12.4)')' synmos r,i_chi,unit_chi=',
c     &        re_chilay,ai_chilay,unit_chi

c        external field and scatterer orientation written on fr2
c        th_22nuclear routines take the field from common/avfr2trf
         do i=1,6
          dumvfr2(1+i)=dumvfr1(i)
         end do

         b_lay=b_vfr2.or.b_fo
         b_total=b_total.or.b_lay       
        if(b_Poincare) then
         thicklayer(lay)=1.
        else
         thicklayer(lay)=thicklay
         if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
          chilay(lay)=cmplx(re_chilay,ai_chilay)*unit_chi
         else
          chilay(lay)=(0.,0.)
         end if
         i=rep_grp
         laystr(2*lay-1)=i
         laystr(2*lay)=10*(rep_grp-float(i)+.01)
         roughlay(lay)=roughness
        end if

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
         b_isgt1=.true.
         iposlay(lay)=l2_put(lstruct2)
         do i=1,8*(nTH+1)
          carray(i)=(0.,0.)
         end do
        end if
        b_sites(lay)=.false.

        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

         iset=lstruct3
         b_sites(lay)=.true.

         call mapsub(lstruct1,lstruct2,lstruct3)

         sftr=vsstrf(2)
         b_sftr= b_vsstrf(2)
         wi(iset)=sftr*relthick
c         write(6,'(i3,2x,a,i4,3g10.3)')lstruct1,
c     &    'synmos lay,wi,sftr,winc=',lay,wi(iset),sftr,winc(lstruct1)


         if(.not.b_Poincare) then
          if(b_sftr) then
           if(wi(iset).gt.sing/20..or.sing.gt.0.05)
     &      write(nwr,'(2(a,g8.1),a)')
     &     '** f*unit_thickness=',wi(iset),' << sin(th)=',sing,' << 1 ?'
          end if
         end if
         isubthe=0
         call get_theory(isubthe,info)
         b_lay=b_lay.or.b_sftr.or.(isubthe.gt.0)
         b_total=b_total.or.b_lay

c         write(6,'(8f12.4)')array_fr(l3_get(lstruct3)+1)*1.e4,
c     &                      array_fr(l3_get(lstruct3)+9)*1.e4

         if(b_isgt1) then
          isctp=l3_get(lstruct3)
          do n=0,nTH
           nn=isctp+8*n
           ll=8*n
            do k=1,8
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(iset)
            end do
          end do
c        write(6,'(a)') 'synmoss carray(1..)='
c        write(6,'(8f12.4)') (carray(i)*1000,i=1,8)
         else
          iposlay(lay)=l3_get(lstruct3)
c           write(6,'(a,i2,a2,i8)')
c     &       'synmos  iposlay(',lay,')=',iposlay(lay)
         end if
        end do

        if(b_isgt1.and.b_lay) then
         ll=iposlay(lay)
         do i=1,8*(nTH+1)
          array_fr(ll+i)=carray(i)
         end do
c         write(6,'(a,2i6)') 'synmoss carray(1..)  nn=',nn
c         write(6,'(8f12.4)') (carray(i)*1000,i=1,40)
        end if

       end do
       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0

c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sap(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)

c      write(6,'(a,20i3)')'synmos laystr(1..mlay)=',(laystr(i),i=1,mlay)
      if(.not.b_total) goto 2000

      do k=1,mlay
       laysites(k)=0
      end do
      if(b_Poincare) then
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
        if(b_sites(lay)) then
         mlays=mlays+1
         iposlay(mlays)=iposlay(lay)
         if(is_e.gt.is_a) thicklayer(mlays)=thicklayer(lay)
         if(is_e.eq.is_a)
     &           thicklayer(mlays)=thicklayer(lay)*wi(is_a)
c        write(6,'(i2,a,i4,2f10.3)')lstruct1,
c    &   'synmos lay,wi(is_a),thicklayer',lay,wi(is_a),thicklayer(lay)
        end if
       end do
      else
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
c        write(6,'(i2,a,2i2,f10.3)')lstruct1,' is_a,is_e=',
c     &                                       is_a,is_e,wi(is_a)
        vkd(lay)=vector_k*thicklayer(lay)
        if(is_e.lt.is_a) then
         thicklayer(lay)=0.
        else
         if(is_e.gt.is_a) thicklayer(lay)=1./vector_k
         if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k
        end if
       end do
      end if

c      do lstruct2=layb+1,laye
c       lay=lstruct2-layb
c       write(6,'(i4,2x,L3,a,2g12.4,a,g12.4,a,g12.4)')
c     & lay,b_sites(lay),' chilay=',chilay(lay)/unit_chi,
c     & ' vkd=',vkd(lay),' thicklayer=',thicklayer(lay)
c       end do


      if(.not.b_Poincare) then
C     *********************************************************************
C     We reconstruct the layer strucrure from the laystr variabale. 
c     ELEMENT(GRP) is the number of layers in group GRP.
C     *** L. Deak, 09.10.2002 *** 
       GRP         =0
       GEOSTR(GRP) =0
       MGRP      =0
C
       b_first     =.true.
       POINTER=1
       do lay=2,2*mlay,2
        if(b_first)then
         if(GRP.eq.laystr(lay))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(lay-1)
         end if
C
         if(vkd(lay/2).lt.0.) then
          b_first         =.false.
          vkd(lay/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ***********************************************************************
       do lay=1,mlay
        if(b_sites(lay)) then
         Cmatrix(1,1,lay)= hc0 
         Cmatrix(2,2,lay)= hc0
         Cmatrix(1,2,lay)= hc0
         Cmatrix(2,1,lay)= hc0
        end if
       end do

       call optic(b_ew,mlay,b_sites,MGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
       R_oo=Rmatrix(1,1)
      endif

c      write(6,'(a,i6)')' iposlay(1)=',iposlay(1) 

      do n=-nTH,nTH-1

c      construction of the input for general optics program
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
        npos=8*abs(n)
        if(n.lt.0)npos=npos+4

         if(b_Poincare) then
           satraceh=cmplx(0.,0.)
           do lays=1,mlays
            nn=iposlay(lays)+npos
            satraceh=satraceh+array_fr(nn+1)*thicklayer(lays)
            app=array_fr(nn+2)*thicklayer(lays)
            apm=array_fr(nn+3)*thicklayer(lays)
            amp=array_fr(nn+4)*thicklayer(lays)
            call expo_22(app,apm,amp,dd)
            do k=1,4
             aam(k,lays)=dd(k)
            end do
           end do   ! lays=1,mlays
c          if(abs(n).lt.1) write(6,'(i3,2i6,6g12.4)') 
c     &        lstruct1,n,nn,array_fr(nn+1),array_fr(nn+2),thicklayer(1)
           satrexp=exp(satraceh*hci)
c          if(abs(n).lt.5) write(6,'(i6,6g12.4)') n,satrexp,app

c          multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c          laystr(rep,grp,rep,grp,.....)

           if(mlays.gt.1) then
            do k=1,4
             dcc(k)=dble(aam(k,mlays))
            end do

            do lays=mlays-1,1,-1
             do k=1,4
              daa(k)=dcc(k)
              dbb(k)=dble(aam(k,lay))
             end do
             call matproD(daa,dbb,dcc)
            end do
            do k=1,4
             dd(k)=dcc(k)
            end do
           end if

c          conversion from dd to rho
c           Trace= 0.5*real(dd(1)+dd(4))-1.
c           Pxsi =   real(dd(2))
c           Peta = aimag(dd(2))
c           Pzeta= 0.5*real(dd(1)-dd(4))

C           rho(1)=cmplx(1.+Pzeta,0.)
C           rho(3)=cmplx(Pxsi,-Peta)
C           rho(2)=cmplx(Pxsi,Peta)
C           rho(4)=cmplx(1.-Pzeta,0.)             
              

           ii=(nTH+n)*4+nstorTH1

           array_fr(ii+1)=dd(1)*satrexp
           array_fr(ii+2)=dd(2)*satrexp
           array_fr(ii+3)=dd(3)*satrexp
           array_fr(ii+4)=dd(4)*satrexp
         else   ! b_Poincare
           do lay=1,mlay
            if(b_sites(lay)) then
             nn=iposlay(lay)+npos
c            effi to Fortran notation
             Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
             Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
             Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
             Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
            end if
           end do   ! lay=1,mlay          

           call optic(b_ew,mlay,b_sites,MGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)

c          Fortran notation          
           nn=(nTH+n)*4
           POC(nn+1)=Rmatrix(1,1)-R_oo
           POC(nn+3)=Rmatrix(1,2)
           POC(nn+2)=Rmatrix(2,1)
           POC(nn+4)=Rmatrix(2,2)-R_oo
         end if ! reflection (b_Poincare=0)
        end do     ! n=-nTH,nTH


 2000   continue
        if(mstruct1.gt.1) goto 1000


 2500   continue
c        product of the F and G matrices
c        Fortran  ( 1 3 )     convention
c               ( 2 4 )
c        c=a*b
c        c(1)=a(1)*b(1)+a(3)*b(2)
c        c(3)=a(1)*b(3)+a(3)*b(4)
c        c(2)=a(2)*b(1)+a(4)*b(2)
c        c(4)=a(2)*b(3)+a(4)*b(4)

         if(ifrcase.eq.11)then
c          fG case
          do n=-nTH,nTH-1
           nn=(nTH+n)*4
           ii=nn+nstorTH1
           dd(1)=array_fr(ii+1)*POC(nn+1)+array_fr(ii+3)*POC(nn+2)         
           dd(2)=array_fr(ii+1)*POC(nn+3)+array_fr(ii+3)*POC(nn+4)         
           dd(3)=array_fr(ii+2)*POC(nn+1)+array_fr(ii+4)*POC(nn+2)         
           dd(4)=array_fr(ii+2)*POC(nn+3)+array_fr(ii+4)*POC(nn+4)         
           POC(nn+1)=dd(1)
           POC(nn+2)=dd(2)
           POC(nn+3)=dd(2)
           POC(nn+4)=dd(4)
          end do 
         else if(ifrcase.eq.12)then
          do N=-nTH,nTH-1
           nn=(nTH+n)*4
           ii=nn+nstorTH1
           dd(1)=POC(nn+1)*array_fr(ii+1)+POC(nn+3)*array_fr(ii+2)         
           dd(2)=POC(nn+1)*array_fr(ii+3)+POC(nn+3)*array_fr(ii+4)         
           dd(3)=POC(nn+2)*array_fr(ii+1)+POC(nn+4)*array_fr(ii+2)         
           dd(4)=POC(nn+2)*array_fr(ii+3)+POC(nn+4)*array_fr(ii+4)     
           POC(nn+1)=dd(1)
           POC(nn+2)=dd(2)
           POC(nn+3)=dd(2)
           POC(nn+4)=dd(4)
          end do
         end if

        i=nstorTH1+nCP*4
        jj=4*nTH
        do n=-nCP,nCP-1
         j=4*n
         nn=jj+j*nsrw
         ii=i+j
c        array_fr(...) Fortran Notation
         array_fr(ii+1)=POC(nn+1)
         array_fr(ii+2)=POC(nn+2)
         array_fr(ii+3)=POC(nn+3)
         array_fr(ii+4)=POC(nn+4)
        end do


        nn=2*nTH
        call fourier4r(nn)

        do n=1,nTH
c        trace (dd+*dd*rho) is the intensity
c        bb=cc+
          jj=4*(n-1)
          do i=1,4
           dd(i)=POC(jj+i)
          end do
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))

         call tracematpro4(Arho,dd,rho,bb,trace)
         h1=real(trace)
          jj=4*(nTH+n-1)
          do i=1,4
           dd(i)=POC(jj+i)
          end do
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))

         call tracematpro4(Arho,dd,rho,bb,trace)
         h2=real(trace)
         yth(n)=h1
         yth(n+nTH)=h2
c         write(8,'(i6,4g12.4)')n,h1,h2
        end do ! n
        yth(0)=yth(1)

c     normalization
      nt=2*nTH
      jt0=2*jt0_ch
      sum=0.
      do j=jt0+1,nt-1,2
       sum=sum+yth(j)*4
      end do
      do j=jt0+2,nt-2,2
       sum=sum+yth(j)*2
      end do
      sum=sum+yth(jt0)+yth(nt)
      sum=sum/6.0/ith_channels*(nt-jt0)/2.

c      write(6,'(a,2i6,f15.5)') ' synmos jt0_ch,nTH,sum=',
c     &                                  jt0_ch,nTH,sum
      if(sum.eq.0.0) sum=1.0
      jftau=0
      nn=nstorTH*2
c      write(6,'(a,2i8)')'synmos iT_max,nstorTH=',iT_max,nstorTH
      if(iT_max.gt.0) then
        nt=nTH*2
        do k=1,iT_max
         nt=nt/2
         do j=1,nt
          yth(j)=yth(j)+yth(j+nt)
         end do
        end do
        jftau=nt/1024
c        write(6,'(a,3i6)') '1 synmos nth,nTH,jftau=',
c     &             nth,nTH,jftau
        if(jftau.gt.1) then
         sum=sum/jftau
         nt=nt/2
         do i=1,nt
          ij=i*jftau
          real_fr(nn+i)=yth(ij)/sum
         end do
        else
         jftau=1
         ii=nt/2
         sum=sum*512/ii
         do i=1,nt
          real_fr(nn+i)=yth(i)/sum
         end do
        end if

      else
        jftau=nTH/512
c        write(6,'(a,2i6,f15.5)') '2 synmos nTH,jf=',nTH,jftau,sum
        if(jftau.gt.1) then
         sum=sum/jftau
         do i=1,nTH/2
          ij=i*jftau
          real_fr(nn+i)=yth(ij)/sum
         end do

        else
         sum=sum*512/nTH
         do i=1,nTH*2 
          real_fr(nn+i)=yth(i)/sum
         end do
        end if
      end if

      return
      end

