c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              last version April 200

      subroutine fr_synchrotron(cmch,jss,info)
c     synchrotron
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'
      include 'comdas.for'

      integer    jss,info,
     &           ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &           l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &           nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,nTH2,nsrw,
     &           nstore,iflag_basis,l_Poincare,nLG,ipLG,nTH,
     &           ith_channels,nsampling,ak8,nomega,nstrob_order,jt0_ch,
     &           iT_max,nvch,nhyperfine
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              ipLG,iaddr(3),nTH1,nCP,nTH2,nsrw,nstore,ifrth(3),           
     &              iflag_basis,l_Poincare,nLG,nTH,ith_channels,
     &              nsampling,ak8,nomega,srw8,nstrob_order,jt0_ch,
     &              iT_max,nvch,nhyperfine,idex(2)
c      1+4*maxfr1+4+4*maxfr2+1+3*maxthss+32+8+8+16             

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
     &              th_channels,th_sampling, 
     &              strob_order,omega,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,                           ! 5
     &              ak_extension,T_bunch,scale,channels,              ! 9
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,    ! 14
     &              th_channels,th_sampling,                          ! 16
     &              strob_order,omega,dumcsp(icstrf-19)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,
     &              phi_z,detekt_eff,counts_bunch,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,
     &              phi_z,detekt_eff,counts_bunch,dumvsp(ivstrf-15)

      integer      mscale,nchansp,moschannel,k_extension,
     &             iT_max2,lstruct1,lstruct2,lstruct3,ncloc,
     &             nstorLG,nstorint,i,j,isub,k,k1,k2,m1,m3,jshift
      real         pi,rad,vector_k,cv_ET,schrw
c**************** user defined common block and definitions ******************
      character    cmch*4,text(3)*40,ch1*1,ch132*132,
     &             cp132*132
c      used for subroutine channelnumberall(nvch,nhyperfine,nstrob_order,
c                                 nomega,iall) , thfrcase(6)
c      ichall array contains the non eqidistant channel numbers for integra-
c      tion over the stroboscopic windows (important for computation time)
       integer     iall,ichall,idumscrd
       common/scrd/ichall(0:maxn*2),idumscrd(maxscrd-1-2*maxn)
       integer     nstrob,n_omega,n_theta,n_angpairs,n5_offspec,icase
       dimension   n5_offspec(5)
c*****************************************************************************

      if(cmch.eq.'thna') then
       theoryname='Synchrotron source       v=100'
       thfrcase(1)='time differential transmission spectrum(11) v=100'
       thfrcase(2)='time differential reflection spectrum(21)   v=100'
       thfrcase(3)='time integral - rocking curve-Fourier(22)   v=100'
       thfrcase(4)='time integral - rocking curve(24)           v=100'
       thfrcase(5)='time integral - rocking curve_fi(25)        v=100'
       thfrcase(6)='prompt - rocking curve(23)                  v=100'
       thfrcase(7)='time integral - offspecular(31)             v=001'
       thfrcase(8)=' '
c      index <= 8
       return
      end if 
c*****************************************************************************
      ncloc=ncl
      if(ncloc.gt.132)ncloc=132
c      if(cmch.eq.'plot') then
c        write(6,'(a,a)') ' fr_synmos cmch=',cmch
c      end if
      nchansp=channels
      if(cmch.eq.'arr0') then
c      ++++++++++++++++++++++++ arr0 +++++++++++++++++++++++++++++++++
       ipLG=nuofdatas
c       write(6,'(a,i8)')' frame ipLG=',ipLG
       k_extension=ak_extension
       pi=atan(1.)*4.
       rad=pi/180.
       vector_k=2*pi/wavelength    ! /Angstroem
       cv_ET=100.*wavelength       ! mm/s*ns
       iflag_basis=nint(flag_basis)
       l_Poincare=0
       if(ifrcase.eq.11) l_Poincare=1
      
       if(ifrcase.le.22) then
c       time integral - rocking curve-Fourier -------------------
        nsampling=8
 
        iT_max=nint(aiT_max)
         iT_max2=2**iT_max
         schrw=cv_ET/abs(T_bunch*iT_max2)
         i=2*v_max/schrw+1
         moschannel=1
         do while(i.gt.0)
          i=i/2
          moschannel=moschannel*2
         end do

         schrw=schrw*(moschannel-1)/moschannel
         v_max=schrw/2.0*(moschannel-1)

         nTH=moschannel*2**k_extension
         ak8=8*moschannel

         jt0_ch=t0_norm*moschannel/abs(T_bunch)
         ith_channels=moschannel

         if(enwr(6)(1:1).eq.'y') then
          write(nwr,'(a,f10.3,a,i4,/,a,/a,i3)')
     &      'actual used v_max=',v_max,
     &    '  and number of channels of the theory=',moschannel,
     &    '(in order to fulfil the FFT-conditions)',
     &    '  and number of channels for t0_norm=',jt0_ch
         end if

c        write(6,'(a,2f15.5,3i6)')
c     &  'T_bunch,aiT_max,iT_max,iT_max2,nth=',
c     &   T_bunch,aiT_max,iT_max,iT_max2,nth
c         write(6,'(a,4i6)') 'jt0_ch,nTH,nth,moschannel=',
c     &           jt0_ch,nTH,nth,moschannel
         

         if(nTH.gt.4*maxn) then
          info=nTH
          if(ifrcase.eq.22) then
           infotext(1)='<Synchrotron-time_integral>/synmos/channels'
          else
           infotext(1)='<Synchrotron-time_differential>/synmos/channels'
          end if
          infotext(2)=' number of channels too large'
          infotext(3)=' '
          return
         end if

         nCP=0
         if(ifrcase.eq.11.or.ifrcase.eq.21) then
          nCP=nTH
          nsrw=1
          do while(2*nCP.gt.maxn)
           nCP=nCP/2
           nsrw=nsrw*2
          end do
         end if
c         write(6,'(a,3i4)')'frame02 nTH,nCP,nsrw=',nTH,nCP,nsrw

         jshift=abs(t_shift/T_bunch*2.*moschannel)+1
         if(jshift.gt.maxn/4) then
          info=jshift/4
          if(ifrcase.eq.22) then
           infotext(1)='<Synchrotron-time_integral>/synmos/timeshift'
          else
          infotext(1)='<Synchrotron-time_differential>/synmos/timeshift'
          end if
          infotext(2)='t_shift channels too large'
          infotext(3)=' '
          return
         end if

c        write(6,'(a,2f10.1)')'ch_angle=',ch_angle
         srw8=schrw/8.
         nLG=(nTH+moschannel)*8

         if(ifrcase.lt.22) then
          nTH1=nTH/iT_max2
          if(nTH1.gt.512) nTH1=512
          nTH2=8*(nCP+1)
         end if
         if(ifrcase.eq.22) then
          nTH1=int(ch_angle/4.)*2
          nTH2=int(ch_angle/4.)*2
         end if
         nstorLG=5+(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves
       else if(ifrcase.eq.23) then
c       ifrcase=23 prompt  ------------------------------------------
         nsampling=8
         nCP=0
         nTH=0
         srw8=0.
         nstorLG=0
         nTH1=int(ch_angle/4.)*2
         nTH2=16+int(ch_angle/4.)*2
         nstore=0
       else if(ifrcase.eq.24) then
c       time integral - rocking curve--------------------------------

         nstrob_order=strob_order      ! obtained from subtheory
c                                        called on level 0
c        vector_k=2*pi/wavelength    ! /Angstroem
c        cv_ET=100.*wavelength       ! mm/s*ns
         l_Poincare=0
         nsampling=2**th_sampling

         schrw=v_max/th_channels
         nomega=cv_ET/T_bunch/schrw
         i=nomega/2
         nomega=2*i
         schrw= cv_ET/T_bunch/float(nomega)

         ith_channels=nint(th_channels)
         nTH=ith_channels+nomega*nstrob_order
         ak8=8*nTH
         nTH=nTH*8/nsampling
         
         if(enwr(6)(1:1).eq.'y') then
          write(nwr,'(a,f10.2,2(a,i5))')
     &      ' v_max=',v_max,' nomega=',nomega,
     &    '  and number of channels of the theory=',nTH
         end if
         if(nTH.gt.2*maxn) then
          info=nTH
          infotext(1)='<Synchrotron-time_integral>/synmos//channels'
          infotext(2)=' number of theory channels too large'
          infotext(3)=' '
          return
         end if

         nCP=0
         srw8=schrw/8
         nLG=(2*ith_channels+nomega*nstrob_order)*8

         nTH1=int(ch_angle/4.)*2
         nTH2=int(ch_angle/4.)*2
         nstore=0
         nstorLG=5+(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves
       else if(ifrcase.eq.25.or.ifrcase.eq.31) then
c        time integral - rocking curve_fi ----------------------------
c                                              called on level 0
        if(ifrcase.eq.25)then 
         nstrob_order=strob_order      ! obtained from subtheory
        end if            
        if(ifrcase.eq.31) then
c        time integral - offspecular ---------------------------------

c        for the theory  "time integral - offspecular" the common block
c        common/acstrf/ is rearranged (see subroutine thstr_synoffspec in 
c        thstr_synmos.f) Some constants are different 
c        according to the definition of the common block in thstr_synoffspec:         

c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
c     &              th_channels,th_sampling,
c     &              strob_order,omega,dumcsp(icstrf-19)
c        is replaced by 
c     &              n_TH,T_bunch,scale,channels,                          9
c     &              columns,strob_order,t1_window,t2_window,flag_basis,   14
c     &              nhyperfine,n_angpairs,                                16
c     &              DWBA,omega                                            18
c        We get the numbers for the calculation of reservation of storage 
         nstrob_order=graz_beg
         n_omega=omega
         n_angpairs=th_sampling
         n_theta=dumcsp(3)
        end if

c       vector_k=2*pi/wavelength    ! /Angstroem
c       cv_ET=100.*wavelength       ! mm/s*ns
        l_Poincare=0
c       v_max is the velocity according to the hyperfine energies 
c       for 57Fe H_field=33T ca. 8mm/s
        nhyperfine=th_channels
c       th_channels is the number of channels for v_max. The channel
c       width schrw=v_max/th_channel should not exceed 2*gamma,
c       gamma is the natural line width (0.097mm/s for 57Fe)
        nTH=ak_extension            ! nch_TH
c       storage for the Cmatrices of each site 
        k1=0

        if(nTH.gt.4*maxn) nTH=4*maxn
        j=maxn/(1.+float(nstrob_order)*cv_ET/T_bunch/v_max/2.)
        if(nhyperfine.gt.j)nhyperfine=j

        schrw=v_max/float(nhyperfine)
        nomega=cv_ET/T_bunch/schrw
        i=nomega/2
        nomega=2*i

        j=nstrob_order*nomega+nhyperfine
        if(j.ge.nTH)nTH=j+2

        j=(nTH-nstrob_order*nomega-nhyperfine)*2

        
        i=(sqrt(float(4*j+1))-1.)/2.
c        write(6,'(a,8i5)')'#nvch,nhyperfine=',i,nhyperfine,nTH
        if(i.gt.1) then
         j=nTH-nstrob_order*nomega-nhyperfine-i*(i+1)/2
         do while(j.lt.0.or.i.gt.95)
          i=i-1
          j=nTH-nstrob_order*nomega+nhyperfine-i*(i+1)/2
c          write(6,'(a,6i6)') ' i,j=',i,j,nomega,
c     &            nTH-nstrob_order*nomega-nhyperfine
         end do
         if(i.le.95.and.j.gt.0) then
          nvch=i
          goto 10
         end if 
        end if

 10     schrw=v_max/float(nhyperfine)
        nomega=cv_ET/T_bunch/schrw
        i=nomega/2
        nomega=2*i
        schrw= cv_ET/T_bunch/float(nomega)
        
c       nvch are the number of channels with increasing stepwidth
c       .. .  .   .    .     .      .       .       . (=nvch=10)
        if(nvch.gt.95) nvch=95
        call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                         iall)
c        write(6,'(8i4)')(ichall(j),j=1,iall)
        j=nhyperfine+nvch+nstrob_order*nomega/2
c        write(6,'(a,15i5)')'nvch,nhyperfine,nstrob_order,nomega,iall=',
c     &  nvch,nhyperfine,nstrob_order,nomega,iall,ichall(iall),j,nth

        if(iall.lt.0.or.j.gt.maxn) then
         nhyperfine=nhyperfine-2
         if(nhyperfine.lt.32)then 
          nstrob_order=nstrob_order-1
          nhyperfine=nhyperfine+2
          k1=k1+1
         end if 
         goto 10
        end if

        j=ichall(iall)
        if(j.gt.nTH.or.j.gt.4*maxn)then
         nvch=nvch-2
c         write(6,'(a,5i6)') ' nTH,nvch,iall=',j,nTH,nvch,iall
         k1=k1+1         
         goto 10
        end if

        if(k1.eq.0) then
         k1=k1-1
         goto 10
        end if
        nTH=ichall(iall)
c        nTH=494
c        schrw=0.1402
        ith_channels=nhyperfine
        srw8=schrw
        nsampling=1
c       nhyperfine,nstrob_order,nomega,nvch,nTH determine iall,ichall
c       iall is limited by maxn -> -maxn:maxn are the size of arrays
c       these values are transported by common/struct/ 
c      &             iflag_basis,l_Poincare,nLG,nTH,ith_channels,nsampling,
c      &             ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,nvch,
c      &             idex(3)

        if(n_angpairs.eq.0) then
        write(nwr,'(a,/,a,i5,2(a,f8.3),/,2(a,i5),/,3(a,i5),a2,i4,/,2a)')
     &   'at least one of the constants have been altered:',
     &   ' nch_hypf    =',nhyperfine,'    v_nTH  =',nTH*schrw,
     &   '     dv =',schrw,
     &   ' nstrob_order=',nstrob_order,'    n_omega=',nomega,
     &   ' ch_TH       =',nTH,'    ch_used=',iall,'  ch_intr. =',
     &    nhyperfine+nvch,' /',nhyperfine+nvch+nstrob_order*nomega/2,
     &   'these values are compatible with each other',
     &   ' and all array sizes'
        end if
        

c       -channel by chanel integration--------------
c       nvch=0 
c       iall=nTH
c       do i=0,iall
c        ichall(i)=i
c       end do
c       -remove c also in th_synoffspecular---------

       if(ifrcase.eq.25) then
         nstore=0
         nstorLG=0         ! case=2 (no sampling)-routine is called
c                          only true if flag_SAMP=0
         nTH1=int(ch_angle/4.)*2
         nTH2=int(ch_angle/4.)*2
       else if(ifrcase.eq.31) then
c      -------------------- remove c also in th_synoffspecular---------
        k1=(nhyperfine+nvch)*2                   ! used in Gamma_mju()
        nstore=0                                 ! storage of trace() for 
        DO nstrob=0,nstrob_order                 ! nstrob_order loop
         nstore=nstore+(k1+nstrob*nomega)/2+1
        end do

c       write(6,'(a,10f10.2)')'dumcsp=',strob_order,(dumcsp(i),i=1,5)

        nstorLG=0          ! case=2 (no sampling)-routine is called
        nTH1=0             ! storage of offspec at l1_get(0)+6
c       calculated in  th_scanmode(), here only to preserve shape of ifrsto
        nTH2=4*(iall+1)*2*maxfr2/2        ! storage of Fourier average
c                                           double 2x2 <= maxfr2/2
       end if
      end if    ! ifrcase

c      nTH+1 is the out of synmos , nchansp/2 for thyy in syn_the2exp
c      both on array_fr, yth is calculated from nTH+1 -> nchansp/2
c      and linear t_scale with tshift=0


       ifrsto=ipLG+nstorLG+nTH1+nTH2+nstore+(nchansp+1)/2+
     &                                       maxsub*(1+maxthss)
c       write(6,'(a,8i8)')
c     & 'fr_synmoss ifrsto,ipLG,nstorLG,nTH1,nTH2,nstore,nchansp=',
c     &             ifrsto,ipLG,nstorLG,nTH1,nTH2,nstore,nchansp

c      the relativ addresses are stored after finishing
c      the entries arr0,i,e
       nstorTH=ipLG+nstorLG
       nstorTH1=nstorTH+nTH1
       nstorTHyy=nstorTH1+nTH2+nstore       ! calculated values (nchansp/2) 
c                                             for each measured point  
       nstorSI=nstorTHyy+(nchansp+1)/2          ! the maxsub*(1+maxthss)*2
c                                             are needed for i_int in routine
c                                             select.f of subspectra

c      the relativ addresses are reloaded before entering fr_theoryxx
c      and changed to absolute addresses which are temporarily stored 
c      the 8 integers following c3_prp(maxthss) are considered to be 
c      relative addresses which during reloading are changed to absolute
c      addresses of the complex array  'array_fr(1:marray_sp). 
       je_a=0
       jg_a=0
c      reset of common/sym3j/  in include file comnuc.for
       return

      else if(cmch.eq.'arri')then
c      ++++++++++++++++++++++++++ arri +++++++++++++++++++++++++++++++++
       ifrsto=0
       call l_structure(jss,lstruct1,lstruct2,lstruct3)
c       ifrsto=100+jss
       if(lstruct3.eq.0) then
        if(lstruct2.eq.0) then
c        lstruct1#0 , incoherent sum over mstruct1 members
         if(mstruct1.gt.1) ifrsto=maxn
        else
         if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
          ifrsto=8*(nTH+1)
         end if
        end if
       end if

       return
      else if(cmch.eq.'arre')then
c       +++++++++++++++++++++++++++ arre ++++++++++++++++++++++++++++++++

       ifrsto=0
       return
      end if   ! arr0,i,e 

c      write(6,'(a,/,8i8)')
c     &'iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI=',
c     & iarray_sp,nstorFR,l1_put(0),nstorTH,nstorTH1,nstorTHyy,nstorSI

c      write(6,'(a,/,6i8,f12.3)')
c     & 'nTH,nTH1,ak8,nLG,nsampling,mscale,srw8=',
c     &                   nTH,nTH1,ak8,nLG,nsampling,mscale,srw8

c     initializing the array_fr section for nstorint (see subspectra)
c     (intensity of all subsets are 0)

      if(.not.b_theory) then
c      absolute address of nstorSI is known here
       nstorint=maxsub*(1+maxthss)
       do k=1,nstorint
        array_fr(nstorSI+k)=(0.,0.)
       end do
      end if

      n5_offspec(1)=l1_get(0)
      n5_offspec(2)=channels
      n5_offspec(3)=th_sampling
      n5_offspec(4)=counts
      n5_offspec(5)=background

c     pointer
      
c      write(6,'(a,L5,5i7)')' b_data mscale=',b_data,mscale
      m1=mstruct1
      m3=istruct2(istruct1(mstruct1))
c      storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f) 
c      corresponds to the i= drive_mode (label 100)
      mfpt=2*(iarray_sp+nstorFR)  ! measured (function) data
      if(ifrcase.eq.31) then
       mdfpt=mfpt+nchansp         ! errors of f data (calculated by sqrt) 
       mxpt=mfpt+2*nchansp        ! x data (angle) 
       mypt=mfpt+3*nchansp        ! y data (angle)
       mgpt=mfpt+4*nchansp        ! address for x group of angle 
      else  
       mdfpt=mfpt+nchansp         ! errors of y data (calculated by sqrt 
       mxpt=mfpt+2*nchansp        ! x data (angle) mscale=3
      end if
      mscale=scale 
      if(mscale.lt.1.or.mscale.gt.2) mscale=1

c      write(6,'(a,5i7)')' mfpt,mxptmscale=',mfpt,mxpt,mscale
c*****************************************************************************
c      write(6,'(i4,a,a)') ifrcase,' frame02 entered with=',cmch
      if(cmch.eq.'dstr') then
       k1=1
      else if(cmch.eq.'data') then
       k1=2
      else if(cmch.eq.'ecic') then
       k1=3
      else if(cmch.eq.'test') then
       k1=4
      else if(cmch.eq.'dfdp') then
       k1=5
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=6
      else if(cmch(1:3).eq.'ple') then
       k1=7
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=8
      else if(cmch.eq.'punc')then
       k1=9
      end if
      
      goto (100,110,120,200,300,400,500,600,700),k1
c**********************************************************************
 100  continue
      if(ifrcase.eq.31) then
       call offspec_plot(cmch,n5_offspec,info)
       data_str=formdata(1)
       call data3dread(0,info)
      else
       call syn_plot(cmch)
       data_str=formdata(mscale)
       call data2dread(0,info)      
      end if
      return
 110  continue
      k1=jss 
      if(ifrcase.eq.31) then
       call data3dread(k1,info)
      else
       call data2dread(k1,info)      
      end if
      return
 120  continue
      if(ifrcase.eq.31) then
       call excinc3d(info)
      else
       call excinc2d(info)      
      end if
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer

  200 continue
      k1=1
      if(ifrcase.eq.31) then
       call synoffspec_the2exp(k1,info)
      else
       call syn_the2exp(k1,info)
      end if
c     write(6,'(a)') ' after syn_the2exp  test'

      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      if(ifrcase.eq.31) then
       call synoffspec_the2exp(k1,info)
      else
       call syn_the2exp(k1,info)
      end if
      return

c****************************************************************************
c     subs, subt
  400 continue
      text(1)='       scatterer'
      text(2)=' incoherent part'
      text(3)='                '
      if(info.eq.-1.and.n_subset.ne.0) return
      if(cmch.eq.'subt') goto 450
      print *,' '
      print *,'                 **warning** '
      print *,' subspectra are not additive in the time domain'
      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncloc)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncloc)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncloc),ch132(:ncloc)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncloc)
      write(nwr,'(/,a)') ch132(:ncloc)
      call syn_selsubset(text)
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,'          subtraction of subspectra'
      print *,'      has no meaning in the time domain'
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       icase=int(real(array_fr(l1_get(0)+1)))
       k1=0
       if(b_theory) k1=1
       if(cmch(4:4).eq.'2') k1=2   ! update test
       if(cmch(4:4).eq.'3') k1=3   ! update fit

c              0,1    2d standard plot, 2,3 3d-plot
c              0,2: plot and return;  1,3: interactive plot
       k2=1
       if(ifrcase.eq.31)then
        k2=3
        if(ndisplay_mode.ge.3) k2=1
       end if
       call xmosplo(k1,k2)
       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue

      if(cmch.eq.'dmod') then
        if(ifrcase.eq.31) then
         n5_offspec(1)=l1_get(0)
         call offspec_plot(cmch,n5_offspec,info)
        else
          call syn_plot(cmch)
        end if
      else  ! cmch='plot'
       if(b_theory)then
        k1=3
        if(ifrcase.eq.31) then
         call synoffspec_the2exp(k1,info)
        else
         call syn_the2exp(k1,info)
        end if
        if(n_subset.gt.0)
     &     call syn_subset(m1,m3,'subs',isub,info)
         if(info.gt.0) return
        end if
c       write(6,'(a,a4,4i6)')' fr_synmoss cmch,ifrcase,scale=',
c     &                                cmch,ifrcase,int(scale)
        if(ifrcase.eq.31) then
         n5_offspec(1)=l1_get(0)
         n5_offspec(2)=channels
         n5_offspec(3)=th_sampling
         n5_offspec(4)=counts
         n5_offspec(5)=background
         call offspec_plot(cmch,n5_offspec,info)
        else
          k1=4
          call syn_the2exp(k1,info)          
          call syn_plot(cmch)
        end if
      end if
      return
c**************************************************************************
c     punch data and theory
 700  continue
      k1=jss 
      if(ifrcase.eq.31) then
       call punch3d(k1,info)
      else
       call punch2d(k1,info)
      end if
      return

      end



      subroutine syn_the2exp(n1,info)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comthe.for'
      include 'comdas.for'
      include 'complt.for'

      integer     info,ifrth,idex,istr,dstr,iaddr,
     &            nstorTH,idum1,nstorTHyy,nTH1
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),nstorTH,idum1,nstorTHyy,iaddr(5),        !13.9.05 
     &              nTH1,ifrth(7),idex(16)

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pdum,t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pdum(6),
     &              t_shift,dumvsp(ivstrf-10)

      logical       b_vs,b_counts,b_background,b_Pdum,
     &              b_t_shift,b_graz_min,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pdum(6),
     &              b_t_shift,b_graz_min,b_dumvsp(ivstrf-11)

      logical b_total,b_residual

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit
      real      yth
      dimension yth(-maxn:4*maxn)


      real    x_exp,countsy,dx_the,dx_exp,xb_the,xb_exp,
     &        y1,y2,yi,ff,hi
      integer nexp,nthe,iT_max,iT_max2,invers,jshift,
     &        ji,i,k,k1,n1,nn,j,mscale

      common/ascale/x_exp(max8),nexp,xb_exp,dx_exp,nthe,xb_the,dx_the

  

c      write(6,'(a,5i6)')'syngl n1,ifrcase,scale=',
c     &                         n1,ifrcase,mscale
      ibmisfit=0
      nexp=channels
      nthe=nTH1*2

      if(ifrcase.ge.22) then
       dx_the=abs(graz_end-graz_beg)/(ch_angle-1.0)
       dx_exp=abs(graz_end-graz_beg)/(channels-1.0)
       xb_the=graz_beg+t_shift
       xb_exp=graz_beg
       invers=0
       if(dx_the.lt.0) then
        invers=nexp+1
        dx_the=-dx_the
       end if
      else
       dx_the=abs(T_bunch)/nthe
       dx_exp=abs(T_bunch)/channels
       xb_the=t_shift
       xb_exp=0.0
       invers=0
       if(T_bunch.lt.0) invers=nexp+1
       xb_the=t_shift
      end if
      jshift=abs(xb_the/dx_the)+1
c     warning** xb_exp is not correct if x-data are read from file
c     it is correct after calling x_scale()
      mscale=1                    ! if no data 
      if(b_data)mscale=scale
      call x_scale(mscale)
c     write(6,'(6f12.4)') (x_exp(i),i=1,nexp,16)
      if(n1.eq.4)goto 310     
 
      countsy=counts-background*channels
c     integral 0-inf is normalized to 1
c     write(6,'(a,4f10.2)') ' frame02 counts,background,channels=',
c     &    counts,background,channels
      if(ifrcase.ge.22) then
       countsy=countsy/channels*nTH1       
      else
       iT_max=aiT_max
       iT_max2=2**iT_max  
c      write(6,'(a,i6,f15.5)') 'iT_max2=',2**iT_max
      end if


c     write(6,'(8f10.5)') (yth(i)*100.,i=-2,nthe,16)
c     write(6,'(8f12.2)') (yth(i)*countsy,i=1,nTH1)
c      write(6,'(4(a,f10.5),a,i4)') ' ***synchrotron*** backgr=',
c     &         background,' aiT_max=',aiT_max,' dx_the=',dx_the,
c     &         '  t_shift=',t_shift,'  nexp=',nexp
c      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',
c     &             b_total, b_background,b_counts,b_t_shift


      k1=n1
      goto (100,200,300),k1

 100  continue
c     calculation of thfk
      if(ifrcase.ge.22) then
       call synrocking(b_total,info)
      else
       call synchrotron(b_total,info)
      end if

      nn=nstorTH*2
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do

c      write(6,'(a,/,2i5,2f10.3,i5,2f10.3)')
c     & '      mscale,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the=',
c     &        mscale,nexp,dx_exp,xb_exp,nthe,dx_the,xb_the 
c      write(6,'(a,2i6,3f10.3)')
c     & 'frame02 nstorTH,nTH1,xb_the,dx_the=',
c     &          nstorTH,nTH1,xb_the,dx_the
c      write(6,'(6g12.3)') (yth(k),k=1,2*nTH1,8)
c      write(6,'(8f10.5)') (yth(k)*100.,k=1,100)

      ji=abs(invers-1)
      hi=(x_exp(ji)-xb_the)/dx_the
      i=int(hi)
c     write(6,'(a,4i6,f10.3)')'ji,i,nthe,jshift,hi=',ji,i,nthe,jshift,hi

       do k=0,jshift+abs(i)
        yth(-k)=0.
        yth(nthe+k+1)=yth(nthe)
       end do
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1+4)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
c       y2=yth(i-2)+yth(i+2)
c       y1=yth(i-1)+yth(i+1)
c       aa=(2.0*y2-y1-yth(i))/14.0
c       bb=(-2.0*(yth(i-2)-yth(i+2))-yth(i-1)+yth(i+1))/10.0
c       cc=(-3.0*y2+12.0*y1+17*yth(i))/35.0
c       yi=cc+hi*(aa*hi+bb)
       y1=yth(i)
       y2=yth(i+1)
       yi=y1+hi*(y2-y1)
       if(yi.lt.0.)yi=0.
       thfk(j)=yi*countsy+background
      end do


      nn=nstorTHyy*2
      do j=1,nexp
       real_fr(nn+j)=thfk(j)
      end do
      b_theory=.true.
      return

 200  continue
      ib_df=0
c      write(6,'(a,g12.3)')' pg_synmos ddpk=',ddpk 

c     derivatives
c     ib_df=1: derivative calculated
c     ib_df=0 happens if a parameter of a set, wich is not currently 
c     fitted, is free. It will be fixed in the routine fit. 

c     analytical and numerical derivatives are handled fdifferently
c     integer kana (k analytical) = 1 indicates an analytical derivative

c     (the fact that a parameter x can mix up variables type 
c      complicates the situation. An analytical derivative of a variale 
c      can only be calculated, if it is not connected to a different 
c      parameter by the transformation matrix)  

c     variable background, counts are analytically derived 
c     the total number of variables of the set is contained in b_total
c     (for all variables of synchrotron, synrock) and the glabal 
c     variables of this routine: counts,background,t_shift
c     t_shift is numerically derived (enters x_scale by xb_the)

c      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
c     &          PAxsi,PAeta,PAzeta,t_shift,graz_angle,graz_min,
c                phi_z,dumvsp(idumvsp)

      b_total=b_total.or.b_t_shift

      b_residual=.not.(b_total.or.b_counts)
c     all variables unchanged but background

      if(b_background.and.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
      end if
c     for background derivative the last theory values were not neccessary
      nn=nstorTHyy*2
      do j=1,nexp
       thfk(j)=real_fr(nn+j)
      end do
c     write(6,'(8f10.5)') (thfk(i),i=1,nexp,18)

      b_residual=.not.(b_total.or.b_background)
c     all variables but counts
      if(b_counts.and.b_residual) then
c       write(6,'(a)')  '   derivative of counts ------------'
        do j=1,nexp
         dfdp(j)=(thfk(j)-background)/countsy
        end do
        kana=1
        ib_df=1
        goto 250
      end if

      if(ifrcase.ge.22) then
       call synrocking(b_total,info)
      else
       call synchrotron(b_total,info)
      end if

c     numerical derivatives
      b_residual=.not.(b_total.or.b_background.or.b_counts.or.
     &                b_graz_min)
c     (b_residual=.true.: parameter is connected only to variables 
c     of other sets 
c      write(6,'(a,l5,g15.3)')'fr_synmoss b_resid.,ddpk=',b_residual,ddpk
      if(b_residual) goto 250  

      kana=0
      nn=nstorTH*2
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do
      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if

c      call x_scale(mscale)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       y1=yth(i)
       y2=yth(i+1)
       ff=y1+hi*(y2-y1)
       dfdp(j)=(ff*countsy+background-thfk(j))/ddpk
      end do   ! j=1,nexp
      ib_df=1

 250  continue
      return

 300  continue
c     calculation of thfk

      if(.not.b_theory) goto 310

      nn=nstorTH*2       
      do j =1,nthe
       yth(j)=real_fr(nn+j)
      end do
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1,8)

      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       ji=abs(invers-1)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       do k=0,jshift+abs(i)
        yth(-k)=0.0
        yth(nthe+k+1)=yth(nthe)
       end do
      end if
      
      if(ndisplay_mode.gt.1) then

c       call x_scale(mscale)
       do j=1,nexp
        ji=abs(invers-j)
        hi=(x_exp(ji)-xb_the)/dx_the
        i=int(hi)
        if(i.le.0)i=i-1
        hi=hi-float(i)
        y1=yth(i)
        y2=yth(i+1)
        yi=y1+hi*(y2-y1)
        thfk(j)=yi*countsy+background
       end do
      else
       do j=1,nthe
        thfk(j)=yth(j)*countsy+background
       end do
      end if
 310  return
      end

c
      subroutine synchrotron(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for' 

c     ifrcase=1  ! forward scattering geometry
c     ifrcase=2  ! grazing incidence geometry,time differential

      logical     b_total
      integer     info,ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,iduma,nCP,idumb,nsrw,
     &            iflag_basis,l_Poincare,idumc,nTH,ith_channels,idumd,
     &            ak8,jt0_ch,iT_max,idum3
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),   !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,iaddr(6),
     &              iduma,nCP,idumb,nsrw,ifrth(4),                   
     &              iflag_basis,l_Poincare,idumc,nTH,ith_channels,idumd,
     &              ak8,idum3(3),jt0_ch,iT_max,idex(4)

c     &              iflag_basis,l_Poincare,nLG,nTH,ith_channels,nsampling,
c     &              ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,idex(4)

      real          acsp,wavelength,uthick,unit_chi,dumcsp
      common/acstrf/acsp,wavelength,uthick,unit_chi,dumcsp(icstrf-4)


      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z,
     &              dumvsp(ivstrf-12)

      logical       b_avsp,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_PAxsi,b_PAeta,b_PAzeta,b_t_shift,b_graz_angle,
     &              b_phi_z,b_dumvsp
      common/bvstrf/b_avsp,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_PAxsi,b_PAeta,b_PAzeta,b_t_shift,b_graz_angle,
     &              b_phi_z,b_dumvsp(ivstrf-12)

      real            avfr1,pvfr1,dumvfr1
      common/avfr1trf/avfr1,pvfr1,dumvfr1(ivfr1trf-2)
      logical         b_vfr1,b_pvfr1,b_dumvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_dumvfr1(ivfr1trf-2)

      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
       common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(ivfr2trf-5)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(ivfr2trf-5)

      real           vsstrf,sftr
      common/avsstrf/vsstrf(ivsstrf)
      logical        b_vsstrf,b_sftr
      common/bvsstrf/b_vsstrf(ivsstrf)

      logical  b_lay,b_isgt1,b_sites,b_HeangleLS
      real      winc,wi,vkd
      dimension winc(maxfr1),wi(maxthss),vkd(maxfr2),
     &          b_sites(maxfr2)

      integer isubthe,nt,inc_pos,
     &        lstruct1,lstruct2,lstruct3,icmp,is_a,is_e,
     &        i,ii,j,jj,ij,l,n,nn,jftau,jt0,
     &        k,ll,lay,mlay,layb,laye,isctp,
     &        iposlay,npos,lays,mlays,laysites,laystr,nsth2

      real pi,rad,grazing,vector_k,h1,h2,sqrt2,
     &     sing,sum,relthick,thicklayer,roughlay

      dimension thicklayer(maxfr2),roughlay(maxfr2),
     &          iposlay(maxfr2),
     &          laystr(2*maxfr2),laysites(maxfr2)



      complex hc,hc1,hci,hc0,app,apm,amp,trace,
     &        satraceh,R_oo,
     &        aam(4,maxfr2),bb(4),dd(4),rho(4),Arho(4),
     &        satrexp,Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2),trv(2,2),TSPCA(2,2),sph(2,2)
      complex*16 daa(4),dbb(4),dcc(4)

      integer    mFF,mAL,mAL1,mAL2
      parameter (mFF=16*maxn,mAL=mFF+8,mAL1=mAL+1,mAL2=mAL1+4*maxn+2)
      complex    carray,POC,dumscrd
      real       yth,tthick
      dimension  carray(mAL),POC(mFF),yth(0:4*maxn)
      common/scrd/dumscrd(maxscrd/2)
      equivalence (dumscrd(1),POC(1)),(dumscrd(mAL1),yth(0)),
     &            (dumscrd(mAL2),carray(1))

C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MGRP,GEOSTR(0:2*maxfr2)
      logical b_first,b_ew,b_winc
C ****                                                       ***     

c       thfrcase(1)='time differential transmission spectrum(11)'
c       thfrcase(2)='time differential reflection spectrum(21)'

cc       thfrcase(3)='time integral - rocking curve,Fourier(22)'
cc       thfrcase(4)='time integral - rocking curve(24)'
cc       thfrcase(5)='prompt - rocking curve(23)'

c       write(6,'(a,2i4)')' th_synmos ifrcase=',ifrcase
c       write(6,'(a,f15.3)')' th_synmos t_shift=',t_shift

       b_ew=.false.
       b_total=.false.
       b_winc=.false.
c------------------------------------------------------------------
c      L_poincare =0 is used for theories calling optics
c-------------------------------------------------------------------

      call mapsub(0,0,0)
      isubthe=1
      call get_theory(isubthe,info)
      b_total= b_total.or.(isubthe.gt.0).or.b_Pxsi.or.b_Peta.or.b_Pzeta
     &                      .or.b_PAxsi.or.b_PAeta.or.b_PAzeta 
            
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

      pi=atan(1.)*4.
      rad=pi/180.
      vector_k=2.0*pi/wavelength    ! /Angstroem

c     fortran notation 
      rho(1)=cmplx(1.+Pzeta,0.)/2.
      rho(3)=cmplx(Pxsi,-Peta)/2.
      rho(2)=cmplx(Pxsi,Peta)/2.
      rho(4)=cmplx(1.-Pzeta,0.)/2.

      Arho(1)=cmplx(1.+PAzeta,0.)/2.
      Arho(3)=cmplx(PAxsi,-PAeta)/2.
      Arho(2)=cmplx(PAxsi,PAeta)/2.
      Arho(4)=cmplx(1.-PAzeta,0.)/2.
c     write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)
c-----------------------------------------------------------
      if(iflag_basis.eq.0) then
c      linear polarization basis
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)

       sph(1,1)=rho(1)
       sph(1,2)=rho(3)
       sph(2,1)=rho(2)
       sph(2,2)=rho(4)
       do i=1,2
       do k=1,2
        hc=(0.,0.)
        do j=1,2
        do l=1,2
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
        end do
        end do
        trv(i,k)=hc
       end do
       end do
       rho(1)=trv(1,1)
       rho(3)=trv(1,2)
       rho(2)=trv(2,1)
       rho(4)=trv(2,2)

       sph(1,1)=Arho(1)
       sph(1,2)=Arho(3)
       sph(2,1)=Arho(2)
       sph(2,2)=Arho(4)
       do i=1,2
       do k=1,2
        hc=(0.,0.)
        do j=1,2
        do l=1,2
         hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
        end do
        end do
        trv(i,k)=hc
       end do
       end do
       Arho(1)=trv(1,1)
       Arho(3)=trv(1,2)
       Arho(2)=trv(2,1)
       Arho(4)=trv(2,2)
      end if
c-----------------------------------------------------------
      relthick=uthick

      tthick=0.
      lstruct1=0
 1000 continue
      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2500

      call mapsub(lstruct1,0,0)

      if(ifrcase.gt.11) then
c      b_HeangleLS change of external field and scatterer orientation
       b_HeangleLS=.false.
       do i=1,6
        b_HeangleLS=b_HeangleLS.or.b_dumvfr1(i)
       end do
       b_total=b_total.or.b_HeangleLS
      end if

      winc(lstruct1)=pvfr1/float(mstruct1)
      b_winc=b_winc.or.b_pvfr1
c      write(6,'(a,i1,a2,i8,L5,f10.2)')'synmos l1_put(',lstruct1,')=',
c     &   l1_put(lstruct1),b_pvfr1,pvfr1  
      inc_pos=l1_put(lstruct1)

c      write(6,'(a,L4,a,g12.4)')' b_graz_angle=',b_graz_angle,
c     &     ' graz_angle=',graz_angle
      if(l_Poincare.eq.0) then
       grazing=0.001*graz_angle
       sing=sin(grazing)
       b_total=b_total.or.b_graz_angle
      end if

       layb=istruct1(lstruct1-1)
       laye=istruct1(lstruct1)
       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nTH------------0------------nTH                    srw
        lay=lstruct2-layb

        call mapsub(lstruct1,lstruct2,0)
c        write(6,'(a,3g12.4)')' synmos r,i_chi,unit_chi=',
c     &        re_chilay,ai_chilay,unit_chi

        if(ifrcase.gt.11) then
c        external field and scatterer orientation written from fr1 to fr2
c        subr. th_22nuclear routines take the field from common/avfr2trf
         do i=1,6
          dumvfr2(5+i)=dumvfr1(i)
          b_dumvfr2(5+i)=b_dumvfr1(i)         
         end do
        end if


         b_lay=b_vfr2.or.b_HeangleLS.or.b_thicklay
         b_total=b_total.or.b_lay       
        if(l_Poincare.eq.1) then
         thicklayer(lay)=1.
         if(thicklay.gt.0.)thicklayer(lay)=thicklay
        else
         thicklayer(lay)=thicklay
         if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
          chilay(lay)=cmplx(re_chilay,ai_chilay)*unit_chi
         else
          chilay(lay)=(0.,0.)
         end if
         i=rep_grp
         laystr(2*lay-1)=i
         laystr(2*lay)=10*(rep_grp-float(i)+.01)
         roughlay(lay)=roughness
        end if

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
         b_isgt1=.true.
         iposlay(lay)=l2_put(lstruct2)
         do i=1,8*(nTH+1)
          carray(i)=(0.,0.)
         end do
        end if
        b_sites(lay)=.false.

        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

         icmp=lstruct3
         b_sites(lay)=.true.

         call mapsub(lstruct1,lstruct2,lstruct3)

         sftr=vsstrf(2)
         b_sftr= b_vsstrf(2)
         wi(icmp)=sftr*relthick
c         write(6,'(i3,2x,a,i4,3g10.3)')lstruct1,
c     &    'synmos lay,wi,sftr,winc=',lay,wi(icmp),sftr,winc(lstruct1)
         tthick=tthick+sftr*winc(lstruct1)
c         if(lstruct1.eq.mstruct1)write(6,'(a,f12.3)')
c     &    'average thickness=',tthick/mstruct1

         if(l_Poincare.eq.0) then
          if(b_sftr) then
           if(wi(icmp).gt.sing/20..or.sing.gt.0.05)
     &      write(nwr,'(2(a,g8.1),a)')
     &     '** f*unit_thickness=',wi(icmp),' << sin(th)=',sing,' << 1 ?'
          end if
         end if

         isubthe=0
         call get_theory(isubthe,info)
         b_lay=b_lay.or.b_sftr.or.(isubthe.gt.0)
         b_total=b_total.or.b_lay

c         write(6,'(8f12.4)')array_fr(l3_get(lstruct3)+1)*1.e4,
c     &                      array_fr(l3_get(lstruct3)+9)*1.e4
         if(b_isgt1) then
          isctp=l3_get(lstruct3)
c         write(6,'(a,2i8,f12.2)') 'isctp,iposlay(lay),wi(icmp)=',
c     &                         isctp,iposlay(lay),wi(icmp)
          do n=0,nTH
           nn=isctp+8*n
           ll=8*n
            do k=1,8
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(icmp)
            end do
           end do
         else
          iposlay(lay)=l3_get(lstruct3)
c           write(6,'(a,i2,a2,i8,f10.2)')
c     &       'synmos  iposlay(',lay,')=',iposlay(lay),wi(icmp)
         end if
        end do

        if(b_isgt1.and.b_lay) then
         ll=iposlay(lay)
         do i=1,8*(nTH+1)
          array_fr(ll+i)=carray(i)
         end do
        end if
        
       end do
       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0
 
c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sap(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)

c      write(6,'(a,20i3)')'synmos laystr(1..mlay)=',(laystr(i),i=1,mlay)
      if(.not.b_total) goto 2000

      do k=1,mlay
       laysites(k)=0
      end do
      if(l_Poincare.eq.1) then
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
        if(b_sites(lay)) then
         mlays=mlays+1
         iposlay(mlays)=iposlay(lay)
         if(is_e.gt.is_a) thicklayer(mlays)=thicklayer(lay)
         if(is_e.eq.is_a)
     &           thicklayer(mlays)=thicklayer(lay)*wi(is_a)
c          write(6,'(i2,a,i4,2f10.3)')lstruct1,
c     &   'synmos lay,wi(is_a),thicklayer',lay,wi(is_a),thicklayer(lay)
        end if
       end do
      else
       mlays=0
       do lstruct2=layb+1,laye
        lay=lstruct2-layb
        is_a=istruct2(lstruct2-1)+1
        is_e=istruct2(lstruct2)
c        write(6,'(i2,a,2i2,f10.3)')lstruct1,' is_a,is_e=',
c     &                                       is_a,is_e,wi(is_a)
        vkd(lay)=vector_k*thicklayer(lay)
        if(is_e.lt.is_a) then
         thicklayer(lay)=0.
        else
         if(is_e.gt.is_a) thicklayer(lay)=1./vector_k
         if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k
        end if
       end do
      end if

c      do lstruct2=layb+1,laye
c       lay=lstruct2-layb
c       write(6,'(i4,2x,L3,a,2g12.4,a,g12.4,a,g12.4)')
c     & lay,b_sites(lay),' chilay=',chilay(lay),
c     & ' vkd=',vkd(lay),' thicklayer=',thicklayer(lay)
c       end do

      if(l_Poincare.eq.0) then
C     *********************************************************************
C     We reconstruct the layer strucrure from the laystr variabale. 
c     ELEMENT(GRP) is the number of layers in group GRP.
C     *** L. Deak, 09.10.2002 *** 
       GRP         =0
       GEOSTR(GRP) =0
       MGRP      =0
C
       b_first     =.true.
       POINTER=1
       do lay=2,2*mlay,2
        if(b_first)then
         if(GRP.eq.laystr(lay))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(lay-1)
         end if
C
         if(vkd(lay/2).lt.0.) then
          b_first         =.false.
          vkd(lay/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ***********************************************************************
       do lay=1,mlay
        if(b_sites(lay)) then
         Cmatrix(1,1,lay)= hc0 
         Cmatrix(2,2,lay)= hc0
         Cmatrix(1,2,lay)= hc0
         Cmatrix(2,1,lay)= hc0
        end if
       end do

       call optic(b_ew,mlay,b_sites,MGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
       R_oo=Rmatrix(1,1)
      endif

c      write(6,'(a,i6)')' iposlay(1)=',iposlay(1) 



      do n=-nTH,nTH-1
c      construction of the input for general optics program
c      here the matrix R for the layers are given :
c      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                          (samplay(n,lay) -sapplay(n,lay))
       npos=8*abs(n)
       if(n.lt.0)npos=npos+4

       if(l_Poincare.eq.1) then
         satraceh=cmplx(0.,0.)
         do lays=1,mlays
          nn=iposlay(lays)+npos
          satraceh=satraceh+array_fr(nn+1)*thicklayer(lays)
          app=array_fr(nn+2)*thicklayer(lays)
          apm=array_fr(nn+3)*thicklayer(lays)
          amp=array_fr(nn+4)*thicklayer(lays)
          call expo_22(app,apm,amp,dd)
          do k=1,4
           aam(k,lays)=dd(k)
          end do
         end do   ! lays=1,mlays

         satrexp=exp(satraceh*hci)

c        multiplication of the matrices exp(iR(mlay))*...*exp(iR(1))
c        laystr(rep,grp,rep,grp,.....)

         if(mlays.gt.1) then
          do k=1,4
           dcc(k)=aam(k,mlays)
          end do

          do lays=mlays-1,1,-1
           do k=1,4
            daa(k)=dcc(k)
            dbb(k)=aam(k,lays)
           end do
           call matproD(daa,dbb,dcc)
          end do
          do k=1,4
           dd(k)=dcc(k)
          end do
         end if


         nn=(nTH+n)*4

         POC(nn+1)=(1.,0.)-dd(1)*satrexp
         POC(nn+2)=       -dd(2)*satrexp
         POC(nn+3)=       -dd(3)*satrexp
         POC(nn+4)=(1.,0.)-dd(4)*satrexp 
c        if(abs(n).lt.10) write(6,'(i2,8g10.4)')
c     &     n,POC(nn+1),POC(nn+2),POC(nn+3),POC(nn+4)
       else   ! l_Poincare=1
        
        do lay=1,mlay
         if(b_sites(lay)) then
          nn=iposlay(lay)+npos
c         effi to Fortran notation
          Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
          Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
          Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
          Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
C        if(abs(n).lt.5) write(6,'(i6,8f9.4,4x,g12.3)') nn,
c     &   (array_fr(nn+ii),ii=1,4),thicklayer(lay)
         end if
        end do   ! lay=1,mlay          

        call optic(b_ew,mlay,b_sites,MGRP,GEOSTR,grazing,
     &               Cmatrix,chilay,roughlay,vkd,Rmatrix)

c       Fortran notation          
        nn=(nTH+n)*4
        POC(nn+1)=Rmatrix(1,1)-R_oo
        POC(nn+3)=Rmatrix(1,2)
        POC(nn+2)=Rmatrix(2,1)
        POC(nn+4)=Rmatrix(2,2)-R_oo

       end if ! reflection (l_Poincare=0)
      end do     ! n=-nTH,nTH

c        write(6,'(a,4i8)')'nstorTH1,nCP,nCC,nsrw=',nstorTH1,nCP,nsrw
c        i=nstorTH+nstorTH1+nTH/nsrw*4

        nn=2*nTH
        call fourier4r(nn)


        do n=1,nTH
c        trace (dd+*dd*rho) is the intensity
c        bb=cc+
          jj=4*(n-1)
          do i=1,4
           dd(i)=POC(jj+i)
          end do
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))

         call tracematpro4(Arho,dd,rho,bb,trace)
c        aa=cc*cc+ is a Hermitian matrix
         h1=real(trace)
          jj=4*(nTH+n-1)
          do i=1,4
           dd(i)=POC(jj+i)
          end do
          bb(1)=conjg(dd(1))
          bb(4)=conjg(dd(4))
          bb(2)=conjg(dd(3))
          bb(3)=conjg(dd(2))

c          call matprof(bb,Arho,cc)
c          call matprof(cc,dd,aa)
c          call matprof(aa,rho,bb)
c          trace=bb(1)+bb(4)
         call tracematpro4(Arho,dd,rho,bb,trace)
         h2=real(trace)
         yth(n)=h1
         yth(n+nTH)=h2
c         write(8,'(i6,4g12.4)')n,h1,h2
        end do ! n
        yth(0)=yth(1)
 

c     normalization
      nt=2*nTH
      jt0=2*jt0_ch
      sum=0.
      do j=jt0+1,nt-1,2
       sum=sum+yth(j)*4
      end do
      do j=jt0+2,nt-2,2
       sum=sum+yth(j)*2
      end do
      sum=sum+yth(jt0)+yth(nt)
      sum=sum/6.0/ith_channels*(nt-jt0)/2.
c      write(6,'(a,2i6,f15.5)') ' synmos jt0_ch,nTH,sum=',
c     &                                  jt0_ch,nTH,sum
      if(sum.eq.0.0) sum=1.0
      jftau=0
      nn=nstorTH*2
      if(mstruct1.gt.1) nn=inc_pos*2

c      write(6,'(a,5i8)')'iT_max,nstorTHinc_pos=',iT_max,nstorTH,nn
      if(iT_max.gt.0) then
        nt=nTH*2
        do k=1,iT_max
         nt=nt/2
         do j=1,nt
          yth(j)=yth(j)+yth(j+nt)
         end do
        end do
        jftau=nt/1024
c        write(6,'(a,3i6)') '1 synmos nth,nTH,jftau=',
c     &             nth,nTH,jftau
        if(jftau.gt.1) then
         sum=sum/jftau
         nt=nt/2
         do i=1,nt
          ij=i*jftau
          real_fr(nn+i)=yth(ij)/sum
         end do
        else
         jftau=1
         ii=nt/2
         sum=sum*512/ii
         do i=1,nt
          real_fr(nn+i)=yth(i)/sum
c         write(6,'(i6,4g12.4)') i, real_fr(nn+i)
         end do
        end if
      else
        jftau=nTH/512
        if(jftau.gt.1) then
         sum=sum/jftau
         nt=nTH/2
         do i=1,nt
          ij=i*jftau
          real_fr(nn+i)=yth(ij)/sum
         end do
c        write(6,'(a,3i6,g15.5)') '2 nt,nTH,jf,sum=',nt,nTH,jftau,sum
        else
         sum=sum*512/nTH
         nt=nTH*2
         do i=1,nTH*2
          real_fr(nn+i)=yth(i)/sum
         end do
c        write(6,'(a,2i6,g15.5)') '2 nt,nTH,sum=',nt,nTH,sum
        end if
      end if
 
c      if(mstruct1.eq.1)write(6,'(8f10.4)')(real_fr(nn+i)*100,i=1,16)
c     end of calculation for incoherent part

 2000 continue
      if(mstruct1.gt.1) goto 1000

 2500  continue
      b_total=b_total.or.b_winc
      if(.not.b_total) return

      nsth2=nstorTH*2 
      if(mstruct1.gt.1) then
c      summation of incoherent parts mstruct1
       n=nTH
       if(n.gt.512) n=512
       do i=1,n*2
        real_fr(nsth2+i)=0.0
       end do
       do k=1,mstruct1
        nn=l1_put(k)*2
c        write(6,'(8f10.4)')(real_fr(nn+i)*100,i=1,16)
        do i=1,n*2
         real_fr(nsth2+i)=
     &       real_fr(nsth2+i)+real_fr(nn+i)*winc(k)
        end do
       end do
      end if

      return
      end


C  *****************************************************************
C
C                 Fourier-transformation
C                   (fortran recipies)
C  *****************************************************************
C
      subroutine fourier(DATA,NN,mFF,ISIGN)
      real*8 WR,WI,WPR,WPI,WTEMP,THETA
      real DATA(2*mFF)
C
      N=2*NN
      J=1
C
      do 11 I=1,N,2
        if(J.gt.I)then
          TEMPR=DATA(J)
          TEMPI=DATA(J+1)
          DATA(J)=DATA(I)
          DATA(J+1)=DATA(I+1)
          DATA(I)=TEMPR
          DATA(I+1)=TEMPI
        endif
        M=N/2
1       if ((M.ge.2).and.(J.gt.M)) then
          J=J-M
          M=M/2
        go to 1
        endif
        J=J+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        WPR=-2.D0*dsin(0.5D0*THETA)**2
        WPI=dsin(THETA)
        WR=1.D0
        WI=0.D0
        do 13 M=1,MMAX,2
          do 12 I=M,N,ISTEP
            J=I+MMAX
            TEMPR=WR*DATA(J)-WI*DATA(J+1)
            TEMPI=WR*DATA(J+1)+WI*DATA(J)
            DATA(J)=DATA(I)-TEMPR
            DATA(J+1)=DATA(I+1)-TEMPI
            DATA(I)=DATA(I)+TEMPR
            DATA(I+1)=DATA(I+1)+TEMPI
12        continue
          WTEMP=WR
          WR=WR*WPR-WI*WPI+WR
          WI=WI*WPR+WTEMP*WPI+WI
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end

C  *****************************************************************
C
C                 c-Fourier-transformation
C                   (fortran recipies)
C  *****************************************************************
C
      subroutine cfourier(DATA,NN,mFF,ISIGN)
      real*8 THETA
      complex DATA(mFF)
      complex ww,wwp,temp
C
      N=2*NN
      J=1
C
      do 11 I=1,N,2
        if(J.gt.I)then
          ii=(I+1)/2
          jj=(J+1)/2
          temp=DATA(jj)
          DATA(jj)=DATA(ii)
          DATA(ii)=temp
        endif
        M=N/2
1       if ((M.ge.2).and.(J.gt.M)) then
          J=J-M
          M=M/2
        go to 1
        endif
        J=J+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        wwp=cmplx(-2.D0*dsin(0.5D0*THETA)**2,dsin(THETA))
        ww=cmplx(1.0,0.0)
        do 13 M=1,MMAX,2
          do 12 I=M,N,ISTEP
            J=I+MMAX
          ii=(I+1)/2
          jj=(J+1)/2
            temp=ww*DATA(jj)
            DATA(jj)=DATA(ii)-temp
            DATA(ii)=DATA(ii)+temp
12        continue
          ww=(wwp+(1.,0.))*ww
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end


C  *****************************************************************
C
C                 Fourier-transformation
C                   (fortran recipies)
C                transform of 4 arrays (l=1-4)
C                          6.6.97
C  *****************************************************************
C
      subroutine fourier4r(NN)
      include 'comglb.for'
      real POC(32*maxn),dumscrd
      common/scrd/dumscrd(maxscrd)
      equivalence (dumscrd(1),POC(1))

      real*8 THETA
      real hr,wwr,wwi,wwpr,wwpi,tempr,tempi
C
      N=2*NN
      JN2=1
C
      do 11 IN2=1,N,2
        if(JN2.gt.IN2)then
          jj=4*(JN2-1)-1
          ii=4*(IN2-1)-1
          do l=2,8,2
           i=ii+l
           j=jj+l
           tempr=POC(j)
           tempi=POC(j+1)
           POC(j)=POC(i)
           POC(j+1)=POC(i+1)
           POC(i)=tempr
           POC(i+1)=tempi
          end do
        endif
        M=N/2
1       if ((M.ge.2).and.(JN2.gt.M)) then
          JN2=JN2-M
          M=M/2
        go to 1
        endif
        JN2=JN2+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/dfloat(MMAX)
        wwpr=dcos(THETA)
        wwpi=-dsin(THETA)
        wwr=1.
        wwi=0.
        do 13 M=1,MMAX,2
          do 12 IMN=M,N,ISTEP
           ii=4*(IMN-1)-1
           jj=ii+2*ISTEP
           do l=2,8,2
            i=ii+l
            j=jj+l
            tempr=wwr*POC(j)-wwi*POC(j+1)
            tempi=wwr*POC(j+1)+wwi*POC(j)
            POC(j)=POC(i)-tempr
            POC(j+1)=POC(i+1)-tempi
            POC(i)=POC(i)+tempr
            POC(i+1)=POC(i+1)+tempi
           end do
12        continue
          hr=wwr
          wwr=wwpr*wwr-wwpi*wwi
          wwi=wwpi*hr +wwpr*wwi
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end






c     H. Spiering January,1999 Mainz
c     Jg Je arbitrary spin
c     synchrotron source
c     5.06.05
      subroutine synrocking(b_total,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

      logical     b_total
      integer     info,ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,nCC,nsrw,
     &            iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
     &            ak8,nomega,nstrob_order,jt0_ch,iT_max,nvch,
     &            nhyperfine
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              iaddr(4),nTH1,nCP,nCC,nsrw,ifrth(4),                   
     &              iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
     &              ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,nvch,
     &              nhyperfine,idex(2) 

      real          acsp,wavelength,uthick_A,
     &              unitchi,dum6,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick_A,
     &              unitchi,dum6(6),ch_angle,graz_beg,graz_end,
     &              dumcsp(icstrf-13)

      real          avs,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,ang_shift,graz_min,phi_z,
     &              detekt_eff,counts_bunch,dumvsp
      common/avstrf/avs,counts,background,Pxsi,Peta,Pzeta,
     &              PAxsi,PAeta,PAzeta,ang_shift,graz_min,phi_z,
     &              detekt_eff,counts_bunch,dumvsp(ivstrf-14)

      logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_PAxsi,b_PAeta,b_PAzeta,b_ang_shift,b_graz_min,
     &              b_phi_z,b_detekt_eff,b_counts_bunch,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_PAxsi,b_PAeta,b_PAzeta,b_ang_shift,b_graz_min,
     &              b_phi_z,b_detekt_eff,b_counts_bunch,
     &              b_dumvsp(ivstrf-14)
 
      real            avfr1,pvfr1,dum1,phiA,thetaA,dvfr1
      common/avfr1trf/avfr1,pvfr1,dum1(3),phiA,thetaA,dvfr1(ivfr1trf-7)
      logical         b_vfr1,b_pvfr1,b_dum1,b_dvfr1
      common/bvfr1trf/b_vfr1,b_pvfr1,b_dum1(3),b_dvfr1(ivfr1trf-5)

      real            acfr2,rep_grp,dumcfr2
      common/acfr2trf/acfr2,rep_grp,dumcfr2(icfr2trf-2)

      real            avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2
      common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,
     &                dumvfr2(ivfr2trf-5)
      logical         b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2
      common/bvfr2trf/b_vfr2,b_thicklay,b_re_chilay,b_ai_chilay,
     &                b_roughness,b_dumvfr2(ivfr2trf-5)

      real            vsstrf,sftr
      common/avsstrf/ vsstrf(ivsstrf)
      logical         b_vsstrf
      common/bvsstrf/ b_vsstrf(ivsstrf)

      logical  b_chilay,b_lay,b_absorber,
     &         b_isgt1,b_sites,b_chilaynz

      real      winc,wi,vkd
      dimension winc(maxfr1),wi(maxthss),vkd(maxfr2),
     &          b_sites(maxfr2),
     &          b_chilay(maxfr2),b_chilaynz(maxfr2)

      integer lstruct1,lstruct2,lstruct3,nt,isubthe,
     &        icmp,is_a,is_e,inc_pos,
     &        i,i4,jj,j,j1,j3,n,nn,n_s,k,ll,nb_ch,ne_ch,
     &        lay,mlay,nch_angle,nchan,nyout,nst16,
     &        ipos_mstruct1,iposlay,npos,mlays,laysites,laystr,chT0

      real    pi,rad,grazing,rd_theta,vector_k,h1,h2,
     &        sing,h,sum,thicklayer,roughlay

      dimension thicklayer(maxfr2),roughlay(maxfr2),
     &          ipos_mstruct1(maxfr1),iposlay(maxfr2),
     &          laystr(2*maxfr2+2),laysites(maxfr2)

      complex hc,hc1,hcc,hci,hc0,swin,
     &        aa(4),bb(4),cc(4),dd(4),rho(4),R_oo,
     &        Cmatrix(2,2,maxfr2),chilay(maxfr2),
     &        Rmatrix(2,2)


      integer   mAL,mFF,ichall,ichstr,iall,neg,isamp,
     &          ij,mcht,icht,ii,ka,k0,k1,k2,idumscrd
      real      yth,chrock,fn,qn,dn,grazmin,dumi,dumscrd,trc,
     &          ap0,ap1,ap2,bp0,bp1,bp2,cp0,cp1,cp2,dx1,dx2,dx3,hhoff,
     &          ap,bp,cp,det,x0,x1,x2,hh,hhstr,swinr,swini,start,finish
      complex   carray,POC,pocfi,trace

      parameter (mAL=8*(2*maxn+1),mFF=16*maxn,
     &           idumscrd=maxscrd-4-12*maxn-2*mAL-2*mFF-3*32-12*96-
     &           9-18*maxn-4*maxn)
      common/scrd/ichall(0:maxn*2),ichstr(0:maxn),
     &            carray(mAL),POC(mFF),dumi(0:4*maxn),
     &            yth(0:4*maxn),chrock(maxn),fn(0:31),dn(0:31),qn(0:31),
     &            ap0(0:95),ap1(0:95),ap2(0:95),
     &            bp0(0:95),bp1(0:95),bp2(0:95),
     &            cp0(0:95),cp1(0:95),cp2(0:95),
     &            dx1(0:95),dx2(0:95),dx3(0:95),
     &            pocfi(4,-maxn:maxn),trc(-maxn:maxn),
     &            trace(1:2*maxn),dumscrd(idumscrd)

      logical b_bunchinf,b_ew,b_HeangleLS
C **** Definitions of structure variables L. Deak 09.10.2002 ***
      integer POINTER,GRP,MAXGRP,GEOSTR(0:2*maxfr2)
      logical b_first
C ****                                                       ***     
      b_bunchinf=.false.
      b_ew=.false.
c      write(6,'(a,L5,2g12.4)')'b_counts_bunch,counts_bunch=',
c     &                           b_counts_bunch,counts_bunch
c      write(6,'(a,3L5,2g12.4)')' b_vs,b_counts,b_graz_min=',
c     &                    b_vs,b_counts,b_graz_min,counts,graz_min
c------------------------------------------------------------------
c-------------------------------------------------------------------

      call cpu_time(start)

      call mapsub(0,0,0)
      b_absorber=b_vs
      b_total=b_vs

c     calculation of non equidistant energy points
       call channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                          iall)

c      the routine calculates channels needed for a nonequidistant
c      channel numbers for all later shifts +- nomega in the stoboscopic 
c      integration
c----------------------------------------------------------------------
c       nvch=0 
c       iall=nTH
c       do i=0,iall
c        ichall(i)=i
c       end do
c       ichall(nTH+1)=-1
c       write(6,'(a,i5)') ' th_synrock nTH=',nTH
c----------------------------------------------------------------------

      isubthe=1
      call get_theory(isubthe,info)
      b_total= b_total.or.(isubthe.gt.0) 
      hc1=cmplx(1.,0.)
      hci=cmplx(0.,1.)
      hc0=cmplx(0.,0.)

c     write(6,'(a,2i4)')' th_synrock ifrcase=',ifrcase 

c     thfrcase(1)='time differential transmission spectrum(11)   v=100'
c     thfrcase(2)='time differential reflection spectrum(21)     v=100'
c     thfrcase(3)='time integral - rocking curve-Fourier(22)     v=100'
c     thfrcase(4)='time integral - rocking curve(24)        v=100'
c     thfrcase(5)='time integral - rocking curve_fi(25)        v=100'
c     thfrcase(6)='prompt - rocking curve(23)     v=100'
c     thfrcase(7)='time integral - offspecular(31)          v=001'

      if(ifrcase.eq.24.or.ifrcase.eq.25) then
       do n_s=0,nstrob_order
        swin=array_fr(l1_get(0)+1+abs(n_s))

c        write(6,'(i5,2x,2f10.3)')n_s,swin
       end do
      end if

c-------------------------------------------------------------------

c     write(6,'(3(a,e8.2))')
c    &    ' synmos-- Pxsi=',Pxsi,' Peta=',Peta,' Pzeta=',Pzeta

       pi=atan(1.)*4.
       rad=pi/180.
c      transformation matrix from spherical basis to (sigma,pi)-basis

      vector_k=2.0*pi/wavelength    ! /Angstroem
      grazmin=graz_min*0.001
c---------------------------------------------------------------------------
c     transformation matrix from spherical basis to (sigma,pi)-basis
c     orientation of the absorber with respect to the beam

        rho(1)=cmplx(1.+Pzeta,0.)/2.
        rho(3)=cmplx(Pxsi,-Peta)/2.
        rho(2)=cmplx(Pxsi,Peta)/2.
        rho(4)=cmplx(1.-Pzeta,0.)/2.
c       write(6,'(a,8f8.2)') ' rho=', (rho(k),k=1,4)
c       (1 3)     fortran definition
c       (2 4)

      lstruct1=0
 1000 continue
       if(ifrcase.eq.23) b_absorber=
     &                 b_absorber.or.b_detekt_eff.or.b_counts_bunch

      lstruct1=lstruct1+1
      if(lstruct1.gt.mstruct1) goto 2500
      inc_pos=l1_put(lstruct1)
      ipos_mstruct1(lstruct1)=inc_pos

c       write(6,'(a,i1,a2,i8)')
c     &         'synmos l1_put(',lstruct1,')=',l1_put(lstruct1)  

       call mapsub(lstruct1,0,0)

c      b_HeangleLS change of external field and scatterer orientation
       b_HeangleLS=b_phi_z
       do i=1,3
        b_HeangleLS=b_HeangleLS.or.b_dum1(i)
       end do

       winc(lstruct1)=pvfr1
       b_total=b_total.or.b_pvfr1.or.b_HeangleLS

       nch_angle=ch_angle
       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)
c      write(6,'(a,g15.5)')'1synrock rd_theta=',rd_theta

       thetaA=(graz_end-graz_beg)/2.
       sing=sin(0.001*thetaA)
       thetaA=0.001*thetaA/rad !  hyperfine fields - fix

       do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
c      ------------------------------------------------------------
c      layer lay1,2 ... mlay of  absorber
c      ---------------------------------------------------------------
c      The Lorentz curve of the absorber in npq is 1 at resonance so that
c      for a singl line the exponent at resonance is just -teff (effective
c      thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/srw8,
c      normalizes ( to area 1) the Lorentz curve.
c
c      Sums of absorber curves at the positions Eagd.
c
c      ----0--------------------------naLG
c       naLG--------------------------0-------------        srw8
c        nTH------------0------------nTH                    srw

        lay=lstruct2

        call mapsub(lstruct1,lstruct2,0)
c       external field and scatterer orientation written on fr2
c       th_22nuclear routines take the field from common/avfr2trf
c       mapsub overwrites common/.vfr2trf, therefore
        do i=1,3
         dumvfr2(1+i)=dum1(i)
         b_dumvfr2(1+i)=b_dum1(i)
        end do
        dumvfr2(5)=phi_z
        dumvfr2(6)=thetaA
        b_dumvfr2(5)=b_phi_z
        b_dumvfr2(6)=.false.
c       end of transfer       


        thicklayer(lay)=thicklay
        if(abs(re_chilay)+abs(ai_chilay).gt.1.0e-10) then
         chilay(lay)=cmplx(re_chilay,ai_chilay)*unitchi
         b_chilaynz(lay)=.true.
        else
         chilay(lay)=(0.,0.)
         b_chilaynz(lay)=.false.
        end if
        b_chilay(lay)=b_vfr2.or.b_thicklay
        b_absorber=b_absorber.or.b_chilay(lay)
c       write(6,'(a,l5)') '1------b_absorber=', b_absorber

        i=rep_grp
        laystr(2*lay-1)=i
        laystr(2*lay)=10*(rep_grp-float(i)+.01)
        roughlay(lay)=roughness*vector_k

        b_isgt1=.false.
        if(istruct2(lstruct2)-istruct2(lstruct2-1)-1.gt.0)then
         b_isgt1=.true.
         iposlay(lay)=l2_put(lstruct2)
         do i=1,8*(nTH+1)
          carray(i)=(0.,0.)
         end do
        end if

        b_sites(lay)=.false.
        b_lay=.false.
        do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2)

         icmp=lstruct3
         b_sites(lay)=.true.

         call mapsub(lstruct1,lstruct2,lstruct3)

         b_lay=b_vsstrf(2).or.b_HeangleLS
c        write(6,'(a,l5)') '2------b_absorber=', b_absorber
c         write(6,'(a,2i4)') 'synrock lay,icmp=',lay,icmp

         sftr=vsstrf(2)
         wi(icmp)=sftr*uthick_A
 
         if(b_vsstrf(1)) then
          if((wi(icmp).gt.sing/20..or.sing.gt.0.05).and.
     &       (ifrcase.eq.22.or.ifrcase.eq.24.or.ifrcase.eq.25))
     &     write(nwr,'(2(a,g8.1),a)')
     &     '** f*unit_thickness=',wi(icmp),' << sin(th)=',sing,' << 1 ?'
         end if


         if(ifrcase.eq.22.or.ifrcase.eq.24.or.ifrcase.eq.25) then
          isubthe=0
          call get_theory(isubthe,info)
          b_lay=b_lay.or.(isubthe.gt.0)
         end if
         b_absorber=b_absorber.or.b_lay

         if(b_isgt1) then
          i=l3_get(lstruct3)
          do n=0,nTH
           ll=8*n
           nn=i+ll
            do k=1,8
            carray(ll+k)=carray(ll+k)+ array_fr(nn+k)*wi(icmp)
            end do
          end do
         else
          iposlay(lay)=l3_get(lstruct3)
         end if

        end do

        if(b_isgt1.and.b_lay) then
         ll=iposlay(lay)
         do i=1,8*(nTH+1)
          array_fr(ll+i)=carray(i)
         end do
        end if

       end do
       mlay=lay
       laystr(2*lay+2)=-1
       laystr(2*lay+1)=0
       b_total=b_total.or.b_absorber

c      write(6,'(a)')'++++++++++++++synrock++++++++++++++++++++++'
c      write(6,'(a,20i3)') 'laystr(1..lay)=',(laystr(i),i=1,2*lay)
c-----------------------------------------------------------------------
c     here the matrix R for the layers are given :
c     satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                         (samplay(n,lay) -sapplay(n,lay))
c
c     calculation of the transmittivity matrix T for all channels n
c     by   T = exp(iR)*rho*exp(-iR+)


      if(.not.(b_total.or.b_graz_min)) goto 1000

      do k=1,mlay
       laysites(k)=0
      end do
      mlays=0
      do lay=1,mlay
       is_a=istruct2(lay-1)+1
       is_e=istruct2(lay)
c      write(6,'(a,2i4)') 'synrock is_a,is_e=',is_a,is_e
       vkd(lay)=vector_k*thicklayer(lay)
c       write(6,'(i4,a,f15.5)')lay,' synrock vkd(lay)=',vkd(lay)
       if(is_e.lt.is_a) then
        thicklayer(lay)=0.
       else
        if(is_e.gt.is_a) thicklayer(lay)=1./vector_k
        if(is_e.eq.is_a) thicklayer(lay)=wi(is_a)/vector_k
       end if
c       write(6,'(a,g15.5,2i6,L5)') 'thickl,lay,iposlay(lay)=',
c     &   thicklayer(lay)*1.e6,lay,iposlay(lay),b_sites(lay)
      end do

C      ****************************************************************
C      We reconstarct the layerstrucrure from the laystr variable. 
c      GEOSTR(GRP) is the number of layers in group GRP.
c      L. Deak, 09.10.2002                                         *** 
       GRP         =0
       GEOSTR(GRP) =0
       MAXGRP      =0
C
       b_first     =.true.
       POINTER=1
       do lay=2,2*mlay,2
        if(b_first)then
         if(GRP.eq.laystr(lay))then
          GEOSTR(2*GRP)   =GEOSTR(2*GRP)+1
         else
          POINTER         =POINTER+GEOSTR(2*GRP)
          GRP             =GRP+1
          MAXGRP          =GRP
          GEOSTR(2*GRP)   =1
          GEOSTR(2*GRP-1) =laystr(lay-1)
         end if
C
         if(vkd(lay/2).lt.0.) then
          b_first         =.false.
          vkd(lay/2)      =1.e30
          GEOSTR(2*GRP-1) =1
         end if ! VKD < 0
        end if  ! b_first
       end do
C      ******************************************************************
c      write(6,'(a,l5)')'4 synrock b_total=',b_total

c------------------------------ifrcase=22--------------------------------
      if(ifrcase.eq.22) then
c      only b_graz_min=.true.
       if(.not.b_total) goto 800

       do nchan=1,nch_angle
c       grazing=0.001*15
c       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
c        write(6,'(a,i3,a,4f10.5)') 'synrock nchan=',nchan,
c     &    ' grazing=',grazing,graz_beg,rd_theta
  
C       ******************************************************************     
C       L.Deak 09.10.2002
C 
         do lay=1,mlay
          if(b_sites(lay)) then
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0
           Cmatrix(1,2,lay)= hc0
           Cmatrix(2,1,lay)= hc0
          end if
         end do
  
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
         R_oo=Rmatrix(1,1)
c         write(6,'(a,4g15.5)') 'synrock  R_oo=', R_oo  
c        *********************************************************************
   
         do n=-nTH,nTH-1
c        do n=-1,1
   
c        construction of the input for general optics program
c        here the matrix R for the ylayers are given :
c        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                           (samplay(n,lay) -sapplay(n,lay))
         npos=8*abs(n)
         if(n.lt.0)npos=npos+4
c          effi (1 3)  to fortran  ( 1 3 )
c               (4 2)              ( 2 4 )   
         do lay=1,mlay
          if(b_sites(lay)) then
           nn=iposlay(lay)+npos
           Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
           Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
           Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
           Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
          end if
         end do   ! lay=1,mlay
    
c         if(n.lt.1.and.n.gt.-1)
c     &      write(6,'(a,i4,4e15.5,/,20x,4e15.5)')
c     &     'synrock Cmatrix=',n,Cmatrix(1,1,1),Cmatrix(2,2,1)
c     &       Cmatrix(2,1,1),Cmatrix(2,2,1)
    
    
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
c        Fortran notation    
         nn=(nTH+n)*4
         POC(nn+1)=Rmatrix(1,1)-R_oo
         POC(nn+2)=Rmatrix(2,1)
         POC(nn+3)=Rmatrix(1,2)
         POC(nn+4)=Rmatrix(2,2)-R_oo
        end do     ! n=-nTH,nTH
    
c        write(6,'(a,i5)') 'nTH=',nTH

c       do n=1,30,9
c        write(6,'(8f10.5)')(POC(n+i)*1000,i=1,4)
c       end do
        nn=2*nTH
c       write(6,'(a)') ' synrock bef Fourier POC'
        call fourier4(POC,nn,mFF,-1)
  
c        write(6,'(a)') ' synrock after Fourier POC'
c        write(6,'(8f10.3)') (POC(i),i=1,nn,64)
  
        do n=1,nTH
c        trace (dd+*dd*rho) is the intensity
c        bb=cc+
         jj=4*(n-1)
         do i=1,4
          dd(i)=POC(jj+i)
         end do
         bb(1)=conjg(dd(1))
         bb(4)=conjg(dd(4))
         bb(2)=conjg(dd(3))
         bb(3)=conjg(dd(2))
         call matprof(bb,dd,aa)
         call matprof(aa,rho,bb)
c        aa=cc*cc+ is a Hermitian matrix
         h1=real(bb(1)+bb(4))
         jj=4*(nTH+n-1)
         do i=1,4
          dd(i)=POC(jj+i)
         end do
         bb(1)=conjg(dd(1))
         bb(4)=conjg(dd(4))
         bb(2)=conjg(dd(3))
         bb(3)=conjg(dd(2))
         call matprof(bb,dd,aa)
         call matprof(aa,rho,bb)
         h2=real(bb(1)+bb(4))
         yth(n)=h1
         yth(n+nTH)=h2
        end do ! n
c        write(6,'(8g12.3)')( yth(j),j=1,nTH,16)
        if(b_bunchinf) then
         do k=1,2*nTH
          dumi(k)=0.0
          do j=k,2*nTH
           dumi(k)=dumi(k)+yth(j)
          end do
         end do
         do k=1,2*nTH
           yth(k)=dumi(k)
         end do
c         write(6,'(a)')
c         write(6,'(8g12.3)')( yth(j),j=1,nTH,16)
         if(iT_max.gt.0) then
          nt  =nTH*2
          chT0=jt0_ch*2
          do k=1,iT_max
           nt  =nt/2
           chT0=chT0/2
          end do
         else
          nt  =2*nTH
          chT0=jt0_ch*2
         end if
        else
         if(iT_max.gt.0) then
          nt=nTH*2
          chT0=jt0_ch*2
          do k=1,iT_max
           nt  =nt/2
           chT0=chT0/2
           do j=1,nt
            yth(j)=yth(j)+yth(j+nt)
           end do
          end do
         else
          nt=2*nTH
          chT0=jt0_ch*2
         end if
        end if
   
c        integration of yth from nt0 - nth
        sum =0.
C For the SPRING8 experiment the symmetrical time window should be used
C original:  do j=2*jt0_ch,nt
C        write(*,*)chT0,nt-chT0,nt
        do j=chT0,nt-chT0
         sum=sum+yth(j)
        end do
   
        chrock(nchan)=sum
   
c       write(6,'(a,i3,a2,3i5,g15.5,)')
c     &    ' synrock jt0_ch,iT_max,nth,chrock(',nchan,')=',
c     &    jt0_ch,iT_max,nth,sum
       end do  ! loop over angles by nch_angle
c       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)
       nn=2*nstorTH1
       do i=1,nch_angle
        real_fr(nn+i)=chrock(i)
       end do
c------------------------------ifrcase=24--------------------------------
      else if(ifrcase.eq.24) then
c      only b_graz_min=.true.
       if(.not.b_total) goto 800
       isamp=8/nsampling
       if(enwr(16).eq.'omeg') write(nwr,'(2(a,i4),a,f6.2,a,f8.4)')
     & ' nomega=',nomega,'    nTH=',nTH,'   v_nTH=',
     &  srw8*nsampling*(ith_channels+nstrob_order*nomega+1.5),
     &  '    dv=',srw8*nsampling
       do nchan=1,nch_angle
c       grazing=0.001*15
c       rd_theta=(graz_end-graz_beg)/(ch_angle-1.)
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
c        write(6,'(a,i3,a,4f10.5)') 'synrock nchan=',nchan,
c     &    ' grazing=',grazing,graz_beg,rd_theta
  
C       ******************************************************************     
C       L.Deak 09.10.2002
C 
         do lay=1,mlay
          if(b_sites(lay)) then
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0
           Cmatrix(1,2,lay)= hc0
           Cmatrix(2,1,lay)= hc0
          end if
         end do
  
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
         R_oo=Rmatrix(1,1)
c         write(6,'(a,4g15.5)') 'synrock  R_oo=', Rmatrix(1,1)  
c        *********************************************************************
   
         do n=-nTH,nTH
c        do n=-1,1
   
c        construction of the input for general optics program
c        here the matrix R for the ylayers are given :
c        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                           (samplay(n,lay) -sapplay(n,lay))
         npos=8*abs(n)
         if(n.lt.0)npos=npos+4
c          effi (1 3)  to fortran  ( 1 3 )
c               (4 2)              ( 2 4 )   
         do lay=1,mlay
          if(b_sites(lay)) then
           nn=iposlay(lay)+npos
           Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
           Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
           Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
           Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
          end if
         end do   ! lay=1,mlay
    
c         if(n.lt.1.and.n.gt.-1)
c           write(6,'(a,i4,4e15.5,/,20x,4e15.5)')
c     &     'synrock Cmatrix=',n,Cmatrix(1,1,3),Cmatrix(2,2,3)
c     &       Cmatrix(2,1,3),Cmatrix(2,2,3)
    
    
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
    
c        Fortran notation
         nn=(nTH+n)*4
         POC(nn+1)=Rmatrix(1,1)-R_oo
         POC(nn+3)=Rmatrix(1,2)
         POC(nn+2)=Rmatrix(2,1)
         POC(nn+4)=Rmatrix(2,2)-R_oo
        end do     ! n=-nTH,nTH


          hh=0.
          do n_s=0,nstrob_order
           swin=array_fr(l1_get(0)+1+abs(n_s))
           if(n_s.eq.0) swin=swin/2.0
           h1=real(conjg(swin)*swin)
           if(h1.gt.1.e-3)then
      
            j1=4*(n_s*nomega/2) 
            j3=4*(-n_s*nomega/2) 
            nb_ch=((nstrob_order*2-n_s)*nomega/2)*isamp
            ne_ch=((nstrob_order*2+n_s)*nomega/2+2*ith_channels)*isamp

            do i=nb_ch,ne_ch
             i4=4*i
             j=j1+i4
             aa(1)=POC(j+1)     
             aa(2)=POC(j+2)      
             aa(3)=POC(j+3)      
             aa(4)=POC(j+4)    
       
             j=j3+i4
             cc(1)=conjg(POC(j+1))     
             cc(3)=conjg(POC(j+2))      
             cc(2)=conjg(POC(j+3))      
             cc(4)=conjg(POC(j+4))      
     
             call matprof(cc,aa,bb)
             trace(i)=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+
     &                                          bb(4)*rho(4)            
c             call matprof(bb,rho,aa)
c             hcc=hcc+aa(1)+aa(4)
            end do  ! nch
            hcc=hc0
            do i=nb_ch+1,ne_ch-1,2
             hcc=hcc+trace(i)*2
            end do
            do i=nb_ch+2,ne_ch-2,2
             hcc=hcc+trace(i)
            end do
            hcc=(hcc*2.0+trace(ne_ch)+trace(ne_ch))/3.0
            hh=hh+2.0*real(hcc*swin)
           end if   ! abs(swin) >0.001
          end do   ! n_s
          chrock(nchan)=hh
       end do  ! loop over angles by nch_angle
c       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)
       nn=2*nstorTH1
       do i=1,nch_angle
        real_fr(nn+i)=chrock(i)
       end do
c------------------------------ifrcase=25--------------------------------
      else if(ifrcase.eq.25) then
c      only b_graz_min=.true.
       if(.not.b_total) goto 800

       do nchan=1,nch_angle
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))
  
C       ******************************************************************     
C       L.Deak 09.10.2002
C 
         do lay=1,mlay
          if(b_sites(lay)) then
           Cmatrix(1,1,lay)= hc0 
           Cmatrix(2,2,lay)= hc0
           Cmatrix(1,2,lay)= hc0
           Cmatrix(2,1,lay)= hc0
          end if
         end do
  
         call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
         R_oo=Rmatrix(1,1)
c         write(6,'(a,4g15.5)') 'synrock  R_oo=', Rmatrix(1,1)  
c        *********************************************************************
   
c         do n=-nTH,nTH
c        do n=-1,1
   
c        construction of the input for general optics program
c        here the matrix R for the ylayers are given :
c        satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))
c                           (samplay(n,lay) -sapplay(n,lay))
c         npos=8*abs(n)
c         if(n.lt.0)npos=npos+4

c          write(6,'(a,2i6)')' iall=',iall
c          write(6,'(a,3i6)')' nomega,nTH=',nomega,nTH,nsampling 
        do ka=0,iall
         n=ichall(ka)
         do neg=-1,1,2     
          npos=8*n+(1-neg)*2
c        (11 12)    effi (1 3)     fortran  ( 1 3 )
c        (21 22)         (4 2)              ( 2 4 )   
          do lay=1,mlay
           if(b_sites(lay)) then
            nn=iposlay(lay)+npos
            Cmatrix(1,1,lay)= array_fr(nn+1)*thicklayer(lay)
            Cmatrix(2,2,lay)= array_fr(nn+2)*thicklayer(lay)
            Cmatrix(1,2,lay)= array_fr(nn+3)*thicklayer(lay)
            Cmatrix(2,1,lay)= array_fr(nn+4)*thicklayer(lay)
           end if
          end do   ! lay=1,mlay
    
c         if(n.lt.iall)
c     &      write(6,'(a,i4,4e15.5)')
c     &     'synrock Cmatrix=',n,Cmatrix(1,1,3),Cmatrix(2,2,3)
c     &       Cmatrix(2,1,3),Cmatrix(2,2,3)
    
    
          call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                 Cmatrix,chilay,roughlay,vkd,Rmatrix)
c         Fortran notation
          i=neg*n 
          pocfi(1,i)=Rmatrix(1,1)-R_oo 
          pocfi(3,i)=Rmatrix(1,2)      
          pocfi(2,i)=Rmatrix(2,1)      
          pocfi(4,i)=Rmatrix(2,2)-R_oo 

         end do
        end do     ! n=-nTH,nTH
c           write(6,'(8f12.4)')( pocfi(1,i)*1000,i=-nTH,0,16)
c           write(6,'(8f12.4)')( pocfi(2,i)*1000,i=-nTH,0,16)
c           write(6,'(8f12.4)')( pocfi(3,i)*1000,i=-nTH,0,16)
c           write(6,'(8f12.4)')( pocfi(4,i)*1000,i=-nTH,0,16)
c          read(5,'(a)')
        hhstr=0.
        hhoff=0.
        DO n_s=0,nstrob_order   
         swinr=real(array_fr(l1_get(0)+1+abs(n_s)))
         swini=aimag(array_fr(l1_get(0)+1+abs(n_s)))
         if(n_s.eq.0) swinr=swinr/2.0
         if(abs(swinr)+abs(swini).gt.0.001)then

          ij=n_s*nomega/2
          mcht=ij+nhyperfine
          do i=0,mcht
           ichstr(i)=i
          end do        
          do i=1,nvch
           ichstr(mcht+i)=mcht+i*(i+1)/2
          end do
          icht=mcht+nvch

          DO ka=0,icht
           ii=ichstr(ka)

           i=ii+ij
           aa(1)=pocfi(1,i)     
           aa(2)=pocfi(2,i)  
           aa(3)=pocfi(3,i)  
           aa(4)=pocfi(4,i)

           j=ii-ij
           cc(1)=conjg(pocfi(1,j))     
           cc(3)=conjg(pocfi(2,j))      
           cc(2)=conjg(pocfi(3,j))      
           cc(4)=conjg(pocfi(4,j))      
           call matprof(cc,aa,bb)     
c          trace(bb*rho)
           hc=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)            
           trc(ii)=swinr*real(hc)-swini*aimag(hc)
          END DO 

          DO ka=1,icht
           ii=-ichstr(ka)

           i=ii+ij
           aa(1)=pocfi(1,i)     
           aa(2)=pocfi(2,i)  
           aa(3)=pocfi(3,i)  
           aa(4)=pocfi(4,i)

           j=ii-ij
           cc(1)=conjg(pocfi(1,j))     
           cc(3)=conjg(pocfi(2,j))      
           cc(2)=conjg(pocfi(3,j))      
           cc(4)=conjg(pocfi(4,j))      
           call matprof(cc,aa,bb)     
c          trace(bb*rho)
           hc=bb(1)*rho(1)+bb(3)*rho(2)+bb(2)*rho(3)+bb(4)*rho(4)            
           trc(ii)=swinr*real(hc)-swini*aimag(hc)
          END DO 

c          write(6,'(8f12.4)')(trc(i)*1000,i=-icht,icht,8)
c          read(5,'(a)')
          hh=0.
          do i=-mcht+1,mcht-1,2
           hh=hh+trc(i)*2
          end do
          do i=-mcht+2,mcht-2,2
           hh=hh+trc(i)
          end do
          hh=(hh*2.0+trc(-mcht)+trc(mcht))/3.0
          h1=hh
c         if(mcht.ne.iall)then          
          do i=0,nvch
           x0 =-ichstr(icht-i+2)        ! -ichstr(icht-i+2)=+ichstr(-icht+i-2)
           x1 =-ichstr(icht-i+1)
           x2 =-ichstr(icht-i)
           ap0(i)= (x1-x2)
           ap1(i)=-(x0-x2)
           ap2(i)= (x0-x1)
           bp0(i)=-(x1**2-x2**2)
           bp1(i)= (x0**2-x2**2)
           bp2(i)=-(x0**2-x1**2)
           cp0(i)= (x1-x2)*x1*x2
           cp1(i)=-(x0-x2)*x0*x2
           cp2(i)= (x0-x1)*x0*x1
         
           det=x0**2*ap0(i)+x0*bp0(i)+cp0(i)
           dx3(i)=(x2**3-x0**3)/3./det
           dx2(i)=-bp1(i)/2./det 
           dx1(i)=ap1(i)/det    
          end do              
         
          do i=2,nvch,2
           k0 =-(icht-i+2)        
           k1 =-(icht-i+1)
           k2 =-(icht-i)
           ap= trc(k0)*ap0(i)+trc(k1)*ap1(i)+trc(k2)*ap2(i)
           bp= trc(k0)*bp0(i)+trc(k1)*bp1(i)+trc(k2)*bp2(i)
           cp= trc(k0)*cp0(i)+trc(k1)*cp1(i)+trc(k2)*cp2(i)
           hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i)
          end do
           
          do i=0,nvch-2
           x0 =ichstr(i+mcht)
           x1 =ichstr(i+mcht+1)
           x2 =ichstr(i+mcht+2)
           ap0(i)= (x1-x2)
           ap1(i)=-(x0-x2)
           ap2(i)= (x0-x1)
           bp0(i)=-(x1**2-x2**2)
           bp1(i)= (x0**2-x2**2)
           bp2(i)=-(x0**2-x1**2)
           cp0(i)= (x1-x2)*x1*x2
           cp1(i)=-(x0-x2)*x0*x2
           cp2(i)= (x0-x1)*x0*x1
         
           det=x0**2*ap0(i)+x0*bp0(i)+cp0(i)
           dx3(i)=(x2**3-x0**3)/3./det
           dx2(i)=-bp1(i)/2./det 
           dx1(i)=ap1(i)/det    
          end do              
         
          do i=0,nvch-2,2
           k0=(mcht+i) 
           k1=(mcht+i+1) 
           k2=(mcht+i+2) 
           ap= trc(k0)*ap0(i)+trc(k1)*ap1(i)+trc(k2)*ap2(i)
           bp= trc(k0)*bp0(i)+trc(k1)*bp1(i)+trc(k2)*bp2(i)
           cp= trc(k0)*cp0(i)+trc(k1)*cp1(i)+trc(k2)*cp2(i)
           hh=hh+ap*dx3(i)+bp*dx2(i)+cp*dx1(i)
          end do
          hhoff=hhoff+hh-h1
          hhstr=hhstr+hh
         end if ! swin >> 0.001
        END DO    ! nstrob=0,nstrob_order
c        write(6,'(f10.3,a,2f15.5)')grazing*1000,' hhstr,hhoff=',
c     &                                            hhstr,hhoff/hhstr
        chrock(nchan)=hhstr*2.0
       end do  ! loop over angles by nch_angle
c       write(6,'(8g10.5)') (chrock(i), i=1,nch_angle)
       nn=2*nstorTH1
       do i=1,nch_angle
        real_fr(nn+i)=chrock(i)
       end do
c-----------------------------ifrcase=23---------------------------
      else if(ifrcase.eq.23) then
c      write(6,'(a)') ' synrock roughlay'
c      write(6,'(4f12.5)') (roughlay(i),i=1,mlay)
c      write(6,'(20i5)') (laystr(i),i=1,2*mlay)
c      write(6,'(4e12.5)') (chilay(i),i=1,mlay)
c      write(6,'(4e15.5)') (vkd(i),i=1,mlay)
c      write(6,'(20L3)') (b_sites(i),i=1,mlay)
c      write(6,'(f12.6)') graz_min
c      write(6,'(20i3)')GEOSTR
c      write(6,'(a,20i3)')' mlay,MAXGRP=',mlay,MAXGRP

       do i=1,mlay
        Cmatrix(1,1,i)=(0.0,0.0)
        Cmatrix(1,2,i)=(0.0,0.0)
        Cmatrix(2,1,i)=(0.0,0.0)
        Cmatrix(2,2,i)=(0.0,0.0)
       end do

       do nchan=1,nch_angle
        grazing=0.001*(graz_beg+rd_theta*(nchan-1))

        call optic(b_ew,mlay,b_sites,MAXGRP,GEOSTR,grazing,
     &                Cmatrix,chilay,roughlay,vkd,Rmatrix)
c        if(nchan.eq.2)then
c        write(6,'(i5,a,f15.5)')nchan,' synrock grazing=',grazing
c        write(6,'(8f10.4)')Rmatrix
c        end if
c       trace (dd+*dd*rho) is the intensity
c       bb=cc+
        dd(1)=Rmatrix(1,1)
        dd(3)=Rmatrix(1,2)
        dd(2)=Rmatrix(2,1)
        dd(4)=Rmatrix(2,2)

c       if(nchan.lt.20)write(6,'(8f10.5)') (dd(i),i=1,4)
        bb(1)=conjg(dd(1))
        bb(4)=conjg(dd(4))
        bb(2)=conjg(dd(3))
        bb(3)=conjg(dd(2))
        call matprof(bb,dd,aa)
        call matprof(aa,rho,bb)
c       aa=cc*cc+ is a Hermitian matrix
        h1=real(bb(1)+bb(4))

        if(grazing.lt.grazmin) then
         h1=h1*sin(grazing)/sin(grazmin)
        end if
        chrock(nchan)=h1
       end do  ! loop over angles by nch_angle
c       write(6,'(6g12.5)') (chrock(i),i=1,nch_angle,4)

       do j=1,nch_angle
        chrock(j)=chrock(j)*counts_bunch
       end do
c       chrock(1)=counts_bunch
c       write(6,'(a,2f10.3,L5)') 'prompt counts_bunch,det.,b_det.=',
c     &   counts_bunch,detekt_eff,b_detekt_eff

       qn(0)=1
       nst16=nstorTH1+nch_angle/2
       if(b_detekt_eff) then
        fn(0)=1
        dn(0)=1
        do i=1,30
         dn(i)=dn(i-1)*(1.0-detekt_eff)
        end do
        do i=1,30
         fn(i)=fn(i-1)*float(i)
        end do
        do i=1,30
         dn(i)=(1.0-dn(i))/fn(i)
        end do
        do i=1,15
         array_fr(nst16+i)=cmplx(dn(i),dn(i+15))
        end do
       else
        do i=1,30
         dn(i)=(1.0-dn(i))/fn(i)
        end do
        do i=1,15
         dn(i)=real(array_fr(nst16+i))
         dn(i+15)=aimag(array_fr(nst16+i))
        end do
       end if
       if(b_counts_bunch) then
        do i=1,30
         qn(i)=qn(i-1)*counts_bunch
        end do
        k=0
        h=1
        do while(h.gt.1.0e-4.and.k.le.29)
         k=k+1
         h=qn(k)/fn(k)/counts_bunch
c        write(6,'(a,i2,a2,g15.5,)') 'prompt qn(k)/fn(',k,')=',h
        end do

        array_fr(nst16+16)=cmplx(float(k-1),0.0)
       else
        k=real(array_fr(nst16+16))
       end if
       do j=1,nch_angle
        do i=1,k
         qn(i)=qn(i-1)*chrock(j)
        end do
        h=0
        do i=1,k
         h=h+dn(i)*qn(i)
        end do
        chrock(j)=h*exp(-chrock(j))
       end do

       goto 900

      end if ! ifrcase

 800  continue
c     write(6,'(8g10.5)') (chrock(i)*100,i=1,100)
      nn=2*nstorTH1
      do nchan=1,nch_angle
       chrock(nchan)=real_fr(nn+nchan)
      end do

      do nchan=1,nch_angle
       grazing=0.001*(graz_beg+rd_theta*(nchan-1))
       if(grazing.lt.grazmin) then
        chrock(nchan)=chrock(nchan)*sin(grazing)/sin(grazmin)
       end if
      end do
      b_total=.true.
 
 900  sum=0.
      do nchan=1,nch_angle
       sum=sum+chrock(nchan)
      end do

      nn=nstorTH*2
      if(mstruct1.gt.1) nn=inc_pos*2
      do i=1,nch_angle
       real_fr(nn+i)=chrock(i)/sum
      end do
      call cpu_time(finish)
      print '(" runtime = ",f15.3," seconds.")',finish-start
c      write(6,'(8f10.5)') (chrock(i)*100./sum,i=1,100)
c      write(6,'(a,i6)')' end of synrocking nstorTH=',nn

c     end of calculation of absorber function
c     end of calculation for incoherent par
 2000 continue
c      write(6,'(a,2i6)')'synrock lstruct1,mstruct1=',lstruct1,mstruct1
      if(mstruct1.gt.1) goto 1000

      if(.not.b_total) return

 2500 continue
      if(mstruct1.gt.1) then
c      summation of incoherent parts mstruct1
       if(nyout.gt.512) nyout=512
       nyout=nch_angle/2
       do i=1,nyout
        array_fr(nstorTH+i)=cmplx(0.,0.)
       end do
       do k=1,mstruct1
        nn=ipos_mstruct1(k)
c       write(6,'(a,i6,2i4,2i8,f10.3)')
c     &    'nstorTH,k,nthchannel,iarray_sp,ipos_mstruct1(k),winc(k)=',
c     &        nstorTH,k,n,iarray_sp,nn,winc(k)
c       write(6,'(8f10.4)')(array_fr(nn+i)*100,i=1,16)
        do i=1,nyout
         array_fr(nstorTH+i)=
     &       array_fr(nstorTH+i)+array_fr(nn+i)*winc(k)
        end do
       end do
      end if

      return
      end

