      subroutine thstr_relaxhalfintegral(l_jth,cmch,nhelpentry)
      
c     hyperfine parameters of Hi,DEQ,1/2 relaxation powder 
c     for scalar index of refraction
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth      
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name') then
       nhelpentry='scalar ref.index(dyn)-halfint'            
c      names for child theories , mthchild=3 <= max_nth       
       nameth(1)='Kramers doublet (nuclear 3/2->1/2 tr)'
       namepg(1)='spin_half_refindex_dynamic scal,1 '
       nameth(2)='crystal field-Kramers doublet (nuclear 3/2->1/2 tr)'
       namepg(2)='spin_half_refindex_dynamic scal,2 '
       nameth(3)='crystal field S=5/2 sextet (nuclear 3/2->1/2 tr)'
       namepg(3)='spin_half_refindex_dynamic scal,3 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='scalar refraction index (dynamic,sad)'
       ntheory(2)='scalar refraction index (dynamic,sad-interpol.)'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(2))l_jth=3
       return
      end if
      
      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth  
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

c     common/acssptrf/ acssp,gamnat,aISYM,aNPLONG

      thco(jc+1)='iset(1-3)  i_pos=1    include=y  1 '
              ! number of theta values for powder averaging
      thco(jc+2)='i_sym   i_pos=2    include=y    12 '
      jc=jc+2
              ! number of phi values for powder averaging
c     definition of isym (spezified by the calling routine):
c     C4 || z-axis                     C3 || z-axis
c     cubic    isym=11                 cubic     isym=21
c     D4       isym=12                 D3             22
c     D2            13                 C2             23
c     C2            14                 C1             24
c     C1            15                
c     iOM  (i-Omega) number of points, equal weights  dOM=1./iOM
c     np: number of points on 1/48 sphere,  np=2**(iset+1)
     
      if(l_jth.eq.3) then 
c                 123456789012345678901234567      
       thco(jc+1)='temperature  i_pos=3    include= y  4.2 '
       jc=jc+1
      end if
     
c     intensity and gamnat are defined in  the structure definition routine 
c     thstr_mossbauerf0(l_jth,cmch,nhelpentry)

c      common/avssptrf/ avssp,intensity,L_width,iso,h0,
c     &                 dq,eta,gml,ax,ay,az,gx,gy,gz
c        iso                   !isomer shift
c        h0                    !overall hyperfine splitting, mm/s
c        dq                    !quadrupole splitting, mm/s
c        eta                   !quadrupole assymetry
c        gml                   !relaxation rate, mm/s (*11.625 MHz)

c        ax      !A-tensor     Delta       D     ! axial splitting    Delta   
c        ay                    V_rhomb     E/D                        V_rhomb
c        az                                cube  ! cubic splitting
c        gx      !g-tensor                 F
c        gy                                alpha ! orientation of Deq 
c        gz                                beta
c                                          gamma
      
      ntrmt(jm+1)='position   matrix=(1,1)   include=y'
      ctrmt(jm+1)='position of the spectrum'
       thpa(jp+1)='is_shift           , 0.0  0.0 0.0  0.1'
       thvr(jv+1)='is_shift                2    1  '
      
      ntrmt(jm+2)='L_broadening matrix=(1,1)   include=[n]'
      ctrmt(jm+2)='Lorentz broadening in units of natural wdths'
       thpa(jp+2)='L_width              , 0.0  0.0 0.0  0.1'
       thvr(jv+2)='L_width                 1   1'

       ntrmt(jm+3)='splitting  matrix=(1,1)   include=y'
       ctrmt(jm+3)='splitting for 5/2*A_tensor at  crystal site'
        thpa(jp+3)='splitting[mm/s]         , 3.0  0.0 0.0  0.1'
        thvr(jv+3)='splitting[mm/s]          3    1 '

       ntrmt(jm+4)='EFG  matrix=(2,2)   include=[n]'
       ctrmt(jm+4)='electric field gradient tensor at crystal site'
        thpa(jp+4)='EFG                 , 0.0  0.0 0.0  0.1'         
        thpa(jp+5)='eta                 , 0.0  0.0 0.0  0.1'         
        thvr(jv+4)='EFG                      4   , 1 0'                 
        thvr(jv+5)='eta                      5   , 0 1'                                    
       
       
       
       ntrmt(jm+5)='relaxation_rate matrix=(1,1)   include=y'
       ctrmt(jm+5)='relaxation rate, mm/s (*11.625 MHz)'
        thpa(jp+6)='g_relax            ,  0.3  0.0 0.0  0.05'
        thvr(jv+6)='g_relax                  6    1 '
       jm=jm+5
       jp=jp+6 
       jv=jv+6    

       if(l_jth.eq.1) then
c                      123456789012345678901234567      
        ntrmt(jm+1)='A_tensor  matrix=(3,3)   include=y'
        ctrmt(jm+1)='A_tensor components at crystal site'
         thpa(jp+1)='ax               , 3.0  0.0 0.0  0.1'
         thpa(jp+2)='ay               , 2.0 0.0 0.0   0.1'
         thpa(jp+3)='az               , 1.0 0.0 0.0   0.1 '
         thvr(jv+1)='ax                       7     1 0 0  '
         thvr(jv+2)='ay                       8   , 0 1 0 '
         thvr(jv+3)='az                       9   , 0 0 1 '
      
        ntrmt(jm+2)='g_tensor  matrix=(3,3)   include=y'
        ctrmt(jm+2)='g_tensor components at crystal site'
         thpa(jp+4)='gx             , 6.0  0.0 0.0  0.1'
         thpa(jp+5)='gy             , 4.0  0.0 0.0  0.1'
         thpa(jp+6)='gz             , 2.0  0.0 0.0  0.1'
         thvr(jv+4)='gx                      10   1 0 0'
         thvr(jv+5)='gy                      11   0 1 0'
         thvr(jv+6)='gz                      12   0 0 1 '
        jm=jm+2
        jp=jp+6
        jv=jv+6
        else if(l_jth.eq.2) then
        ntrmt(jm+1)='crystal_field   matrix=(2,2)   include=y'
        ctrmt(jm+1)='crystal_field components D,V at crystal site'
         thpa(jp+1)='Delta                  , 3.0  0.0 0.0  0.1'
         thpa(jp+2)='V_rhomb                , 2.0  0.0 0.0  0.1'
         thvr(jv+1)='Delta                     7     1 0  '
         thvr(jv+2)='V_rhomb                   8     0 1  '
        jm=jm+1 
        jp=jp+2
        jv=jv+2
       else if(l_jth.eq.3) then
        ntrmt(jm+1)='D_F_tensor  matrix=(4,4)   include=y'
        ctrmt(jm+1)='spin Hamiltonian for s=5/2at crystal site'
         thpa(jp+1)='D[cm-1]                 1.5  0.0 0.0  0.1'
         thpa(jp+2)='E/D                     0.3  0.0 0.0  0.03'
         thpa(jp+3)='cube[cm-1]              0.2  0.0 0.0  0.01'
         thpa(jp+4)='F[cm-1]                 0.1  0.0 0.0  0.01'
         thvr(jv+1)='D[cm-1]                  7  1 0 0 0'
         thvr(jv+2)='E/D                      8  0 1 0 0'
         thvr(jv+3)='cube[cm-1]               9  0 0 1 0'
         thvr(jv+4)='F[cm-1]                  10 0 0 0 1'

        ntrmt(jm+2)='Q_orientation   matrix=(3,3)   include=[n]'
        ctrmt(jm+2)='orientation of DEq tensor at crystal site'
         thpa(jp+5)='Q_alpha             , 0.0  0.0 0.0  0.1'
         thpa(jp+6)='Q_beta              , 0.0  0.0 0.0  0.1'
         thpa(jp+7)='Q_gamma             , 0.0  0.0 0.0  0.1'
         thvr(jv+5)='Q_alpha                  11   1 0 0'
         thvr(jv+6)='Q_beta                   12   0 1 0'
         thvr(jv+7)='Q_gamma                  13   0 0 1 '
        jm=jm+2
        jp=jp+7
        jv=jv+7
        end if
 
      call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

      subroutine thstr_relaxtwostate(l_jth,cmch,nhelpentry)
      
c     hyperfine parameters of Hi,DEQ,1/2 relaxation powder 
c     for scalar index of refraction
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='scalar ref.index(dyn)-twostate'
c      names for child theories , mthchild=2 <= max_nth       
       nameth(1)='two state +H/-H perturbation'
       namepg(1)='two_state_refindex_dynamic_pert scal,1 '
       nameth(2)='two state +H/-H perturbation-B/T'
       namepg(2)='two_state_refindex_dynamic_pert scal,2 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='scalar refraction index (dynamic,sad)'
       ntheory(2)='scalar refraction index (dynamic,sad-interpol.)'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(2))l_jth=2
       return
      end if
      
      chth='th'//nhelpentry(1:6)
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3,5   chth='//chth      
c                 ! 2+8 constants
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
       if(l_jth.eq.2) then 
c                 123456789012345678901234567      
        thco(jc+1)='Treference  i_pos=1    include=y    100.0 '
              ! reference temperature for claculation of magnetization
        jc=jc+1
       end if

c      common/avssptrf/ avssp,intensity,iso,hz1,hz2,
c     &                 dq,t_rate,gam
c        iso                   ! isomer shift
c        hz1                   ! 1/2(hz1+hz2) kG
c        dhz                   ! hz1-hz       kG
c        dq                    ! quadrupole shift, mm/s
c        t_rate                ! relaxation rate, mm/s (*11.625 MHz)
c        pop_ratio             ! population of state 1/population state 2
c        forM(T)               ! for calculation of magnetization(T)
c        ai0                   ! m=0 intensity ratio 1=random
      
      
c                    123456789012345678901234567      
      ntrmt(jm+1)='position  matrix=(1,1)   include= y'
      ctrmt(jm+1)='position of the spectrum'
       thpa(jp+1)='is_shift           , 0.0  0.0 0.0  0.1'
       thvr(jv+1)='is_shift                1    1  '
      
c                     123456789012345678901234567
       ntrmt(jm+2)='Hz-field  matrix=(2,2)   include= y'
       ctrmt(jm+2)='Hz1 are the fields of the two states '
        thpa(jp+2)='Hz1[kG]               , 330.0  0.0 0.0  1.0'
        thpa(jp+3)='Hz2[kG]              , -330.0   0.0 0.0  0.5'
        thvr(jv+2)='Hz1[kG]                  2    1 0'
        thvr(jv+3)='Hz2[kG]                  3    0 1'

       ntrmt(jm+3)='quadrupole-shift matrix=(1,1)   include=[n]'
       ctrmt(jm+3)='line shift by electric field gradient tensor'
        thpa(jp+4)='qu[mm/s]               , 0.0  0.0 0.0  0.1'         
        thvr(jv+4)='qu[mm/s]                 4    1'                  
       jm=jm+3
       jp=jp+4
       jv=jv+4 
       if(l_jth.eq.1)then      
        ntrmt(jm+1)='relaxation_rate  matrix=(2,2)   include= y'
        ctrmt(jm+1)='relaxation rate, mms (*11.625 MHz)'
         thpa(jp+1)='rate[mm/s]            0.3  0.0 0.0  0.05'
         thpa(jp+2)='popratio              1.0  1.0 100.  0.1'
         thvr(jv+1)='raterelax                5  1  0 '
         thvr(jv+2)='popratio                 6  0  1 '
        jm=jm+1
        jp=jp+2
        jv=jv+2  
       else
        ntrmt(jm+1)='relaxation_rate  matrix=(1,1)   include=y'
        ctrmt(jm+1)='relaxation rate, mms (*11.625 MHz)'
         thpa(jp+1)='rate[mm/s]            0.3  0.0 0.0  0.05'
         thvr(jv+1)='raterelax                5  1   '

        ntrmt(jm+2)='magnetization  matrix=(2,2)   include= y'
        ctrmt(jm+2)='magnetic moment and M(T) parameter'
         thpa(jp+2)='forM(T)               -0.05  0.0 0.0  0.05'
         thpa(jp+3)='Moment                 2.24  1.0 100.  0.1'
         thvr(jv+2)='forMofT                  7  1  0 '
         thvr(jv+3)='Moment                   6  0  1 '
        jm=jm+2
        jp=jp+3 
        jv=jv+3 
c       0.0467 *B[kG]cm**-1 ; 0.695*T cm**-1 ; 2.24^=10**4 mu-Bohr*1kG/300K
       end if

       ntrmt(jm+1)='intratio_m0  matrix=(1,1)   include=y'
       ctrmt(jm+1)='factor intensity delta m=0 (1=random)'
        thpa(jp+1)='intratio-m0              , 1.0  0.0 0.0  0.1'         
        thvr(jv+1)='intratio-m0                8    1'                  
       jm=jm+1
       jp=jp+1
       jv=jv+1
      call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end
      

      subroutine thstr_lines126(l_jth,cmch,nhelpentry)

c     hyperfine parameters of singlet, doublet, and sextet
c     for scalar n(E) refraction index (static)
c     level 3 theory
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='scalar ref.index(stat)-l1 l2 l6' 
c      names for child theories , mthchild=3 <= max_nth       
       nameth(1)='singlet: width, position and intensity'
       namepg(1)='singlet_doublet_sextet scal,1 '
       nameth(2)='doublet: width, position and intensity'
       namepg(2)='singlet_doublet_sextet scal,2 '
       nameth(3)='sextet : width, position and intensity'
       namepg(3)='singlet_doublet_sextet scal,3 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='scalar refraction index (static,sad)'
       ntheory(2)='scalar refraction index (static)'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(2))l_jth=3
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if      
      
      call conmatpar('coll',jc,jm,jp,jv,chth)

      
c      common/avssptrf/ avssp,
c     &                 intensity,shift,
c     &                 avss(19),fr_int(8),pos(8)     ! 34
      
      if(l_jth.eq.1) then
       ntrmt(jm+1)='broadening  matrix=(2,2)   include=[n]'
       ctrmt(jm+1)='broadening of the lines of the spectrum'
        thpa(jp+1)='G_width          , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='L_width          , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='G_width                 1   1.  0  '
        thvr(jv+2)='L_width                 9   0   1.  '
       jm=jm+1
       jp=jp+2
       jv=jv+2
      end if
      
      if(l_jth.eq.2) then 
       ntrmt(jm+1)='splitting   matrix=(2,1)   include=y'
       ctrmt(jm+1)='splitting of the doublet lines'
        thpa(jp+1)='splitting        , 0.0  0.0 0.0  0.1'
c       thpa(jp+2)= dummy            , 0.0  0.0 0.0  0.1
        thvr(jv+1)='pos_1                   25    -0.5 '
        thvr(jv+2)='pos_2                   26     0.5 '
       jm=jm+1
       jp=jp+1
       jv=jv+2
c                      123456789012345678901234567      
       ntrmt(jm+1)='broadening  matrix=(4,4)   include=[n]'
       ctrmt(jm+1)='broadening of the lines of the spectrum'
        thpa(jp+1)='G_width_1        , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='L_width_1        , 0.0  0.0 0.0  0.1'
        thpa(jp+3)='G_width_2        , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width_2        , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='G_width_1               1   1 0 0 0 '
        thvr(jv+2)='L_width_1               9   0 1 0 0 '
        thvr(jv+3)='G_width_2               2   0 0 1 0 '
        thvr(jv+4)='L_width_2               10  0 0 0 1 '
      
       ntrmt(jm+2)='Intensity_frc  matrix=(2,2)   include=y'
       ctrmt(jm+2)='intensities fraction of the doublet lines'
        thpa(jp+5)='fr_int_1         , 0.5  0.0 1.0  0.01'
        thpa(jp+6)='fr_int_2         , 0.5  0.0 1.0  0.01'
        thvr(jv+5)='fr_int_1                17   1 0 '
        thvr(jv+6)='fr_int_2                18   0 1 '
       jm=jm+2
       jp=jp+6
       jv=jv+6
      end if
      
      if(l_jth.eq.3) then
c                     123456789012345678901234567      
       ntrmt(jm+1)='position  matrix=(6,6)   include=y'
       ctrmt(jm+1)='position of the lines of the sextet'
        thpa(jp+1)='rel_pos_1        , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='rel_pos_2        , 0.0  0.0 0.0  0.1'
        thpa(jp+3)='rel_pos_3        , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='rel_pos_4        , 0.0  0.0 0.0  0.1'
        thpa(jp+5)='rel_pos_5        , 0.0  0.0 0.0  0.1'
        thpa(jp+6)='rel_pos_6        , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='rel_pos_1               25   1 0 0 0 0 0 '
        thvr(jv+2)='rel_pos_2               26   0 1 0 0 0 0 '
        thvr(jv+3)='rel_pos_3               27   0 0 1 0 0 0 '
        thvr(jv+4)='rel_pos_4               28   0 0 0 1 0 0 '
        thvr(jv+5)='rel_pos_5               29   0 0 0 0 1 0 '
        thvr(jv+6)='rel_pos_6               30   0 0 0 0 0 1 '
       jm=jm+1
       jp=jp+6
       jv=jv+6
      
       ntrmt(jm+1)='G_broadening  matrix=(6,6)   include=[n]'
       ctrmt(jm+1)='Gauss broadening of the lines of the spectrum'
        thpa(jp+1)='G_width_1         , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='G_width_2         , 0.0  0.0 0.0  0.1'
        thpa(jp+3)='G_width_3         , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='G_width_4         , 0.0  0.0 0.0  0.1'
        thpa(jp+5)='G_width_5         , 0.0  0.0 0.0  0.1'
        thpa(jp+6)='G_width_6         , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='G_width_1               1   1 0 0 0 0 0 '
        thvr(jv+2)='G_width_2               2   0 1 0 0 0 0 '
        thvr(jv+3)='G_width_3               3   0 0 1 0 0 0 '
        thvr(jv+4)='G_width_4               4   0 0 0 1 0 0 '
        thvr(jv+5)='G_width_5               5   0 0 0 0 1 0 '
        thvr(jv+6)='G_width_6               6   0 0 0 0 0 1 '
       jm=jm+1
       jp=jp+6
       jv=jv+6
       ntrmt(jm+1)='L_broadening matrix=(6,6)   include=[n]'
       ctrmt(jm+1)='Lorentz broadening of the lines of the spectrum'
        thpa(jp+1)='L_width_1        , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='L_width_2        , 0.0  0.0 0.0  0.1'
        thpa(jp+3)='L_width_3        , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width_4        , 0.0  0.0 0.0  0.1'
        thpa(jp+5)='L_width_5        , 0.0  0.0 0.0  0.1'
        thpa(jp+6)='L_width_6        , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='L_width_1               9    1 0 0 0 0 0 '
        thvr(jv+2)='L_width_2               10   0 1 0 0 0 0 '
        thvr(jv+3)='L_width_3               11   0 0 1 0 0 0 '
        thvr(jv+4)='L_width_4               12   0 0 0 1 0 0 '
        thvr(jv+5)='L_width_5               13   0 0 0 0 1 0 '
        thvr(jv+6)='L_width_6               14   0 0 0 0 0 1 '
       jm=jm+1
       jp=jp+6
       jv=jv+6
       ntrmt(jm+1)='Intensity  matrix=(6,6)   include=y'
       ctrmt(jm+1)='intensities  of the  sextet'
        thpa(jp+1)='fr_int_1         , 0.2499  0.0 1.0  0.01'
        thpa(jp+2)='fr_int_2         , 0.1666  0.0 1.0  0.01'
        thpa(jp+3)='fr_int_3         , 0.0833  0.0 1.0  0.01'
        thpa(jp+4)='fr_int_4         , 0.0833  0.0 1.0  0.01'
        thpa(jp+5)='fr_int_5         , 0.1666  0.0 1.0  0.01'
        thpa(jp+6)='fr_int_6         , 0.2499  0.0 1.0  0.01'
        thvr(jv+1)='fr_int_1                17   1 0 0 0 0 0 '
        thvr(jv+2)='fr_int_2                18   0 1 0 0 0 0 '
        thvr(jv+3)='fr_int_3                19   0 0 1 0 0 0 '
        thvr(jv+4)='fr_int_4                20   0 0 0 1 0 0 '
        thvr(jv+5)='fr_int_5                21   0 0 0 0 1 0 '
        thvr(jv+6)='fr_int_6                22   0 0 0 0 0 1 '
       jm=jm+1
       jp=jp+6
       jv=jv+6
      end if

      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end
      
    
      
      
      subroutine thstr_hdeqmiscil(l_jth,cmch,nhelpentry)
      
c     hyperfine parameters of Hi,DEQ,powder average <rik(j)>
c                             Hi,DEQ, width(1-8)
c                             Hi,DEQ, intensity(1-8),width(1-8)
c     for scalar index of refraction
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth      
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo
 

      if(cmch.eq.'name')then 
       nhelpentry='scalar ref.index(stat)-Hi,DEQ'                         
c      names for child theories , mthchild=3 <= max_nth      
       nameth(1)='Hi,DEQ,powder average <rik(j)>'
       namepg(1)='Hi_DEQ_miscellaneous  scal,1 '
       nameth(2)='Hi,DEQ, width(1-8) '
       namepg(2)='Hi_DEQ_miscellaneous  scal,2 '
       nameth(3)='Hi,DEQ, intensity(1-8),width(1-8) '
       namepg(3)='Hi_DEQ_miscellaneous  scal,3 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='scalar refraction index (static,sad)'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=3
       return
      end if
      
      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=5   chth='//chth
c                 8 constants
       return
      end if

c      common/avssptrf/ avssp,
c     &                 intensity,shift,                        2
c     &                 w_Gaus(8),w_Lorentz(8),
c     &                 fr_int(8),aH,thetaH,phiH,DEq,eta        29
      
      call conmatpar('coll',jc,jm,jp,jv,chth)
      
c                     123456789012345678901234567
       ntrmt(jm+1)='H_internal  matrix=(1,1)   include=[n]'
       ctrmt(jm+1)='internal magnetic field at crystal site'
        thpa(jp+1)='Hi               , 333.0  0.0 0.0  1.0'
        thvr(jv+1)='Hi                       25   , 1   '
      
       ntrmt(jm+2)='H_direction  matrix=(2,2)   include=[n]'
       ctrmt(jm+2)='direction of internal magnetic field in the EFG'
        thpa(jp+2)='thetaH           , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiH             , 0.0 0.0 0.0   1.0 '
        thvr(jv+2)='thetaH                   26   , 1 0 '
        thvr(jv+3)='phiH                     27   , 0 1 '

       ntrmt(jm+3)='EFG   matrix=(2,2)   include=[n]'
       ctrmt(jm+3)='electric field gradient tensor at crystal site'
        thpa(jp+4)='EFG              , 0.0  0.0 0.0  0.1'
        thpa(jp+5)='eta              , 0.0  0.0 0.0  0.1'
        thvr(jv+4)='EFG                     28   , 1 0'
        thvr(jv+5)='eta                     29   , 0 1 '
       jm=jm+3
       jp=jp+5
       jv=jv+5     

      if(l_jth.eq.1) then
       ntrmt(jm+1)='broadening matrix=(2,2)   include=[n]'
       ctrmt(jm+1)='broadening of the lines of the spectrum'
        thpa(jp+1)='L_width         , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='G_width         , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='L_width                  9   1 0 '
        thvr(jv+2)='G_width                  1   0 1 '
       jm=jm+1
       jp=jp+2 
       jv=jv+2

       call conmatpar('layn',jc,jm,jp,jv,chth)
       return
      end if

      thco(jc+1)='offset_line   i_pos=1    include=[n]    0'
               ! offset counter if more than 8 energies 
      jc=jc+1
      
c                    123456789012345678901234567      
      ntrmt(jm+1)='G_broadening   matrix=(8,8)   include=[n]'
      ctrmt(jm+1)='Gauss broadening(8) of lines of the spectrum'
       thpa(jp+1)='G_width_1        , 0.0  0.0 0.0  0.1'
       thpa(jp+2)='G_width_2        , 0.0  0.0 0.0  0.1'
       thpa(jp+3)='G_width_3        , 0.0  0.0 0.0  0.1'
       thpa(jp+4)='G_width_4        , 0.0  0.0 0.0  0.1'
       thpa(jp+5)='G_width_5        , 0.0  0.0 0.0  0.1'
       thpa(jp+6)='G_width_6        , 0.0  0.0 0.0  0.1'
       thpa(jp+7)='G_width_7        , 0.0  0.0 0.0  0.1'
       thpa(jp+8)='G_width_8        , 0.0  0.0 0.0  0.1'
       thvr(jv+1)='G_width_1                1   1 0 0 0 0 0 0 0'
       thvr(jv+2)='G_width_2                2   0 1 0 0 0 0 0 0'
       thvr(jv+3)='G_width_3                3   0 0 1 0 0 0 0 0'
       thvr(jv+4)='G_width_4                4   0 0 0 1 0 0 0 0'
       thvr(jv+5)='G_width_5                5   0 0 0 0 1 0 0 0'
       thvr(jv+6)='G_width_6                6   0 0 0 0 0 1 0 0'
       thvr(jv+7)='G_width_7                7   0 0 0 0 0 0 1 0'
       thvr(jv+8)='G_width_8                8   0 0 0 0 0 0 0 1 '
      jm=jm+1
      jp=jp+8
      jv=jv+8
      ntrmt(jm+1)='L_broadening   matrix=(8,8)   include=[n]'
      ctrmt(jm+1)='Lorentz broadening(8) of lines of the spectrum'
       thpa(jp+1)='L_width_1        , 0.0  0.0 0.0  0.1'
       thpa(jp+2)='L_width_2        , 0.0  0.0 0.0  0.1'
       thpa(jp+3)='L_width_3        , 0.0  0.0 0.0  0.1'
       thpa(jp+4)='L_width_4        , 0.0  0.0 0.0  0.1'
       thpa(jp+5)='L_width_5        , 0.0  0.0 0.0  0.1'
       thpa(jp+6)='L_width_6        , 0.0  0.0 0.0  0.1'
       thpa(jp+7)='L_width_7        , 0.0  0.0 0.0  0.1'
       thpa(jp+8)='L_width_8        , 0.0  0.0 0.0  0.1'
       thvr(jv+1)='L_width_1                9   1 0 0 0 0 0 0 0'
       thvr(jv+2)='L_width_2                10   0 1 0 0 0 0 0 0'
       thvr(jv+3)='L_width_3                11   0 0 1 0 0 0 0 0'
       thvr(jv+4)='L_width_4                12   0 0 0 1 0 0 0 0'
       thvr(jv+5)='L_width_5                13   0 0 0 0 1 0 0 0'
       thvr(jv+6)='L_width_6                14   0 0 0 0 0 1 0 0'
       thvr(jv+7)='L_width_7                15   0 0 0 0 0 0 1 0'
       thvr(jv+8)='L_width_8                16   0 0 0 0 0 0 0 1 '
      jm=jm+1
      jp=jp+8
      jv=jv+8                      
c                     123456789012345678901234567      
      if(l_jth.eq.3) then
       ntrmt(jm+1)='Intensity   matrix=(8,8)   include=y'
       ctrmt(jm+1)='intensities(8)  of the lines'
        thpa(jp+1)='fr_int_1         , 0.0277  0.0 1.0  0.01'
        thpa(jp+2)='fr_int_2         , 0.0555  0.0 1.0  0.01'
        thpa(jp+3)='fr_int_3         , 0.0833  0.0 1.0  0.01'
        thpa(jp+4)='fr_int_4         , 0.1111  0.0 1.0  0.01'
        thpa(jp+5)='fr_int_5         , 0.1388  0.0 1.0  0.01'
        thpa(jp+6)='fr_int_6         , 0.1666  0.0 1.0  0.01'
        thpa(jp+7)='fr_int_7         , 0.1944  0.0 1.0  0.01'
        thpa(jp+8)='fr_int_8         , 0.2222  0.0 1.0  0.01'
        thvr(jv+1)='fr_int_1                 17    1 0 0 0 0 0 0 0'
        thvr(jv+2)='fr_int_2                 18    0 1 0 0 0 0 0 0'
        thvr(jv+3)='fr_int_3                 19    0 0 1 0 0 0 0 0'
        thvr(jv+4)='fr_int_4                 20    0 0 0 1 0 0 0 0'
        thvr(jv+5)='fr_int_5                 21    0 0 0 0 1 0 0 0'
        thvr(jv+6)='fr_int_6                 22    0 0 0 0 0 1 0 0'
        thvr(jv+7)='fr_int_7                 23    0 0 0 0 0 0 1 0'
        thvr(jv+8)='fr_int_8                 24    0 0 0 0 0 0 0 1 '
       jm=jm+1
       jp=jp+8
       jv=jv+8        
      end if
      call conmatpar('layn',jc,jm,jp,jv,chth)
      
      return
      end
