      subroutine thstr_hdeq(l_jth,cmch,nhelpentry)

c     hyperfine parameters of H(j),DEQ(j), equivalent sites
c     for n_ik(E) refraction index (static)
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth 
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo
 
      if(cmch.eq.'name')then
       nhelpentry='22ref.index(stat)-H DEQ' 
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='H(S_E),DEQ, equivalent sites'
       namepg(1)='H_DEQ_equivalent_sites  plrs,1 '
       nameth(2)='H(S_C),DEQ, equivalent sites'
       namepg(2)='H_DEQ_equivalent_sites  plrs,2 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (static,sad)'
       ntheory(2)='2x2 refraction index (static)'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(2))l_jth=2
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth  
c      list=5 introduces <= 8 constants
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      thco(jc+1)='sym_case    i_pos=1    include=y   0'
               ! equivalent sites by rotation around the z-axis
      thco(jc+2)='time_invers  i_pos=2   include=y   0' 
               ! equivalent sites by rotation around the y-axis
      jc=jc+2

c      common/avsstrf/avss,
c                      sftr,aisom,w_Gauss,w_Lorentz
c     &                sx2zz,sx2eta,sx2phi,sx2theta,sx2psi,
c     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE


c                    123456789012345678901234567      
      ntrmt(jm+1)='H_internal  matrix=(3,3)   include=[n] '
      ctrmt(jm+1)='internal magnetic field at crystal site'
       thpa(jp+1)='Hi               , 333.0  0.0 0.0  1.0'
       thpa(jp+2)='thetaH           , 0.0 0.0 0.0   1.0'
       thpa(jp+3)='phiH             , 0.0 0.0 0.0   1.0 '
       thvr(jv+1)='Hi                      1    1 0 0  '
       thvr(jv+2)='thetaH                  2    0 1 0 '
       thvr(jv+3)='phiH                    3    0 0 1'

      ntrmt(jm+2)='EFG   matrix=(2,2)   include=[n] '
      ctrmt(jm+2)='electric field gradient tensor at crystal site'
       thpa(jp+4)='EFG              , 0.0  0.0 0.0  0.1'
       thpa(jp+5)='eta              , 0.0  0.0 0.0  0.1'
       thvr(jv+4)='EFG                     4    1 0 '
       thvr(jv+5)='eta                     5     0 1 '

      ntrmt(jm+3)='orient_EFG   matrix=(3,3)   include=[n] '
      ctrmt(jm+3)='Euler angle of the EFG in the crystal system'
       thpa(jp+6)='phiE            , 0.0  0.0 0.0  1.0'
       thpa(jp+7)='thetaE          , 0.0 0.0 0.0   1.0'
       thpa(jp+8)='psiE            , 0.0 0.0 0.0   1.0 '
       thvr(jv+6)='phiE                    6   1 0 0'
       thvr(jv+7)='thetaE                  7   0 1 0'
       thvr(jv+8)='psiE                    8   0 0 1 '
      jm=jm+3
      jp=jp+8
      jv=jv+8
       call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end


      subroutine thstr_hdeqf(l_jth,cmch,nhelpentry)

c     hyperfine parameters of H(j),DEQ(j), equivalent sites
c     for n_ik(E) refraction index (static), 
c     powder,texture and external field
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth 
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='22ref.index(stat)-H DEQ f'
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='H(S_E),DEQ,f(S_C), equiv. sites'  ! H in S_efg 
       namepg(1)='H_DEQ_f_equivalent_sites  plrs,1 '
       nameth(2)='H(S_C),DEQ,f(S_C), equiv. sites'  ! H in S_C
       namepg(2)='H_DEQ_f_equivalent_sites  plrs,2 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (static,f_anisotrop,sad)'
       ntheory(2)='2x2 refraction index (static)'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(2))l_jth=2
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth   
c      8 constants from list=5 
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

       thco(jc+1)='sym_case  i_pos=1    include=y   0'
               ! equivalent sites by rotation around the z-axis
       thco(jc+2)='time_invers  i_pos=2 include=y   0'
               ! equivalent sites by rotation around the y-axis
       jc=jc+2

c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,
c     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE
c                     123456789012345678901234567      
       ntrmt(jm+1)='x2sanisotropy  matrix=(2,2)   include=[n]'
       ctrmt(jm+1)='mean square <x2> at the site'
        thpa(jp+1)='dsx2                  ,  0.0  0.0 0.0  0.1'
        thpa(jp+2)='x2seta                ,  0.0  0.0 0.0  0.1'
        thvr(jv+1)='dsx2                     1    1 0  '
        thvr(jv+2)='x2seta                   2    0 1  '

       ntrmt(jm+2)='x2sorientation  matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='<x2> orientation with respect to S_C for'
        thpa(jp+3)='x2sphi                , 0.0  0.0 0.0  1.0'
        thpa(jp+4)='x2stheta              , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='x2spsi                , 0.0  0.0 0.0  1.0'
        thvr(jv+3)='x2sphi                   3    1 0 0 '
        thvr(jv+4)='x2stheta                 4    0 1 0 '
        thvr(jv+5)='x2spsi                   5    0 0 1 '

       ntrmt(jm+3)='H_internal  matrix=(3,3)   include=[n]'
       ctrmt(jm+3)='internal magnetic field at crystal site'
        thpa(jp+6)='Hi               , 333.0  0.0 0.0  1.0'
        thpa(jp+7)='thetaH           , 0.0 0.0 0.0   1.0'
        thpa(jp+8)='phiH             , 0.0 0.0 0.0   1.0 '
        thvr(jv+6)='Hi                       6    1 0 0  '
        thvr(jv+7)='thetaH                   7    0 1 0 '
        thvr(jv+8)='phiH                     8    0 0 1'
       jm=jm+3
       jp=jp+8
       jv=jv+8
       ntrmt(jm+1)='EFG    matrix=(2,2)   include=[n]'
       ctrmt(jm+1)='electric field gradient tensor at crystal site'
        thpa(jp+1)='EFG              , 0.0  0.0 0.0  0.1'
        thpa(jp+2)='eta              , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='EFG                      9     1 0 '
        thvr(jv+2)='eta                      10    0 1 '
       
       ntrmt(jm+2)='orient_EFG    matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='Euler angle of the EFG in the crystal system'
        thpa(jp+3)='phiE            , 0.0  0.0 0.0  1.0'
        thpa(jp+4)='thetaE          , 0.0 0.0 0.0   1.0'
        thpa(jp+5)='psiE            , 0.0 0.0 0.0   1.0 '
        thvr(jv+3)='phiE                    11   1 0 0'
        thvr(jv+4)='thetaE                  12   0 1 0'
        thvr(jv+5)='psiE                    13   0 0 1'
       jm=jm+2
       jp=jp+5
       jv=jv+5
       call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end


      subroutine thstr_hyperfineft(l_jth,cmch,nhelpentry)

c     hyperfine parameters of H(j),DEQ(j), equivalent sites
c     for n_ik(E) refraction index (static), 
c     powder,texture and external field
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth 
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='2x2_index_f_spinham'                           

c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='DEQ spin Hamiltonian'    !  in S_C 
       namepg(1)='DEQ_H_spinham_equiv_sites plrs,1 '
       nameth(2)='DEQ spin Hamiltonian, 2 hyp_fields'  !  in S_C      
       namepg(2)='DEQ_H_spinham_equiv_sites plrs,2 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (f,t,spinham,sad)'
       ntheory(2)='2x2 refraction index (f,t,spinham)'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(2))l_jth=2
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth   
c      8 constants from list=5 
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
 
       thco(jc+1)='sym_case  i_pos=1    include=y   0'
               ! equivalent sites by rotation around the z-axis
       jc=jc+1

c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,
c     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE

       ntrmt(jm+1)='x2sanisotropy    matrix=(2,2)   include=[n]'
       ctrmt(jm+1)='mean square <x2> at the site'
        thpa(jp+1)='dsx2                  ,  0.0  0.0 0.0  0.1'
        thpa(jp+2)='x2seta                ,  0.0  0.0 0.0  0.1'
        thvr(jv+1)='dsx2                     1    1 0  '
        thvr(jv+2)='x2seta                   2    0 1  '

       ntrmt(jm+2)='x2sorientation   matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='<x2> orientation with respect to S_C for'
        thpa(jp+3)='x2sphi                , 0.0  0.0 0.0  1.0'
        thpa(jp+4)='x2stheta              , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='x2spsi                , 0.0  0.0 0.0  1.0'
        thvr(jv+3)='x2sphi                   3    1 0 0 '
        thvr(jv+4)='x2stheta                 4    0 1 0 '
        thvr(jv+5)='x2spsi                   5    0 0 1 '
       jm=jm+2
       jp=jp+5
       jv=jv+5
      call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

