      subroutine frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,
     &                                           cmch,nhelpentry)
      integer l_nfrtheo,lstruct1,lstruct2     
      character*132 nhelpentry,cmch*4,chth*8
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      integer mstruct1,idum   
      common/struct/mstruct1,idum(istruct-1)
      logical lfrthi2i6 

c      write(6,'(2a,i6)')'####frstr_mossbauer cmch=',cmch,l_nfrtheo
      if(cmch.eq.'name') then
c#########################################################################
       nhelpentry  ='Mossbauer spectrum'                                   
       ntheory(1)='Mossbauer radioactive source'

       n_device=3 
       ndevice(1)='source'
       ndevice(2)='absorber/scatterer'
       ndevice(3)='detector'
c#########################################################################
       return
      end if
c     nhelpentry defines the name of the helpfile: Mossbauer_spectrum.help

c     the different cases of theories are selected by the subroutine
c     thstr_frmossbauer:
c     l_nfrtheo=1 :'Mossbauer transmission_vA'
c     l_nfrtheo=2 :'Mossbauer transmission_vB'
c     l_nfrtheo=3 :'Mossbauer reemission_vA'
c     l_nfrtheo=4 :'Mossbauer reemission_vB'
c     l_nfrtheo=5 :'Mossbauer transmission_vC'
c     l_nfrtheo=6 :'Mossbauer transmission_vD'

cc    l_nfrtheo=7 :'Mossbauer resonance reflection'

c     Constants and parameters defined in thstr_frmossbauer are global
c     (may be different for each of the theories) and therefore the same 
c     for all devices. The devices are addressed by lstruct1=1,2,3 which is 
c     only available in the frstr_...() routine. 
c     For lstruct1=0 Constants and parameters are also global.

c     The choice of the theories follows the sequence defined in
c     thstr_mossbauer, which is allowed to be different from the list
c     in the routine fr_mossbauer.
c     The sequence in thstr_mossbauer has been changed in order 
c     to have first the transmission theories and then the reemission
c     theories.
c     Example: Having selected  -Mossbauer transmission_vC- (the 3rd theory
c              in the list) the name is identified for the case number 
c              l_nfrtheo=5 in the theory fr_mossbauer
        
      i1=1    !  nameth(1)  ='Mossbauer transmission_vA'    
      i2=2    !  nameth(2)  ='Mossbauer transmission_vB'   
      i3=5    !  nameth(5)  ='Mossbauer reemission_vA'   
      i4=6    !  nameth(6)  ='Mossbauer reemission_vB'   
      i5=3    !  nameth(3)  ='Mossbauer transmission_vC' 
      i6=4    !  nameth(4)  ='Mossbauer transmission_vD'

      i7=7    !  nameth(7)  ='Mossbauer resonance reflection' 

c     Decissions asked for the theory out of the list nameth(n) are
c     translated by the numbers in.

c      The numbers l_nfrtheo are used for selection of constants and 
c      variables (defined by parameters and transformation matices)
c      for the common blocks from which the theories (1,...,5) take
c      the values.
c      lstruct1=0                common/acstrf/    /avstrf/  
c                                applies to all devices
c      lstruct1=1  lstruct2=0    common/acfr1trf/    /avfr1trf/      
c                  lstruct2=1    common/acfr2trf/    /avfr2trf/
c                                device: source 
c      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/      
c                  lstruct2=1    common/acfr2trf/    /avfr2trf/
c                                device: absorber/scatterer 
c      lstruct1=2  lstruct2=0    common/acfr1trf/    /avfr1trf/      
c                  lstruct2=1    common/acfr2trf/    /avfr2trf/
c                                device: detector 

      lfrthi2i6=l_nfrtheo.eq.i2.or.l_nfrtheo.eq.i6

c     In the list of the frame routine fr_mossbauer the numbers 
c     in brackets (without any blanks!) at the end of the names are arbitrary
c     (different for each case). These numbers are accessible as ifrcase
c     in routines fr_mossbauer and th_mossbauer by the 'common/thpt/'
c     in comthe.for:

c       theoryname='Mossbauer radioactive source'
c       thfrcase(1)='Mossbauer transmission_vA(1)'         
c       thfrcase(2)='Mossbauer transmission_vB(3)'
c       thfrcase(3)='Mossbauer reemission_vA(2)'           
c       thfrcase(4)='Mossbauer reemission_vB(4)'           
c       thfrcase(5)='Mossbauer transmission_vC(5)'           
c       thfrcase(6)='Mossbauer transmission_vD(3)'  

cc      thfrcase(7)='Mossbauer resonance reflection(6)' not in use

c       ifrcase may be the same for different theories which uses the same 
c       part of code in the subroutine.
c--------------------------------------------------------

      chth='fr'//nhelpentry(1:6)

      if(lstruct1.eq.0) then 
c      global definitions  
       if(cmch.eq.'hdbk') then
        nstruct='handbook=nucleus.hdb    list=1   chth='//chth  
        return
       end if
  
       call conmatpar('coll',jc,jm,jp,jv,chth)
  
       if(l_nfrtheo.eq.i1.or.lfrthi2i6) then
        strcmt(1)='source_absorber_detector n_set=[sp] [2] 0'
        strcmt(2)='name for the spectrum '
        strcmt(3)='v=0 between source and detector with resonant nuclei'
        strcmt(4)='theory/'//chth//'/Mossbauer transmission/go'
        strcmt(5)='theory/'//chth//'/layer/detector'      
       else if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4) then
        strcmt(1)='source_scatterer  n_set=[sp]   2 0  '
        strcmt(2)=' set name for the spectrum of the scatterer '
        strcmt(3)='detector is device 3 , v(source-detector)=0 '
        strcmt(4)='theory/'//chth//'/Mossbauer reemission/go'
        strcmt(5)='theory/'//chth//'/layer/CEMS'
       else if(l_nfrtheo.eq.i5) then
        strcmt(1)='source_absorber_detector   n_set=[sp] [2] 2 '
        strcmt(2)=' set name for the mosaic spectrum  '
        strcmt(3)='number of incoherent parts of the mosaic absorber'
        strcmt(4)='theory/'//chth//'/Mossbauer mosaic-absorber/go'
        strcmt(5)='theory/'//chth//'/layer/detector'            
       else if(l_nfrtheo.eq.i7) then
        strcmt(1)='source_scatterer    n_set=sp   2 0'
        strcmt(2)=' set name for the scattering spectrum  '
        strcmt(3)='v=0 between source and detector with resonant nuclei'
        strcmt(4)='theory/'//chth//'/Mossbauer reflection/go'
        strcmt(5)='theory/'//chth//'/layer/scatterer'
       end if
  
       call conmatpar('dev0',jc,jm,jp,jv,chth)
       return
      end if

      goto(100,200,300)number_device(lstruct1)
c------------------------------------------------------------------------
c     device number 1:Mossbauer source
 100  if(lstruct2.gt.0) goto 110
c     device  common/acfr1trf/    /avfr1trf/ 

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      strcmt(1)='source_layer   n_device=[sc]   1 1'
      strcmt(2)='name of source '
      strcmt(3)='(the source has one layer)'             ! not used
      strcmt(4)='distribution of parameters at sites of the source'
      strcmt(5)='theory/'//chth//'/layer/source'

      call conmatpar('dev1',jc,jm,jp,jv,chth)
      return
c     --------------------------------------------------
 110  continue
c     layers of device source  common/acfr2trf/    /avfr2trf/ 

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      strcmt(1)='source   n_cmpt=[s] [1] 1'
      strcmt(2)='one letter for name of the site '
      strcmt(3)='number of inequivalent sites of the source '
      strcmt(4)='distribution of parameters of site number'
      strcmt(5)='theory/'//chth//'/sites/source'


c     Temperature of the source at position 5 of  common/acfr2trf/
c     (all theories l_nfrtheo)
      thco(jc+1) ='T_source         i_pos=5    include=[n]   300.0'
                ! temperatue of the layer 
      jc=jc+1

      if(l_nfrtheo.eq.i1.or.l_nfrtheo.eq.i3) then 

c      l_nfrtheo=1 :'Mossbauer transmission_vA'
c                   call of subroutine th_hdeq,th_lines126,th_hdeqmiscellaneous,
c                   th_relaxglobalsad,th_relaxtwostatesad
c      common/acfr2trf/acfr2

       thco(jc+1)='iset_powder  i_pos=2  include=[n]  0'
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       thco(jc+2)='isymmetry  i_pos=3  include=[n]  10' 
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       jc=jc+2

c      common/avfr2trf/ avfr2,dum(5),Hext,thetaHe,phiHe,phi,theta,psi
       ntrmt(jm+1)='Hextern_sc  matrix=(3,3) include=[n]'
       ctrmt(jm+1)='external magnetic field (lab) at the source'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     6    1 0 0  '
        thvr(jv+2)='thetaHe                  7    0 1 0 '
        thvr(jv+3)='phiHe                    8    0 0 1'
       
       ntrmt(jm+2)='euler_source matrix=(3,3) include=[n]'
       ctrmt(jm+2)='orientation of the source (lab)'
        thpa(jp+4)='phi              , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='theta            , 0.0 0.0 0.0   1.0'
        thpa(jp+6)='psi              , 0.0 0.0 0.0   1.0 '
        thvr(jv+4)='phi                       9    1 0 0  '
        thvr(jv+5)='theta                    10    0 1 0 '
        thvr(jv+6)='psi                      11    0 0 1'
       jm=jm+2
       jp=jp+6      
       jv=jv+6
              
      else if(lfrthi2i6.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 
c      l_nfrtheo=2 :'Mossbauer transmission_vB'
c                   call of subroutine th_hdeqf
c      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,temperature
c      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,
c                      phi,theta,psi     


       thco(jc+1)='iset_powder  i_pos=2  include=[n]  0'
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       thco(jc+2)='isymmetry  i_pos=3  include=[n]  10'
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       thco(jc+3)='n_psi_powder  i_pos=4  include=[n]  0'
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)
       jc=jc+3

       ntrmt(jm+1)='thickn_factor  matrix=(1,1) include=[n]'
       ctrmt(jm+1)='thickness factor for all sites of the layer'
        thpa(jp+1)='th_factor           , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='th_factor               1    1  '

       ntrmt(jm+2)='x2_anisotropy  matrix=(2,2) include==[n] '
       ctrmt(jm+2)='mean square <x2> of a crystal (source)'
        thpa(jp+2)='d_x2                  ,  0.0  0.0 0.0  0.1'
        thpa(jp+3)='x2_eta                ,  0.0  0.0 0.0  0.1'
        thvr(jv+2)='d_x2                     12    1 0  '
        thvr(jv+3)='x2_eta                   13    0 1  '
 
       ntrmt(jm+3)='x2_orientation   matrix=(3,3) include=[n] '
       ctrmt(jm+3)='x2_orientation with ref. to a crystal (source)'
        thpa(jp+4)='x2_phi                , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='x2_theta              , 0.0  0.0 0.0  1.0'
        thpa(jp+6)='x2_psi                , 0.0  0.0 0.0  1.0'
        thvr(jv+4)='x2_phi                   14    1 0 0 '
        thvr(jv+5)='x2_theta                 15    0 1 0 '
        thvr(jv+6)='x2_psi                   16    0 0 1 '
  
       ntrmt(jm+4)='ax_texture  matrix=(2,2) include=[n] '
       ctrmt(jm+4)='texture of the source layer '
        thpa(jp+7)='t200                   , 0.0  0.0 0.0  0.1'
        thpa(jp+8)='t400                   , 0.0  0.0 0.0  0.1'
        thvr(jv+7)='t200                     17    1 0'
        thvr(jv+8)='t400                     18    0 1 '
       jm=jm+4
       jp=jp+8      
       jv=jv+8       
       ntrmt(jm+1)='Hextern_sc  matrix=(3,3) include=[n] '
       ctrmt(jm+1)='external magnetic field (lab) at the source'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0'
        thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     6    1 0 0  '
        thvr(jv+2)='thetaHe                  7    0 1 0 '
        thvr(jv+3)='phiHe                    8    0 0 1'
       jm=jm+1
       jp=jp+3      
       jv=jv+3
      end if

      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
c--------------------------------------------------------------------
c     device number 2:Mossbauer absorber/scatterer
 200  if(lstruct2.gt.0) goto 210


      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      if(l_nfrtheo.le.i1.or.lfrthi2i6)then
       strcmt(1)='absorber n_device=[ab] mijk=po;sw;an [1]  1'
       strcmt(2)='name of the absorber '
       strcmt(3)='number of layers of the absorber '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/absorber/layer'
      else if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4)then
       strcmt(1)='scatterer n_device=[sr] mijk=po;sw;an [1]  1'
       strcmt(2)='name of the scatterer '
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/scatterer/layer'

c      common/avfr1trf/avfr1,dumint,Hext,thetaHe,phiHe,phi,theta,psi
c      If the theories: th_22nuclear.f, th_hyperfine.f are selected
c      for the reemission program the common/avfr1trf/(3-8)
c      has to be mapped onto common/avfr2trf/(6-11) for each layer,
c      since these theories take the external field and the orientation
c      from the layer parameter (allowing each layer having another
c      external field and orientation - which make no sence for CEMS etc)
 
       ntrmt(jm+1)='Hextern_dv   matrix=(3,3) include=[n]'
       ctrmt(jm+1)=
     &  'external magnetic field (lab) at all scatterer layers'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     2    1 0 0  '
        thvr(jv+2)='thetaHe                  3    0 1 0 '
        thvr(jv+3)='phiHe                    4    0 0 1'
        jm=jm+1
        jp=jp+3
        jv=jv+3
       ntrmt(jm+1)='euler_dv  matrix=(3,3) include=[n]'
       ctrmt(jm+1)='orientation of the scatterer (lab)'
        thpa(jp+1)='phi_dv              , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='theta_dv            , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='psi_dv              , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='phi_dv                       5    1 0 0  '
        thvr(jv+2)='theta_dv                     6    0 1 0 '
        thvr(jv+3)='psi_dv                       7    0 0 1'
       jm=jm+1
       jp=jp+3       
       jv=jv+3
c      
      else if(l_nfrtheo.eq.i5)then
       strcmt(1)='absorber n_device=[Mj] mij=l1;ln [1]  1'
       strcmt(2)='name of the mosaic area section'
       strcmt(3)='number of layers of the  mosaic area section'
       strcmt(4)=
     &       'distribution of parameters at sites of the area section'
       strcmt(5)='theory/'//chth//'/mosaicabsorber/layer'


       ntrmt(jm+1)='device_factor  intensity'
       ctrmt(jm+1)='device factor for all sites of the device'
        thpa(jp+1)='dev_factor           , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='dev_factor               1    1  '
        jm=jm+1
        jp=jp+1       
        jv=jv+1       
       ntrmt(jm+1)='Hextern_dev   matrix=(3,3) include=[n]'
       ctrmt(jm+1)='external magnetic field (lab) at the absorber'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     2    1 0 0  '
        thvr(jv+2)='thetaHe                  3    0 1 0 '
        thvr(jv+3)='phiHe                    4    0 0 1'
       jm=jm+1
       jp=jp+3      
       jv=jv+3       
c      
      else if(l_nfrtheo.eq.i6)then
       strcmt(1)='scatterer_layer n_device=[sr] mijk=po;sw;an [3]  1'
       strcmt(2)='name of the scatterer'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/scatterer/layer'
      end if
 
      call conmatpar('dev2',jc,jm,jp,jv,chth)

      return
c     --------------------------------------------
 210  continue
c     layers of device absorber/scatterer  common/acfr2trf/  /avfr2trf/ 

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      thco(jc+1) ='temperature  i_pos=5 include=[n]  300.0 '
                ! temperatue of the layer 
      jc=jc+1

      if(l_nfrtheo.eq.i1.or.l_nfrtheo.eq.i3) then 

       if(l_nfrtheo.eq.i1) then
        strcmt(1)='absorber_site   n_cmpt=s  [1]  1'
        strcmt(2)='one letter for name of the site '
        strcmt(3)='number of inequivalent sites of the absorber layer'
        strcmt(4)='distribution of parameters of site number'
        strcmt(5)='theory/'//chth//'/absorber/layer/sites'
       else if(l_nfrtheo.eq.i3) then
        strcmt(1)='scatterer_site   n_cmpt=s  [1]  0'
        strcmt(2)='one letter for name of the site '
        strcmt(3)='Number of inequivalent sites of the scatterer'
        strcmt(4)='distribution of parameters of site number'
        strcmt(5)='theory/'//chth//'/scatterer/sites'
       end if


       thco(jc+1)='iset_powder  i_pos=2 include=[n] 0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       thco(jc+2)='isymmetry   i_pos=3 include=[n] 10  '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       jc=jc+2

c      l_nfrtheo=1,3 :'Mossbauer transmission_vA, reemission_vA'
c                   call of subroutine th_hdeq    
c      common/acfr2trf/acfr2
c      common/avfr2trf/ avfr2,dum(5),Hext,thetaHe,phiHe,phi,theta,psi
       ntrmt(jm+1)='thickn_factor matrix=(1,1) include=[n]'
       ctrmt(jm+1)='thickness factor for all sites of the layer'
        thpa(jp+1)='th_factor           , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='th_factor               1    1  '

       if(l_nfrtheo.eq.i3.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then
        ntrmt(jm+2)='dummy  matrix=(1,1) from_data=y '
        ctrmt(jm+2)='dummy '
         thpa(jp+2)='dummy                0.0  0.0 0.0  0.0'
         thvr(jv+2)='dummy                    11    1  '
         jm=jm+2
         jp=jp+2       
         jv=jv+2       
c       reservation for 11 parameters on common/avfr2trf/
       else
        ntrmt(jm+2)='Hextern_layer   matrix=(3,3) include=[n]'
        ctrmt(jm+2)='external magnetic field (lab) at the absorber'
         thpa(jp+2)='Hext             , 0.0  0.0 0.0  1.0'
         thpa(jp+3)='thetaHe          , 0.0 0.0 0.0   1.0'
         thpa(jp+4)='phiHe            , 0.0 0.0 0.0   1.0 '
         thvr(jv+2)='Hext                     6    1 0 0  '
         thvr(jv+3)='thetaHe                  7    0 1 0 '
         thvr(jv+4)='phiHe                    8    0 0 1'
  
        ntrmt(jm+3)='euler_layer    matrix=(3,3) include=[n]'
        ctrmt(jm+3)='orientation of the absorber/scatterer (lab)'
         thpa(jp+5)='phi              , 0.0  0.0 0.0  1.0'
         thpa(jp+6)='theta            , 0.0 0.0 0.0   1.0'
         thpa(jp+7)='psi              , 0.0 0.0 0.0   1.0 '
         thvr(jv+5)='phi                       9    1 0 0  '
         thvr(jv+6)='theta                    10    0 1 0 '
         thvr(jv+7)='psi                      11    0 0 1'
        jm=jm+3
        jp=jp+7       
        jv=jv+7
       end if

      else if(lfrthi2i6.or.l_nfrtheo.eq.i4.or.l_nfrtheo.eq.i5)then 

       if(lfrthi2i6) then
        strcmt(1)='absorber_site   n_cmpt=[s] [1] 1'
        strcmt(2)=' one letter for name of the site '
        strcmt(3)='number of inequivalent sites of the absorber layer'
        strcmt(4)='distribution of parameters of site number'
        strcmt(5)='theory/'//chth//'/absorber/layer/sites'
       else if(l_nfrtheo.eq.i4) then
        strcmt(1)='scatterer_site  n_cmpt=[s] [1] 0'
        strcmt(2)=' one letter for name of the site '
        strcmt(3)='Number of inequivalent sites of the scatterer'
        strcmt(4)='distribution of parameters of site number'
        strcmt(5)='theory/'//chth//'/scatterer/sites'
       else if(l_nfrtheo.eq.i5) then
        strcmt(1)='mosaic_absorber_site   n_cmpt=[s] [1] 0'
        strcmt(2)=' one letter for name of the site '
        strcmt(3)='number of inequivalent sites of the layer'
        strcmt(4)='distribution of parameters of site number'
        strcmt(5)='theory/'//chth//'/absorber/part/sites'
       end if

c      l_nfrtheo=2,4,5 :'Mossbauer transmission_vB, reemission_vB
c                                  transmission_vC
c                   call of subroutine th_hdeqf
c      common/acfr2trf/acfr2,rep_grp,aset,asymmetry,a_psi,temperature
c      common/avfr2trf/avfr2,th_factor,dum(4),Hext,thetaHe,phiHe,
c                      phi,theta,psi     

       if(l_nfrtheo.ne.i5)then
        thco(jc+1)='iset_powder  i_pos=2 include=[n] 0 '
                 ! iset=1-6 for 4-128 points on 1/48 of the sphere
        thco(jc+2)='isymmetry   i_pos=3 include=[n] 10 '
                 ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
        thco(jc+3)='n_psi_powder i_pos=4 include=[n] 0 '
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)
        jc=jc+3
       end if

       ntrmt(jm+1)='thickn_factor   matrix=(1,1) include=[n]'
       ctrmt(jm+1)='thickness factor for all sites of the layer'
        thpa(jp+1)='th_factor             , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='th_factor               1    1  '

       ntrmt(jm+2)='x2_anisotropy  matrix=(2,2) include=[y]'
       ctrmt(jm+2)=
     & 'mean square <x2> of a crystal of the scatterer layer'
       if(lfrthi2i6)ctrmt(jm+2)=
     &  'mean square <x2> of a crystal of the absorber layer'
        thpa(jp+2)='d_x2                  ,  0.0  0.0 0.0  0.1'
        thpa(jp+3)='x2_eta                ,  0.0  0.0 0.0  0.1'
        thvr(jv+2)='d_x2                     12    1 0  '
        thvr(jv+3)='x2_eta                   13    0 1  '
 
       ntrmt(jm+3)='x2_orientation  matrix=(3,3) include=[y]'
       ctrmt(jm+3)=
     & 'x2_orientation with ref. to a crystal (scatterer layer)'
       if(lfrthi2i6)ctrmt(jm+3)=
     & 'x2_orientation with ref. to a crystal (absorber layer)'
       thpa(jp+4)='x2_phi                , 0.0  0.0 0.0  1.0'
       thpa(jp+5)='x2_theta              , 0.0  0.0 0.0  1.0'
       thpa(jp+6)='x2_psi                , 0.0  0.0 0.0  1.0'
       thvr(jv+4)='x2_phi                   14    1 0 0 '
       thvr(jv+5)='x2_theta                 15    0 1 0 '
       thvr(jv+6)='x2_psi                   16    0 0 1 '
 
       ntrmt(jm+4)='ax_texture   matrix=(2,2) include=[n]'
       ctrmt(jm+4)='texture of the scatterer layer '
       if(lfrthi2i6)ctrmt(jm+4)='texture of the absorber layer'
        thpa(jp+7)='t200                   , 0.0  0.0 0.0  0.1'
        thpa(jp+8)='t400                   , 0.0  0.0 0.0  0.1'
        thvr(jv+7)='t200                     17    1 0'
        thvr(jv+8)='t400                     18    0 1 '
       jm=jm+4
       jp=jp+8
       jv=jv+8
       if(l_nfrtheo.ne.i5)then
        ntrmt(jm+1)='Hextern   matrix=(3,3) include=[n]'
        ctrmt(jm+1)=
     &      'external magnetic field (lab) at the scatterer layer'
        if(lfrthi2i6)ctrmt(jm+1)=
     &      'external magnetic field (lab) at the absorber layer'
         thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0'
         thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0'
         thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 '
         thvr(jv+1)='Hext                     6    1 0 0  '
         thvr(jv+2)='thetaHe                  7    0 1 0 '
         thvr(jv+3)='phiHe                    8    0 0 1'
        jm=jm+1        
        jp=jp+3      
        jv=jv+3 
       end if
 
      else if(l_nfrtheo.eq.i7) then

       strcmt(1)='scatterer_site   n_cmpt=[s] [1]  0'
       strcmt(2)='one letter for name of the site '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='distribution of parameters of site number'
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites'

       thco(jc+1)='rep.grp    i_pos=1 include=[n] 1.1 '
                ! layer belongs to a group which repeat with period
       jc=jc+1
      
       ntrmt(jm+1)='Hextern   matrix=(3,3) include=[n]'
       ctrmt(jm+1)='external magnetic field (lab) at the scatterer'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     6    1 0 0  '
        thvr(jv+2)='thetaHe                  7    0 1 0 '
        thvr(jv+3)='phiHe                    8    0 0 1'

       ntrmt(jm+2)='rotation    matrix=(3,3) include=[n]'
       ctrmt(jm+2)='rotation of the scatterer surface'
        thpa(jp+4)='phi              , 0.0  0.0 0.0  1.0'
        thvr(jv+4)='phi                     9    1 0 0  '
     
       ntrmt(jm+3)='thickn_lay  matrix=(1,1) include=y' 
       ctrmt(jm+3)='thickness of the layer'
        thpa(jp+5)='thicklay        , 1.0  0.0 0.0  0.1'
        thvr(jv+5)='thicklay                1    1  '
c              0         012345
      
       ntrmt(jm+4)='r_chi_electronic   matrix=(1,1) include=y'
       ctrmt(jm+4)='real part of chi_electronic of the layer  '
        thpa(jp+6)='r_chilay        , 0.0  0.0 0.0  0.1'
        thvr(jv+6)='r_chilay                2    1 '

       ntrmt(jm+5)='i_chi_electronic  matrix=(1,1) include=y'
       ctrmt(jm+5)='imaginary part of chi_electronic of the layer'
        thpa(jp+7) ='i_chilay        , 0.0  0.0 0.0  0.1'
        thvr(jv+7) ='i_chilay                3    1'
      
       ntrmt(jm+6)='roughness   matrix=(1,1) include=[n]'
       ctrmt(jm+6)='roughness of the layer  '
        thpa(jp+8)='roughness        , 0.0  0.0 0.0  0.1'
        thvr(jv+8)='roughness               4    1 '
       jm=jm+6
       jp=jp+8
       jv=jv+8
      end if
 
      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
c--------------------------------------------------------------------
c      common/avfr1trf/pvfr1,Hext,thetaHe,phiHe
c      device number 3:detector
 300  if(lstruct2.gt.0) goto 310
      
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
      
      strcmt(1)='detector_layer  n_device=[dt]   1 1'
      strcmt(2)='name of the detector layer'
      strcmt(3)=' '
      strcmt(3)=' '
      strcmt(5)='theory/'//chth//'/layer/detector'

      call conmatpar('dev3',jc,jm,jp,jv,chth)
       return
c----------------------------------------------------------------------- 
310   continue
      
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      strcmt(1)='detector_site   n_cmpt=[s] [1] 1'
      strcmt(2)=' one letter for name of the site '
      strcmt(3)='number of inequivalent sites of the detector'
      strcmt(4)='distribution of parameters of site number'
      strcmt(5)='theory/'//chth//'/sites/detector'

      ntrmt(jm+1)='Hextern_dt  matrix=(3,3)   include=[n]'
      ctrmt(jm+1)='external magnetic field (lab) at the detector'
       thpa(jp+1)='Hext             , 0.0  0.0 0.0  1.0'
       thpa(jp+2)='thetaHe          , 0.0 0.0 0.0   1.0'
       thpa(jp+3)='phiHe            , 0.0 0.0 0.0   1.0 '
       thvr(jv+1)='Hext                    6     1 0 0 '
       thvr(jv+2)='thetaHe                 7     0 1 0 '
       thvr(jv+3)='phiHe                   8     0 0 1 '
      jm=jm+1
      jp=jp+3
      jv=jv+3

      call conmatpar('lay1',jc,jm,jp,jv,chth)
      return
      end
      
      



      subroutine thstr_mossbauer(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='Mossbauer radioactive source (distribute)'
c      names for child theories, sequence l_frtheo=1,2,3,.. , mthchild=6
       nameth(1)  ='Mossbauer transmission_vA'
       nameth(2)  ='Mossbauer transmission_vB'
       nameth(5)  ='Mossbauer reemission_vA'
       nameth(6)  ='Mossbauer reemission_vB'
       nameth(3)  ='Mossbauer transmission_vC'
       nameth(4)  ='Mossbauer transmission_vD'
c      nameth(7)  ='Mossbauer resonance reflection'
       return
      else if(cmch.eq.'theo') then
c      look for ntheory, mthparent=1 <=max_nth
       ntheory(1)='Mossbauer radioactive source'
       if(name_eq_ntheo(1))l_jth=6      ! mthparent=1,mthchild=6 
       return
      end if

      chth='th'//nhelpentry(1:6)


c   common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,vm_SC,convol,
c  &              th_dum,drive_mode,channels_vmax,flag_misfit,
c  &              om_samp,Dsource,Dabsorber,
c  &              sc2absorber,sc2aperture,dumcs(icstrf-17)


      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      thco(jc+1)='vm_SC   i_pos=5  include=y     0.0'
c               ! value of source splitting'
c                 >0  gt absorber splitting
c                 =0  single line source
c                 <0  lt absorber splitting
      
      thco(jc+2)='i_convol  i_pos=6  include=y  128'
                  ! limits of convolution integrals +/- 128
      
      thco(jc+3)='nu_channels    i_pos=4   from_data=y  1024 '
                ! channel number of the spectrum
      thco(jc+4)='channels_vmax  i_pos=9 from_data=[y]  256 '
                ! period of the drive unit
      thco(jc+5)='drive_mode     i_pos=8 from_data=[y]  1 '
                ! determines function for channel to velocity scale
      thco(jc+6)=' flag_misfit    i_pos=10  include=y  0'
                ! determines function for channel to velocity scale
      jc=jc+6
      if(l_jth.eq.7) then
       thco(jc+1)='unit_chi    i_pos=3  include=y  1.0e-6 '
                ! susceptibility multiplied by
       thco(jc+2)='flag_basis  i_pos=2   1 '
                ! 1/0 : circular/linear basis 
       jc=jc+2
      end if
      
c------------------------------------------------------------------------
c     variables of frame theory: source,absorber and detector orientation
c      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
c     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
c     &        Daperture,d_absorber,d_source
      
      ntrmt(jm+1)='baseline  matrix=(1,1) include=y '
      ctrmt(jm+1)='(1) parameter base line '
       thpa(jp+1)='base            , 100000.0  0.0 0.0 10.0'     ! baseline
       thvr(jv+1)='base                    2    , 1 '

      ntrmt(jm+2)='source   matrix=(1,1) from_data=[n] '
      ctrmt(jm+2)='(1) parameter f_factor of the source'
       thpa(jp+2)='f_source        , 0.70  0.0  1.0  0.02'        !
       thvr(jv+2)='f_source                1    , 1  '        !
      
      ntrmt(jm+3)='background   matrix=(1,1) from_data=[n] '
      ctrmt(jm+3)='(1) parameter back ground fraction of the source'
       thpa(jp+3)='bg_fraction     , 0.2  0.0  1.0  0.01'
       thvr(jv+3)='bg_fraction             3    , 1 '

      ntrmt(jm+4)='geometry  matrix=(1,1) from_data=[n] '
      ctrmt(jm+4)='(1) parameter geo=v_max**2/2bF'
       thpa(jp+4)='geo              ,  0.000e-4   0.0 0.0 0.1'    
       thvr(jv+4)='geo              ,      10     , 1 '  
      jm=jm+4
      jp=jp+4
      jv=jv+4
      ntrmt(jm+1)='calibration  matrix=(2,2) from_data=[n] '
      ctrmt(jm+1)='(2) parameters for calibration v_max,channel_v0'
       thpa(jp+1)='v_max             ,  8.0   0.0 0.0 0.05 '  !
       thpa(jp+2)='channel_v0        , 256.0  0.0 0.0 0.1 '   ! channel_v0
       thvr(jv+1)='v_max                   4     , 1 0'
       thvr(jv+2)='channel_v0              5     , 0 1 '

      ntrmt(jm+2)='non_linearity  matrix=(4,4) include=[n]'
      ctrmt(jm+2)='(4) non linearity parameters for calibration'
       thpa(jp+3)='vmax2            , 0.0   0.0 0.0 0.05 '   !
       thpa(jp+4)='vphase2          , 256.0  0.0 0.0 0.1 '   ! phase shift2
       thpa(jp+5)='vmax3            , 0.0   0.0 0.0 0.05 '  !
       thpa(jp+6)='vphase3          , 256.0  0.0 0.0 0.1 '   ! phase shift3
       thvr(jv+3)='vmax2                   6     1 0 0 0 '
       thvr(jv+4)='vphase2                 7     0 1 0 0 '
       thvr(jv+5)='vmax3                   8     0 0 1 0 '
       thvr(jv+6)='vphase3                 9     0 0 0 1 '
      jm=jm+2
      jp=jp+6
      jv=jv+6
      call conmatpar('layn',jc,jm,jp,jv,chth)
            
      return
      end


      subroutine thstr_11indexmoss(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory

c     sad= source,absorber,detector : lstr1case=1,2,3      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      integer jc,jm,jp,jv,l_jth     
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='scalar refraction index (sad)'
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='scalar refraction index (static,sad)'
       namepg(1)='1x1_ref_index_static_sad  scal,1 '
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=5 <=max_nth
       ntheory(1)='Mossbauer transmission_vA_3'
       ntheory(2)='Mossbauer transmission_vB_3'
       ntheory(3)='Mossbauer reemission_vA_3'
       ntheory(4)='Mossbauer reemission_vB_3'
       ntheory(5)='Mossbauer transmission_vC_3'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(5))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  1'
               ! discrete (1) , continuous(0) LG-curves
      thco(jc+2)='flag_Voigt    i_pos=2   include=y  0'
                ! LG-convolution (1) , Voigt profile (0)
      jc=jc+2            

      ntrmt(jm+1)='t_eff  intensity     '
      ctrmt(jm+1)='effective thickness by the f-factor at the site'
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1'
       thvr(jv+1)='mg/cm2xf                 1     1  '
       jm=jm+1     
       jp=jp+1     
       jv=jv+1       
      if(l_jth.eq.1) then
       ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=y'
       ctrmt(jm+1)='isomer shift of the spectrum'
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='shift                   2     1 '
       jm=jm+1
       jp=jp+1
       jv=jv+1
      end if
      call conmatpar('layn',jc,jm,jp,jv,chth)  

      return
      end
      


      subroutine thstr_11indexmossdyn(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory

c     sad= source,absorber,detector : lstr1case=1,2,3      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      integer jc,jm,jp,jv,l_jth     
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='scalar refraction index (dynamic)'
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='scalar refraction index (dynamic,sad-interpol.)'
       namepg(1)='1x1_ref_index_dynamic_sad  scal,1 '
       nameth(2)='scalar refraction index (dynamic,sad)'
       namepg(2)='1x1_ref_index_dynamic_sad  scal,2 '
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=5 <=max_nth
       ntheory(1)='Mossbauer transmission_vA_3b'
       ntheory(2)='Mossbauer transmission_vB_3b'
       ntheory(3)='Mossbauer reemission_vA_3'
       ntheory(4)='Mossbauer reemission_vB_3'
       ntheory(5)='Mossbauer transmission_vC_3b'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(5))l_jth=2
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
      thco(jc+1)='flag_SAMP     i_pos=1   include=y  1'
               ! discrete (1) , continuous(0) LG-curves
      thco(jc+2)='flag_Voigt    i_pos=2   include=y  0'
                ! LG-convolution (1) , Voigt profile (0)
      jc=jc+2            

      ntrmt(jm+1)='t_eff  intensity     '
      ctrmt(jm+1)='effective thickness by the f-factor at the site'
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1'
       thvr(jv+1)='mg/cm2xf                 1     1  '
       jm=jm+1     
       jp=jp+1     
       jv=jv+1       
      if(l_jth.eq.1) then
       ntrmt(jm+1)='isomer_shift  matrix=(1,1)   include=y'
       ctrmt(jm+1)='isomer shift of the spectrum'
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='shift                   2     1 '
       jm=jm+1
       jp=jp+1
       jv=jv+1
      end if
      call conmatpar('layn',jc,jm,jp,jv,chth)  

      return
      end
      
      subroutine thstr_11indexMB(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory

c     sad= source,absorber,detector : lstr1case=1,2,3      

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth           
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='scalar refraction index MB'
      
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='scalar refraction index (static,sad)'
       namepg(1)='1x1_ref_index_static_sad  scal,1 '
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=1 <=max_nth
       ntheory(1)='Mossbauer transmission_vD_3'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       if(l_jth.eq.1) then
        nstruct='handbook=nucleus.hdb   list=3   chth='//chth 
c       2 constants 
       else
        nstruct=' '
       end if
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
       thco(jc+1)='flag_SAMP   i_pos=1   include=y  1'
                 ! discrete (1) , continuous(0) LG-curves
       thco(jc+2)='flag_Voigt  i_pos=2   include=y  0'
                 ! LG-convolution (1) , Voigt profile (0)
       jc=jc+2            
         
      ntrmt(jm+1)='t_eff   intensity '
      ctrmt(jm+1)='effective thickness by the f-factor at the site'
       thpa(jp+1)='mg/cm2xf          , 1.0  0.0 0.0  0.1'
       thvr(jv+1)='mg/cm2xf                 1     1  '
       jm=jm+1     
       jp=jp+1     
       jv=jv+1       
      if(l_jth.eq.1) then
       ntrmt(jm+1)='isomer_shift    matrix=(1,1)   include=y'
       ctrmt(jm+1)='isomer shift of the spectrum'
        thpa(jp+1)='shift            , 0.0  0.0 0.0  0.1'
        thvr(jv+1)='shift                   2     1 '
       jm=jm+1
       jp=jp+1
       jv=jv+1
      end if
      call conmatpar('layn',jc,jm,jp,jv,chth)  

      return
      end

      subroutine thstr_22indexmoss(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission and   Mossbauer resonance reflection theories
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth           
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='2x2 refraction index (sad)'
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='2x2 refraction index (static,sad)'
       namepg(1)='2x2_ref_index_static_sad   plrs,1 '
       return  
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=5 <=max_nth
       ntheory(1)='Mossbauer transmission_vA_3b'
       ntheory(2)='Mossbauer transmission_vB_3b'
       ntheory(3)='Mossbauer reemission_vA_3'
       ntheory(4)='Mossbauer reemission_vB_3'
       ntheory(5)='Mossbauer transmission_vC_3b'
c      ntheory(6)='Mossbauer resonance reflection_3'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(5))l_jth=1
       return
      end if
      
      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3   chth='//chth  
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

       thco(jc+1)='flag_SAMP        i_pos=1  include=y   1 '
                 ! discrete (1) , continuous(0) LG-curves
       thco(jc+2)='flag_Voigt       i_pos=2  include=y   0'
                 ! LG-convolution (1) , Voigt profile (0)
       jc=jc+2            
        
c                     123456789012345678901234567      
       ntrmt(jm+1)='t_eff   intensity'
       ctrmt(jm+1)='effective thickness by the f-factor at the site'
        thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='mg/cm2xf                1     1  '
                  
       ntrmt(jm+2)='position  matrix=(1,1)   include=y'
       ctrmt(jm+2)='position of the spectrum'
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1'
        thvr(jv+2)='is_shift                2    1  '
                  
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]'
       ctrmt(jm+3)='broadening of the lines of the spectrum'
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1'
        thvr(jv+3)='G_width                 3      1 0 '
        thvr(jv+4)='L_width                 4      0 1 '
       jm=jm+3
       jp=jp+4
       jv=jv+4        
       call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end


      subroutine thstr_22indexfmoss(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      integer   jc,jm,jp,jv,l_jth      
      character nhelpentry*132,chth*8,cmch*4
      logical   name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='2x2 refraction index_f (sad)' 
c      names for child theories , mthchild=1 <= max_nth
       nameth(1)='2x2 refraction index (static,f_anisotrop,sad)'
       namepg(1)='2x2_ref_index_static_sad plrs,1 '
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=3 <=max_nth
       ntheory(1)='Mossbauer transmission_vB_3b'
       ntheory(2)='Mossbauer reemission_vB_3'
       ntheory(3)='Mossbauer transmission_vC_3b'

       if(name_eq_ntheo(3))l_jth=1      !mthparent=3,mthchild=1 
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth  
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
      thco(jc+1)='flag_SAMP  i_pos=1  include=y  1 '
                 ! discrete (1) , continuous(0) LG-curves
      thco(jc+2)='flag_Voigt  i_pos=2    include=y  0 ' 
                 ! LG-convolution (1) , Voigt profile (0)
      jc=jc+2            

      ntrmt(jm+1)='t_eff  intensity'
      ctrmt(jm+1)='effective thickness by the f-factor at the site'
       thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
       thvr(jv+1)='mg/cm2xf                 1     1  '
                         
      ntrmt(jm+2)='position  matrix=(1,1)   include=y'
      ctrmt(jm+2)='position of the spectrum'
       thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1'
       thvr(jv+2)='is_shift                 2    1  '
                         
      ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]'
      ctrmt(jm+3)='broadening of the lines of the spectrum'
       thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1'
       thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1'
       thvr(jv+3)='G_width                  3      1 0 '
       thvr(jv+4)='L_width                  4      0 1 '
      jm=jm+3
      jp=jp+4
      jv=jv+4 
      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end

      subroutine thstr_22indexMB(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth       
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='2x2 refraction index MB'
      
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='2x2 refraction index (static,sad)'
       namepg(1)='2x2_ref_index_static_sad plrs,1 '
       nameth(2)='2x2 refraction index (f,t,spinham,sad)'
       namepg(2)='2x2_ref_index_static_sad plrs,1 '
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=1 <=max_nth
       ntheory(1)='Mossbauer transmission_vD_3b'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=2
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth  
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

       thco(jc+1)='flag_SAMP   i_pos=1    include=y  1 '
                 ! discrete (1) , continuous(0) LG-curves
       thco(jc+2)='flag_Voigt  i_pos=2    include=y  0 '
                 ! LG-convolution (1) , Voigt profile (0)
       jc=jc+2            

c                     123456789012345678901234567      
       ntrmt(jm+1)='t_eff    intensity'
       ctrmt(jm+1)='effective thickness by the f-factor at the site'
        thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='mg/cm2xf                 1     1  '
                         
       ntrmt(jm+2)='position   matrix=(1,1)   include=y'
       ctrmt(jm+2)='position of the spectrum'
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1'
        thvr(jv+2)='is_shift                 2    1  '
                         
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]'
       ctrmt(jm+3)='broadening of the lines of the spectrum'
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1'
        thvr(jv+3)='G_width                  3      1 0 '
        thvr(jv+4)='L_width                  4      0 1 '
       jm=jm+3
       jp=jp+4
       jv=jv+4 
       call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end

      subroutine thstr_sampleorient(l_jth,cmch,nhelpentry)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission
c     level 2 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      integer   i,i0,jc,jm,jp,jv,l_jth
      character nhelpentry*132,chth*8,cmch*4
      logical   name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='sample orientation'
      
c      names for child theories , mthchild=5 <= max_nth 
       nameth(1)='nocall (angle(sample)=0)'
       namepg(1)='sample_orientation    nono,1 '
       nameth(2)='sample orient.(rot-axis)'
       namepg(2)='sample_orientation    nono,2 '
       nameth(3)='sample orient.(rot-axis & thickness)'
       namepg(3)='sample_orientation    nono,3 '
       nameth(4)='sample orient.(x,z-axis)'
       namepg(4)='sample_orientation    nono,4 '
       nameth(5)='sample orient.(x,z-axis & thickness)'
       namepg(5)='sample_orientation    nono,5 '
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=3 <=max_nth
       ntheory(1)='Mossbauer transmission_vB_2'
       ntheory(2)='Mossbauer transmission_vC_1'
       ntheory(3)='Mossbauer transmission_vD_2'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(3))l_jth=5
       return
      end if

      chth='th'//nhelpentry(1:6)
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

      if(l_jth.eq.2.or.l_jth.eq.3) then
       ntrmt(jm+1)='orient_euler   matrix=(3,3)   include=y'
       ctrmt(jm+1)='orientation of the sample in the lab'
        thpa(jp+1)='phi                  , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='theta                , 0.0  0.0 0.0  1.0'
        thpa(jp+3)='psi                  , 0.0  0.0 0.0  1.0'
        thvr(jv+1)='phi                      1    1 0 0 '
        thvr(jv+2)='theta                    2    0 1 0 '
        thvr(jv+3)='psi                      3    0 0 1 '

       ntrmt(jm+2)='rotation  matrix=(3,3)   include=[y]'
       ctrmt(jm+2)='rotation axes in the lab system, rot.angle'
        thpa(jp+4)='axtheta               , 0.0  0.0 0.0  0.1'
        thpa(jp+5)='axphi                 , 0.0  0.0 0.0  0.1'
        thpa(jp+6)='omega                 , 0.0  0.0 0.0  0.1'
        thvr(jv+4)='axtheta                  4    1 0 0 '
        thvr(jv+5)='axphi                    5    0 1 0 '
        thvr(jv+6)='omega                    6    0 0 1 '
       jm=jm+2
       jp=jp+6
       jv=jv+6
       
      else if(l_jth.gt.3)then 
       do i=1,6
        ntrmt(jm+1)='dum matrix=(1,1) include= n'
        thvr(jv+1)='dumvr            '//char(i0+i)//'     , 1' 
        thpa(jp+1)='dumpa                , 0.0  0.0 0.0  1.0'
        jm=jm+1
        jp=jp+1
        jv=jv+1
       end do
       ntrmt(jm+1)='orientation_x,z  matrix=(4,4)   include=y'
       ctrmt(jm+1)='x,z orientation of the sample in the lab'
        thpa(jp+1)='x_theta              , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='x_phi                , 0.0  0.0 0.0  1.0'
        thpa(jp+3)='z_theta              , 0.0  0.0 0.0  1.0'
        thpa(jp+4)='z_phi                , 0.0  0.0 0.0 1.0'
        thvr(jv+1)='x_theta                  7    1 0 0 0 '
        thvr(jv+2)='x_phi                    8    0 1 0 0 '
        thvr(jv+3)='z_theta                  9    0 0 1 0 '
        thvr(jv+4)='z_phi                    10   0 0 0 1 '
       jm=jm+1
       jp=jp+4
       jv=jv+4
      end if
       
      call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

      subroutine thstr_aperture(l_jth,cmch,nhelpentry)
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer   i,i0,jc,jm,jp,jv,l_jth 
      character nhelpentry*132,chth*8,cmch*4
      logical   name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='Mossbauer geometry'
c      names for child theories , mthchild=4 <= max_nth 
       nameth(1)='source-absorber distance=large'
       nameth(2)='cos smearing & aperture effect'
       nameth(3)='extended source'
       nameth(4)='missalignment: point source-absorber-detector'
       return
      else if(cmch.eq.'theo') then
c      look for ntheory,mthparent=6 <=max_nth
       ntheory(1)='Mossbauer transmission_vA_0'
       ntheory(2)='Mossbauer transmission_vB_0'
       ntheory(3)='Mossbauer reemission_vA_0'
       ntheory(4)='Mossbauer reemission_vB_0'
       ntheory(5)='Mossbauer transmission_vC_0'
       ntheory(6)='Mossbauer transmission_vD_0'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(6))l_jth=4
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
c     geometry effects are only calculated if N_om_samp > 0
c     if source-absorber distance=larg : l_jth=1 the value
c     om_samp=0 taken from
c     common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,
c     &              vm_SC,convol,th_dum,drive_mode,channels_vmax,
c     &              flag_misfit,om_samp,dumcs(icstrf-13)
c     has to be ensured. this can be done defining  
c     'N_om_samp i_pos=1  include= n  0 ' 

      call conmatpar('coll',jc,jm,jp,jv,chth)

      if(l_jth.eq.1)then
       i0=ichar('0')
       do i=1,5
        thco(jc+1)='N_om_samp i_pos='//char(i0+i)//'  include= n  5 '
        jc=jc+1
       end do
      else
c      common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,vm_SC,convol,
c     &              th_dum,drive_mode,channels_vmax,yflag_misfit,
c     &              om_samp,dsource,dabsorber,
c     &              sc2absorber,sc2aperture


       thco(jc+1)='N_om_samp i_pos=1  include= [y]  0 '
                ! determines function for channel to velocity scale
       thco(jc+2)='sc-aperture i_pos=5  from_data=[n]  10.0 '
                ! distance source to aperture/detector
       thco(jc+3)='Dabsorber   i_pos=3  from_data=[n]  2.0 '
                 ! diameter of the absorber
       thco(jc+4)='sc-absorber i_pos=4  from_data=[n]  5.0 '
                ! distance source to absorber
       jc=jc+4
       if(l_jth.eq.3) then
        thco(jc+1)='Dsource  i_pos=2  from_data=n  0.1 '
                ! diameter of the source (point source 0.0)
       else
        thco(jc+1)='Dsource      i_pos=2  include= n  0.0 '
       end if 
       jc=jc+1

 
c     variables of frame theory: source,absorber and detector orientation
c      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
c     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,
c     &        Daperture,d_absorber,d_source

c                    1                  012345
       ntrmt(jm+1)='Daperture matrix=(1,1) from_data=[y]'
       ctrmt(jm+1)='(1) diameter Daperture of the detector'
        thpa(jp+1)='Daperture        ,  2.00        0.0 0.0 0.1'  
        thvr(jv+1)='Daperture        ,       1     , 1' 
       jm=jm+1
       jp=jp+1
       jv=jv+1

       ntrmt(jm+1)='misalign   matrix=(2,2) from_data=[y]'
       ctrmt(jm+1)='(2) misalignmernt of absorber/source'
        thpa(jp+1)='d_absorber          0.00        0.0 0.0 0.1'
        thpa(jp+2)='d_source            0.00        0.0 0.0 0.1'
        thvr(jv+1)='d_absorber               2     , 1 0'
        thvr(jv+2)='d_source                 3     , 0 1'
       jm=jm+1 
       jp=jp+2
       jv=jv+2
      end if
      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end
