#include <termios.h>
#include <termios.h>
#include <unistd.h> /* defines STDIN_FILENO */
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdlib.h>

static struct termios stored_settings;

#define help help_
#define key key_
#define window window_
#define term term_

#define path path_
#define infopath infopath_
#define STRL 80

extern struct path{
      char  hepath[STRL],utpath[STRL],term[STRL],editor[STRL],
            shell[STRL],colfile[STRL],workdir[132];
} path;

extern struct term{
      int id1,npl,ncol[8],nrows[8],xpixel[8],ypixel[8];
      char winfile[16];
} term;

static int pr_winsize(int fd, int it)
{
 struct winsize size;
 int i;

 if (isatty(fd) != 0){ i=1;
  if (ioctl(fd, TIOCGWINSZ, (char *) &size) < 0) i=0; 
/* printf("pr_winsize i=%d npl=%d \n",i, size.ws_col);*/
 }
 if(i==1){
  term.ncol[it]=size.ws_col;
  term.nrows[it]=size.ws_row;
  term.xpixel[it]=size.ws_xpixel;  
  term.ypixel[it]=size.ws_ypixel;
  if(size.ws_col==0){
   term.ncol[it]=80;
  term.npl=80;
  term.nrows[it]=24;  } 
 }else{
  term.ncol[it]=80;
  term.npl=80;
  term.nrows[it]=24;  }
 return(i); 
}

void window(int *i)
{char *tm;
 int it,ifile,j;
 it=*i-1;

 if(*i==1){
   pr_winsize(STDIN_FILENO,it);
   term.npl=term.ncol[it];
   if(term.npl>130)term.npl=130;
 }else{
   tm=term.winfile;     
   for (j=0; j<16; j++){if(tm[j]==' '){term.winfile[j] = 0;}
   else{term.winfile[j] = tm[j];}}
   /*printf(" tm=%s\n",tm);*/
   ifile = open(term.winfile,O_WRONLY,0); 
   pr_winsize(ifile,it);
   close(ifile);
   /* printf(" ifile=%d ncol(%d)=%d\n",ifile,it,term.ncol[it]);*/
 }
 return ; 
}

void set_keypress(void)
{
    struct termios new_settings;
    tcgetattr(0,&stored_settings);
    new_settings = stored_settings;
    /* Disable canonical mode, and set buffer size to 1 byte */
    new_settings.c_lflag &= (~ICANON);
    new_settings.c_cc[VTIME] = 0;
    new_settings.c_cc[VMIN] = 1;
    new_settings.c_cc[VINTR]='#';
    /*new_settings.c_lflag &= (~ECHO);*/
    tcsetattr(0,TCSANOW,&new_settings);
    return;
}

void reset_keypress(void)
{
    tcsetattr(0,TCSANOW,&stored_settings);
    return;
}


int key(){
   unsigned int c,is;
   char ch; 
   set_keypress();
   c=getchar(); ch=unctrl(c);
   if(c==10) ch='@';
   if(ch=='@'){is=0;c=ch;}else{is=iscntrl(c);}
   if(is>0){
   c=getchar(); 
   c=getchar(); c=-c;}   
   reset_keypress();
   return c;
}

void infopath() 
{
  int i,j;
  char *carray;


  if((carray=getenv("EFFIHEPATH"))!=NULL){
    i=0;do{path.hepath[i]=carray[i];i++;} while(carray[i] != '\0');}  

  if((carray=getenv("EFFIUTPATH"))!=NULL){
    i=0;do{path.utpath[i]=carray[i];i++;} while(carray[i] != '\0');}  

 if((carray=getenv("TERM"))!=NULL){
      i=0;do{path.term[i]=carray[i];i++;} while(carray[i] != '\0');} 

 if((carray=getenv("EDITOR")) !=NULL){
    i=0;do{path.editor[i]=carray[i];i++;} while(carray[i] != '\0');}

 if((carray=getenv("SHELL")) !=NULL){
    i=0;do{path.shell[i]=carray[i];i++;} while(carray[i] != '\0');}

 if((carray=getenv("COLORFILE")) !=NULL){
    i=0;do{path.colfile[i]=carray[i];i++;} while(carray[i] != '\0');}
 
if((carray=getenv("PWD")) !=NULL){
    i=0;do{path.workdir[i]=carray[i];i++;} while(carray[i] != '\0');}
}







