C-------------------------------------------------------------------------------
C
C      Sammlung SUBROUTINES fuer Benson-Ansteuerung mit ALLPLO etc.
C                    25-SEP-1989
C
C       Sie enthaelt folgende Subroutines:
C       SCALE,VELO,NUMERO,NAXFOR,NFRAME
C       TRANS, ZEICH, TXTPLO, saemtliche Zeichensatze, sowie aus
C       der Benson-Library  die Subroutines:
C       IBENA, TRAA,  POSA, BECENA
C
c       pluma modifiziert fuer Rueckgabe der Federposition
c       M. Alflen  23-aug-1989                   
c     
c       txtplo modifiziert fuer Wahl der Feder
c       M. Alflen  25-aug-1989
c
c       line modifiziert fuer Wahl der Feder
c       M. Alflen  29-aug-1989
c
c	txtplo modifiziert fuer Umlaute
c	M. Alflen
c
c       zeich um 19 Zeichen erweitert
c       A.Vef      09-aug-1994 
 
C-------------------------------------------------------------------------------
      SUBROUTINE TXTPLO(OP,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,alpha,
     &                                                   X2,Y2,Z2)
C-------------------------------------------------------------------------------
C      PLOTTET EINEN TEXTSTRING  ITEXT  MIT  NTEXT  ZEICHEN IN VERSCHIEDENEN
C      SCHRIFTTYPEN  ( ROMAN, ITALIC, SCRIPT, GREEK )  MIT GROSSEN UND
C      KLEINEN BUCHSTABEN SOWIE SONDERZEICHEN
C      DIE VERWENDUNG ALS OBERER ODER UNTERER INDEX IST MOEGLICH
C      AUSSERDEM VERSCHIEDENE SYMBOLE ( SCHRIFTART 'ZEICHEN' ),
C      DIE AUCH ZENTRIERT GEZEICHNET WERDEN KOENNEN
C
C                                 EBERHARD MEISSNER  17.05.83
c
c      modifiziert fuer federwahl
c   
c                                 M. Alflen  25.8.89
c	modifiziert fuer Umlaute
c				  M. Alflen 28.2.1990
c       modifications             h.spiering 27.5.2008
c                  \y\Y   symbols included to the text
c                  $_,$^  according to Latex
c                  + 22 Zeichen called by name $\name 
c                         according to Latex
c                  9 colors called by @n  
c                  extra changes of charracter size
c                                   shift of upper and lower index
c       further in routines like addtxt.f:
c
c                  box rotates, colored area 
c                  colored frame areas
c                  colored background                c
C------------------------------------------------------------------------------
C      FUER DEN BENUTZER:
C      -UMSCHALTUNG DER SCHRIFTTYPEN:
C       \R  ODER  \r   :  ROMAN  (VOREINSTELLUNG)
C       \I  ODER  \i   :  ITALIC
C       \S  ODER  \s   :  SCRIPT
C       \G  ODER  \g   :  GREEK
C       \Z  ODER  \z   :  ZEICHEN (signs)
C       \y             :  Symbol 01-33
C       \Y             :  gefuelltes Symbol 01-33

c        \,        2/5 : Leerzeichen
c        \!       -1/5 : Leerzeichen

c       \"a \"o \"u    : Umlaute
c        


C       $              :  Zurueck zum NORMALBUCHSTABEN  (VOREINSTELLUNG)
C       $^             :  OBERER INDEX
C       $_             :  UNTERER INDEX
C       $P  ODER  $p   :  POSITION FUER SPAETEREN RUECKSPRUNG
C       $B  ODER  $b   :  RUECKSPRUNG ZUR GEMERKTEN POSITION
C       $F  ODER  $f   :  SPRUNG VORWAERTS ZUM BISHERIGEN TEXTENDE
c       $H       *1.2  :  Buchstabengroesse
c       $h       /1.2  :  Buchstabengroesse
c       $U   (14+...)  :  > shift oberer Index
c       $u   (14-...)  :  < shift oberer Index
c       $D   (-7-...)  :  > shift unterer Index
c       $d   (-7+...)  :  < shift unterer Index
c       $m       m     :  multiple Zeichnung  (bold-m fach)
c       $\name         :  name of Zeichen up to 16 characters     

C      -UMSCHALTUNG Gross/Kleinschreibung und der Feder
c       @u oder @U     :  Grosschreibung
c       @l oder @L     :  Kleinschreibung
c       @c oder @C     :  case Standard

C       @n   n = 0...N :  Wahl der Farbe (x11_ps_colors.txt legt N fest)
C------------------------------------------------------------------------------
C      FUER DEN PROGRAMMIERER :
C      -DIE ELEMENTE VON  ITEXT  MUESSEN IM FORMAT  A1  BESCHRIEBEN SEIN
C      -KOORDINATEN DER LINKEN UNTEREN ECKE DES STRINGS,
c       Schrift wird in der y,z Ebene geschrieben.
c       (alte X0,Y0 == 0)
c       alpha dreht den String in der x,z Ebene.
c       
C       BEI  ISTEU=2  DIE DES ZENTRUMS DES ERSTEN ZEICHEN DES STRINGS
C      -BREITE  UND  HOEHE  GELTEN FUER EINEN GROSSBUCHSTABEN WIE
C       ETWA "A"  ( UNTERLAENGEN UND SCHMALERE BUCHSTABEN KOMMEN VOR )
C      -COSA, SINA  SIND DER COSINUS UND DER SINUS DES WINKELS, DEN
C       DER TEXTSTRING MIT DER X-RICHTUNG DES PLOTTERS EINSCHLIESST
c       wird mit alpha berechnet
C      -X2,Y2  SIND DIE KOORDINATEN DER RECHTEN UNTEREN ECKE DES STRINGS
C       BEIM RUECKSPRUNG IN DAS RUFENDE PROGRAMM
C      -ISTEU >= 0   PLOTTEN VON  TEXT :
C             = 1   STARTKOORDINATE LINKE UNTERE ECKE
C             = 2   STARTKOORDINATE ZENTRUM DES ERSTEN ZEICHENS
C             = 3   WIE  = 2  MIT VERBINDEN DER MITTEN DER ZEICHEN
C             = -1  BERECHNUNG VON  X2,Y2  OHNE PLOT
C------------------------------------------------------------------------------
      implicit none
      integer     NTEXT,ISTEU
      real        OP,BREITE,HOEHE,alpha,X2,Y2,Z2
      dimension   OP(0:8)

      character*1 ICHAR1,ICHAR2,ICHAR3,IIC,
     &           IBLANK,IBSL,IAFFE,IDACH,IUMLAUT,ITEXT,
     &            chtxt,ch1,sonderz*16,fsym*16
      DIMENSION  ICHAR1(26),ICHAR2(26),ICHAR3(37),ITEXT(NTEXT)
      integer    KOORD,ICHARG,ICHARN
      DIMENSION  KOORD(75),ICHARG(26),ICHARN(37),sonderz(43)

c      parameter   (max8subn=maxsub*max8,
c     &            idumplot=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-87)
c      common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
c     &            plotxx(max8),plotyy(max8),plotsub(max8subn),
c     &            xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
c     &            int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),
c     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
c     &            n_subspectra,logx,logy,logf,
c     &            namechan(infplot),kform(infplot),axisformat(3),
c     &            axesname(3),title,plotstrdef,plotstrpu,
c     &            bgcolor,fgcolor,datacolor,thcolor,rescolor,
c     &            auxcolor1,auxcolor2,auxcolor3,chardum(idumplot)


      integer      ifeder,ltext,jcw,int3d,npnt3d,idumplot,maxn
      real         plotdum,rad,xyzdz,vtxt,vtxtp
      character    chardum*4
      parameter   (maxn=1024,rad=0.0174533,
     &            idumplot=144*maxn-140*maxn-8*39)
      common/plot/plotdum(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &            chardum(idumplot)

      integer ITYPE,INDEX,I6BIT,JTYPE,JNDEX,J6BIT,jumlaut,MARK,
     &        IC,i,j,jpm,IZEICH,IB,IX,IY,jumsiz,KC,IPEN,
     &        mult,nmult,i0,iloop,isymbol,k,ICOLOR,npenup

      logical isymfill
      real    XB,YB,ZB,XF,YF,ZF,X1,Y1,Z1,H,B,
     &        HX,HY,X,Y,DX,DY,XSHIFT,YSHIFT,WID,HEI,YOFF,XOFF,
     &        XHALF,YHALF,XX1,XX2,YY1,YY2,XS,YS,bsize,usize,dsize,
     &        penfill,g6,g5,COSA,SINA

c      parameter (IBSL=char(92),IAFFE=char(64),IDACH=char(94),
c     &           IUMLAUT=char(34), IBLANK=char(32),i0=48)
      parameter (IBSL='\\',IAFFE='@',IDACH='^',
     &           IUMLAUT='"', IBLANK=' ',i0=48)

c      GROSSE BUCHSTABEN
      DATA ICHAR1 /'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &             'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
C      KLEINE BUCHSTABEN
      DATA ICHAR2 /'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &             'n','o','p','q','r','s','t','u','v','w','x','y','z'/
C      NUMERISCHE- UND SONDERZEICHEN
      DATA ICHAR3 /'0','1','2','3','4','5','6','7','8','9','.',',',':',
     &             ';','!','?','<','>','&','$','/','(',')','*','-','+',
     &             '=',IBSL,'"','#','[',']','%','_','{','}','|'/
      DATA sonderz
     &        /'Int             ','Aring           ','underscore      ',
     &         'hat             ','rightarrow      ','leftarrow       ',
     &         'leftrightarrow  ','Rightarrow      ','Leftarrow       ',
     &         'Leftrightarrow  ','vert            ','uparrow         ',
     &         'downarrow       ','updownarrow     ','cdot            ',
     &         'parallel        ','neq             ','sim             ',
     &         'perp            ','approx          ','hbar            ',
     &         'at              ','backslash       ','number          ',
     &         'section         ','infty           ','int             ',
     &         'oint            ','sqrt            ','overscore       ',
     &         'frac            ','nabla           ','partial         ',
     &         'cap             ','supset          ','subset          ',
     &         'cup             ','tilde           ','propto          ',
     &         'geqq            ','leqq            ','pm              ',
     &         'mp              '/

C      UMGEORDNETE STARTWERTE FUER GROSSE UND KLEINE GRIECH. BUCHSTABEN
      DATA ICHARG /1,2,7,4,5,21,3,22,9,0,10,11,12,
     &              13,15,16,8,17,18,19,20,0,24,14,23,6/
C      UMGEORDNETE STARTWERTE FUER ROMAN NUMERISCHE/SONDERZEICHEN
      DATA ICHARN /1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,27,28,
     &            29,30,21,22,23,20,24,25,26,17,18,37,31,32,33,34,
     &            35,36,38/

      if(NTEXT.eq.0)return
      penfill=0.1
c      write(6,'(80a1)')(ITEXT(i),i=1,NTEXT)
c      IBLANK=' '
c      IBSL=char(92)   ! \
c      IAFFE=char(64)  ! @
c      IDACH=char(94)  ! ^
c      IUMLAUT='"'
c      i0=ichar('0')
      npenup=-1
c       write(6,'(a,i2,2x,80a1)')' TEXTPLO NTEXT ITEXT=',
c     &                     NTEXT,(ITEXT(i),i=1,NTEXT)
c       write(6,'(a)')'X0,Y0,ISTEU,ITEXT,NTEXT,BREITE,HOEHE,COSA,SINA'
c       write(6,'(2f10.2,i3,4g12.3)')X0,Y0,ISTEU,BREITE,HOEHE,COSA,SINA
   
      if(ISTEU.gt.-1) then
       j=1
       do while(ltext(j).ne.0.and.j.lt.32)
        j=j+1
       end do
       if(j.eq.1)then
        jcw=0
       else
        jcw=abs(ltext(j-1))
       end if
       do i=1,8
        vtxtp(i,j)=OP(i)
       end do
      end if

      COSA=cos(alpha*rad)
      SINA=sin(alpha*rad)
      
C      VORBESETZEN VON SCHRIFTART (ROMAN) , INDEX (NORMAL), 6-BIT-ASCII (7-BIT)
      ITYPE = 1
      INDEX = 1
      I6BIT = 0
C      VORBESETZEN DER UMSCHALTINDIKATOREN
      JTYPE = 0
      JNDEX = 0
      J6BIT = 0
      jumlaut=0
C      VORBESETZUNG DER BUCHHALTER VON  @M, @B, @F
      MARK = 0
      XB = 0.
      YB = 0.
      XF = 0.
      YF = 0.
C
      X1 = 0.
      Y1 = 0.
      Z1=HOEHE
      H = HOEHE/21.
      B = BREITE/20.
      bsize=1.
      usize=0.
      dsize=0.
      nmult=1
      ICOLOR=0


C      SCHLEIFE UEBER ALLE  NTEXT  ZEICHEN
      IC=0
      DO while(IC.lt.NTEXT)
       IC=IC+1
       chtxt= ITEXT(IC)     
C      WAR DAS LETZTE ZEICHEN EIN UMSCHALTZEICHEN, SO DUERFEN NUR
C      BESTIMMTE ZEICHEN AUFTRETEN :   VERZWEIGUNG
      IF ( JTYPE.NE.0 ) GO TO 500
      IF ( JNDEX.NE.0 ) GO TO 600
      IF ( J6BIT.NE.0 ) GO TO 700
C      ES WURDE KEIN SCHALTZEICHEN ERWARTET
C
C      BLANK ODER UMSCHALTZEICHEN ?
   50 IF ( chtxt.EQ.IBLANK) goto 800
      IF ( chtxt.EQ.IBSL )  GO TO 810
      IF ( chtxt.EQ.'$' )   GO TO 820
      IF ( chtxt.EQ.IAFFE)  GO TO 830
C      ES HANDELT SICH WEDER UM EIN BLANK NOCH UM EIN UMSCHALTZEICHEN
C
C      GROSSBUCHSTABE ?
  100 DO 110  I=1,26
      J = I
      IF ( chtxt.EQ.ICHAR1(I) ) GO TO 120
  110 CONTINUE
C      KEIN GROSSBUCHSTABE, WEITERSUCHEN
      GO TO 200
C      GROSSBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP
C      FALLS JEDOCH  I6BIT  GESETZT IST, SOLL EIN KLEINER
C      BUCHSTABE GEZEICHNET WERDEN
  120 IF ( I6BIT.eq.2 ) GO TO 220
      GO TO (130,140,150,160,170), ITYPE
  130 CALL GROMAN (J,KOORD)
      GO TO 400
  140 CALL GITALI (J,KOORD)
      GO TO 400
  150 CALL GSCRIP (J,KOORD)
      GO TO 400
C      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORDNEN
  160 J = ICHARG(J)
C      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN
      IF ( J.EQ.0 ) GO TO 800
      CALL GGREEK (J,KOORD)
      GO TO 400
C      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT
  170 J = 0
      GO TO 360
C
C      KLEINBUCHSTABE ?
  200 DO 210  I=1,26
      J = I
      IF ( chtxt.EQ.ICHAR2(I) ) GO TO 215
  210 CONTINUE
C      KEIN KLEINBUCHSTABE, WEITERSUCHEN
      GO TO 300
C      KLEINBUCHSTABE ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP
  215 IF ( I6BIT.eq.1 ) GO TO 120 
  220 GO TO (230,240,250,260,270), ITYPE
  230 CALL KROMAN (J,KOORD)
      GO TO 400
  240 CALL KITALI (J,KOORD)
      GO TO 400
  250 CALL KSCRIP (J,KOORD)
      GO TO 400
C      GRIECHISCHE BUCHSTABEN : ANDERE REIHENFOLGE DES ALPHABETS : UMORDNEN
  260 J = ICHARG(J)
C      "J" UND "V" GIBT ES NICHT : WIE BLANK BEHANDELN
      IF ( J.EQ.0 ) GO TO 800
      CALL KGREEK (J,KOORD)
      GO TO 400
C      SCHRIFTART  ZEICHEN :  BUCHSTABE ALS ZIFFER "0" INTERPRETIERT
  270 J = 0
      GO TO 360
C
C      NUMERISCHES- ODER SONDERZEICHEN ?
  300 DO 310  I=1,37
      J = I
      IF ( chtxt.EQ.ICHAR3(I) ) GO TO 320
  310 CONTINUE
C      KEIN NUMERISCHES- ODER SONDERZEICHEN
C      KANN NICHT IDENTIFIZIERT WERDEN : WIE BLANK BEHANDELN
      GO TO 800
C      NUM./SONDERZEICHEN ERKANNT, VERZWEIGUNG NACH SCHRIFTTYP
  320 GO TO (330,340,340,330,350,350), ITYPE
C      ROMAN  NUM./SONDERZEICHEN : ANDERE REIHENFOLGE : UMORDNEN
  330 J = ICHARN(J)
      CALL NROMAN (J,KOORD)
      GO TO 400
  340 CALL NSCRIP (J,KOORD)
      GO TO 400
C      ZEICHEN: J=1,..,10  ENTSPRICHT ZIFFERN  0,..,9
  350 IF ( J.LE.10 ) J = J-1
C      J > 10 :  KEINE ZIFFER, WIE "0" BEHANDELN
      IF ( J.GT.10 ) J = 0
C
C      AUSWERTUNG FUER ZEICHEN (ITYPE=5)
C      HINTER \Z WURDE EINE ZIFFER (J=0,..,9) ODER EIN ANDERES ZEICHEN
C      GEFUNDEN (INTERPRETIERT ALS J=0). JE ZWEI SOLCHER ZEICHEN WERDEN
C      PAARWEISE ALS ZWEISTELLIGE INTEGERZAHL INTERPRETIERT.
  360 IZEICH =J
      if(IC+1.le.NTEXT)then
       J=ichar(ITEXT(IC+1))-i0
       if(J.ge.0.and.J.le.9)then
        IC=IC+1
        IZEICH=10*IZEICH+J
       end if
      end if
      J=IZEICH
      IF ( J.ge.1) GO TO 380
C      J = 0  ODER J > 32 :  FALSCHE EINGABE
C      MIT GEHOBENER FEDER NACH (X1,Y1), BEI  ISTEU = 3  GESENKTE FEDER
 370  IPEN = npenup
      IF ( ISTEU.EQ.3 ) IPEN  = ICOLOR
      CALL TRAA (X1,Y1,IPEN,jcw)
      GO TO 1000
C     VORHANDENES ZEICHEN
  380 if(ITYPE.eq.5)then
        CALL ZEICH (J,KOORD)
        if(j.lt.0)goto 370
      else if(ITYPE.eq.6)then
       isymbol=J
       if(J.lt.1.or.J.gt.33) goto 370
       goto 490
      end if
      GO TO 400
C
C      DIE ZIELKOORDINATEN  KOORD  SIND VON DER RICHTIGEN SUBROUTINE UEBERNOMMEN
  400 if(J.lt.0)goto 491
      IPEN = npenup
C      BREITE DES BUCHSTABENS  = IB
      IB = KOORD(1)
C      FALLS  ISTEU=0 , SOLL NUR  X2,Y2  BERECHNET WERDEN
C      DAHER WERDEN DIE FAHRBEFEHLE UEBERSPRUNGEN
      IF ( ISTEU.eq.-1) GO TO 900
C      FALLS  ISTEU = 3 :  VERBINDEN DER (X1,Y1)
      IF ( ISTEU.EQ.3 ) CALL TRAA (X1,Y1,ICOLOR,jcw)
C      SCHLEIFE UEBER DIE FAHRBEFEHLE EINES BUCHSTABENS

      jpm=1
      do mult=1,nmult
       jpm=-jpm
       XS=X1+float(mult-1)*0.0125
       YS=Y1+float(mult-1)*0.0125   

      DO 470  J=2,75
      if(KOORD(J).lt.0) then
       IY = ( KOORD(J) - 30 ) / 100
      else
       IY = ( KOORD(J) + 30 ) / 100
      end if
      IX = KOORD(J) - 100*IY
C      IX = 50, IY = 50 :  BUCHSTABE ZU ENDE
C      IX = 50, IY =  0 :  PENUP (SONST STETS PENDOWN)
      IF ( IX.NE.50 ) GO TO 420
      IF ( IY.EQ.50 ) GO TO 480
      IF ( IY.NE. 0 ) GO TO 420
C      50, 0  GEFUNDEN :  PENUP   UND DANN NEUEN KOORDINATENPUNKT ANSTEUERN
      IPEN = npenup
      GO TO 470
C      NORMALER KOORDINATENPUNKT
  420 CONTINUE
C      FALLS  ISTEU=2 : ZENTRIEREN DER ZEICHEN/BUCHSTABEN
      IF ( ISTEU.NE.2 ) GO TO 421
      IX = IX - IB/2
      IY = IY - 10
C      VERZWEIGUNG JE NACH INDEX
  421 GO TO (430,440,450), INDEX
C      NORMALES TEXTFORMAT
  430 HX = IX
      HY = IY
      GO TO 460
C      OBERER INDEX
  440 HX =  0.6*IX
      HY = (14.+usize)/bsize + 0.6*IY
      GO TO 460
C      UNTERER INDEX
  450 HX =  0.6*IX
      HY = -(7.+dsize)/bsize + 0.6*IY
C      BERECHNUNG DER ABSOLUTEN KOORDINATEN
  460 X = XS + ( HX*B*COSA - HY*H*SINA )
      Y = YS + ( HY*H*COSA + HX*B*SINA )
      CALL TRAA (X,Y,IPEN,jcw)
      IPEN = ICOLOR
  470 CONTINUE

  480 CONTINUE
c
c     Umlaute zeichnen
c
      IF (JUMLAUT .EQ. 1) THEN
       DX = 6.66 * ( B*SINA )
       DY = 6.66 * ( B*COSA )
       XSHIFT = 19.95 * (H*COSA )
       YSHIFT =-19.95 * (H*SINA )
       IF (ITYPE .EQ. 3 .AND. JUMSIZ .EQ. 0) THEN
        XSHIFT=XSHIFT*.8
        YSHIFT=YSHIFT*.8
       END IF
       IF (JUMSIZ .EQ. 1) THEN
         YSHIFT=YSHIFT*1.25
         XSHIFT=XSHIFT*1.25
       END IF
       WID=1.60*B
       HEI=1.68*H
       IF (INDEX .GT. 1) THEN
        IF (INDEX .EQ. 2) THEN
         YOFF=yshift*.33
         XOFF=xshift*.33
        END IF
        IF (INDEX .EQ. 3) THEN
         YOFF=-yshift*.8
         XOFF=-xshift*.8
        END IF
        DX=DX*.66
        DY=DY*.66
	WID=WID*.66
	HEI=HEI*.66
       ELSE
        YOFF=0.
        XOFF=0.
       END IF
       XHALF= DX/.33*IB/40
       YHALF= DY/.33*IB/40
       XX1 = YS + (XHALF-DX/2.) + (XOFF+XSHIFT)  
       XX2 = YS + (XHALF+DX/2.) + (XOFF+XSHIFT)
       YY1 = XS + (YOFF+YSHIFT) + (YHALF-DY/2.) 
       YY2 = XS + (YOFF+YSHIFT) + (YHALF+DY/2.)
       CALL BECENA(YY1,XX1,IPEN,14,WID,HEI,COSA,SINA,jcw)
       CALL BECENA(YY2,XX2,IPEN,14,WID,HEI,COSA,SINA,jcw)
       CALL TRAA(XS,YS,npenup,jcw)
      END IF
      IPEN = npenup
      end do    ! mult
      JUMLAUT=0

      goto 491
 490  continue
      IPEN=ICOLOR
      YS=Y1+H*11*SINA+B*10*COSA
      XS=X1-B*10*SINA+H*11*COSA
c      write(6,'(a,i3,6f10.3)')'ISTEU,YS,XS,Y1,X1=',ISTEU,YS,XS,Y1,X1
      if(ISTEU.gt.0) then
      if(isymfill) then          
         iloop=ifix(amin1(B*14,H*16)/penfill)+1
         do k=1,iloop                    ! fill up symbol  
          g5=B*14-(k-1)*penfill
          if ( g5 .gt. 0 ) then
           g6=H*16-(k-1)*penfill
           if ( g6 .gt. 0 ) then
            if ( isymbol .ne. 33 ) then  
             call becena(XS,YS,IPEN,isymbol,g5,g6,COSA,SINA,jcw) ! plot symbol
            else
             g5=(g5+g6)/4.                        
             CALL BCERCA (XS,YS,IPEN,g5,90.,360.,jcw)         ! plot circle
            end if
           end if
          end if
         end do
      else
       if ( isymbol .ne. 33 ) then
        g5=B*14
        g6=H*16
        call becena(XS,YS,IPEN,isymbol,g5,g6,COSA,SINA,jcw)
       else
        g5=(B*14+H*16)/4.                        
        CALL BCERCA (XS,YS,IPEN,g5,90.,360.,jcw)         ! plot circle   
       end if
      end if
      end if

 491  continue

C      BUCHST./ZIFFER/ZEICHEN ABGEARBEITET
C      FALLS  ISTEU = 2,3 :  MIT GEHOBENER FEDER NACH (X1,Y1)
      IF ( ISTEU.EQ.2 .OR. ISTEU.EQ.3 ) CALL TRAA (X1,Y1,npenup,jcw)
      GO TO 900
C
C      ES WIRD EINE STEUERUNG DES SCHRIFTTYPES ERWARTET
C      ZULAESSIGE ZEICHEN SIND :
C          \R,r       ROMAN         ITYPE = 1
C          \I,i       ITALIC        ITYPE = 2
C          \S,s       SCRIPT        ITYPE = 3
C          \G,g       GREEK         ITYPE = 4
C          \Z,z       ZEICHEN       ITYPE = 5
c          \,        2/5   Leerzeichen
c          \!       -1/5   Leerzeichen

c          \"a \"o \"u      Umlaute

  500 JTYPE = 0
      if( chtxt.eq.'r'.or.chtxt.eq.'R')then
C      SCHRIFTTYP  ROMAN  GEWUENSCHT
       ITYPE = 1
      else if( chtxt.eq.'i'.or.chtxt.eq.'I')then
C      SCHRIFTTYP  ITALIC  GEWUENSCHT
       ITYPE = 2
      else if( chtxt.eq.'s'.or.chtxt.eq.'S')then
C      SCHRIFTTYP  SCRIPT  GEWUENSCHT
       ITYPE = 3
      else if( chtxt.eq.'g'.or.chtxt.eq.'G')then
C      SCHRIFTTYP  GREEK  GEWUENSCHT
       ITYPE = 4
      else if( chtxt.eq.'z'.or.chtxt.eq.'Z')then
C      SCHRIFTART  ZEICHEN  GEWUENSCHT
       ITYPE = 5
      else if( chtxt.eq.'y')then
C      SCHRIFTART  Symbol  GEWUENSCHT
       ITYPE = 6
       isymfill=.false.
      else if( chtxt.eq.'Y')then
C      SCHRIFTART  Symbol  GEWUENSCHT
       ITYPE = 6
       isymfill=.true.
      else if( chtxt.eq.',')then
C      Blank der Groesse \, gefunden
       GO TO 801
      else if( chtxt.eq.'!')then
C      Blank der Groesse \! gefunden (Ruecksetzung)
       GO TO 802
      else if( chtxt.eq.'"')then
C      \" gefunden (UMLAUT)
       GO TO 840
      else if( chtxt.eq.'$')then
C      \$  gefunden Steuerzeichen $ wird gezeichnet
       GO TO 300
      else if( chtxt.eq.IBSL)then      
C      \\  gefunden Steuerzeichen $ wird gezeichnet
       J=23
       CALL ZEICH (J,KOORD)
       GO TO 400
      else if( chtxt.eq.IAFFE)then      
C      \@  gefunden Steuerzeichen $ wird gezeichnet
       J=22
       CALL ZEICH (J,KOORD)
       GO TO 400
      end if
      GO TO 1000
C
C      ES WIRD EINE STEUERUNG DES INDEX ERWARTET
C      ZULAESSIGE ZEICHEN SIND : 
c          $
C          $^         OBERER INDEX     INDEX = 2
C          $_         UNTERER INDEX    INDEX = 3
C          $P,p       POSITION X1,Y1 MERKEN
C          $B,b       ZURUECK ZUR GEMERKTEN POSITION
C          $F,f       VORWAERTS ZUR BISHER WEITESTEN POSITION
c          $H         *1.2   Buchstabengroesse
c          $h         /1.2   Buchstabengroesse
c       $U   (14+...)  :  > shift oberer Index
c       $u   (14-...)  :  < shift oberer Index
c       $D   (-7-...)  :  > shift unterer Index
c       $d   (-7+...)  :  < shift unterer Index
c          $m         m     multiple Zeichnung  (bold)
          


  600  ch1=chtxt
       JNDEX = 0
       i=ichar(ch1)-i0
       if(i.gt.0.and.i.lt.10) ch1='m'
C      NORMALBUCHSTABE GEWUENSCHT
      if(ch1.eq.'^')then
C      OBERER INDEX GEWUENSCHT
       INDEX = 2
      else if(ch1.eq.'_')then
C      UNTERER INDEX GEWUENSCHT
       INDEX = 3
      else if( ch1.eq.'H')then
C      $H  gefunden Buchstabengroesse *1.2
       bsize=bsize*1.2
       H=H*1.2
       B=B*1.2
      else if( ch1.eq.'h')then
C      $h  gefunden Buchstabengroesse /1.2
       bsize=bsize/1.2
       H=H/1.2
       B=B/1.2
      else if( ch1.eq.'U')then
C      $h  gefunden Buchstabengroesse /1.2
       usize=usize+3
      else if( ch1.eq.'u')then
C      $h  gefunden Buchstabengroesse /1.2
       usize=usize-3
      else if( ch1.eq.'D')then
C      $h  gefunden Buchstabengroesse /1.2
       dsize=dsize+3
      else if( ch1.eq.'d')then
C      $h  gefunden Buchstabengroesse /1.2
       dsize=dsize-3
      else if( ch1.eq.'m')then
C      $m  gefunden Buchstabengroesse 
       nmult=i
      else if(ch1.eq.'p'.or.ch1.eq.'P')then
C      MERKEN DER AKTUELLEN X1,Y1 AUF XB,YB
       MARK = 1
       XB = X1
       YB = Y1
       ZB = Z1
      else if(ch1.eq.'b'.or.ch1.eq.'B')then
C      RUECKSPRUNG AUF (XB,YB),
C      MERKEN DER AKTUELLEN X1,Y1 AUF XF,YF
       IF ( MARK.EQ.0 ) GO TO 1000
C      RUECKSPRUNGSTELLE BEKANNT
       XF = X1
       YF = Y1
       ZF = Z1
       X1 = XB
       Y1 = YB
       Z1 = ZB
      else if(ch1.eq.'f'.or.ch1.eq.'F')then
C      SPRUNG AUF (XF,YF), FALLS DIESER WEITER RECHTS STEHT
C      ALS DAS AKTUELLE (X1,Y1)
       MARK = 0
       IF ( (X1-XF)*COSA.lt.0) X1 = XF
       IF ( (Y1-YF)*SINA.lt.0) Y1 = YF
       IF ( (Z1-ZF)*SINA.lt.0) Z1 = ZF
      else if(ch1.eq.' ')then
       H=H/bsize
       B=B/bsize
       nmult=1 
       INDEX=1
      else if(ch1.eq.IBSL)then
       IC=IC+1
       ch1=ITEXT(IC)
       i=1
       do while(ch1.ne.' '.and.ch1.ne.'$'.and.ch1.ne.'@'
     &           .and.ch1.ne.IBSL.and.IC.le.NTEXT)
        fsym(i:i)=ch1
c        write(6,'(i4,2a)')IC,'   fsym=',fsym(:i)
        i=i+1
        IC=IC+1
        if(IC.gt.NTEXT)then
         ch1='$'
        else
         ch1=ITEXT(IC)
        end if
       end do
       IC=IC-1 
       i=i-1
c        write(6,'(2i4,2a)')NTEXT,IC,'  # fsym=',fsym(:i)
       J=1
       do while(fsym(:i).ne.sonderz(J)(:i).and.J.le.42)
        J=J+1
       end do
       if(J.gt.0.and.J.le.43)then
        CALL ZEICH (J,KOORD)
        GO TO 400
       end if
      end if
      GO TO 1000

C      ES WIRD EINE UMSTEUERUNG GROSS-/KLEINBUCHSTABE ERWARTET
C      ZULAESSIGE ZEICHEN SIND : 
c           @
C           @U,u       Grossbuchstaben               I6BIT = 1
C           @L,l       KLEINBUCHSTABEN MIT 6-BIT     I6BIT = 2
c           @C,c       Buchstaben gross(shift)/klein I6BIT = 0
c           @n         0<=n<=9     Farbe der Feder

  700 continue
      J6BIT = 0
      I6BIT = 0
      i=ichar(chtxt)-i0
      if(i.ge.0.and.i.le.9)then
       k=ichar(ITEXT(IC+1))-i0
       if(k.ge.0.and.k.le.9)then
c       second number
        i=10*i+k
        IC=IC+1
        if(ITEXT(IC+1).eq.' ')IC=IC+1
       end if
      else
       i=-1
      end if       
      if( chtxt.eq.'u'.or.chtxt.eq.'U')then
C      7-BIT-ASCII (UMSCHALTUNG MIT 'SHIFT') GEWUENSCHT
       I6BIT = 1
      else if( chtxt.eq.'l'.or.chtxt.eq.'L')then
C      KLEINBUCHSTABEN BEI 6-BIT-ASCII GEWUENSCHT
       I6BIT = 2
      else if( chtxt.eq.'c'.or.chtxt.eq.'C')then
C      gross(shift)/klein GEWUENSCHT
       I6BIT = 0
      else if(i.ge.0)then
c      federwahl
       ICOLOR=i
      else
       ICOLOR=1
       goto 50
      end if
      GO TO 1000 

C      BLANK, GEFUNDEN
 800  IB = 20
      goto 803
 801  IB=8
      goto 803
 802  IB=-4
 
 803  IF ( ITYPE.NE.5 ) GO TO 900
C      ZEICHEN: BLANK ALS "0" INTERPRETIEREN
      J = 0
      GO TO 360
C      BACKSLASH  "\"  GEFUNDEN
  810 JTYPE = 1
      GO TO 1000
C     Dollar   "$"  GEFUNDEN
  820 JNDEX = 1
      GO TO 1000
C     KLAMMERAFFE  "@"  GEFUNDEN
  830 J6BIT = 1
      GO TO 1000

  840 IF (JUMLAUT .NE. 1) THEN
       KC=IC
       IF (KC .LE. NTEXT .AND. ITYPE .LE. 3) THEN
        IIC=ITEXT(KC)
        IF (IIC .EQ. ICHAR1(1) .OR. IIC .EQ. ICHAR1(15) .OR.
     &      IIC .EQ. ICHAR1(21) ) THEN
         JUMLAUT=1
         JUMSIZ=1
        ELSE IF(  IIC .EQ. IUMLAUT .OR.
     &            IIC .EQ. ICHAR2(1) .OR. IIC .EQ. ICHAR2(15) .OR.
     &            IIC .EQ. ICHAR2(21) ) THEN
         JUMLAUT=1
         JUMSIZ=0
        else
         jumlaut=0
	END IF
       END IF
       GO TO 1000
      ELSE				! doppeltes "
       JUMLAUT=0
       GO TO 100
      END IF
C
C      BUCHSTABE IST FERTIG, X1,Y1 WERDEN UM DIE BUCHSTABENBREITE ERHOEHT
C      DIESE IST   =IB        ,  FALLS  INDEX = 1        (NORMALBUCHSTABE)
C                  =0.6*IB    ,  FALLS  INDEX = 2, 3     (OBERER, UNTERER INDEX)
  900 CONTINUE
       IF ( INDEX.GT.1 ) GO TO 910
C      INDEX = 1
  901 X1 = X1 + IB*B*COSA
      Y1 = Y1 + IB*B*SINA
      if(Z1.lt.H*21) Z1=H*21 
C      BUCHSTABE FERTIG
      GO TO 1000
C      INDEX = 2, 3
  910 CONTINUE
      X1 = X1 + 0.6*IB*B*COSA
      Y1 = Y1 + 0.6*IB*B*SINA
      if(Z1.lt.H*21) Z1=H*21 
C      BUCHSTABE FERTIG
 1000 CONTINUE
      end do
      X2 = X1
      Y2 = Y1
      Z2 = Z1
C      ITEXT  IST ABGEARBEITET
C      DIE LAGE DER RECHTEN UNTEREN ECKE DER TEXTZEICHNUNG
C      WIRD AN DAS RUFENDE PROGRAMM ZURUECKUEBERGEBEN
c
c     wahl der startfeder
      if(ISTEU.gt.-1) then
       j=1
       do while(ltext(j).ne.0.and.j.lt.32)
        j=j+1
       end do
       ltext(j)=jcw
       if(OP(0).eq.0)ltext(j)=-jcw
      if(jcw.gt.4*maxn) return
       ifeder(jcw+1)=npenup
c       write(6,'(a,2i5,3x,9f7.2)')' j,jcw,OP=',j,jcw,OP
      end if
c      write(6,'(a,4f10.2)')' X2,Y2,Z2=',X2,Y2,Z2
      RETURN
      END
C-------------------------------------------------------------------------------
C*******************************************************************************
C
C     BENSON-LIBRARY         
C
C*******************************************************************************
      SUBROUTINE TRAA(X,Y,J,jcw)
      COMMON /BENXY/ IX,IY,XP,YP,XV,YV
      real X,Y
      character    chardum*4
      integer      J,jcw,ifeder,int3d,npnt3d,ltext,idumplot
      real         plotdum,xyzdz,vtxt,vtxtp
      parameter   (maxn=1024,rad=0.0174533,
     &            idumplot=144*maxn-140*maxn-8*39)
      common/plot/plotdum(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &            chardum(idumplot)
      jcw=jcw+1
      vtxt(1,jcw)=X 
      vtxt(2,jcw)=Y 
      ifeder(jcw)=J
c      write(6,'(a,2i4,2x,2f10.2)')' TRAA jcw,icol,X,Y=',jcw,J,X,Y
      RETURN
      END 

      SUBROUTINE  BECENA(X,Y,J,ICA,HX,HY,COSA,SINA,jcw) 
C X Y COORDONNEES DU CENTRE DU SYMBOLE DEFINI DANS UN CARRE 
C         4 * 4 
C     J   MEME DEFINITION QUE DANS TRAA 
C     ICA RANG DU CARACTERE DANS LA TABLE 
C    HX,HY  DIMENSIONS DU CARACTERE EN CENTIMETRES 
C 
      DIMENSION AT(5),IOC(32),IDC(121)
      data AT/0.,0.25,0.50,0.75,1.0/
      data IOC/11,15,7,3,1,5,9,13,17,22,66,71,27,28,34,35,42,43,48,49,
     &         54,55,60,61,76,81,86,92,98,104,110,111/
      data IDC/124,122,142,-122,142,122,120,-122,102,122,124,-122,120, 
     &         122,102,-122,124,120,2,142,-122,104,140,0,144,-122,124, 
     &         24,102,120,142,124,-22,124,24,104,100,140,144,124,-22, 
     &         124,24,100,140,124,-22,120,20,104,144,120,-22,102,2,140, 
     &         144,102,-22,142,42,104,100,142,-22,4,122,120,44,-122,0, 
     &         122,124,40,-122,104,144,100,140,-122,104,100,144,140, 
     &         -122,112,124,132,122,120,-122,123,102,121,122,142,-122, 
     &         112,120,132,122,124,-122,123,142,121,122,102,-122,124, 
     &         24,114,103,101,110,130,141,143,134,124,-22/ 
      ICOLOR=J
      npenup=-1
      CALL TRAA(X,Y,npenup,jcw) 
      IF(ICA.le.0.or.ICA-32.gt.0)goto 10
      IFIN=1 
c      CALL POSA(XA,YA) 
      XA=X
      YA=Y
c      write(6,'(a,8f10.3,4x,3i5)')'X,Y,XA,YA=',X,Y,XA,YA,COSA,SINA,HX,HY
      XA=XA-(HX*COSA-HY*SINA)*0.5 
      YA=YA-(HX*SINA+HY*COSA)*0.5 
      IND=IOC(ICA) 
  3   ID=IDC(IND) 
      IF(ID.ge.0)goto 5 
      IFIN=2 
      ID=-ID 
   5  JP=ID/100 
      KX=(ID-JP*100)/10 
      KY=ID-JP*100-KX*10+1 
      KX=KX+1 
      TX=HX*AT(KX) 
      TY=HY*AT(KY) 
      DX=XA+TX*COSA-TY*SINA 
      DY=YA+TX*SINA+TY*COSA 
c      write(6,'(a,2f10.3,4x,3i5)')'DX,DY,JP,jcw=',DX,DY,JP,KX,KY
      if(JP.eq.0)then
       CALL TRAA(DX,DY,npenup,jcw) 
      else
       CALL TRAA(DX,DY,ICOLOR,jcw) 
      end if
      GO TO (6,10),IFIN 
   6  IND=IND+1 
      GO TO 3 
 10   RETURN 
      END

      SUBROUTINE BCERCA(X,Y,J,R,ANG,DANG,jcw)
      ICOLOR=J
      J=0
c      J=-1             !pen down
c      write(6,'(a,i4)')' BCERCA J=',ICOLOR
      A=0.5 
      EPS=0.02 
      RAD=0.01745329 
      I=J-2 
      IF(I.ge.0)goto 2 
      JJ=J 
      XP=X 
      YP=Y 
      GO TO 3 
2     JJ=I 
c      CALL POSA(XP,YP)
      XP=X
      YP=Y 
      XP=XP+X 
      YP=YP+Y 
3     IF(R.gt.0) goto 5 
      CALL TRAA(XP,YP,JJ,jcw) 
      GO TO 100 
5     ALF=ANG*RAD 
      XX=XP + R*COS(ALF) 
      YY=YP + R*SIN(ALF) 
      CALL TRAA(XX,YY,JJ,jcw) 
      PHI=SQRT(EPS/(A+R)) 
      IF(DANG.eq.0)goto 100 
      IF(DANG.lt.0)PHI=-PHI 
      DELTA=RAD*DANG 
      JJ=DELTA/PHI 
      DELTA=ALF+DELTA 
      IF(JJ.le.0) goto 11
      DO I=1,JJ 
       ALF=ALF+PHI 
       XX=XP + R*COS(ALF) 
       YY=YP + R*SIN(ALF) 
       CALL TRAA(XX,YY,ICOLOR,jcw) 
      end do
11    XX=XP + R*COS(DELTA) 
      YY=YP + R*SIN(DELTA) 
      CALL TRAA(XX,YY,ICOLOR,jcw) 
100   RETURN 
      END




c#############################################################################
c     vector tables
c#############################################################################
      SUBROUTINE  ZEICH (J,KOORD)
C-------------------------------------------------------------------------------
C  Symbol 1     :  M.Alflen, irgendwann 1990 oder frueher
C  Symbol 2..14 :  A.Vef, 08.08.1994
C      ZEICHEN UND SYMBOLE
C      J = 1,..,32
C  Zeichentabelle:
C     1 : Integral
C     2 : Angstroem
C     3 : Underscore
C     4 : Caret (^)
C     5 : Einfacher Pfeil rechts
C     6 : Einfacher Pfeil links 
C     7 : Einfacher Pfeil beide 
C     8 : Doppelter Pfeil rechts
C     9 : Doppelter Pfeil links 
C    10 : Doppelter Pfeil beide 
C    11 : Senkrechter Strich, so hoch wie [ und ]
C    12 : Pfeil nach oben
C    13 : Pfeil nach unten
C    14 : Pfeil nach oben und unten
C    15 : Punkt in halber Buchstabenhoehe, wie \cdot in TeX
C    16 : parallel
C    17 : ungleich
C    18 : Tilde (proportional)
C    19 : senkrecht
C    20 : Doppeltilde (ungefaehr gleich)
C    21 : h-quer
C    22 : at sign (see 
c         http://www.webopedia.com/DidYouKnow/Internet/2002/HistoryofAtSign.asp)
C    23 : Backslash
C    24 : #
c    25 : §
c    26 : infinty
c    27 : integral
c    28 : closed integral
c    29 : sqrt
c    30 : overline for sqrt
c    31 : division sign
c    32 :
c    33 :
Chttp://www.webopedia.com/DidYouKnow/Internet/2002/HistoryofAtSign.asp
      parameter (istdim=44)
      DIMENSION KOORD(75), ISTART(istdim), K(865)
C
      SAVE
C
      DATA ISTART / 
     &    1,  55,  84,  88,  93, 101, 109, 121, 132, 143,
     &  158, 165, 173, 181, 193, 200, 207, 217, 242, 249,
     &  298, 336, 395, 399, 424, 467, 510, 541, 586, 596, 600, 
     &  604, 617, 656, 687, 712, 737, 768, 783, 824, 835, 846,
     &  856, 866/
C Symbol 01 : Integral
      DATA K(  1),K(  2),K(  3),K(  4)/   16, -396, -496, -596/
      DATA K(  5),K(  6),K(  7),K(  8)/ -398, -296, -496, -497/
      DATA K(  9),K( 10),K( 11),K( 12)/ -397, -396, -296, -297/
      DATA K( 13),K( 14),K( 15),K( 16)/ -398, -498, -597, -596/
      DATA K( 17),K( 18),K( 19),K( 20)/ -495, -294,  107, 2009/
      DATA K( 21),K( 22),K( 23),K( 24)/ 2410, 2611, 2712, 2713/
      DATA K( 25),K( 26),K( 27),K( 28)/ 2614, 2514, 2413, 2412/
      DATA K( 29),K( 30),K( 31),K( 32)/ 2512, 2513, 2613, 2612/
      DATA K( 33),K( 34),K( 35),K( 36)/ 2713, 2514, 2412, 2612/
      DATA K( 37),K( 38),K( 39),K( 40)/ 2513,   50, -495, -194/
      DATA K( 41),K( 42),K( 43),K( 44)/  307, 1809, 2310, 2611/
      DATA K( 45),K( 46),K( 47),K( 48)/   50, 1709, 1409,  207/
      DATA K( 49),K( 50),K( 51),K( 52)/ 1709,  407, 1909,  707/
      DATA K( 53),K( 54)              /  407, 5050/
C Symbol 02 : Angstroem: das A
      DATA K( 55),K( 56),K( 57),K( 58)/   20, 2110,    3,   50/
      DATA K( 59),K( 60),K( 61),K( 62)/ 2110,   17,   50, 1810/
      DATA K( 63),K( 64),K( 65),K( 66)/   16,   50,  605,  614/
      DATA K( 67),K( 68),K( 69),K( 70)/   50,    1,    7,   50/
      DATA K( 71),K( 72),K( 73)       /   13,   19,   50/
C             ... und der Kringel drauf
      DATA K( 74),K( 75),K( 76),K( 77)/ 2109, 2111, 2212, 2412/
      DATA K( 78),K( 79),K( 80),K( 81)/ 2511, 2509, 2408, 2208/
      DATA K( 82),K( 83)              / 2109, 5050/
C Underscore
      DATA K( 84),K( 85),K( 86),K( 87)/   20,    1,   19, 5050/
C Caret
      DATA K( 88),K( 89),K( 90),K( 91)/   14, 1002, 1707, 1012/
      DATA K( 92)                     / 5050/                      
C     5 : Einfacher Pfeil rechts
      DATA K( 93),K( 94),K( 95),K( 96)/   27, 1003, 1025,   50/
      DATA K( 97),K( 98),K( 99),K(100)/ 1419, 1025,  619, 5050/
C     6 : Einfacher Pfeil links 
      DATA K(101),K(102),K(103),K(104)/   27, 1025, 1003,   50/
      DATA K(105),K(106),K(107),K(108)/ 1409, 1003,  609, 5050/
C     7 : Einfacher Pfeil beide 
      DATA K(109),K(110),K(111),K(112)/   27, 1025, 1003,   50/
      DATA K(113),K(114),K(115),K(116)/ 1409, 1003,  609,   50/
      DATA K(117),K(118),K(119),K(120)/ 1419, 1025,  619, 5050/
C     8 : Doppelter Pfeil rechts                      
      DATA K(121),K(122),K(123),K(124)/   27, 1104, 1124,   50/
      DATA K(125),K(126),K(127)       /  904,  924,   50/
      DATA K(128),K(129),K(130),K(131)/ 1420, 1025,  620, 5050/
C     9 : Doppelter Pfeil links 
      DATA K(132),K(133),K(134),K(135)/   27, 1104, 1124,   50/
      DATA K(136),K(137),K(138)       /  904,  924,   50/
      DATA K(139),K(140),K(141),K(142)/ 1408, 1003,  608, 5050/
C    10 : Doppelter Pfeil beide 
      DATA K(143),K(144),K(145),K(146)/   27, 1104, 1124,   50/
      DATA K(147),K(148),K(149)       /  904,  924,   50/
      DATA K(150),K(151),K(152),K(153)/ 1408, 1003,  608,   50/
      DATA K(154),K(155),K(156),K(157)/ 1420, 1025,  620, 5050/
C    11 : Senkrechter Strich, so hoch wie [ und ]
      DATA K(158),K(159),K(160),K(161)/    5, 2503, -297,   50/
      DATA K(162),K(163),K(164)       / 2504, -296, 5050/
C    12 : Pfeil nach oben
      DATA K(165),K(166),K(167),K(168)/   13,  107, 1907,   50/
      DATA K(169),K(170),K(171),K(172)/ 1303, 1907, 1311, 5050/
C    13 : Pfeil nach unten
      DATA K(173),K(174),K(175),K(176)/   13,  107, 1907,   50/
      DATA K(177),K(178),K(179),K(180)/  703,  107,  711, 5050/
C    14 : Pfeil nach oben und unten
      DATA K(181),K(182),K(183),K(184)/   13,  107, 1907,   50/
      DATA K(185),K(186),K(187),K(188)/ 1303, 1907, 1311,   50/
      DATA K(189),K(190),K(191),K(192)/  703,  107,  711, 5050/
C    15 : Punkt in halber Buchstabenhoehe, wie \cdot in TeX
      DATA K(193),K(194),K(195),K(196)/    7, 1003, 1104, 1005/
      DATA K(197),K(198),K(199)       /  904, 1003, 5050/
C    16 : parallel
      DATA K(200),K(201),K(202),K(203)/   11,  104, 1904,   50/
      DATA K(204),K(205),K(206)       /  107, 1907, 5050/
C    17 : ungleich
      DATA K(207),K(208),K(209),K(210)/   26, 1204, 1222,   50/
      DATA K(211),K(212),K(213),K(214)/  604,  622,   50, 1816/
      DATA K(215),K(216)              /   10, 5050/ 
C    18 : Tilde (proportional)
      DATA K(217)                     /   27 /
      DATA K(218),K(219),K(220),K(221)/  603,  803, 1104, 1206/
      DATA K(222),K(223),K(224),K(225)/ 1208, 1111,  715,  617/
      DATA K(226),K(227),K(228),K(229)/  620,  722,  923,   50/
      DATA K(230),K(231),K(232),K(233)/  803, 1004, 1106, 1108/
      DATA K(234),K(235),K(236),K(237)/ 1011,  615,  517,  520/
      DATA K(238),K(239),K(240),K(241)/  622,  923, 1123, 5050/
C    19 : senkrecht                   
      DATA K(242),K(243),K(244),K(245)/   11,  100,  110,   50/
      DATA K(246),K(247),K(248)       /  105, 1905, 5050/
C    20 : Doppeltilde (ungefaehr gleich)
      DATA K(249)                     /   27 /
      DATA K(250),K(251),K(252),K(253)/  903, 1003, 1304, 1406/
      DATA K(254),K(255),K(256),K(257)/ 1408, 1311,  915,  817/
      DATA K(258),K(259),K(260),K(261)/  820,  922, 1123,   50/
      DATA K(262),K(263),K(264),K(265)/ 1003, 1204, 1306, 1308/
      DATA K(266),K(267),K(268),K(269)/ 1211,  815,  717,  720/
      DATA K(270),K(271),K(272),K(273)/  822, 1123, 1223,   50/
      DATA K(274),K(275),K(276),K(277)/  503,  603,  904, 1006/
      DATA K(278),K(279),K(280),K(281)/ 1008,  911,  515,  417/
      DATA K(282),K(283),K(284),K(285)/  420,  522,  723,   50/
      DATA K(286),K(287),K(288),K(289)/  603,  804,  906,  908/
      DATA K(290),K(291),K(292),K(293)/  811,  415,  317,  320/
      DATA K(294),K(295),K(296),K(297)/  422,  723,  823, 5050/
C h-quer (kursives h)
      DATA K(298),K(299),K(300)       /   21, 2108,    2/
      DATA K(301),K(302),K(303),K(304)/   50, 2109,    3,   50/
      DATA K(305),K(306),K(307),K(308)/  705, 1107, 1309, 1411/
      DATA K(309),K(310),K(311),K(312)/ 1413, 1315, 1216, 1016/
      DATA K(313),K(314),K(315),K(316)/  414,  114,   15,   50/
      DATA K(317),K(318),K(319),K(320)/ 1413, 1215, 1015,  413/
      DATA K(321),K(322),K(323),K(324)/  113,   14,   17,  219/
      DATA K(325),K(326),K(327),K(328)/  420,   50, 2105, 2109/
      DATA K(329),K(330),K(331),K(332)/   50, 1500, 1817,   50/
      DATA K(333),K(334),K(335)       / 1600, 1917, 5050/
c     @ at sign
      DATA K(336),K(337),K(338),K(339)/   21, 1314, 1412, 1410/                 
      DATA K(340),K(341),K(342),K(343)/ 1308, 1207, 1006,  806/
      DATA K(344),K(345),K(346),K(347)/  607,  509,  511,  613/
      DATA K(348),K(349),K(350),K(351)/  814,   50, 1410, 1208/
      DATA K(352),K(353),K(354),K(355)/ 1007,  707,  509,   50/
      DATA K(356),K(357),K(358),K(359)/ 1414,  814,  614,  516/
      DATA K(360),K(361),K(362),K(363)/  617,  718, 1019, 1419/
      DATA K(364),K(365),K(366),K(367)/ 1717, 1813, 1810, 1706/
      DATA K(368),K(369),K(370),K(371)/   50,  502,  104,   10/
      DATA K(372),K(373),K(374),K(375)/   50, 1414, 1315,  815/
      DATA K(376),K(377),K(378),K(379)/  615,  516,   50, 1019/
      DATA K(380),K(381),K(382),K(383)/ 1419, 1717, 1816, 1913/
      DATA K(384),K(385),K(386),K(387)/ 1910, 1807, 1605, 1303/
      DATA K(388),K(389),K(390),K(391)/  902,  502,    5,    9/
      DATA K(392),K(393),K(394)/  113,   10, 5050/
C Backslash
      DATA K(395),K(396),K(397),K(398)/   24, -580, 2402, 5050/
c     #
      DATA K(399),K(400),K(401),K(402)/   17,  403, 1905,   50/                 
      DATA K(403),K(404),K(405),K(406)/  407, 1909,   50,  900/
      DATA K(407),K(408),K(409),K(410)/  911,   50, 1401, 1412/
      DATA K(411),K(412),K(413),K(414)/   50,  404, 1906,   50/
      DATA K(415),K(416),K(417),K(418)/  408, 1910,   50, 1001/
      DATA K(419),K(420),K(421),K(422)/ 1012,   50, 1502, 1513/
      DATA K(423)/ 5050/
c     §
      DATA K(424),K(425),K(426),K(427)/   10, 2007, 2006, 1906/                 
      DATA K(428),K(429),K(430),K(431)/ 1907, 2007, 2106, 2104/
      DATA K(432),K(433),K(434),K(435)/ 2003, 1603, 1404, 1207/
      DATA K(436),K(437),K(438),K(439)/ 1108,   50, 1603, 1504/
      DATA K(440),K(441),K(442),K(443)/ 1307, 1108,  908,  706/
      DATA K(444),K(445),K(446),K(447)/   50, 1404, 1202, 1002/
      DATA K(448),K(449),K(450),K(451)/  803,  606,  507,   50/
      DATA K(452),K(453),K(454),K(455)/ 1002,  903,  706,  507/
      DATA K(456),K(457),K(458),K(459)/  107,    6,    4,  103/
      DATA K(460),K(461),K(462),K(463)/  203,  204,  104,  103/
      DATA K(464),K(465),K(466)/  202,  202, 5050/
c     infinity
      DATA K(467),K(468),K(469),K(470)/   24,  812, 1208, 1306/                 
      DATA K(471),K(472),K(473),K(474)/ 1305, 1203, 1002,  602/
      DATA K(475),K(476),K(477),K(478)/  403,  305,  306,  408/
      DATA K(479),K(480),K(481),K(482)/  812, 1207, 1206, 1104/
      DATA K(483),K(484),K(485),K(486)/  903,  703,  504,  406/
      DATA K(487),K(488),K(489),K(490)/  407,  812,  416,  318/
      DATA K(491),K(492),K(493),K(494)/  319,  421,  622, 1022/
      DATA K(495),K(496),K(497),K(498)/ 1221, 1319, 1318, 1216/
      DATA K(499),K(500),K(501),K(502)/  812,  417,  418,  520/
      DATA K(503),K(504),K(505),K(506)/  721,  921, 1120, 1218/
      DATA K(507),K(508),K(509)/ 1217,  812, 5050/
c     integral another
      DATA K(510),K(511),K(512),K(513)/   20, 2418, 2417, 2317/                 
      DATA K(514),K(515),K(516),K(517)/ 2318, 2418, 2517, 2515/
      DATA K(518),K(519),K(520),K(521)/ 2313, 1911, 1610,  609/
      DATA K(522),K(523),K(524),K(525)/  208, -194,   50,  309/
      DATA K(526),K(527),K(528),K(529)/  -93, -295, -297, -198/
      DATA K(530),K(531),K(532),K(533)/  -98,  -97, -197, -198/
      DATA K(534),K(535),K(536),K(537)/   50, 2414, 2012, 1611/
      DATA K(538),K(539),K(540)/  610,  309, 5050/
c     closed integral
      DATA K(541),K(542),K(543),K(544)/   20, 2418, 2417, 2317/                 
      DATA K(545),K(546),K(547),K(548)/ 2318, 2418, 2517, 2515/
      DATA K(549),K(550),K(551),K(552)/ 2313, 1911, 1610,  609/
      DATA K(553),K(554),K(555),K(556)/  208, -194,   50,  309/
      DATA K(557),K(558),K(559),K(560)/  -93, -295, -297, -198/
      DATA K(561),K(562),K(563),K(564)/  -98,  -97, -197, -198/
      DATA K(565),K(566),K(567),K(568)/   50, 2414, 2012, 1611/
      DATA K(569),K(570),K(571),K(572)/  610,  309,   50, 1509/
      DATA K(573),K(574),K(575),K(576)/ 1407, 1206, 1006,  807/
      DATA K(577),K(578),K(579),K(580)/  709,  711,  813, 1014/
      DATA K(581),K(582),K(583),K(584)/ 1214, 1413, 1511, 1509/
      DATA K(585)/ 5050/
c     sqrt
      DATA K(586),K(587),K(588),K(589)/   22,  902,  905, -289/                 
      DATA K(590),K(591),K(592),K(593)/   50,  904, -389, 2520/
      DATA K(594),K(595)/ 2522, 5050/
c     overline for sqrt
      DATA K(596),K(597),K(598),K(599)/   24, 2500, 2524, 5050/ 
c     geteilt
      DATA K(600),K(601),K(602),K(603)/   16, 800, 816, 5050/      
c     nabla
      DATA K(604),K(605),K(606),K(607)/   22, 2102,   11,   50/                 
      DATA K(608),K(609),K(610),K(611)/ 2103,  211,   50, 2120/
      DATA K(612),K(613),K(614),K(615)/   11,   50, 2102, 2120/
      DATA K(616)/ 5050/
c     partial
      DATA K(617),K(618),K(619),K(620)/   16, 1010,  713,  813/                 
      DATA K(621),K(622),K(623),K(624)/ 1010, 1108, 1106, 1004/
      DATA K(625),K(626),K(627),K(628)/  803,  302,  103,    5/
      DATA K(629),K(630),K(631),K(632)/    7,  110,  413,  714/
      DATA K(633),K(634),K(635),K(636)/ 1014, 1414, 1713, 1911/
      DATA K(637),K(638),K(639),K(640)/ 1908, 1806, 1605, 1606/
      DATA K(641),K(642),K(643),K(644)/ 1806,   50, 1106,  804/
      DATA K(645),K(646),K(647),K(648)/  503,  103,   50,    7/
      DATA K(649),K(650),K(651),K(652)/  210,  412,  813, 1113/
      DATA K(653),K(654),K(655)/ 1413, 1812, 5050/
c     Durchschnitt
      DATA K(656),K(657),K(658),K(659)/   19,    2,    3, 1003/                 
      DATA K(660),K(661),K(662),K(663)/ 1404, 1605, 1706, 1808/
      DATA K(664),K(665),K(666),K(667)/ 1811, 1713, 1614, 1415/
      DATA K(668),K(669),K(670),K(671)/ 1016,   16,   50,    2/
      DATA K(672),K(673),K(674),K(675)/ 1002, 1403, 1604, 1705/
      DATA K(676),K(677),K(678),K(679)/ 1806, 1908, 1911, 1813/
      DATA K(680),K(681),K(682),K(683)/ 1714, 1615, 1416, 1017/
      DATA K(684),K(685),K(686)/   17,   16, 5050/
c     includes right
      DATA K(687),K(688),K(689),K(690)/   17, 1702, 1602, 1610/                 
      DATA K(691),K(692),K(693),K(694)/ 1512, 1413, 1114,  914/
      DATA K(695),K(696),K(697),K(698)/  613,  512,  410,  402/
      DATA K(699),K(700),K(701),K(702)/   50, 1702, 1710, 1612/
      DATA K(703),K(704),K(705),K(706)/ 1414, 1215,  815,  614/
      DATA K(707),K(708),K(709),K(710)/  412,  310,  302,  402/
      DATA K(711)/ 5050/
c     includes left
      DATA K(712),K(713),K(714),K(715)/   17, 1715, 1615, 1607/                 
      DATA K(716),K(717),K(718),K(719)/ 1505, 1404, 1103,  903/
      DATA K(720),K(721),K(722),K(723)/  604,  505,  407,  415/
      DATA K(724),K(725),K(726),K(727)/   50, 1715, 1707, 1605/
      DATA K(728),K(729),K(730),K(731)/ 1403, 1202,  802,  603/
      DATA K(732),K(733),K(734),K(735)/  405,  307,  315,  415/
      DATA K(736)/ 5050/
c     vereinigung
      DATA K(737),K(738),K(739),K(740)/   19, 1902, 1903,  903/                 
      DATA K(741),K(742),K(743),K(744)/  504,  305,  206,  108/
      DATA K(745),K(746),K(747),K(748)/  111,  213,  314,  515/
      DATA K(749),K(750),K(751),K(752)/  916, 1916,   50, 1902/
      DATA K(753),K(754),K(755),K(756)/  902,  503,  304,  205/
      DATA K(757),K(758),K(759),K(760)/  106,    8,   11,  113/
      DATA K(761),K(762),K(763),K(764)/  214,  315,  516,  917/
      DATA K(765),K(766),K(767)/ 1917, 1916, 5050/
c     tilde
      DATA K(768),K(769),K(770),K(771)/   16, 1702, 1902, 2103/                 
      DATA K(772),K(773),K(774),K(775)/ 2105, 1811, 1813,   50/
      DATA K(776),K(777),K(778),K(779)/ 1902, 2003, 2005, 1711/
      DATA K(780),K(781),K(782)/ 1713, 2114, 5050/
c     half infinity
      DATA K(783),K(784),K(785),K(786)/   23,  812, 1208, 1306/                 
      DATA K(787),K(788),K(789),K(790)/ 1305, 1203, 1002,  602/
      DATA K(791),K(792),K(793),K(794)/  403,  305,  306,  408/
      DATA K(795),K(796),K(797),K(798)/  812, 1207, 1206, 1104/
      DATA K(799),K(800),K(801),K(802)/  903,  703,  504,  406/
      DATA K(803),K(804),K(805),K(806)/  407,  812,  416,  318/
      DATA K(807),K(808),K(809),K(810)/  320,  421,   50, 1320/
      DATA K(811),K(812),K(813),K(814)/ 1318, 1216,  812,  516/
      DATA K(815),K(816),K(817),K(818)/  418,  421,   50, 1320/
      DATA K(819),K(820),K(821),K(822)/ 1221, 1218, 1116,  812/
      DATA K(823)/ 5050/
c     groesse gleich
      DATA K(824),K(825),K(826),K(827)/   14, 1602, 1212,  802/                 
      DATA K(828),K(829),K(830),K(831)/   50,  702,  712,   50/
      DATA K(832),K(833),K(834)/  302,  312, 5050/
c     kleiner gleich
      DATA K(835),K(836),K(837),K(838)/   14, 1612, 1202,  812/                 
      DATA K(839),K(840),K(841),K(842)/   50,  702,  712,   50/
      DATA K(843),K(844),K(845)/  302,  312, 5050/
c     +-
      DATA K(846),K(847),K(848),K(849)/   14, 1307,  307,   50/                 
      DATA K(850),K(851),K(852),K(853)/  802,  812,   50,  302/
      DATA K(854),K(855)/  312, 5050/
c     -+
      DATA K(856),K(857),K(858),K(859)/   14, 1307,  307,   50/                 
      DATA K(860),K(861),K(862),K(863)/ 1302, 1312,   50,  802/
      DATA K(864),K(865)/  812, 5050/

      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J  = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
       
      SUBROUTINE  KROMAN (J,KOORD)
C-------------------------------------------------------------------------------
C      KLEINE ROMAN
c      abcdefghijklmnopqrstuvwxyz
      parameter (istdim=27)
      DIMENSION KOORD(75),ISTART(istdim),K(759)
C
      SAVE
C
      DATA ISTART/  1, 41, 75,104,141,173,196,257,286,305,331,359,372,
     &            417,446,483,520,554,578,611,628,657,673,698,720,743,
     &            760/
      DATA K(  1),K(  2),K(  3),K(  4)/   20, 1205, 1105, 1104/
      DATA K(  5),K(  6),K(  7),K(  8)/ 1204, 1305, 1407, 1411/
      DATA K(  9),K( 10),K( 11),K( 12)/ 1313, 1214, 1015,  315/
      DATA K( 13),K( 14),K( 15),K( 16)/  116,   17,   50, 1214/
      DATA K( 17),K( 18),K( 19),K( 20)/  314,  115,   17,   18/
      DATA K( 21),K( 22),K( 23),K( 24)/   50, 1014,  913,  807/
      DATA K( 25),K( 26),K( 27),K( 28)/  704,  503,  303,  104/
      DATA K( 29),K( 30),K( 31),K( 32)/    7,   10,  112,  314/
      DATA K( 33),K( 34),K( 35),K( 36)/   50,  807,  705,  504/
      DATA K( 37),K( 38),K( 39),K( 40)/  304,  105,    7, 5050/
      DATA K( 41),K( 42),K( 43),K( 44)/   21, 2105,    5,   50/
      DATA K( 45),K( 46),K( 47),K( 48)/ 2106,    6,   50, 1106/
      DATA K( 49),K( 50),K( 51),K( 52)/ 1308, 1410, 1412, 1315/
      DATA K( 53),K( 54),K( 55),K( 56)/ 1117,  818,  618,  317/
      DATA K( 57),K( 58),K( 59),K( 60)/  115,   12,   10,  108/
      DATA K( 61),K( 62),K( 63),K( 64)/  306,   50, 1412, 1314/
      DATA K( 65),K( 66),K( 67),K( 68)/ 1116,  817,  617,  316/
      DATA K( 69),K( 70),K( 71),K( 72)/  114,   12,   50, 2102/
      DATA K( 73),K( 74),K( 75),K( 76)/ 2106, 5050,   19, 1115/
      DATA K( 77),K( 78),K( 79),K( 80)/ 1014,  915, 1016, 1116/
      DATA K( 81),K( 82),K( 83),K( 84)/ 1314, 1412, 1409, 1306/
      DATA K( 85),K( 86),K( 87),K( 88)/ 1104,  803,  603,  304/
      DATA K( 89),K( 90),K( 91),K( 92)/  106,    9,   11,  114/
      DATA K( 93),K( 94),K( 95),K( 96)/  316,   50, 1409, 1307/
      DATA K( 97),K( 98),K( 99),K(100)/ 1105,  804,  604,  305/
      DATA K(101),K(102),K(103),K(104)/  107,    9, 5050,   21/
      DATA K(105),K(106),K(107),K(108)/ 2115,   15,   50, 2116/
      DATA K(109),K(110),K(111),K(112)/   16,   50, 1115, 1313/
      DATA K(113),K(114),K(115),K(116)/ 1411, 1409, 1306, 1104/
      DATA K(117),K(118),K(119),K(120)/  803,  603,  304,  106/
      DATA K(121),K(122),K(123),K(124)/    9,   11,  113,  315/
      DATA K(125),K(126),K(127),K(128)/   50, 1409, 1307, 1105/
      DATA K(129),K(130),K(131),K(132)/  804,  604,  305,  107/
      DATA K(133),K(134),K(135),K(136)/    9,   50, 2112, 2116/
      DATA K(137),K(138),K(139),K(140)/   50,   15,   19, 5050/
      DATA K(141),K(142),K(143),K(144)/   19,  804,  816, 1016/
      DATA K(145),K(146),K(147),K(148)/ 1215, 1314, 1412, 1409/
      DATA K(149),K(150),K(151),K(152)/ 1306, 1104,  803,  603/
      DATA K(153),K(154),K(155),K(156)/  304,  106,    9,   11/
      DATA K(157),K(158),K(159),K(160)/  114,  316,   50,  815/
      DATA K(161),K(162),K(163),K(164)/ 1115, 1314,   50, 1409/
      DATA K(165),K(166),K(167),K(168)/ 1307, 1105,  804,  604/
      DATA K(169),K(170),K(171),K(172)/  305,  107,    9, 5050/
      DATA K(173),K(174),K(175),K(176)/   13, 2010, 1909, 1810/
      DATA K(177),K(178),K(179),K(180)/ 1911, 2011, 2110, 2108/
      DATA K(181),K(182),K(183),K(184)/ 2006, 1805,    5,   50/
      DATA K(185),K(186),K(187),K(188)/ 2108, 2007, 1806,    6/
      DATA K(189),K(190),K(191),K(192)/   50, 1402, 1410,   50/
      DATA K(193),K(194),K(195),K(196)/    2,    9, 5050,   19/
      DATA K(197),K(198),K(199),K(200)/ 1408, 1306, 1205, 1004/
      DATA K(201),K(202),K(203),K(204)/  804,  605,  506,  408/
      DATA K(205),K(206),K(207),K(208)/  410,  512,  613,  814/
      DATA K(209),K(210),K(211),K(212)/ 1014, 1213, 1312, 1410/
      DATA K(213),K(214),K(215),K(216)/ 1408,   50, 1306, 1105/
      DATA K(217),K(218),K(219),K(220)/  705,  506,   50,  512/
      DATA K(221),K(222),K(223),K(224)/  713, 1113, 1312,   50/
      DATA K(225),K(226),K(227),K(228)/ 1213, 1314, 1416, 1316/
      DATA K(229),K(230),K(231),K(232)/ 1314,   50,  605,  504/
      DATA K(233),K(234),K(235),K(236)/  303,  203,    4,  -93/
      DATA K(237),K(238),K(239),K(240)/  -88, -185, -284,   50/
      DATA K(241),K(242),K(243),K(244)/  203,  104,    7,   12/
      DATA K(245),K(246),K(247),K(248)/  -85, -284, -384, -585/
      DATA K(249),K(250),K(251),K(252)/ -688, -694, -597, -398/
      DATA K(253),K(254),K(255),K(256)/ -298,  -97,    6, 5050/
      DATA K(257),K(258),K(259),K(260)/   22, 2105,    5,   50/
      DATA K(261),K(262),K(263),K(264)/ 2106,    6,   50, 1106/
      DATA K(265),K(266),K(267),K(268)/ 1308, 1411, 1413, 1316/
      DATA K(269),K(270),K(271),K(272)/ 1117,   17,   50, 1413/
      DATA K(273),K(274),K(275),K(276)/ 1315, 1116,   16,   50/
      DATA K(277),K(278),K(279),K(280)/ 2102, 2106,   50,    2/
      DATA K(281),K(282),K(283),K(284)/    9,   50,   13,   20/
      DATA K(285),K(286),K(287),K(288)/ 5050,   11, 2105, 2004/
      DATA K(289),K(290),K(291),K(292)/ 1905, 2006, 2105,   50/
      DATA K(293),K(294),K(295),K(296)/ 1405,    5,   50, 1406/
      DATA K(297),K(298),K(299),K(300)/    6,   50, 1402, 1406/
      DATA K(301),K(302),K(303),K(304)/   50,    2,    9, 5050/
      DATA K(305),K(306),K(307),K(308)/   15, 2106, 2005, 1906/
      DATA K(309),K(310),K(311),K(312)/ 2007, 2106,   50, 1407/
      DATA K(313),K(314),K(315),K(316)/ -393, -594, -696, -698/
      DATA K(317),K(318),K(319),K(320)/ -599, -499, -398, -497/
      DATA K(321),K(322),K(323),K(324)/ -598,   50, 1406, -394/
      DATA K(325),K(326),K(327),K(328)/ -595, -696,   50, 1403/
      DATA K(329),K(330),K(331),K(332)/ 1407, 5050,   21, 2105/
      DATA K(333),K(334),K(335),K(336)/    5,   50, 2106,    6/
      DATA K(337),K(338),K(339),K(340)/   50, 1416,  406,   50/
      DATA K(341),K(342),K(343),K(344)/  811,   17,   50,  810/
      DATA K(345),K(346),K(347),K(348)/   16,   50, 2102, 2106/
      DATA K(349),K(350),K(351),K(352)/   50, 1413, 1419,   50/
      DATA K(353),K(354),K(355),K(356)/    2,    9,   50,   13/
      DATA K(357),K(358),K(359),K(360)/   19, 5050,   11, 2105/
      DATA K(361),K(362),K(363),K(364)/    5,   50, 2106,    6/
      DATA K(365),K(366),K(367),K(368)/   50, 2102, 2106,   50/
      DATA K(369),K(370),K(371),K(372)/    2,    9, 5050,   33/
      DATA K(373),K(374),K(375),K(376)/ 1405,    5,   50, 1406/
      DATA K(377),K(378),K(379),K(380)/    6,   50, 1106, 1308/
      DATA K(381),K(382),K(383),K(384)/ 1411, 1413, 1316, 1117/
      DATA K(385),K(386),K(387),K(388)/   17,   50, 1413, 1315/
      DATA K(389),K(390),K(391),K(392)/ 1116,   16,   50, 1117/
      DATA K(393),K(394),K(395),K(396)/ 1319, 1422, 1424, 1327/
      DATA K(397),K(398),K(399),K(400)/ 1128,   28,   50, 1424/
      DATA K(401),K(402),K(403),K(404)/ 1326, 1127,   27,   50/
      DATA K(405),K(406),K(407),K(408)/ 1402, 1406,   50,    2/
      DATA K(409),K(410),K(411),K(412)/    9,   50,   13,   20/
      DATA K(413),K(414),K(415),K(416)/   50,   24,   31, 5050/
      DATA K(417),K(418),K(419),K(420)/   22, 1405,    5,   50/
      DATA K(421),K(422),K(423),K(424)/ 1406,    6,   50, 1106/
      DATA K(425),K(426),K(427),K(428)/ 1308, 1411, 1413, 1316/
      DATA K(429),K(430),K(431),K(432)/ 1117,   17,   50, 1413/
      DATA K(433),K(434),K(435),K(436)/ 1315, 1116,   16,   50/
      DATA K(437),K(438),K(439),K(440)/ 1402, 1406,   50,    2/
      DATA K(441),K(442),K(443),K(444)/    9,   50,   13,   20/
      DATA K(445),K(446),K(447),K(448)/ 5050,   20, 1409, 1306/
      DATA K(449),K(450),K(451),K(452)/ 1104,  803,  603,  304/
      DATA K(453),K(454),K(455),K(456)/  106,    9,   11,  114/
      DATA K(457),K(458),K(459),K(460)/  316,  617,  817, 1116/
      DATA K(461),K(462),K(463),K(464)/ 1314, 1411, 1409,   50/
      DATA K(465),K(466),K(467),K(468)/ 1409, 1307, 1105,  804/
      DATA K(469),K(470),K(471),K(472)/  604,  305,  107,    9/
      DATA K(473),K(474),K(475),K(476)/   50,   11,  113,  315/
      DATA K(477),K(478),K(479),K(480)/  616,  816, 1115, 1313/
      DATA K(481),K(482),K(483),K(484)/ 1411, 5050,   21, 1405/
      DATA K(485),K(486),K(487),K(488)/ -695,   50, 1406, -694/
      DATA K(489),K(490),K(491),K(492)/   50, 1106, 1308, 1410/
      DATA K(493),K(494),K(495),K(496)/ 1412, 1315, 1117,  818/
      DATA K(497),K(498),K(499),K(500)/  618,  317,  115,   12/
      DATA K(501),K(502),K(503),K(504)/   10,  108,  306,   50/
      DATA K(505),K(506),K(507),K(508)/ 1412, 1314, 1116,  817/
      DATA K(509),K(510),K(511),K(512)/  617,  316,  114,   12/
      DATA K(513),K(514),K(515),K(516)/   50, 1402, 1406,   50/
      DATA K(517),K(518),K(519),K(520)/ -698, -691, 5050,   20/
      DATA K(521),K(522),K(523),K(524)/ 1415, -685,   50, 1416/
      DATA K(525),K(526),K(527),K(528)/ -684,   50, 1115, 1313/
      DATA K(529),K(530),K(531),K(532)/ 1411, 1409, 1306, 1104/
      DATA K(533),K(534),K(535),K(536)/  803,  603,  304,  106/
      DATA K(537),K(538),K(539),K(540)/    9,   11,  113,  315/
      DATA K(541),K(542),K(543),K(544)/   50, 1409, 1307, 1105/
      DATA K(545),K(546),K(547),K(548)/  804,  604,  305,  107/
      DATA K(549),K(550),K(551),K(552)/    9,   50, -688, -681/
      DATA K(553),K(554),K(555),K(556)/ 5050,   17, 1405,    5/
      DATA K(557),K(558),K(559),K(560)/   50, 1406,    6,   50/
      DATA K(561),K(562),K(563),K(564)/  806, 1107, 1309, 1411/
      DATA K(565),K(566),K(567),K(568)/ 1414, 1315, 1215, 1114/
      DATA K(569),K(570),K(571),K(572)/ 1213, 1314,   50, 1402/
      DATA K(573),K(574),K(575),K(576)/ 1406,   50,    2,    9/
      DATA K(577),K(578),K(579),K(580)/ 5050,   17, 1213, 1414/
      DATA K(581),K(582),K(583),K(584)/ 1014, 1213, 1312, 1410/
      DATA K(585),K(586),K(587),K(588)/ 1406, 1304, 1203, 1003/
      DATA K(589),K(590),K(591),K(592)/  904,  806,  611,  513/
      DATA K(593),K(594),K(595),K(596)/  414,   50, 1103, 1004/
      DATA K(597),K(598),K(599),K(600)/  906,  711,  613,  514/
      DATA K(601),K(602),K(603),K(604)/  214,  113,   11,    7/
      DATA K(605),K(606),K(607),K(608)/  105,  204,  403,    3/
      DATA K(609),K(610),K(611),K(612)/  204, 5050,   15, 2105/
      DATA K(613),K(614),K(615),K(616)/  405,  106,    8,   10/
      DATA K(617),K(618),K(619),K(620)/  112,  313,   50, 2106/
      DATA K(621),K(622),K(623),K(624)/  406,  107,    8,   50/
      DATA K(625),K(626),K(627),K(628)/ 1402, 1410, 5050,   22/
      DATA K(629),K(630),K(631),K(632)/ 1405,  305,  106,    9/
      DATA K(633),K(634),K(635),K(636)/   11,  114,  316,   50/
      DATA K(637),K(638),K(639),K(640)/ 1406,  306,  107,    9/
      DATA K(641),K(642),K(643),K(644)/   50, 1416,   16,   50/
      DATA K(645),K(646),K(647),K(648)/ 1417,   17,   50, 1402/
      DATA K(649),K(650),K(651),K(652)/ 1406,   50, 1413, 1417/
      DATA K(653),K(654),K(655),K(656)/   50,   16,   20, 5050/
      DATA K(657),K(658),K(659),K(660)/   18, 1403,    9,   50/
      DATA K(661),K(662),K(663),K(664)/ 1404,  209,   50, 1415/
      DATA K(665),K(666),K(667),K(668)/    9,   50, 1401, 1407/
      DATA K(669),K(670),K(671),K(672)/   50, 1411, 1417, 5050/
      DATA K(673),K(674),K(675),K(676)/   24, 1404,    8,   50/
      DATA K(677),K(678),K(679),K(680)/ 1405,  308,   50, 1412/
      DATA K(681),K(682),K(683),K(684)/    8,   50, 1412,   16/
      DATA K(685),K(686),K(687),K(688)/   50, 1413,  316,   50/
      DATA K(689),K(690),K(691),K(692)/ 1420,   16,   50, 1401/
      DATA K(693),K(694),K(695),K(696)/ 1408,   50, 1417, 1423/
      DATA K(697),K(698),K(699),K(700)/ 5050,   20, 1404,   15/
      DATA K(701),K(702),K(703),K(704)/   50, 1405,   16,   50/
      DATA K(705),K(706),K(707),K(708)/ 1416,    4,   50, 1402/
      DATA K(709),K(710),K(711),K(712)/ 1408,   50, 1412, 1418/
      DATA K(713),K(714),K(715),K(716)/   50,    2,    8,   50/
      DATA K(717),K(718),K(719),K(720)/   12,   18, 5050,   19/
      DATA K(721),K(722),K(723),K(724)/ 1404,   10,   50, 1405/
      DATA K(725),K(726),K(727),K(728)/  210,   50, 1416,   10/
      DATA K(729),K(730),K(731),K(732)/ -392, -594, -696, -697/
      DATA K(733),K(734),K(735),K(736)/ -598, -497, -596,   50/
      DATA K(737),K(738),K(739),K(740)/ 1402, 1408,   50, 1412/
      DATA K(741),K(742),K(743),K(744)/ 1418, 5050,   18, 1414/
      DATA K(745),K(746),K(747),K(748)/    3,   50, 1415,    4/
      DATA K(749),K(750),K(751),K(752)/   50, 1404, 1003, 1403/
      DATA K(753),K(754),K(755),K(756)/ 1415,   50,    3,   15/
      DATA K(757),K(758),K(759)       /  415,   14, 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  GROMAN (J,KOORD)
C-------------------------------------------------------------------------------
C      GROSSE ROMAN
C      ABCDEFGHILJKLMNOPQRSTUVWXYZ
      parameter (istdim=27)
      DIMENSION KOORD(75),ISTART(istdim),K(735)
C
      SAVE
C
      DATA ISTART/  1, 20, 66, 99,130,153,174,215,243,256,277,305,320,
     &            351,373,418,448,513,559,594,611,635,651,676,698,719,
     &            736/
      DATA K(  1),K(  2),K(  3),K(  4)/   20, 2110,    3,   50/
      DATA K(  5),K(  6),K(  7),K(  8)/ 2110,   17,   50, 1810/
      DATA K(  9),K( 10),K( 11),K( 12)/   16,   50,  605,  614/
      DATA K( 13),K( 14),K( 15),K( 16)/   50,    1,    7,   50/
      DATA K( 17),K( 18),K( 19),K( 20)/   13,   19, 5050,   22/
      DATA K( 21),K( 22),K( 23),K( 24)/ 2105,    5,   50, 2106/
      DATA K( 25),K( 26),K( 27),K( 28)/    6,   50, 2102, 2114/
      DATA K( 29),K( 30),K( 31),K( 32)/ 2017, 1918, 1719, 1519/
      DATA K( 33),K( 34),K( 35),K( 36)/ 1318, 1217, 1114,   50/
      DATA K( 37),K( 38),K( 39),K( 40)/ 2114, 2016, 1917, 1718/
      DATA K( 41),K( 42),K( 43),K( 44)/ 1518, 1317, 1216, 1114/
      DATA K( 45),K( 46),K( 47),K( 48)/   50, 1106, 1114, 1017/
      DATA K( 49),K( 50),K( 51),K( 52)/  918,  719,  419,  218/
      DATA K( 53),K( 54),K( 55),K( 56)/  117,   14,    2,   50/
      DATA K( 57),K( 58),K( 59),K( 60)/ 1114, 1016,  917,  718/
      DATA K( 61),K( 62),K( 63),K( 64)/  418,  217,  116,   14/
      DATA K( 65),K( 66),K( 67),K( 68)/ 5050,   21, 1817, 1518/
      DATA K( 69),K( 70),K( 71),K( 72)/ 2118, 1817, 2015, 2112/
      DATA K( 73),K( 74),K( 75),K( 76)/ 2110, 2007, 1805, 1604/
      DATA K( 77),K( 78),K( 79),K( 80)/ 1303,  803,  504,  305/
      DATA K( 81),K( 82),K( 83),K( 84)/  107,   10,   12,  115/
      DATA K( 85),K( 86),K( 87),K( 88)/  317,  518,   50, 2110/
      DATA K( 89),K( 90),K( 91),K( 92)/ 2008, 1806, 1605, 1304/
      DATA K( 93),K( 94),K( 95),K( 96)/  804,  505,  306,  108/
      DATA K( 97),K( 98),K( 99),K(100)/   10, 5050,   22, 2105/
      DATA K(101),K(102),K(103),K(104)/    5,   50, 2106,    6/
      DATA K(105),K(106),K(107),K(108)/   50, 2102, 2112, 2015/
      DATA K(109),K(110),K(111),K(112)/ 1817, 1618, 1319,  819/
      DATA K(113),K(114),K(115),K(116)/  518,  317,  115,   12/
      DATA K(117),K(118),K(119),K(120)/    2,   50, 2112, 2014/
      DATA K(121),K(122),K(123),K(124)/ 1816, 1617, 1318,  818/
      DATA K(125),K(126),K(127),K(128)/  517,  316,  114,   12/
      DATA K(129),K(130),K(131),K(132)/ 5050,   21, 2105,    5/
      DATA K(133),K(134),K(135),K(136)/   50, 2106,    6,   50/
      DATA K(137),K(138),K(139),K(140)/ 1512,  712,   50, 2102/
      DATA K(141),K(142),K(143),K(144)/ 2118, 1518, 2117,   50/
      DATA K(145),K(146),K(147),K(148)/ 1106, 1112,   50,    2/
      DATA K(149),K(150),K(151),K(152)/   18,  618,   17, 5050/
      DATA K(153),K(154),K(155),K(156)/   20, 2105,    5,   50/
      DATA K(157),K(158),K(159),K(160)/ 2106,    6,   50, 1512/
      DATA K(161),K(162),K(163),K(164)/  712,   50, 2102, 2118/
      DATA K(165),K(166),K(167),K(168)/ 1518, 2117,   50, 1106/
      DATA K(169),K(170),K(171),K(172)/ 1112,   50,    2,    9/
      DATA K(173),K(174),K(175),K(176)/ 5050,   23, 1817, 1518/
      DATA K(177),K(178),K(179),K(180)/ 2118, 1817, 2015, 2112/
      DATA K(181),K(182),K(183),K(184)/ 2110, 2007, 1805, 1604/
      DATA K(185),K(186),K(187),K(188)/ 1303,  803,  504,  305/
      DATA K(189),K(190),K(191),K(192)/  107,   10,   12,  115/
      DATA K(193),K(194),K(195),K(196)/  317,   50, 2110, 2008/
      DATA K(197),K(198),K(199),K(200)/ 1806, 1605, 1304,  804/
      DATA K(201),K(202),K(203),K(204)/  505,  306,  108,   10/
      DATA K(205),K(206),K(207),K(208)/   50,  817,   17,   50/
      DATA K(209),K(210),K(211),K(212)/  818,   18,   50,  814/
      DATA K(213),K(214),K(215),K(216)/  821, 5050,   24, 2105/
      DATA K(217),K(218),K(219),K(220)/    5,   50, 2106,    6/
      DATA K(221),K(222),K(223),K(224)/   50, 2118,   18,   50/
      DATA K(225),K(226),K(227),K(228)/ 2119,   19,   50, 2102/
      DATA K(229),K(230),K(231),K(232)/ 2109,   50, 2115, 2122/
      DATA K(233),K(234),K(235),K(236)/   50, 1106, 1118,   50/
      DATA K(237),K(238),K(239),K(240)/    2,    9,   50,   15/
      DATA K(241),K(242),K(243),K(244)/   22, 5050,   11, 2105/
      DATA K(245),K(246),K(247),K(248)/    5,   50, 2106,    6/
      DATA K(249),K(250),K(251),K(252)/   50, 2102, 2109,   50/
      DATA K(253),K(254),K(255),K(256)/    2,    9, 5050,   15/
      DATA K(257),K(258),K(259),K(260)/ 2110,  410,  109,    7/
      DATA K(261),K(262),K(263),K(264)/    5,  103,  302,  502/
      DATA K(265),K(266),K(267),K(268)/  603,  504,  403,   50/
      DATA K(269),K(270),K(271),K(272)/ 2109,  409,  108,    7/
      DATA K(273),K(274),K(275),K(276)/   50, 2106, 2113, 5050/
      DATA K(277),K(278),K(279),K(280)/   22, 2105,    5,   50/
      DATA K(281),K(282),K(283),K(284)/ 2106,    6,   50, 2119/
      DATA K(285),K(286),K(287),K(288)/  806,   50, 1211,   19/
      DATA K(289),K(290),K(291),K(292)/   50, 1210,   18,   50/
      DATA K(293),K(294),K(295),K(296)/ 2102, 2109,   50, 2115/
      DATA K(297),K(298),K(299),K(300)/ 2121,   50,    2,    9/
      DATA K(301),K(302),K(303),K(304)/   50,   15,   21, 5050/
      DATA K(305),K(306),K(307),K(308)/   18, 2105,    5,   50/
      DATA K(309),K(310),K(311),K(312)/ 2106,    6,   50, 2102/
      DATA K(313),K(314),K(315),K(316)/ 2109,   50,    2,   17/
      DATA K(317),K(318),K(319),K(320)/  617,   16, 5050,   25/
      DATA K(321),K(322),K(323),K(324)/ 2105,    5,   50, 2106/
      DATA K(325),K(326),K(327),K(328)/  312,   50, 2105,   12/
      DATA K(329),K(330),K(331),K(332)/   50, 2119,   12,   50/
      DATA K(333),K(334),K(335),K(336)/ 2119,   19,   50, 2120/
      DATA K(337),K(338),K(339),K(340)/   20,   50, 2102, 2106/
      DATA K(341),K(342),K(343),K(344)/   50, 2119, 2123,   50/
      DATA K(345),K(346),K(347),K(348)/    2,    8,   50,   16/
      DATA K(349),K(350),K(351),K(352)/   23, 5050,   23, 2105/
      DATA K(353),K(354),K(355),K(356)/    5,   50, 2106,  218/
      DATA K(357),K(358),K(359),K(360)/   50, 1906,   18,   50/
      DATA K(361),K(362),K(363),K(364)/ 2118,   18,   50, 2102/
      DATA K(365),K(366),K(367),K(368)/ 2106,   50, 2115, 2121/
      DATA K(369),K(370),K(371),K(372)/   50,    2,    8, 5050/
      DATA K(373),K(374),K(375),K(376)/   22, 2110, 2007, 1805/
      DATA K(377),K(378),K(379),K(380)/ 1604, 1203,  903,  504/
      DATA K(381),K(382),K(383),K(384)/  305,  107,   10,   12/
      DATA K(385),K(386),K(387),K(388)/  115,  317,  518,  919/
      DATA K(389),K(390),K(391),K(392)/ 1219, 1618, 1817, 2015/
      DATA K(393),K(394),K(395),K(396)/ 2112, 2110,   50, 2110/
      DATA K(397),K(398),K(399),K(400)/ 2008, 1806, 1605, 1204/
      DATA K(401),K(402),K(403),K(404)/  904,  505,  306,  108/
      DATA K(405),K(406),K(407),K(408)/   10,   50,   12,  114/
      DATA K(409),K(410),K(411),K(412)/  316,  517,  918, 1218/
      DATA K(413),K(414),K(415),K(416)/ 1617, 1816, 2014, 2112/
      DATA K(417),K(418),K(419),K(420)/ 5050,   22, 2105,    5/
      DATA K(421),K(422),K(423),K(424)/   50, 2106,    6,   50/
      DATA K(425),K(426),K(427),K(428)/ 2102, 2114, 2017, 1918/
      DATA K(429),K(430),K(431),K(432)/ 1719, 1419, 1218, 1117/
      DATA K(433),K(434),K(435),K(436)/ 1014, 1006,   50, 2114/
      DATA K(437),K(438),K(439),K(440)/ 2016, 1917, 1718, 1418/
      DATA K(441),K(442),K(443),K(444)/ 1217, 1116, 1014,   50/
      DATA K(445),K(446),K(447),K(448)/    2,    9, 5050,   22/
      DATA K(449),K(450),K(451),K(452)/ 2110, 2007, 1805, 1604/
      DATA K(453),K(454),K(455),K(456)/ 1203,  903,  504,  305/
      DATA K(457),K(458),K(459),K(460)/  107,   10,   12,  115/
      DATA K(461),K(462),K(463),K(464)/  317,  518,  919, 1219/
      DATA K(465),K(466),K(467),K(468)/ 1618, 1817, 2015, 2112/
      DATA K(469),K(470),K(471),K(472)/ 2110,   50, 2110, 2008/
      DATA K(473),K(474),K(475),K(476)/ 1806, 1605, 1204,  904/
      DATA K(477),K(478),K(479),K(480)/  505,  306,  108,   10/
      DATA K(481),K(482),K(483),K(484)/   50,   12,  114,  316/
      DATA K(485),K(486),K(487),K(488)/  517,  918, 1218, 1617/
      DATA K(489),K(490),K(491),K(492)/ 1816, 2014, 2112,   50/
      DATA K(493),K(494),K(495),K(496)/  207,  307,  508,  610/
      DATA K(497),K(498),K(499),K(500)/  611,  513,  314, -385/
      DATA K(501),K(502),K(503),K(504)/ -484, -482, -281, -181/
      DATA K(505),K(506),K(507),K(508)/   50,  314,  -85, -284/
      DATA K(509),K(510),K(511),K(512)/ -383, -382, -281, 5050/
      DATA K(513),K(514),K(515),K(516)/   22, 2105,    5,   50/
      DATA K(517),K(518),K(519),K(520)/ 2106,    6,   50, 2102/
      DATA K(521),K(522),K(523),K(524)/ 2114, 2017, 1918, 1719/
      DATA K(525),K(526),K(527),K(528)/ 1519, 1318, 1217, 1114/
      DATA K(529),K(530),K(531),K(532)/ 1106,   50, 2114, 2016/
      DATA K(533),K(534),K(535),K(536)/ 1917, 1718, 1518, 1317/
      DATA K(537),K(538),K(539),K(540)/ 1216, 1114,   50,    2/
      DATA K(541),K(542),K(543),K(544)/    9,   50, 1111, 1013/
      DATA K(545),K(546),K(547),K(548)/  914,  217,  118,  119/
      DATA K(549),K(550),K(551),K(552)/  220,   50, 1013,  814/
      DATA K(553),K(554),K(555),K(556)/  116,   17,   19,  220/
      DATA K(557),K(558),K(559),K(560)/  320, 5050,   20, 1816/
      DATA K(561),K(562),K(563),K(564)/ 2117, 1517, 1816, 2014/
      DATA K(565),K(566),K(567),K(568)/ 2111, 2108, 2005, 1803/
      DATA K(569),K(570),K(571),K(572)/ 1603, 1404, 1305, 1207/
      DATA K(573),K(574),K(575),K(576)/ 1013,  915,  717,   50/
      DATA K(577),K(578),K(579),K(580)/ 1603, 1405, 1307, 1113/
      DATA K(581),K(582),K(583),K(584)/ 1015,  916,  717,  317/
      DATA K(585),K(586),K(587),K(588)/  115,   12,    9,  106/
      DATA K(589),K(590),K(591),K(592)/  304,  603,    3,  304/
      DATA K(593),K(594),K(595),K(596)/ 5050,   19, 2109,    9/
      DATA K(597),K(598),K(599),K(600)/   50, 2110,   10,   50/
      DATA K(601),K(602),K(603),K(604)/ 2103, 1502, 2102, 2117/
      DATA K(605),K(606),K(607),K(608)/ 1517, 2116,   50,    6/
      DATA K(609),K(610),K(611),K(612)/   13, 5050,   24, 2105/
      DATA K(613),K(614),K(615),K(616)/  605,  306,  108,   11/
      DATA K(617),K(618),K(619),K(620)/   13,  116,  318,  619/
      DATA K(621),K(622),K(623),K(624)/ 2119,   50, 2106,  606/
      DATA K(625),K(626),K(627),K(628)/  307,  109,   11,   50/
      DATA K(629),K(630),K(631),K(632)/ 2102, 2109,   50, 2116/
      DATA K(633),K(634),K(635),K(636)/ 2122, 5050,   20, 2103/
      DATA K(637),K(638),K(639),K(640)/   10,   50, 2104,  310/
      DATA K(641),K(642),K(643),K(644)/   50, 2117,   10,   50/
      DATA K(645),K(646),K(647),K(648)/ 2101, 2107,   50, 2113/
      DATA K(649),K(650),K(651),K(652)/ 2119, 5050,   24, 2104/
      DATA K(653),K(654),K(655),K(656)/    8,   50, 2105,  508/
      DATA K(657),K(658),K(659),K(660)/   50, 2112,    8,   50/
      DATA K(661),K(662),K(663),K(664)/ 2112,   16,   50, 2113/
      DATA K(665),K(666),K(667),K(668)/  516,   50, 2120,   16/
      DATA K(669),K(670),K(671),K(672)/   50, 2101, 2108,   50/
      DATA K(673),K(674),K(675),K(676)/ 2117, 2123, 5050,   20/
      DATA K(677),K(678),K(679),K(680)/ 2103,   16,   50, 2104/
      DATA K(681),K(682),K(683),K(684)/   17,   50, 2117,    3/
      DATA K(685),K(686),K(687),K(688)/   50, 2101, 2107,   50/
      DATA K(689),K(690),K(691),K(692)/ 2113, 2119,   50,    1/
      DATA K(693),K(694),K(695),K(696)/    7,   50,   13,   19/
      DATA K(697),K(698),K(699),K(700)/ 5050,   21, 2103, 1010/
      DATA K(701),K(702),K(703),K(704)/   10,   50, 2104, 1011/
      DATA K(705),K(706),K(707),K(708)/   11,   50, 2118, 1011/
      DATA K(709),K(710),K(711),K(712)/   50, 2101, 2107,   50/
      DATA K(713),K(714),K(715),K(716)/ 2114, 2120,   50,    7/
      DATA K(717),K(718),K(719),K(720)/   14, 5050,   20, 2116/
      DATA K(721),K(722),K(723),K(724)/    3,   50, 2117,    4/
      DATA K(725),K(726),K(727),K(728)/   50, 2104, 1503, 2103/
      DATA K(729),K(730),K(731),K(732)/ 2117,   50,    3,   17/
      DATA K(733),K(734),K(735)       /  617,   16, 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  NROMAN (J,KOORD)
C-------------------------------------------------------------------------------
C      ZIFFERN, SONDERZEICHEN  ROMAN
C      0123456789.,:;!?'"#*/()-+=<>&$[]%_{}|
      parameter (istdim=39)
      DIMENSION KOORD(75),ISTART(istdim),K(857)
C
      SAVE
C
      DATA ISTART/  1, 42, 54,100,148,162,202,251,283,347,396,403,412,
     &            425,440,456,489,496,509,524,534,538,559,580,584,591,
     &            598,607,616,666,709,720,731,763,767,798,829,854,858/
      DATA K(  1),K(  2),K(  3),K(  4)/   20, 2109, 2006, 1704/
      DATA K(  5),K(  6),K(  7),K(  8)/ 1203,  903,  404,  106/
      DATA K(  9),K( 10),K( 11),K( 12)/    9,   11,  114,  416/
      DATA K( 13),K( 14),K( 15),K( 16)/  917, 1217, 1716, 2014/
      DATA K( 17),K( 18),K( 19),K( 20)/ 2111, 2109,   50, 2109/
      DATA K( 21),K( 22),K( 23),K( 24)/ 2007, 1906, 1705, 1204/
      DATA K( 25),K( 26),K( 27),K( 28)/  904,  405,  206,  107/
      DATA K( 29),K( 30),K( 31),K( 32)/    9,   50,   11,  113/
      DATA K( 33),K( 34),K( 35),K( 36)/  214,  415,  916, 1216/
      DATA K( 37),K( 38),K( 39),K( 40)/ 1715, 1914, 2013, 2111/
      DATA K( 41),K( 42),K( 43),K( 44)/ 5050,   20, 1706, 1808/
      DATA K( 45),K( 46),K( 47),K( 48)/ 2111,   11,   50, 2010/
      DATA K( 49),K( 50),K( 51),K( 52)/   10,   50,    6,   15/
      DATA K( 53),K( 54),K( 55),K( 56)/ 5050,   20, 1704, 1605/
      DATA K( 57),K( 58),K( 59),K( 60)/ 1504, 1603, 1703, 1904/
      DATA K( 61),K( 62),K( 63),K( 64)/ 2005, 2108, 2112, 2015/
      DATA K( 65),K( 66),K( 67),K( 68)/ 1916, 1717, 1517, 1316/
      DATA K( 69),K( 70),K( 71),K( 72)/ 1113,  908,  806,  604/
      DATA K( 73),K( 74),K( 75),K( 76)/  303,    3,   50, 2112/
      DATA K( 77),K( 78),K( 79),K( 80)/ 2014, 1915, 1716, 1516/
      DATA K( 81),K( 82),K( 83),K( 84)/ 1315, 1112,  908,   50/
      DATA K( 85),K( 86),K( 87),K( 88)/  203,  304,  306,  111/
      DATA K( 89),K( 90),K( 91),K( 92)/  114,  216,  317,   50/
      DATA K( 93),K( 94),K( 95),K( 96)/  306,   11,   15,  116/
      DATA K( 97),K( 98),K( 99),K(100)/  317,  517, 5050,   20/
      DATA K(101),K(102),K(103),K(104)/ 1704, 1605, 1504, 1603/
      DATA K(105),K(106),K(107),K(108)/ 1703, 1904, 2005, 2108/
      DATA K(109),K(110),K(111),K(112)/ 2112, 2015, 1816, 1516/
      DATA K(113),K(114),K(115),K(116)/ 1315, 1212, 1209,   50/
      DATA K(117),K(118),K(119),K(120)/ 2112, 2014, 1815, 1515/
      DATA K(121),K(122),K(123),K(124)/ 1314, 1212,   50, 1212/
      DATA K(125),K(126),K(127),K(128)/ 1114,  916,  717,  417/
      DATA K(129),K(130),K(131),K(132)/  216,  115,   12,    8/
      DATA K(133),K(134),K(135),K(136)/  105,  204,  403,  503/
      DATA K(137),K(138),K(139),K(140)/  604,  505,  404,   50/
      DATA K(141),K(142),K(143),K(144)/ 1015,  716,  416,  215/
      DATA K(145),K(146),K(147),K(148)/  114,   12, 5050,   20/
      DATA K(149),K(150),K(151),K(152)/ 1912,   12,   50, 2113/
      DATA K(153),K(154),K(155),K(156)/   13,   50, 2113,  602/
      DATA K(157),K(158),K(159),K(160)/  618,   50,    9,   16/
      DATA K(161),K(162),K(163),K(164)/ 5050,   20, 2105, 1103/
      DATA K(165),K(166),K(167),K(168)/   50, 1103, 1305, 1408/
      DATA K(169),K(170),K(171),K(172)/ 1411, 1314, 1116,  817/
      DATA K(173),K(174),K(175),K(176)/  617,  316,  114,   11/
      DATA K(177),K(178),K(179),K(180)/    8,  105,  204,  403/
      DATA K(181),K(182),K(183),K(184)/  503,  604,  505,  404/
      DATA K(185),K(186),K(187),K(188)/   50, 1411, 1313, 1115/
      DATA K(189),K(190),K(191),K(192)/  816,  616,  315,  113/
      DATA K(193),K(194),K(195),K(196)/   11,   50, 2105, 2115/
      DATA K(197),K(198),K(199),K(200)/   50, 2005, 2010, 2115/
      DATA K(201),K(202),K(203),K(204)/ 5050,   20, 1815, 1714/
      DATA K(205),K(206),K(207),K(208)/ 1615, 1716, 1816, 2015/
      DATA K(209),K(210),K(211),K(212)/ 2113, 2110, 2007, 1805/
      DATA K(213),K(214),K(215),K(216)/ 1604, 1203,  603,  304/
      DATA K(217),K(218),K(219),K(220)/  106,    9,   11,  114/
      DATA K(221),K(222),K(223),K(224)/  316,  617,  717, 1016/
      DATA K(225),K(226),K(227),K(228)/ 1214, 1311, 1310, 1207/
      DATA K(229),K(230),K(231),K(232)/ 1005,  704,   50, 2110/
      DATA K(233),K(234),K(235),K(236)/ 2008, 1806, 1605, 1204/
      DATA K(237),K(238),K(239),K(240)/  604,  305,  107,    9/
      DATA K(241),K(242),K(243),K(244)/   50,   11,  113,  315/
      DATA K(245),K(246),K(247),K(248)/  616,  716, 1015, 1213/
      DATA K(249),K(250),K(251),K(252)/ 1311, 5050,   20, 2103/
      DATA K(253),K(254),K(255),K(256)/ 1503,   50, 1703, 1904/
      DATA K(257),K(258),K(259),K(260)/ 2106, 2108, 1813, 1815/
      DATA K(261),K(262),K(263),K(264)/ 1916, 2117,   50, 1904/
      DATA K(265),K(266),K(267),K(268)/ 2006, 2008, 1813,   50/
      DATA K(269),K(270),K(271),K(272)/ 2117, 1817, 1516, 1012/
      DATA K(273),K(274),K(275),K(276)/  811,  510,   10,   50/
      DATA K(277),K(278),K(279),K(280)/ 1516, 1011,  810,  509/
      DATA K(281),K(282),K(283),K(284)/    9, 5050,   20, 2108/
      DATA K(285),K(286),K(287),K(288)/ 2005, 1804, 1504, 1305/
      DATA K(289),K(290),K(291),K(292)/ 1208, 1212, 1315, 1516/
      DATA K(293),K(294),K(295),K(296)/ 1816, 2015, 2112, 2108/
      DATA K(297),K(298),K(299),K(300)/   50, 2108, 2006, 1805/
      DATA K(301),K(302),K(303),K(304)/ 1505, 1306, 1208,   50/
      DATA K(305),K(306),K(307),K(308)/ 1212, 1314, 1515, 1815/
      DATA K(309),K(310),K(311),K(312)/ 2014, 2112,   50, 1208/
      DATA K(313),K(314),K(315),K(316)/ 1105, 1004,  803,  403/
      DATA K(317),K(318),K(319),K(320)/  204,  105,    8,   12/
      DATA K(321),K(322),K(323),K(324)/  115,  216,  417,  817/
      DATA K(325),K(326),K(327),K(328)/ 1016, 1115, 1212,   50/
      DATA K(329),K(330),K(331),K(332)/ 1208, 1106, 1005,  804/
      DATA K(333),K(334),K(335),K(336)/  404,  205,  106,    8/
      DATA K(337),K(338),K(339),K(340)/   50,   12,  114,  215/
      DATA K(341),K(342),K(343),K(344)/  416,  816, 1015, 1114/
      DATA K(345),K(346),K(347),K(348)/ 1212, 5050,   20, 1416/
      DATA K(349),K(350),K(351),K(352)/ 1115,  913,  810,  809/
      DATA K(353),K(354),K(355),K(356)/  906, 1104, 1403, 1503/
      DATA K(357),K(358),K(359),K(360)/ 1804, 2006, 2109, 2111/
      DATA K(361),K(362),K(363),K(364)/ 2014, 1816, 1517,  917/
      DATA K(365),K(366),K(367),K(368)/  516,  315,  113,   10/
      DATA K(369),K(370),K(371),K(372)/    7,  105,  304,  404/
      DATA K(373),K(374),K(375),K(376)/  505,  406,  305,   50/
      DATA K(377),K(378),K(379),K(380)/  809,  907, 1105, 1404/
      DATA K(381),K(382),K(383),K(384)/ 1504, 1805, 2007, 2109/
      DATA K(385),K(386),K(387),K(388)/   50, 2111, 2013, 1815/
      DATA K(389),K(390),K(391),K(392)/ 1516,  916,  515,  314/
      DATA K(393),K(394),K(395),K(396)/  112,   10, 5050,   10/
      DATA K(397),K(398),K(399),K(400)/  205,  104,    5,  106/
      DATA K(401),K(402)/  205, 5050/
c      DATA ISTART/  1, 42, 54,100,148,162,202,251,283,347,396,
c                  403,412,
c     &            425,440,456,489,496,509,524,534,538,559,580,584,591,
c     &            598,607,616,666,709,720,731,763,767/
c     Sonderzeichen .
      DATA K(403),K(404)/   10,    5/
      DATA K(405),K(406),K(407),K(408)/  104,  205,  106,  -94/
      DATA K(409),K(410),K(411),K(412)/ -295, -396, 5050,   10/
      DATA K(413),K(414),K(415),K(416)/ 1405, 1304, 1205, 1306/
      DATA K(417),K(418),K(419),K(420)/ 1405,   50,  205,  104/
      DATA K(421),K(422),K(423),K(424)/    5,  106,  205, 5050/
      DATA K(425),K(426),K(427),K(428)/   10, 1405, 1304, 1205/
      DATA K(429),K(430),K(431),K(432)/ 1306, 1405,   50,    5/
      DATA K(433),K(434),K(435),K(436)/  104,  205,  106,  -94/
      DATA K(437),K(438),K(439),K(440)/ -295, -396, 5050,   10/
      DATA K(441),K(442),K(443),K(444)/ 2105, 1904,  705, 1906/
      DATA K(445),K(446),K(447),K(448)/ 2105,   50, 1905, 1305/
      DATA K(449),K(450),K(451),K(452)/   50,  205,  104,    5/
      DATA K(453),K(454),K(455),K(456)/  106,  205, 5050,   18/
      DATA K(457),K(458),K(459),K(460)/ 1704, 1605, 1504, 1603/
      DATA K(461),K(462),K(463),K(464)/ 1703, 1904, 2005, 2107/
      DATA K(465),K(466),K(467),K(468)/ 2110, 2013, 1914, 1715/
      DATA K(469),K(470),K(471),K(472)/ 1515, 1314, 1213, 1009/
      DATA K(473),K(474),K(475),K(476)/  709,   50, 2110, 2012/
      DATA K(477),K(478),K(479),K(480)/ 1913, 1714, 1514, 1313/
      DATA K(481),K(482),K(483),K(484)/ 1111,   50,  209,  108/
      DATA K(485),K(486),K(487),K(488)/    9,  110,  209, 5050/
      DATA K(489),K(490),K(491),K(492)/    8, 2104, 1403,   50/
      DATA K(493),K(494),K(495),K(496)/ 2105, 1403, 5050,   16/
      DATA K(497),K(498),K(499),K(500)/ 2104, 1403,   50, 2105/
      DATA K(501),K(502),K(503),K(504)/ 1403,   50, 2112, 1411/
      DATA K(505),K(506),K(507),K(508)/   50, 2113, 1411, 5050/
      DATA K(509),K(510),K(511),K(512)/   14, 2106, 2004, 1803/
      DATA K(513),K(514),K(515),K(516)/ 1603, 1404, 1306, 1308/
      DATA K(517),K(518),K(519),K(520)/ 1410, 1611, 1811, 2010/
      DATA K(521),K(522),K(523),K(524)/ 2108, 2106, 5050,   16/
      DATA K(525),K(526),K(527),K(528)/ 1608,  408,   50, 1303/
      DATA K(529),K(530),K(531),K(532)/  713,   50, 1313,  703/
      DATA K(533),K(534),K(535),K(536)/ 5050,   22, 2520, -698/
      DATA K(537),K(538),K(539),K(540)/ 5050,   14, 2511, 2309/
      DATA K(541),K(542),K(543),K(544)/ 2007, 1605, 1104,  704/
      DATA K(545),K(546),K(547),K(548)/  205, -193, -491, -689/
      DATA K(549),K(550),K(551),K(552)/   50, 2309, 1907, 1606/
      DATA K(553),K(554),K(555),K(556)/ 1105,  705,  206,  -93/
      DATA K(557),K(558),K(559),K(560)/ -491, 5050,   14, 2503/
      DATA K(561),K(562),K(563),K(564)/ 2305, 2007, 1609, 1110/
      DATA K(565),K(566),K(567),K(568)/  710,  209, -193, -495/
      DATA K(569),K(570),K(571),K(572)/ -697,   50, 2305, 1907/
      DATA K(573),K(574),K(575),K(576)/ 1608, 1109,  709,  208/
      DATA K(577),K(578),K(579)/  -93, -495, 5050/
c     - minius
      DATA K(580),K(581),K(582),K(583)/   26,  904,  922, 5050/
c     + minius
      DATA K(584)/26/
      DATA K(585),K(586),K(587),K(588)/ 1813,   13,   50,  904/
      DATA K(589),K(590),K(591),K(592)/  922, 5050,   26, 1204/
      DATA K(593),K(594),K(595),K(596)/ 1222,   50,  604,  622/
      DATA K(597),K(598),K(599),K(600)/ 5050,   26, 1521,  905/
      DATA K(601),K(602),K(603),K(604)/  321, 5050,    0,    0/
      DATA K(605),K(606),K(607),K(608)/    0,    0,   26, 1505/
      DATA K(609),K(610),K(611),K(612)/  921,  305, 5050,    0/
      DATA K(613),K(614),K(615),K(616)/    0,    0,    0,   25/
      DATA K(617),K(618),K(619),K(620)/ 1321, 1220, 1121, 1222/
      DATA K(621),K(622),K(623),K(624)/ 1322, 1421, 1420, 1319/
      DATA K(625),K(626),K(627),K(628)/ 1118,  616,  314,  112/
      DATA K(629),K(630),K(631),K(632)/   10,    7,  104,  303/
      DATA K(633),K(634),K(635),K(636)/  603,  804, 1210, 1412/
      DATA K(637),K(638),K(639),K(640)/ 1613, 1813, 2012, 2110/
      DATA K(641),K(642),K(643),K(644)/ 2008, 1807, 1607, 1308/
      DATA K(645),K(646),K(647),K(648)/ 1010,  315,  117,   20/
      DATA K(649),K(650),K(651),K(652)/   21,  122,  222,   50/
      DATA K(653),K(654),K(655),K(656)/    7,  105,  304,  604/
      DATA K(657),K(658),K(659),K(660)/  805, 1007,   50, 1607/
      DATA K(661),K(662),K(663),K(664)/ 1408,  316,  118,   20/
      DATA K(665),K(666),K(667),K(668)/ 5050,   20, 2508, -392/
      DATA K(669),K(670),K(671),K(672)/   50, 2512, -388,   50/
      DATA K(673),K(674),K(675),K(676)/ 1816, 1715, 1616, 1717/
      DATA K(677),K(678),K(679),K(680)/ 1817, 2015, 2112, 2108/
      DATA K(681),K(682),K(683),K(684)/ 2005, 1803, 1603, 1404/
      DATA K(685),K(686),K(687),K(688)/ 1305, 1207, 1013,  915/
      DATA K(689),K(690),K(691),K(692)/  717,   50, 1603, 1405/
      DATA K(693),K(694),K(695),K(696)/ 1307, 1113, 1015,  916/
      DATA K(697),K(698),K(699),K(700)/  717,  317,  115,   12/
      DATA K(701),K(702),K(703),K(704)/    8,  105,  303,  403/
      DATA K(705),K(706),K(707),K(708)/  504,  405,  304, 5050/
      DATA K(709),K(710),K(711),K(712)/   20, 2514, 2506, -394/
      DATA K(713),K(714),K(715),K(716)/ -386,   50, 2413, 2407/
      DATA K(717),K(718),K(719),K(720)/ -293, -287, 5050,   20/
      DATA K(721),K(722),K(723),K(724)/ 2506, 2514, -386, -394/
      DATA K(725),K(726),K(727),K(728)/   50, 2407, 2413, -287/
      DATA K(729),K(730),K(731),K(732)/ -293, 5050,   22, 2520/
      DATA K(733),K(734),K(735),K(736)/ -698,   50, 2106, 2004/
      DATA K(737),K(738),K(739),K(740)/ 1803, 1603, 1404, 1306/
      DATA K(741),K(742),K(743),K(744)/ 1308, 1410, 1611, 1811/
      DATA K(745),K(746),K(747),K(748)/ 2010, 2108, 2106,   50/
      DATA K(749),K(750),K(751),K(752)/  514,  412,  211,   11/
      DATA K(753),K(754),K(755),K(756)/ -188, -286, -284, -182/
      DATA K(757),K(758),K(759),K(760)/   19,  219,  418,  516/
      DATA K(761),K(762)              /  514, 5050/
      DATA K(763),K(764),K(765),K(766)/   20,    1,   19, 5050/
c     {
      DATA K(767),K(768),K(769),K(770)/  14, -588, -491, -392/ 	
      DATA K(771),K(772),K(773),K(774)/  -93,  507,  806,  905/ 	
      DATA K(775),K(776),K(777),K(778)/ 1003, 1105, 1206, 1507/ 	
      DATA K(779),K(780),K(781),K(782)/ 2107, 2408, 2509, 2612/     
      DATA K(783),K(784),K(785),K(786)/ 2510, 2409, 2108, 1508/ 	
      DATA K(787),K(788),K(789),K(790)/ 1207, 1106, 1003,  906/ 	
      DATA K(791),K(792),K(793),K(794)/  807,  508,  -92, -391/ 	
      DATA K(795),K(796),K(797)       / -490, -588, 5050/
c     }
      DATA K(798),K(799),K(800),K(801)/   14, -598, -495, -394/ 
      DATA K(802),K(803),K(804),K(805)/  -93,  507,  808,  909/ 
      DATA K(806),K(807),K(808),K(809)/ 1011, 1109, 1208, 1507/ 
      DATA K(810),K(811),K(812),K(813)/ 2107, 2406, 2505, 2602/ 
      DATA K(814),K(815),K(816),K(817)/ 2504, 2405, 2106, 1506/ 
      DATA K(818),K(819),K(820),K(821)/ 1207, 1108, 1011,  908/ 
      DATA K(822),K(823),K(824),K(825)/  807,  506,  -94, -395/ 
      DATA K(826),K(827),K(828)       / -496, -598, 5050/  
c     #
      DATA K(829),K(830),K(831),K(832)/   17,  405, 1907,   50/                 
      DATA K(833),K(834),K(835),K(836)/  409, 1911,   50,  902/
      DATA K(837),K(838),K(839),K(840)/  913,   50, 1403, 1414/
      DATA K(841),K(842),K(843),K(844)/   50,  406, 1908,   50/
      DATA K(845),K(846),K(847),K(848)/  410, 1912,   50, 1003/
      DATA K(849),K(850),K(851),K(852)/ 1014,   50, 1504, 1515/
      DATA K(853)/ 5050/
      DATA K(854),K(855),K(856),K(857)/   8, -196,  2404, 5050/            

C      0123456789 . , : ; ! ? ' " # * / ( ) - + = < > & $ [ ] %_{}|
c                11           17    20                29         36
c      write(6,'(a,4i6)')' NRoman j=',J,ISTART(J),ISTART(J+1)
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
  20   RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  KSCRIP (J,KOORD)
C-------------------------------------------------------------------------------
C      KLEINE SCRIPT
c      abcdefghijklmnopqrstuvwxyz
      parameter (istdim=27)
      DIMENSION KOORD(75),ISTART(istdim),K(781)
C
      SAVE
C
      DATA ISTART/  1, 35, 59, 82,116,140,168,207,238,258,283,315,333,
     &            379,412,442,473,509,534,557,578,606,630,667,710,743,
     &            782/
      DATA K(  1),K(  2),K(  3),K(  4)/   16,  610,  809,  907/
      DATA K(  5),K(  6),K(  7),K(  8)/  905,  803,  702,  501/
      DATA K(  9),K( 10),K( 11),K( 12)/  301,  102,    4,    6/
      DATA K( 13),K( 14),K( 15),K( 16)/  108,  309,   50,  905/
      DATA K( 17),K( 18),K( 19),K( 20)/  703,  502,  202,    4/
      DATA K( 21),K( 22),K( 23),K( 24)/   50,  911,  309,  109/
      DATA K( 25),K( 26),K( 27),K( 28)/   11,  113,  214,  516/
      DATA K( 29),K( 30),K( 31),K( 32)/   50,  912,  310,  110/
      DATA K( 33),K( 34),K( 35),K( 36)/   11, 5050,   14,  500/
      DATA K( 37),K( 38),K( 39),K( 40)/  802, 1204,   50, 2107/
      DATA K( 41),K( 42),K( 43),K( 44)/  301,  101,    3,    4/
      DATA K( 45),K( 46),K( 47),K( 48)/  106,  308,  609,  909/
      DATA K( 49),K( 50),K( 51),K( 52)/  510,  411,  412,  514/
      DATA K( 53),K( 54),K( 55),K( 56)/   50, 2108,  302,  102/
      DATA K( 57),K( 58),K( 59),K( 60)/    3, 5050,   12,  808/
      DATA K( 61),K( 62),K( 63),K( 64)/  707,  708,  808,  907/
      DATA K( 65),K( 66),K( 67),K( 68)/  905,  803,  702,  501/
      DATA K( 69),K( 70),K( 71),K( 72)/  301,  102,    4,    7/
      DATA K( 73),K( 74),K( 75),K( 76)/  210,  512,   50,  905/
      DATA K( 77),K( 78),K( 79),K( 80)/  703,  502,  202,    4/
      DATA K( 81),K( 82),K( 83),K( 84)/ 5050,   16,  610,  809/
      DATA K( 85),K( 86),K( 87),K( 88)/  907,  905,  803,  702/
      DATA K( 89),K( 90),K( 91),K( 92)/  501,  301,  102,    4/
      DATA K( 93),K( 94),K( 95),K( 96)/    6,  108,  309,   50/
      DATA K( 97),K( 98),K( 99),K(100)/  905,  703,  502,  202/
      DATA K(101),K(102),K(103),K(104)/    4,   50, 2115,  309/
      DATA K(105),K(106),K(107),K(108)/  109,   11,  113,  214/
      DATA K(109),K(110),K(111),K(112)/  516,   50, 2116,  310/
      DATA K(113),K(114),K(115),K(116)/  110,   11, 5050,   12/
      DATA K(117),K(118),K(119),K(120)/  203,  305,  406,  607/
      DATA K(121),K(122),K(123),K(124)/  807,  906,  905,  803/
      DATA K(125),K(126),K(127),K(128)/  702,  501,  301,  102/
      DATA K(129),K(130),K(131),K(132)/    4,    7,  210,  512/
      DATA K(133),K(134),K(135),K(136)/   50,  905,  703,  502/
      DATA K(137),K(138),K(139),K(140)/  202,    4, 5050,    9/
      DATA K(141),K(142),K(143),K(144)/  903, 1206, 1508, 1809/
      DATA K(145),K(146),K(147),K(148)/ 2009, 2108, 2006, 1805/
      DATA K(149),K(150),K(151),K(152)/ -904,-1104,-1203,-1101/
      DATA K(153),K(154),K(155),K(156)/ -800,  101,    2,    4/
      DATA K(157),K(158),K(159),K(160)/  106,  207,  509,   50/
      DATA K(161),K(162),K(163),K(164)/ 1805, 1304,  903,    0/
      DATA K(165),K(166),K(167),K(168)/ -502, -904, 5050,   16/
      DATA K(169),K(170),K(171),K(172)/  610,  809,  907,  905/
      DATA K(173),K(174),K(175),K(176)/  803,  702,  501,  301/
      DATA K(177),K(178),K(179),K(180)/  102,    4,    6,  108/
      DATA K(181),K(182),K(183),K(184)/  309,   50,  905,  703/
      DATA K(185),K(186),K(187),K(188)/  502,  202,    4,   50/
      DATA K(189),K(190),K(191),K(192)/  911, -895,   50,  912/
      DATA K(193),K(194),K(195),K(196)/    9, -493, -895,-1096/
      DATA K(197),K(198),K(199),K(200)/-1198,-1099, -899, -598/
      DATA K(201),K(202),K(203),K(204)/ -396, -193,   11,  214/
      DATA K(205),K(206),K(207),K(208)/  516, 5050,   15,  500/
      DATA K(209),K(210),K(211),K(212)/  802, 1204,   50, 2107/
      DATA K(213),K(214),K(215),K(216)/    0,   50, 2108,    1/
      DATA K(217),K(218),K(219),K(220)/   50,  603,  805,  907/
      DATA K(221),K(222),K(223),K(224)/  908,  810,  610,  309/
      DATA K(225),K(226),K(227),K(228)/  109,   10,   50,  908/
      DATA K(229),K(230),K(231),K(232)/  809,  609,  308,  108/
      DATA K(233),K(234),K(235),K(236)/   10,  112,  213,  515/
      DATA K(237),K(238),K(239),K(240)/ 5050,    8, 1505, 1404/
      DATA K(241),K(242),K(243),K(244)/ 1305, 1406, 1505,   50/
      DATA K(245),K(246),K(247),K(248)/  903,  301,  101,    3/
      DATA K(249),K(250),K(251),K(252)/  105,  206,  508,   50/
      DATA K(253),K(254),K(255),K(256)/  904,  302,  102,    3/
      DATA K(257),K(258),K(259),K(260)/ 5050,    8, 1505, 1404/
      DATA K(261),K(262),K(263),K(264)/ 1305, 1406, 1505,   50/
      DATA K(265),K(266),K(267),K(268)/  903, -903,   50,  904/
      DATA K(269),K(270),K(271),K(272)/    1, -501, -903,-1104/
      DATA K(273),K(274),K(275),K(276)/-1206,-1107, -907, -606/
      DATA K(277),K(278),K(279),K(280)/ -404, -201,    3,  206/
      DATA K(281),K(282),K(283),K(284)/  508, 5050,   14,  500/
      DATA K(285),K(286),K(287),K(288)/  802, 1204,   50, 2107/
      DATA K(289),K(290),K(291),K(292)/    0,   50, 2108,    1/
      DATA K(293),K(294),K(295),K(296)/   50,  909,  809,  810/
      DATA K(297),K(298),K(299),K(300)/  909,  908,  706,  603/
      DATA K(301),K(302),K(303),K(304)/   50,  603,  506,  107/
      DATA K(305),K(306),K(307),K(308)/    8,   50,  603,  505/
      DATA K(309),K(310),K(311),K(312)/  106,    8,    9,  212/
      DATA K(313),K(314),K(315),K(316)/  514, 5050,    8,  500/
      DATA K(317),K(318),K(319),K(320)/  802, 1204,   50, 2107/
      DATA K(321),K(322),K(323),K(324)/  301,  101,    3,  105/
      DATA K(325),K(326),K(327),K(328)/  206,  508,   50, 2108/
      DATA K(329),K(330),K(331),K(332)/  302,  102,    3, 5050/
      DATA K(333),K(334),K(335),K(336)/   25,  500,  802,  904/
      DATA K(337),K(338),K(339),K(340)/  806,  606,    4,   50/
      DATA K(341),K(342),K(343),K(344)/  904,  805,  605,    3/
      DATA K(345),K(346),K(347),K(348)/   50,  606,  808,  910/
      DATA K(349),K(350),K(351),K(352)/  911,  813,  613,   11/
      DATA K(353),K(354),K(355),K(356)/   50,  911,  812,  612/
      DATA K(357),K(358),K(359),K(360)/   10,   50,  613,  815/
      DATA K(361),K(362),K(363),K(364)/  917,  918,  820,  620/
      DATA K(365),K(366),K(367),K(368)/  319,  119,   20,   50/
      DATA K(369),K(370),K(371),K(372)/  918,  819,  619,  318/
      DATA K(373),K(374),K(375),K(376)/  118,   20,  122,  223/
      DATA K(377),K(378),K(379),K(380)/  525, 5050,   18,  500/
      DATA K(381),K(382),K(383),K(384)/  802,  904,  806,  606/
      DATA K(385),K(386),K(387),K(388)/    4,   50,  904,  805/
      DATA K(389),K(390),K(391),K(392)/  605,    3,   50,  606/
      DATA K(393),K(394),K(395),K(396)/  808,  910,  911,  813/
      DATA K(397),K(398),K(399),K(400)/  613,  312,  112,   13/
      DATA K(401),K(402),K(403),K(404)/   50,  911,  812,  612/
      DATA K(405),K(406),K(407),K(408)/  311,  111,   13,  115/
      DATA K(409),K(410),K(411),K(412)/  216,  518, 5050,   14/
      DATA K(413),K(414),K(415),K(416)/  907,  905,  803,  702/
      DATA K(417),K(418),K(419),K(420)/  501,  301,  102,    4/
      DATA K(421),K(422),K(423),K(424)/    6,  108,  209,  410/
      DATA K(425),K(426),K(427),K(428)/  610,  809,  907,  806/
      DATA K(429),K(430),K(431),K(432)/  606,  407,  309,  311/
      DATA K(433),K(434),K(435),K(436)/  413,  514,   50,  905/
      DATA K(437),K(438),K(439),K(440)/  703,  502,  202,    4/
      DATA K(441),K(442),K(443),K(444)/ 5050,   15,  500,  802/
      DATA K(445),K(446),K(447),K(448)/ 1204,   50, 1505,-1204/
      DATA K(449),K(450),K(451),K(452)/   50, 1506,-1203,   50/
      DATA K(453),K(454),K(455),K(456)/  603,  805,  907,  908/
      DATA K(457),K(458),K(459),K(460)/  810,  610,  309,  109/
      DATA K(461),K(462),K(463),K(464)/   10,   50,  908,  809/
      DATA K(465),K(466),K(467),K(468)/  609,  308,  108,   10/
      DATA K(469),K(470),K(471),K(472)/  112,  213,  515, 5050/
      DATA K(473),K(474),K(475),K(476)/   16,  610,  809,  907/
      DATA K(477),K(478),K(479),K(480)/  905,  803,  702,  501/
      DATA K(481),K(482),K(483),K(484)/  301,  102,    4,    6/
      DATA K(485),K(486),K(487),K(488)/  108,   50,  905,  703/
      DATA K(489),K(490),K(491),K(492)/  502,  202,    4,   50/
      DATA K(493),K(494),K(495),K(496)/  911, -895,-1095,-1194/
      DATA K(497),K(498),K(499),K(500)/-1092, -791,    9,   11/
      DATA K(501),K(502),K(503),K(504)/  214,  516,   50,  912/
      DATA K(505),K(506),K(507),K(508)/    9, -493, -895, 5050/
      DATA K(509),K(510),K(511),K(512)/   14,  500,  802,  904/
      DATA K(513),K(514),K(515),K(516)/  806,  606,    4,   50/
      DATA K(517),K(518),K(519),K(520)/  904,  805,  605,    3/
      DATA K(521),K(522),K(523),K(524)/   50,  606,  808,  910/
      DATA K(525),K(526),K(527),K(528)/  911,  610,   50,  910/
      DATA K(529),K(530),K(531),K(532)/  610,  411,  412,  514/
      DATA K(533),K(534),K(535),K(536)/ 5050,   12,  500,  802/
      DATA K(537),K(538),K(539),K(540)/ 1003,  803,  606,  407/
      DATA K(541),K(542),K(543),K(544)/  207,  106,    4,   50/
      DATA K(545),K(546),K(547),K(548)/  803,  605,  406,  206/
      DATA K(549),K(550),K(551),K(552)/    4,   50,  100,    2/
      DATA K(553),K(554),K(555),K(556)/    7,  210,  512, 5050/
      DATA K(557),K(558),K(559),K(560)/    8,  500,  802, 1204/
      DATA K(561),K(562),K(563),K(564)/   50, 2107,  301,  101/
      DATA K(565),K(566),K(567),K(568)/    3,  105,  206,  508/
      DATA K(569),K(570),K(571),K(572)/   50, 2108,  302,  102/
      DATA K(573),K(574),K(575),K(576)/    3,   50, 1302, 1308/
      DATA K(577),K(578),K(579),K(580)/ 5050,   16,  903,  301/
      DATA K(581),K(582),K(583),K(584)/  101,    3,    4,  106/
      DATA K(585),K(586),K(587),K(588)/  308,  610,   50,  904/
      DATA K(589),K(590),K(591),K(592)/  302,  102,    3,   50/
      DATA K(593),K(594),K(595),K(596)/  911,  309,  109,   11/
      DATA K(597),K(598),K(599),K(600)/  113,  214,  516,   50/
      DATA K(601),K(602),K(603),K(604)/  912,  310,  110,   11/
      DATA K(605),K(606),K(607),K(608)/ 5050,   15,  903,  702/
      DATA K(609),K(610),K(611),K(612)/  401,  101,    3,    4/
      DATA K(613),K(614),K(615),K(616)/  107,  309,  610,  910/
      DATA K(617),K(618),K(619),K(620)/   50,  904,  703,  402/
      DATA K(621),K(622),K(623),K(624)/  102,    3,   50,  910/
      DATA K(625),K(626),K(627),K(628)/  511,  412,  413,  515/
      DATA K(629),K(630),K(631),K(632)/ 5050,   21,  904,  702/
      DATA K(633),K(634),K(635),K(636)/  401,  101,    3,    4/
      DATA K(637),K(638),K(639),K(640)/  106,  308,   50,  905/
      DATA K(641),K(642),K(643),K(644)/  703,  402,  102,    3/
      DATA K(645),K(646),K(647),K(648)/   50,  910,  308,  108/
      DATA K(649),K(650),K(651),K(652)/   10,   11,  113,  315/
      DATA K(653),K(654),K(655),K(656)/  616,  916,   50,  911/
      DATA K(657),K(658),K(659),K(660)/  309,  109,   10,   50/
      DATA K(661),K(662),K(663),K(664)/  916,  517,  418,  419/
      DATA K(665),K(666),K(667),K(668)/  521, 5050,   16,  500/
      DATA K(669),K(670),K(671),K(672)/  802,  904,  906,  807/
      DATA K(673),K(674),K(675),K(676)/  607,  306,  105,    3/
      DATA K(677),K(678),K(679),K(680)/    2,  101,  201,  202/
      DATA K(681),K(682),K(683),K(684)/  101,   50,  813,  712/
      DATA K(685),K(686),K(687),K(688)/  713,  813,  912,  911/
      DATA K(689),K(690),K(691),K(692)/  809,  608,  307,  107/
      DATA K(693),K(694),K(695),K(696)/    8,   11,  214,  516/
      DATA K(697),K(698),K(699),K(700)/   50,  807,  608,   50/
      DATA K(701),K(702),K(703),K(704)/  809,  607,   50,  306/
      DATA K(705),K(706),K(707),K(708)/  107,   50,  307,  105/
      DATA K(709),K(710),K(711),K(712)/ 5050,   16,  903,  301/
      DATA K(713),K(714),K(715),K(716)/  101,    3,    4,  106/
      DATA K(717),K(718),K(719),K(720)/  308,  610,   50,  904/
      DATA K(721),K(722),K(723),K(724)/  302,  102,    3,   50/
      DATA K(725),K(726),K(727),K(728)/  911, -895,   50,  912/
      DATA K(729),K(730),K(731),K(732)/    9, -493, -895,-1096/
      DATA K(733),K(734),K(735),K(736)/-1198,-1099, -899, -598/
      DATA K(737),K(738),K(739),K(740)/ -396, -193,   11,  214/
      DATA K(741),K(742),K(743),K(744)/  516, 5050,   13,  500/
      DATA K(745),K(746),K(747),K(748)/  802,  904,  906,  808/
      DATA K(749),K(750),K(751),K(752)/  508,  307,  104,    2/
      DATA K(753),K(754),K(755),K(756)/   50,  906,  807,  507/
      DATA K(757),K(758),K(759),K(760)/  306,  104,   50,    2/
      DATA K(761),K(762),K(763),K(764)/  -96, -295, -595, -896/
      DATA K(765),K(766),K(767),K(768)/-1098,-1200,-1101, -901/
      DATA K(769),K(770),K(771),K(772)/ -600, -297,  -94,  210/
      DATA K(773),K(774),K(775),K(776)/  513,   50,    2,  -97/
      DATA K(777),K(778),K(779),K(780)/ -296, -596, -897,-1102/
      DATA K(781)                     / 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  GSCRIP (J,KOORD)
C-------------------------------------------------------------------------------
C      GROSSE SCRIPT
C      ABCDEFGHIJKLMNOPQRSTUVWXYZ
      parameter (istdim=27)
      DIMENSION KOORD(75),ISTART(istdim),K(1197)
C
      SAVE
C
      DATA ISTART/  1, 40,111,153,197,247,294,348,404,438,473,533,574,
     &            624,663,698,752,796,862,899,938,978,1015,1057,1110,
     &            1153,1198/
      DATA K(   1),K(   2),K(   3),K(   4)/   23, 2119, 1917, 1615/
      DATA K(   5),K(   6),K(   7),K(   8)/ 1112,  810,  407,  104/
      DATA K(   9),K(  10),K(  11),K(  12)/    2,    0,   99,  299/
      DATA K(  13),K(  14),K(  15),K(  16)/  400,  301,  200,   50/
      DATA K(  17),K(  18),K(  19),K(  20)/ 2119, 1718,  716,   15/
      DATA K(  21),K(  22),K(  23),K(  24)/   50, 2119,   16,   50/
      DATA K(  25),K(  26),K(  27),K(  28)/   15,  215,  514,  713/
      DATA K(  29),K(  30),K(  31),K(  32)/  911, 1009, 1007,  906/
      DATA K(  33),K(  34),K(  35),K(  36)/  706,  407,  110,   13/
      DATA K(  37),K(  38),K(  39),K(  40)/   17,  119, 5050,   24/
      DATA K(  41),K(  42),K(  43),K(  44)/ 2015, 1914, 1713, 1211/
      DATA K(  45),K(  46),K(  47),K(  48)/  609,  408,  106,    4/
      DATA K(  49),K(  50),K(  51),K(  52)/   50, 1914, 1613,  811/
      DATA K(  53),K(  54),K(  55),K(  56)/  510,  309,  107,    4/
      DATA K(  57),K(  58),K(  59),K(  60)/    2,  101,  301,  402/
      DATA K(  61),K(  62),K(  63),K(  64)/  303,  202,   50, 1509/
      DATA K(  65),K(  66),K(  67),K(  68)/ 1308, 1207, 1205, 1304/
      DATA K(  69),K(  70),K(  71),K(  72)/ 1504, 1705, 1907, 2009/
      DATA K(  73),K(  74),K(  75),K(  76)/ 2112, 2118, 2020, 1821/
      DATA K(  77),K(  78),K(  79),K(  80)/ 1621, 1420, 1318, 1214/
      DATA K(  81),K(  82),K(  83),K(  84)/ 1212,   50, 2118, 2019/
      DATA K(  85),K(  86),K(  87),K(  88)/ 1820, 1620, 1419, 1318/
      DATA K(  89),K(  90),K(  91),K(  92)/   50, 1214, 1117, 1018/
      DATA K(  93),K(  94),K(  95),K(  96)/  819,  519,  218,  117/
      DATA K(  97),K(  98),K(  99),K( 100)/   15,   13,  112,  312/
      DATA K( 101),K( 102),K( 103),K( 104)/  613,   50, 1214, 1116/
      DATA K( 105),K( 106),K( 107),K( 108)/ 1017,  818,  518,  217/
      DATA K( 109),K( 110),K( 111),K( 112)/   15, 5050,   21, 1903/
      DATA K( 113),K( 114),K( 115),K( 116)/ 1702, 1502, 1303, 1206/
      DATA K( 117),K( 118),K( 119),K( 120)/ 1209, 1313, 1415, 1617/
      DATA K( 121),K( 122),K( 123),K( 124)/ 1818, 2018, 2117, 2115/
      DATA K( 125),K( 126),K( 127),K( 128)/ 2012, 1709, 1407, 1005/
      DATA K( 129),K( 130),K( 131),K( 132)/  604,  304,  105,    8/
      DATA K( 133),K( 134),K( 135),K( 136)/   10,  113,  315,  516/
      DATA K( 137),K( 138),K( 139),K( 140)/  716,  915,  913,  811/
      DATA K( 141),K( 142),K( 143),K( 144)/  610,   50, 2115, 2013/
      DATA K( 145),K( 146),K( 147),K( 148)/ 1710, 1408, 1006,  605/
      DATA K( 149),K( 150),K( 151),K( 152)/  305,  106,    8, 5050/
      DATA K( 153),K( 154),K( 155),K( 156)/   23, 2015, 1914, 1713/
      DATA K( 157),K( 158),K( 159),K( 160)/ 1211,  609,  408,  106/
      DATA K( 161),K( 162),K( 163),K( 164)/    4,   50, 1914, 1613/
      DATA K( 165),K( 166),K( 167),K( 168)/  811,  510,  309,  107/
      DATA K( 169),K( 170),K( 171),K( 172)/    4,    2,  101,  301/
      DATA K( 173),K( 174),K( 175),K( 176)/  402,  404,  306,  108/
      DATA K( 177),K( 178),K( 179),K( 180)/   10,   13,  115,  317/
      DATA K( 181),K( 182),K( 183),K( 184)/  719, 1220, 1520, 1819/
      DATA K( 185),K( 186),K( 187),K( 188)/ 2017, 2115, 2110, 2007/
      DATA K( 189),K( 190),K( 191),K( 192)/ 1805, 1604, 1404, 1305/
      DATA K( 193),K( 194),K( 195),K( 196)/ 1307, 1408, 1609, 5050/
      DATA K( 197),K( 198),K( 199),K( 200)/   19, 1814, 1713, 1513/
      DATA K( 201),K( 202),K( 203),K( 204)/ 1414, 1416, 1617, 1817/
      DATA K( 205),K( 206),K( 207),K( 208)/ 2016, 2114, 2111, 2009/
      DATA K( 209),K( 210),K( 211),K( 212)/ 1908, 1707, 1507, 1308/
      DATA K( 213),K( 214),K( 215),K( 216)/ 1210,   50, 2111, 1909/
      DATA K( 217),K( 218),K( 219),K( 220)/ 1708, 1408, 1210,   50/
      DATA K( 221),K( 222),K( 223),K( 224)/ 1210, 1208, 1105,  903/
      DATA K( 225),K( 226),K( 227),K( 228)/  702,  402,  203,  104/
      DATA K( 229),K( 230),K( 231),K( 232)/    6,    9,  112,  314/
      DATA K( 233),K( 234),K( 235),K( 236)/  515,  715,  914,  912/
      DATA K( 237),K( 238),K( 239),K( 240)/  810,  609,   50, 1208/
      DATA K( 241),K( 242),K( 243),K( 244)/ 1106,  904,  703,  303/
      DATA K( 245),K( 246),K( 247),K( 248)/  104, 5050,   21, 1916/
      DATA K( 249),K( 250),K( 251),K( 252)/ 1715, 1213,  611,  410/
      DATA K( 253),K( 254),K( 255),K( 256)/  108,    6,   50, 1510/
      DATA K( 257),K( 258),K( 259),K( 260)/ 1309, 1207, 1205, 1404/
      DATA K( 261),K( 262),K( 263),K( 264)/ 1604, 1805, 2007, 2110/
      DATA K( 265),K( 266),K( 267),K( 268)/ 2120, 2017, 1916, 1615/
      DATA K( 269),K( 270),K( 271),K( 272)/  813,  512,  311,  109/
      DATA K( 273),K( 274),K( 275),K( 276)/    6,    4,  102,  201/
      DATA K( 277),K( 278),K( 279),K( 280)/  301,  402,  303,  202/
      DATA K( 281),K( 282),K( 283),K( 284)/   50, 2112, 2016, 2017/
      DATA K( 285),K( 286),K( 287),K( 288)/   50,  808,  909, 1011/
      DATA K( 289),K( 290),K( 291),K( 292)/ 1015, 1117, 1419,  717/
      DATA K( 293),K( 294),K( 295),K( 296)/ 5050,   22, 1803, 1602/
      DATA K( 297),K( 298),K( 299),K( 300)/ 1402, 1203, 1105, 1108/
      DATA K( 301),K( 302),K( 303),K( 304)/ 1211, 1313, 1616, 1917/
      DATA K( 305),K( 306),K( 307),K( 308)/ 2017, 2116, 2115, 2013/
      DATA K( 309),K( 310),K( 311),K( 312)/ 1811, 1610, 1309, 1009/
      DATA K( 313),K( 314),K( 315),K( 316)/  810,  712,  714,  816/
      DATA K( 317),K( 318),K( 319),K( 320)/ 1018, 1219,   50, 2116/
      DATA K( 321),K( 322),K( 323),K( 324)/ 2014, 1812, 1611, 1310/
      DATA K( 325),K( 326),K( 327),K( 328)/  910,  712,   50, 1219/
      DATA K( 329),K( 330),K( 331),K( 332)/  818,  416,  214,  112/
      DATA K( 333),K( 334),K( 335),K( 336)/    8,    5,  103,  302/
      DATA K( 337),K( 338),K( 339),K( 340)/  402,  503,  404,  303/
      DATA K( 341),K( 342),K( 343),K( 344)/   50,  818,  516,  314/
      DATA K( 345),K( 346),K( 347),K( 348)/  111,    8, 5050,   24/
      DATA K( 349),K( 350),K( 351),K( 352)/ 1506, 1605, 1805, 2006/
      DATA K( 353),K( 354),K( 355),K( 356)/ 2109, 2112, 1009,  407/
      DATA K( 357),K( 358),K( 359),K( 360)/  206,  105,    3,    1/
      DATA K( 361),K( 362),K( 363),K( 364)/  100,  300,  401,  302/
      DATA K( 365),K( 366),K( 367),K( 368)/  201,   50, 2112, 1209/
      DATA K( 369),K( 370),K( 371),K( 372)/  908,  406,  205,    3/
      DATA K( 373),K( 374),K( 375),K( 376)/   50,  704,  805,  907/
      DATA K( 377),K( 378),K( 379),K( 380)/ 1216, 1318, 1521, 1723/
      DATA K( 381),K( 382),K( 383),K( 384)/ 1924, 2024, 2123, 2122/
      DATA K( 385),K( 386),K( 387),K( 388)/ 2020, 1718, 1517,  915/
      DATA K( 389),K( 390),K( 391),K( 392)/  514,  214,   16,   17/
      DATA K( 393),K( 394),K( 395),K( 396)/  119,  321,   50, 2122/
      DATA K( 397),K( 398),K( 399),K( 400)/ 1920, 1518,  916,  515/
      DATA K( 401),K( 402),K( 403),K( 404)/  215,   16, 5050,   16/
      DATA K( 405),K( 406),K( 407),K( 408)/ 1914, 1612, 1110,  608/
      DATA K( 409),K( 410),K( 411),K( 412)/  407,  105,    3,   50/
      DATA K( 413),K( 414),K( 415),K( 416)/ 1516, 1314, 1211, 1208/
      DATA K( 417),K( 418),K( 419),K( 420)/ 1306, 1505, 1705, 1906/
      DATA K( 421),K( 422),K( 423),K( 424)/ 2008, 2112, 2116, 1914/
      DATA K( 425),K( 426),K( 427),K( 428)/ 1713, 1111,  509,  308/
      DATA K( 429),K( 430),K( 431),K( 432)/  106,    3,    1,  100/
      DATA K( 433),K( 434),K( 435),K( 436)/  300,  401,  302,  201/
      DATA K( 437),K( 438),K( 439),K( 440)/ 5050,   17, 2116, 1914/
      DATA K( 441),K( 442),K( 443),K( 444)/ 1612, 1110,  207, -195/
      DATA K( 445),K( 446),K( 447),K( 448)/   50, 1416, 1214, 1111/
      DATA K( 449),K( 450),K( 451),K( 452)/ 1108, 1206, 1405, 1605/
      DATA K( 453),K( 454),K( 455),K( 456)/ 1806, 2008, 2112, 2116/
      DATA K( 457),K( 458),K( 459),K( 460)/ 1814, 1613,  710,  308/
      DATA K( 461),K( 462),K( 463),K( 464)/  107, -195, -296, -398/
      DATA K( 465),K( 466),K( 467),K( 468)/ -299,  -99,  102,  304/
      DATA K( 469),K( 470),K( 471),K( 472)/  406,  509,  613, 5050/
      DATA K( 473),K( 474),K( 475),K( 476)/   24, 1506, 1605, 1805/
      DATA K( 477),K( 478),K( 479),K( 480)/ 2007, 2110, 2112, 1009/
      DATA K( 481),K( 482),K( 483),K( 484)/  407,  206,  105,    3/
      DATA K( 485),K( 486),K( 487),K( 488)/    1,  100,  300,  401/
      DATA K( 489),K( 490),K( 491),K( 492)/  302,  201,   50, 2112/
      DATA K( 493),K( 494),K( 495),K( 496)/ 1209,  908,  406,  205/
      DATA K( 497),K( 498),K( 499),K( 500)/    3,   50, 2020, 1617/
      DATA K( 501),K( 502),K( 503),K( 504)/ 1415, 1313, 1210,   50/
      DATA K( 505),K( 506),K( 507),K( 508)/ 2023, 1922, 1823, 1924/
      DATA K( 509),K( 510),K( 511),K( 512)/ 2024, 2123, 2122, 2020/
      DATA K( 513),K( 514),K( 515),K( 516)/ 1517, 1416, 1314, 1210/
      DATA K( 517),K( 518),K( 519),K( 520)/   50, 1210, 1113,  914/
      DATA K( 521),K( 522),K( 523),K( 524)/  215,   16,   50, 1210/
      DATA K( 525),K( 526),K( 527),K( 528)/ 1112,  913,  214,   16/
      DATA K( 529),K( 530),K( 531),K( 532)/   17,  119,  321, 5050/
      DATA K( 533),K( 534),K( 535),K( 536)/   18, 1804, 1603, 1403/
      DATA K( 537),K( 538),K( 539),K( 540)/ 1204, 1106, 1109, 1212/
      DATA K( 541),K( 542),K( 543),K( 544)/ 1314, 1617, 1918, 2018/
      DATA K( 545),K( 546),K( 547),K( 548)/ 2117, 2116, 2014, 1913/
      DATA K( 549),K( 550),K( 551),K( 552)/ 1611,  607,  406,  104/
      DATA K( 553),K( 554),K( 555),K( 556)/    2,   50, 1913, 1511/
      DATA K( 557),K( 558),K( 559),K( 560)/  809,  508,  307,  105/
      DATA K( 561),K( 562),K( 563),K( 564)/    2,    0,   99,  299/
      DATA K( 565),K( 566),K( 567),K( 568)/  400,  402,  304,  107/
      DATA K( 569),K( 570),K( 571),K( 572)/    9,   12,  114,  316/
      DATA K( 573),K( 574),K( 575),K( 576)/ 5050,   28, 2114, 1210/
      DATA K( 577),K( 578),K( 579),K( 580)/  607,  305,  103,    1/
      DATA K( 581),K( 582),K( 583),K( 584)/   -1,   98,  298,  399/
      DATA K( 585),K( 586),K( 587),K( 588)/  300,  199,   50, 2114/
      DATA K( 589),K( 590),K( 591),K( 592)/ 1412, 1011,  510,  110/
      DATA K( 593),K( 594),K( 595),K( 596)/   12,   50, 2114, 1713/
      DATA K( 597),K( 598),K( 599),K( 600)/ 1212,  511,  111,   12/
      DATA K( 601),K( 602),K( 603),K( 604)/   50, 2123, 1219,  314/
      DATA K( 605),K( 606),K( 607),K( 608)/   12,   50, 2123, 1421/
      DATA K( 609),K( 610),K( 611),K( 612)/ 1020,  519,  119,   21/
      DATA K( 613),K( 614),K( 615),K( 616)/   22,  124,  326,   50/
      DATA K( 617),K( 618),K( 619),K( 620)/ 2123, 1722, 1221,  520/
      DATA K( 621),K( 622),K( 623),K( 624)/  120,   21, 5050,   23/
      DATA K( 625),K( 626),K( 627),K( 628)/ 2111, 1710, 1108,  606/
      DATA K( 629),K( 630),K( 631),K( 632)/  405,  103,    1,   -1/
      DATA K( 633),K( 634),K( 635),K( 636)/   98,  298,  399,  300/
      DATA K( 637),K( 638),K( 639),K( 640)/  199,   50, 2111, 1611/
      DATA K( 641),K( 642),K( 643),K( 644)/  512,   13,   50, 2111/
      DATA K( 645),K( 646),K( 647),K( 648)/ 1612,  513,   13,   50/
      DATA K( 649),K( 650),K( 651),K( 652)/ 2025, 1924, 1825, 1926/
      DATA K( 653),K( 654),K( 655),K( 656)/ 2026, 2125, 2123, 2021/
      DATA K( 657),K( 658),K( 659),K( 660)/ 1719, 1518, 1016,  414/
      DATA K( 661),K( 662),K( 663),K( 664)/   13, 5050,   21, 2111/
      DATA K( 665),K( 666),K( 667),K( 668)/ 2009, 1807, 1505, 1304/
      DATA K( 669),K( 670),K( 671),K( 672)/  903,  503,  204,  105/
      DATA K( 673),K( 674),K( 675),K( 676)/    7,    9,  112,  314/
      DATA K( 677),K( 678),K( 679),K( 680)/  616,  817, 1218, 1618/
      DATA K( 681),K( 682),K( 683),K( 684)/ 1917, 2016, 2015, 1913/
      DATA K( 685),K( 686),K( 687),K( 688)/ 1711, 1309,  808,  508/
      DATA K( 689),K( 690),K( 691),K( 692)/   50, 2009, 1707, 1305/
      DATA K( 693),K( 694),K( 695),K( 696)/  904,  504,  205,    7/
      DATA K( 697),K( 698),K( 699),K( 700)/ 5050,   23, 2015, 1914/
      DATA K( 701),K( 702),K( 703),K( 704)/ 1713, 1211,  609,  408/
      DATA K( 705),K( 706),K( 707),K( 708)/  106,    4,   50, 1914/
      DATA K( 709),K( 710),K( 711),K( 712)/ 1613,  811,  510,  309/
      DATA K( 713),K( 714),K( 715),K( 716)/  107,    4,    2,  101/
      DATA K( 717),K( 718),K( 719),K( 720)/  301,  402,  303,  202/
      DATA K( 721),K( 722),K( 723),K( 724)/   50, 1509, 1308, 1207/
      DATA K( 725),K( 726),K( 727),K( 728)/ 1205, 1304, 1504, 1705/
      DATA K( 729),K( 730),K( 731),K( 732)/ 1907, 2009, 2112, 2116/
      DATA K( 733),K( 734),K( 735),K( 736)/ 2019, 1920, 1721, 1421/
      DATA K( 737),K( 738),K( 739),K( 740)/ 1220, 1119, 1016, 1014/
      DATA K( 741),K( 742),K( 743),K( 744)/ 1112,   50, 2116, 2018/
      DATA K( 745),K( 746),K( 747),K( 748)/ 1919, 1720, 1420, 1219/
      DATA K( 749),K( 750),K( 751),K( 752)/ 1118, 1016, 5050,   21/
      DATA K( 753),K( 754),K( 755),K( 756)/ 1713, 1513, 1312, 1211/
      DATA K( 757),K( 758),K( 759),K( 760)/ 1109, 1107, 1306, 1506/
      DATA K( 761),K( 762),K( 763),K( 764)/ 1807, 2009, 2112, 2115/
      DATA K( 765),K( 766),K( 767),K( 768)/ 2017, 1818, 1418, 1117/
      DATA K( 769),K( 770),K( 771),K( 772)/  815,  411,  208,  106/
      DATA K( 773),K( 774),K( 775),K( 776)/    3,    1,  100,  300/
      DATA K( 777),K( 778),K( 779),K( 780)/  401,  403,  305,  108/
      DATA K( 781),K( 782),K( 783),K( 784)/   11,   14,  116,  318/
      DATA K( 785),K( 786),K( 787),K( 788)/   50, 2115, 2016, 1817/
      DATA K( 789),K( 790),K( 791),K( 792)/ 1417, 1116,  814,  511/
      DATA K( 793),K( 794),K( 795),K( 796)/  207,    3, 5050,   24/
      DATA K( 797),K( 798),K( 799),K( 800)/ 2015, 1914, 1713, 1211/
      DATA K( 801),K( 802),K( 803),K( 804)/  609,  408,  106,    4/
      DATA K( 805),K( 806),K( 807),K( 808)/   50, 1914, 1613,  811/
      DATA K( 809),K( 810),K( 811),K( 812)/  510,  309,  107,    4/
      DATA K( 813),K( 814),K( 815),K( 816)/    2,  101,  301,  402/
      DATA K( 817),K( 818),K( 819),K( 820)/  303,  202,   50, 1509/
      DATA K( 821),K( 822),K( 823),K( 824)/ 1308, 1207, 1205, 1304/
      DATA K( 825),K( 826),K( 827),K( 828)/ 1504, 1705, 1907, 2009/
      DATA K( 829),K( 830),K( 831),K( 832)/ 2112, 2117, 2020, 1821/
      DATA K( 833),K( 834),K( 835),K( 836)/ 1621, 1420, 1319, 1216/
      DATA K( 837),K( 838),K( 839),K( 840)/ 1212,   50, 2117, 2019/
      DATA K( 841),K( 842),K( 843),K( 844)/ 1820, 1620, 1419, 1318/
      DATA K( 845),K( 846),K( 847),K( 848)/ 1216,   50, 1212, 1115/
      DATA K( 849),K( 850),K( 851),K( 852)/  916,  217,   18,   50/
      DATA K( 853),K( 854),K( 855),K( 856)/ 1212, 1114,  915,  216/
      DATA K( 857),K( 858),K( 859),K( 860)/   18,   19,  121,  323/
      DATA K( 861),K( 862),K( 863),K( 864)/ 5050,   20, 1806, 1605/
      DATA K( 865),K( 866),K( 867),K( 868)/ 1405, 1206, 1108, 1111/
      DATA K( 869),K( 870),K( 871),K( 872)/ 1214, 1316, 1619, 1920/
      DATA K( 873),K( 874),K( 875),K( 876)/ 2020, 2119, 2118, 2016/
      DATA K( 877),K( 878),K( 879),K( 880)/ 1915, 1714, 1413,  711/
      DATA K( 881),K( 882),K( 883),K( 884)/  410,  108,    6,   50/
      DATA K( 885),K( 886),K( 887),K( 888)/ 1714, 1313,  612,  311/
      DATA K( 889),K( 890),K( 891),K( 892)/  109,    6,    3,  101/
      DATA K( 893),K( 894),K( 895),K( 896)/  300,  400,  501,  402/
      DATA K( 897),K( 898),K( 899),K( 900)/  301, 5050,   18, 1916/
      DATA K( 901),K( 902),K( 903),K( 904)/ 1715, 1213,  611,  410/
      DATA K( 905),K( 906),K( 907),K( 908)/  108,    6,   50, 1510/
      DATA K( 909),K( 910),K( 911),K( 912)/ 1309, 1207, 1205, 1404/
      DATA K( 913),K( 914),K( 915),K( 916)/ 1604, 1805, 2007, 2110/
      DATA K( 917),K( 918),K( 919),K( 920)/ 2119, 2017, 1916, 1615/
      DATA K( 921),K( 922),K( 923),K( 924)/  813,  512,  311,  109/
      DATA K( 925),K( 926),K( 927),K( 928)/    6,    4,  102,  201/
      DATA K( 929),K( 930),K( 931),K( 932)/  301,  402,  303,  202/
      DATA K( 933),K( 934),K( 935),K( 936)/   50, 2112, 2016, 2017/
      DATA K( 937),K( 938),K( 939),K( 940)/ 5050,   22, 1701, 2003/
      DATA K( 941),K( 942),K( 943),K( 944)/ 2105, 2106, 1908, 1608/
      DATA K( 945),K( 946),K( 947),K( 948)/ 1307,  504,  204,    5/
      DATA K( 949),K( 950),K( 951),K( 952)/   50, 2106, 1907, 1607/
      DATA K( 953),K( 954),K( 955),K( 956)/  804,  503,  203,    5/
      DATA K( 957),K( 958),K( 959),K( 960)/    7,  109,  412,  714/
      DATA K( 961),K( 962),K( 963),K( 964)/  915,   50, 2119,  915/
      DATA K( 965),K( 966),K( 967),K( 968)/  514,  214,   16,   17/
      DATA K( 969),K( 970),K( 971),K( 972)/  119,  321,   50, 2120/
      DATA K( 973),K( 974),K( 975),K( 976)/  916,  515,  215,   16/
      DATA K( 977),K( 978),K( 979),K( 980)/ 5050,   21, 1701, 2003/
      DATA K( 981),K( 982),K( 983),K( 984)/ 2105, 2106, 1908, 1608/
      DATA K( 985),K( 986),K( 987),K( 988)/ 1207,  505,  205,    6/
      DATA K( 989),K( 990),K( 991),K( 992)/   50, 2106, 1907, 1607/
      DATA K( 993),K( 994),K( 995),K( 996)/  905,  504,  204,    6/
      DATA K( 997),K( 998),K( 999),K(1000)/    7,  110,  413,  715/
      DATA K(1001),K(1002),K(1003),K(1004)/ 1117, 1418, 1819, 2019/
      DATA K(1005),K(1006),K(1007),K(1008)/ 2118, 2117, 2016, 1815/
      DATA K(1009),K(1010),K(1011),K(1012)/ 1515, 1316, 1118, 1020/
      DATA K(1013),K(1014),K(1015),K(1016)/ 1022, 5050,   23, 1503/
      DATA K(1017),K(1018),K(1019),K(1020)/ 1502, 1601, 1801, 2002/
      DATA K(1021),K(1022),K(1023),K(1024)/ 2104, 2108, 1907, 1506/
      DATA K(1025),K(1026),K(1027),K(1028)/  605,    4,   50, 1506/
      DATA K(1029),K(1030),K(1031),K(1032)/  606,    5,   50, 2116/
      DATA K(1033),K(1034),K(1035),K(1036)/ 1914, 1512,  609,  207/
      DATA K(1037),K(1038),K(1039),K(1040)/    5,   50, 2116, 1915/
      DATA K(1041),K(1042),K(1043),K(1044)/ 1514,  613,   12,   50/
      DATA K(1045),K(1046),K(1047),K(1048)/ 1514,  614,   13,   50/
      DATA K(1049),K(1050),K(1051),K(1052)/ 2126, 2024, 1822, 1520/
      DATA K(1053),K(1054),K(1055),K(1056)/  617,  215,   13, 5050/
      DATA K(1057),K(1058),K(1059),K(1060)/   20, 1608, 1507, 1505/
      DATA K(1061),K(1062),K(1063),K(1064)/ 1604, 1804, 2005, 2107/
      DATA K(1065),K(1066),K(1067),K(1068)/ 2109, 2011, 1812, 1512/
      DATA K(1069),K(1070),K(1071),K(1072)/ 1111,  609,  307,  105/
      DATA K(1073),K(1074),K(1075),K(1076)/    2,    0,   99,  299/
      DATA K(1077),K(1078),K(1079),K(1080)/  400,  301,  200,   50/
      DATA K(1081),K(1082),K(1083),K(1084)/ 2109, 2010, 1811, 1511/
      DATA K(1085),K(1086),K(1087),K(1088)/ 1110,  608,  306,  104/
      DATA K(1089),K(1090),K(1091),K(1092)/    2,   50, 2021, 1920/
      DATA K(1093),K(1094),K(1095),K(1096)/ 1821, 1922, 2022, 2121/
      DATA K(1097),K(1098),K(1099),K(1100)/ 2119, 2017, 1815, 1513/
      DATA K(1101),K(1102),K(1103),K(1104)/ 1111,  610,  310,  111/
      DATA K(1105),K(1106),K(1107),K(1108)/   12,   13,  115,  317/
      DATA K(1109),K(1110),K(1111),K(1112)/ 5050,   22, 1703, 2005/
      DATA K(1113),K(1114),K(1115),K(1116)/ 2107, 2108, 2010, 1810/
      DATA K(1117),K(1118),K(1119),K(1120)/ 1208,  908,  709,   50/
      DATA K(1121),K(1122),K(1123),K(1124)/ 2108, 2009, 1809, 1207/
      DATA K(1125),K(1126),K(1127),K(1128)/  907,  709,  711,  814/
      DATA K(1129),K(1130),K(1131),K(1132)/ 1016, 1318, 1519,   50/
      DATA K(1133),K(1134),K(1135),K(1136)/ 2121, 1519,  716,  314/
      DATA K(1137),K(1138),K(1139),K(1140)/   50, 2122, 1520, 1018/
      DATA K(1141),K(1142),K(1143),K(1144)/  616,  314,  112,    9/
      DATA K(1145),K(1146),K(1147),K(1148)/    5,  103,  302,  402/
      DATA K(1149),K(1150),K(1151),K(1152)/  503,  404,  303, 5050/
      DATA K(1153),K(1154),K(1155),K(1156)/   21, 1919, 1718, 1216/
      DATA K(1157),K(1158),K(1159),K(1160)/  915,  714,  412,  210/
      DATA K(1161),K(1162),K(1163),K(1164)/  108,    5,   50, 1512/
      DATA K(1165),K(1166),K(1167),K(1168)/ 1311, 1209, 1207, 1406/
      DATA K(1169),K(1170),K(1171),K(1172)/ 1606, 1807, 2009, 2112/
      DATA K(1173),K(1174),K(1175),K(1176)/ 2122, 2020, 1919, 1618/
      DATA K(1177),K(1178),K(1179),K(1180)/ 1217,  615,  313,  110/
      DATA K(1181),K(1182),K(1183),K(1184)/    5,    1,  100,  300/
      DATA K(1185),K(1186),K(1187),K(1188)/  401,  403,  305,  108/
      DATA K(1189),K(1190),K(1191),K(1192)/   10,   13,  116,  318/
      DATA K(1193),K(1194),K(1195),K(1196)/   50, 2115, 2019, 2020/
      DATA K(1197)                        / 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  NSCRIP (J,KOORD)
C-------------------------------------------------------------------------------
C      ZIFFERN, SONDERZEICHEN  SCRIPT
C      0123456789 . , : ; ! ? < > & $ / ( ) * - + = ' " # [ ] %_{}
C                11                20               28 30      34
      parameter (istdim=38)
      DIMENSION KOORD(75),ISTART(istdim),K(859)
C 
      SAVE
C
      DATA ISTART/  1, 44, 60,103,154,165,205,252,283,347,394,401,410,
     &            422,437,455,490,499,508,564,606,610,631,652,662,666,
     &            673,680,687,700,715,726,737,769,773,804,835,860/
      DATA K(  1),K(  2),K(  3),K(  4)/   21, 2112, 2009, 1807/
      DATA K(  5),K(  6),K(  7),K(  8)/ 1505, 1204,  803,  503/
      DATA K(  9),K( 10),K( 11),K( 12)/  204,  105,    7,    9/
      DATA K( 13),K( 14),K( 15),K( 16)/  112,  314,  616,  917/
      DATA K( 17),K( 18),K( 19),K( 20)/ 1318, 1618, 1917, 2016/
      DATA K( 21),K( 22),K( 23),K( 24)/ 2114, 2112,   50, 2112/
      DATA K( 25),K( 26),K( 27),K( 28)/ 2010, 1808, 1506, 1205/
      DATA K( 29),K( 30),K( 31),K( 32)/  804,  504,  205,    7/
      DATA K( 33),K( 34),K( 35),K( 36)/   50,    9,  111,  313/
      DATA K( 37),K( 38),K( 39),K( 40)/  615,  916, 1317, 1617/
      DATA K( 41),K( 42),K( 43),K( 44)/ 1916, 2114, 5050,   21/

      DATA K( 45),K( 46),K( 47),K( 48)/ 1712,    7,   50, 2114/
      DATA K( 49),K( 50),K( 51),K( 52)/    8,   50, 2114, 1811/
      DATA K( 53),K( 54),K( 55),K( 56)/ 1608, 1506,   50, 1813/
      DATA K( 57),K( 58),K( 59),K( 60)/ 1609, 1506, 5050,   21/

      DATA K( 61),K( 62),K( 63),K( 64)/ 1707, 1608, 1507, 1606/
      DATA K( 65),K( 66),K( 67),K( 68)/ 1706, 1907, 2008, 2111/
      DATA K( 69),K( 70),K( 71),K( 72)/ 2114, 2017, 1818, 1618/
      DATA K( 73),K( 74),K( 75),K( 76)/ 1417, 1215, 1012,  808/
      DATA K( 77),K( 78),K( 79),K( 80)/  605,  403,    1,   50/
      DATA K( 81),K( 82),K( 83),K( 84)/ 2114, 2016, 1817, 1617/
      DATA K( 85),K( 86),K( 87),K( 88)/ 1416, 1214,  808,   50/
      DATA K( 89),K( 90),K( 91),K( 92)/  202,  303,  305,  110/
      DATA K( 93),K( 94),K( 95),K( 96)/  113,  215,  416,   50/
      DATA K( 97),K( 98),K( 99),K(100)/  305,   10,   13,  115/
      DATA K(101),K(102),K(103),K(104)/  416, 5050,   21, 1707/
      DATA K(105),K(106),K(107),K(108)/ 1608, 1507, 1606, 1706/
      DATA K(109),K(110),K(111),K(112)/ 1907, 2008, 2111, 2114/
      DATA K(113),K(114),K(115),K(116)/ 2017, 1818, 1618, 1417/
      DATA K(117),K(118),K(119),K(120)/ 1214, 1111,   50, 2114/
      DATA K(121),K(122),K(123),K(124)/ 2016, 1817, 1617, 1416/
      DATA K(125),K(126),K(127),K(128)/ 1214,   50, 1109, 1111/
      DATA K(129),K(130),K(131),K(132)/ 1014,  915,  716,  416/
      DATA K(133),K(134),K(135),K(136)/  215,  114,   11,    7/
      DATA K(137),K(138),K(139),K(140)/  104,  203,  402,  502/
      DATA K(141),K(142),K(143),K(144)/  603,  504,  403,   50/
      DATA K(145),K(146),K(147),K(148)/ 1111, 1013,  914,  715/
      DATA K(149),K(150),K(151),K(152)/  415,  214,  113,   11/
      DATA K(153),K(154),K(155),K(156)/ 5050,   21, 2016,   10/
      DATA K(157),K(158),K(159),K(160)/   50, 2117,   11,   50/
      DATA K(161),K(162),K(163),K(164)/ 2117,  602,  618, 5050/
      DATA K(165),K(166),K(167),K(168)/   21, 2109, 1104,   50/
      DATA K(169),K(170),K(171),K(172)/ 2109, 2119,   50, 2009/
      DATA K(173),K(174),K(175),K(176)/ 2014, 2119,   50, 1104/
      DATA K(177),K(178),K(179),K(180)/ 1205, 1308, 1311, 1214/
      DATA K(181),K(182),K(183),K(184)/ 1115,  916,  616,  315/
      DATA K(185),K(186),K(187),K(188)/  113,   10,    7,  104/
      DATA K(189),K(190),K(191),K(192)/  203,  402,  502,  603/
      DATA K(193),K(194),K(195),K(196)/  504,  403,   50, 1311/
      DATA K(197),K(198),K(199),K(200)/ 1213, 1114,  915,  615/
      DATA K(201),K(202),K(203),K(204)/  314,  112,   10, 5050/
      DATA K(205),K(206),K(207),K(208)/   21, 1817, 1716, 1617/
      DATA K(209),K(210),K(211),K(212)/ 1718, 1818, 2017, 2115/
      DATA K(213),K(214),K(215),K(216)/ 2112, 2009, 1807, 1505/
      DATA K(217),K(218),K(219),K(220)/ 1204,  803,  403,  204/
      DATA K(221),K(222),K(223),K(224)/  105,    7,   10,  113/
      DATA K(225),K(226),K(227),K(228)/  315,  516,  816, 1015/
      DATA K(229),K(230),K(231),K(232)/ 1114, 1212, 1209, 1107/
      DATA K(233),K(234),K(235),K(236)/  905,  704,   50, 2112/
      DATA K(237),K(238),K(239),K(240)/ 2010, 1808, 1506, 1205/
      DATA K(241),K(242),K(243),K(244)/  804,  304,  105,   50/
      DATA K(245),K(246),K(247),K(248)/   10,  112,  314,  515/
      DATA K(249),K(250),K(251),K(252)/  915, 1114, 5050,   21/
      DATA K(253),K(254),K(255),K(256)/ 2106, 1504,   50, 2119/
      DATA K(257),K(258),K(259),K(260)/ 1818, 1516,  911,  609/
      DATA K(261),K(262),K(263),K(264)/  408,    7,   50, 1516/
      DATA K(265),K(266),K(267),K(268)/  910,  608,  407,    6/
      DATA K(269),K(270),K(271),K(272)/   50, 1805, 2108, 2110/
      DATA K(273),K(274),K(275),K(276)/ 1815,   50, 1906, 2008/
      DATA K(277),K(278),K(279),K(280)/ 2010, 1815, 1817, 1918/
      DATA K(281),K(282),K(283),K(284)/ 2119, 5050,   21, 2111/
      DATA K(285),K(286),K(287),K(288)/ 2008, 1907, 1706, 1406/
      DATA K(289),K(290),K(291),K(292)/ 1207, 1109, 1112, 1216/
      DATA K(293),K(294),K(295),K(296)/ 1317, 1518, 1818, 2017/
      DATA K(297),K(298),K(299),K(300)/ 2114, 2111,   50, 2111/
      DATA K(301),K(302),K(303),K(304)/ 2009, 1908, 1707, 1407/
      DATA K(305),K(306),K(307),K(308)/ 1208, 1109,   50, 1112/
      DATA K(309),K(310),K(311),K(312)/ 1215, 1316, 1517, 1817/
      DATA K(313),K(314),K(315),K(316)/ 2016, 2114,   50, 1109/
      DATA K(317),K(318),K(319),K(320)/ 1005,  803,  602,  302/
      DATA K(321),K(322),K(323),K(324)/  103,    6,   10,  114/
      DATA K(325),K(326),K(327),K(328)/  215,  416,  716,  915/
      DATA K(329),K(330),K(331),K(332)/ 1014, 1112,   50, 1109/
      DATA K(333),K(334),K(335),K(336)/ 1006,  804,  603,  303/
      DATA K(337),K(338),K(339),K(340)/  104,    6,   50,   10/
      DATA K(341),K(342),K(343),K(344)/  113,  214,  415,  815/
      DATA K(345),K(346),K(347),K(348)/ 1014, 5050,   21, 1417/
      DATA K(349),K(350),K(351),K(352)/ 1216, 1014,  912,  909/
      DATA K(353),K(354),K(355),K(356)/ 1007, 1106, 1305, 1605/
      DATA K(357),K(358),K(359),K(360)/ 1806, 2008, 2111, 2114/
      DATA K(361),K(362),K(363),K(364)/ 2016, 1917, 1718, 1318/
      DATA K(365),K(366),K(367),K(368)/  917,  616,  314,  112/
      DATA K(369),K(370),K(371),K(372)/    9,    6,  104,  303/
      DATA K(373),K(374),K(375),K(376)/  403,  504,  405,  304/
      DATA K(377),K(378),K(379),K(380)/   50, 1007, 1206, 1606/
      DATA K(381),K(382),K(383),K(384)/ 1807, 2009, 2111,   50/
      DATA K(385),K(386),K(387),K(388)/ 2016, 1817, 1317,  916/
      DATA K(389),K(390),K(391),K(392)/  615,  313,  111,    9/
      DATA K(393),K(394),K(395),K(396)/ 5050,   11,  203,  102/
      DATA K(397),K(398),K(399),K(400)/    3,  104,  203, 5050/
      DATA K(401),K(402),K(403),K(404)/   11,    3,  102,  203/
      DATA K(405),K(406),K(407),K(408)/  104,    4, -197, -399/
      DATA K(409),K(410),K(411),K(412)/ 5050,   11, 1406, 1305/
      DATA K(413),K(414),K(415),K(416)/ 1206, 1307, 1406,   50/
      DATA K(417),K(418),K(419),K(420)/  203,  102,    3,  104/
      DATA K(421),K(422),K(423),K(424)/ 5050,   11, 1406, 1305/
      DATA K(425),K(426),K(427),K(428)/ 1206, 1307, 1406,   50/
      DATA K(429),K(430),K(431),K(432)/    3,  102,  203,  104/
      DATA K(433),K(434),K(435),K(436)/    4, -197, -399, 5050/
      DATA K(437),K(438),K(439),K(440)/   11, 2108, 2007,  805/
      DATA K(441),K(442),K(443),K(444)/   50, 2008,  805,   50/
      DATA K(445),K(446),K(447),K(448)/ 2108, 2009,  805,   50/
      DATA K(449),K(450),K(451),K(452)/  203,  102,    3,  104/
      DATA K(453),K(454),K(455),K(456)/  203, 5050,   21, 1707/
      DATA K(457),K(458),K(459),K(460)/ 1608, 1507, 1606, 1706/
      DATA K(461),K(462),K(463),K(464)/ 1907, 2008, 2111, 2115/
      DATA K(465),K(466),K(467),K(468)/ 2018, 1819, 1619, 1418/
      DATA K(469),K(470),K(471),K(472)/ 1317, 1111, 1009,  809/
      DATA K(473),K(474),K(475),K(476)/  710,  712,   50, 2115/
      DATA K(477),K(478),K(479),K(480)/ 2017, 1818, 1618, 1417/
      DATA K(481),K(482),K(483),K(484)/ 1316, 1214,   50,  208/
      DATA K(485),K(486),K(487),K(488)/  107,    8,  109,  208/
      DATA K(489),K(490),K(491),K(492)/ 5050,   26, 1521,  905/
      DATA K(493),K(494),K(495),K(496)/  321, 5050,    0,    0/
      DATA K(497),K(498),K(499),K(500)/    0,    0,   26, 1505/
      DATA K(501),K(502),K(503),K(504)/  921,  305, 5050,    0/
      DATA K(505),K(506),K(507),K(508)/    0,    0,    0,   26/
      DATA K(509),K(510),K(511),K(512)/ 1323, 1222, 1123, 1224/
      DATA K(513),K(514),K(515),K(516)/ 1324, 1423, 1422, 1320/
      DATA K(517),K(518),K(519),K(520)/ 1118,  313,  111,    9/
      DATA K(521),K(522),K(523),K(524)/    6,  103,  302,  502/
      DATA K(525),K(526),K(527),K(528)/  703,  804,  906, 1111/
      DATA K(529),K(530),K(531),K(532)/ 1213, 1415, 1616, 1816/
      DATA K(533),K(534),K(535),K(536)/ 2015, 2113, 2011, 1810/
      DATA K(537),K(538),K(539),K(540)/ 1510,  911,  612,  314/
      DATA K(541),K(542),K(543),K(544)/  116,   18,   20,  221/
      DATA K(545),K(546),K(547),K(548)/  321,   50,    6,  104/
      DATA K(549),K(550),K(551),K(552)/  303,  503,  704,  805/
      DATA K(553),K(554),K(555),K(556)/ 1111,   50, 1510, 1011/
      DATA K(557),K(558),K(559),K(560)/  712,  414,  216,  118/
      DATA K(561),K(562),K(563),K(564)/  120,  221, 5050,   21/
      DATA K(565),K(566),K(567),K(568)/ 2512, -396,   50, 2517/
      DATA K(569),K(570),K(571),K(572)/ -391,   50, 1718, 1617/
      DATA K(573),K(574),K(575),K(576)/ 1518, 1619, 1719, 1918/
      DATA K(577),K(578),K(579),K(580)/ 2017, 2114, 2110, 2007/
      DATA K(581),K(582),K(583),K(584)/ 1805, 1605, 1406, 1307/
      DATA K(585),K(586),K(587),K(588)/  914,  716,   50, 1605/
      DATA K(589),K(590),K(591),K(592)/ 1407, 1014,  915,  716/
      DATA K(593),K(594),K(595),K(596)/  416,  215,  114,   11/
      DATA K(597),K(598),K(599),K(600)/    7,  104,  203,  402/
      DATA K(601),K(602),K(603),K(604)/  502,  603,  504,  403/
      DATA K(605),K(606),K(607),K(608)/ 5050,   22, 2524, -702/
      DATA K(609),K(610),K(611),K(612)/ 5050,   15, 2515, 2211/
      DATA K(613),K(614),K(615),K(616)/ 1908, 1606, 1204,  703/
      DATA K(617),K(618),K(619),K(620)/  303, -196, -495, -694/
      DATA K(621),K(622),K(623),K(624)/   50, 2211, 1808, 1406/
      DATA K(625),K(626),K(627),K(628)/ 1105,  604,  104, -395/
      DATA K(629),K(630),K(631),K(632)/ -694, 5050,   15, 2509/
      DATA K(633),K(634),K(635),K(636)/ 2310, 2011, 1512, 1112/
      DATA K(637),K(638),K(639),K(640)/  611,  209,  -93, -396/
      DATA K(641),K(642),K(643),K(644)/ -700,   50, 2509, 2210/
      DATA K(645),K(646),K(647),K(648)/ 1711, 1211,  710,  409/
      DATA K(649),K(650),K(651),K(652)/    7, -396, 5050,   17/
      DATA K(653),K(654),K(655),K(656)/ 2110,  910,   50, 1805/
      DATA K(657),K(658),K(659),K(660)/ 1215,   50, 1815, 1205/
      DATA K(661),K(662),K(663),K(664)/ 5050,   26,  904,  922/
      DATA K(665),K(666),K(667),K(668)/ 5050,   26, 1813,   13/
      DATA K(669),K(670),K(671),K(672)/   50,  904,  922, 5050/
      DATA K(673),K(674),K(675),K(676)/   26, 1204, 1222,   50/
      DATA K(677),K(678),K(679),K(680)/  604,  622, 5050,    9/
      DATA K(681),K(682),K(683),K(684)/ 2107, 1405,   50, 2108/
      DATA K(685),K(686),K(687),K(688)/ 1405, 5050,   18, 2107/
      DATA K(689),K(690),K(691),K(692)/ 1405,   50, 2108, 1405/
      DATA K(693),K(694),K(695),K(696)/   50, 2116, 1414,   50/
      DATA K(697),K(698),K(699),K(700)/ 2117, 1414, 5050,   15/
      DATA K(701),K(702),K(703),K(704)/ 2108, 2006, 1805, 1605/
      DATA K(705),K(706),K(707),K(708)/ 1406, 1308, 1310, 1412/
      DATA K(709),K(710),K(711),K(712)/ 1613, 1813, 2012, 2110/
      DATA K(713),K(714),K(715),K(716)/ 2108, 5050,   20, 2515/
      DATA K(717),K(718),K(719),K(720)/ 2507, -394, -386,   50/
      DATA K(721),K(722),K(723),K(724)/ 2414, 2408, -293, -287/
      DATA K(725),K(726),K(727),K(728)/ 5050,   20, 2507, 2515/
      DATA K(729),K(730),K(731),K(732)/ -386, -394,   50, 2408/
      DATA K(733),K(734),K(735),K(736)/ 2414, -287, -293, 5050/
      DATA K(737),K(738),K(739),K(740)/   22, 2520, -698,   50/
      DATA K(741),K(742),K(743),K(744)/ 2106, 2004, 1803, 1603/
      DATA K(745),K(746),K(747),K(748)/ 1404, 1306, 1308, 1410/
      DATA K(749),K(750),K(751),K(752)/ 1611, 1811, 2010, 2108/
      DATA K(753),K(754),K(755),K(756)/ 2106,   50,  514,  412/
      DATA K(757),K(758),K(759),K(760)/  211,   11, -188, -286/
      DATA K(761),K(762),K(763),K(764)/ -284, -182,   19,  219/
      DATA K(765),K(766),K(767),K(768)/  418,  516,  514, 5050/
      DATA K(769),K(770),K(771),K(772)/   20,    1,   19, 5050/
c     {
      DATA K(773),K(774),K(775),K(776)/  14, -588, -491, -392/ 	
      DATA K(777),K(778),K(779),K(780)/  -93,  507,  806,  905/ 	
      DATA K(781),K(782),K(783),K(784)/ 1003, 1105, 1206, 1507/ 	
      DATA K(785),K(786),K(787),K(788)/ 2107, 2408, 2509, 2612/     
      DATA K(789),K(790),K(791),K(792)/ 2510, 2409, 2108, 1508/ 	
      DATA K(793),K(794),K(795),K(796)/ 1207, 1106, 1003,  906/ 	
      DATA K(797),K(798),K(799),K(800)/  807,  508,  -92, -391/ 	
      DATA K(801),K(802),K(803)       / -490, -588, 5050/
c     }
      DATA K(804),K(805),K(806),K(807)/   14, -598, -495, -394/ 
      DATA K(808),K(809),K(810),K(811)/  -93,  507,  808,  909/ 
      DATA K(812),K(813),K(814),K(815)/ 1011, 1109, 1208, 1507/ 
      DATA K(816),K(817),K(818),K(819)/ 2107, 2406, 2505, 2602/ 
      DATA K(820),K(821),K(822),K(823)/ 2504, 2405, 2106, 1506/ 
      DATA K(824),K(825),K(826),K(827)/ 1207, 1108, 1011,  908/ 
      DATA K(828),K(829),K(830),K(831)/  807,  506,  -94, -395/ 
      DATA K(832),K(833),K(834)       / -496, -598, 5050/
c     #
      DATA K(835),K(836),K(837),K(838)/   17,  405, 1907,   50/                 
      DATA K(839),K(840),K(841),K(842)/  409, 1911,   50,  902/
      DATA K(843),K(844),K(845),K(846)/  913,   50, 1403, 1414/
      DATA K(847),K(848),K(849),K(850)/   50,  406, 1908,   50/
      DATA K(851),K(852),K(853),K(854)/  410, 1912,   50, 1003/
      DATA K(855),K(856),K(857),K(858)/ 1014,   50, 1504, 1515/
      DATA K(859)/ 5050/
              
C      0123456789 . , : ; ! ? < > & $ / ( ) * - + = ' " # [ ] %_{}
C                11                20               28 30        35
c      write(6,'(a,4i6)')' italic NSCRIP j=',J,ISTART(J),ISTART(J+1)
      
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
 20   RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  KITALI (J,KOORD)
C-------------------------------------------------------------------------------
C      KLEINE ITALICS
c      abcdefghijklmnopqrstuvwxyz
      parameter (istdim=27)
      DIMENSION KOORD(75),ISTART(istdim),K(899)
C
      SAVE
C
      DATA ISTART/  1, 41, 78,104,147,174,210,254,286,313,346,381,400,
     &            453,491,524,567,601,628,657,676,714,741,783,826,868,
     &            900/
      DATA K(  1),K(  2),K(  3),K(  4)/   21, 1416,  714,  313/
      DATA K(  5),K(  6),K(  7),K(  8)/  113,   14,   17,  219/
      DATA K(  9),K( 10),K( 11),K( 12)/  420,   50, 1417,  715/
      DATA K( 13),K( 14),K( 15),K( 16)/  314,  114,   15,   50/
      DATA K( 17),K( 18),K( 19),K( 20)/  714, 1014, 1313, 1411/
      DATA K( 21),K( 22),K( 23),K( 24)/ 1409, 1306, 1004,  703/
      DATA K( 25),K( 26),K( 27),K( 28)/  403,  204,  105,    7/
      DATA K( 29),K( 30),K( 31),K( 32)/    9,  111,  413,  714/
      DATA K( 33),K( 34),K( 35),K( 36)/   50, 1409, 1307, 1005/
      DATA K( 37),K( 38),K( 39),K( 40)/  704,  304,  105, 5050/
      DATA K( 41),K( 42),K( 43),K( 44)/   19, 2108,  804,  504/
      DATA K( 45),K( 46),K( 47),K( 48)/  205,  106,   50, 2109/
      DATA K( 49),K( 50),K( 51),K( 52)/  805,   50,  805, 1106/
      DATA K( 53),K( 54),K( 55),K( 56)/ 1308, 1410, 1412, 1314/
      DATA K( 57),K( 58),K( 59),K( 60)/ 1215, 1016,  716,  415/
      DATA K( 61),K( 62),K( 63),K( 64)/  113,   10,    8,  106/
      DATA K( 65),K( 66),K( 67),K( 68)/  405,  805,   50, 1314/
      DATA K( 69),K( 70),K( 71),K( 72)/ 1115,  715,  414,  112/
      DATA K( 73),K( 74),K( 75),K( 76)/   10,   50, 2105, 2109/
      DATA K( 77),K( 78),K( 79),K( 80)/ 5050,   18, 1114, 1014/
      DATA K( 81),K( 82),K( 83),K( 84)/ 1015, 1115, 1314, 1412/
      DATA K( 85),K( 86),K( 87),K( 88)/ 1409, 1306, 1004,  703/
      DATA K( 89),K( 90),K( 91),K( 92)/  403,  204,  105,    7/
      DATA K( 93),K( 94),K( 95),K( 96)/    9,  112,  414,   50/
      DATA K( 97),K( 98),K( 99),K(100)/ 1409, 1307, 1005,  704/
      DATA K(101),K(102),K(103),K(104)/  304,  105, 5050,   21/
      DATA K(105),K(106),K(107),K(108)/ 2118,  714,  313,  113/
      DATA K(109),K(110),K(111),K(112)/   14,   17,  219,  420/
      DATA K(113),K(114),K(115),K(116)/   50, 2119,  715,  314/
      DATA K(117),K(118),K(119),K(120)/  114,   15,   50,  714/
      DATA K(121),K(122),K(123),K(124)/ 1014, 1313, 1411, 1409/
      DATA K(125),K(126),K(127),K(128)/ 1306, 1004,  703,  403/
      DATA K(129),K(130),K(131),K(132)/  204,  105,    7,    9/
      DATA K(133),K(134),K(135),K(136)/  111,  413,  714,   50/
      DATA K(137),K(138),K(139),K(140)/ 1409, 1307, 1005,  704/
      DATA K(141),K(142),K(143),K(144)/  304,  105,   50, 2115/
      DATA K(145),K(146),K(147),K(148)/ 2119, 5050,   18,  504/
      DATA K(149),K(150),K(151),K(152)/  608,  711,  914, 1115/
      DATA K(153),K(154),K(155),K(156)/ 1314, 1412, 1409, 1306/
      DATA K(157),K(158),K(159),K(160)/ 1004,  703,  403,  204/
      DATA K(161),K(162),K(163),K(164)/  105,    7,    9,  112/
      DATA K(165),K(166),K(167),K(168)/  314,   50, 1409, 1307/
      DATA K(169),K(170),K(171),K(172)/ 1005,  704,  304,  105/
      DATA K(173),K(174),K(175),K(176)/ 5050,   15, 2015, 1914/
      DATA K(177),K(178),K(179),K(180)/ 1815, 1916, 2016, 2115/
      DATA K(181),K(182),K(183),K(184)/ 2113, 2011, 1910, 1709/
      DATA K(185),K(186),K(187),K(188)/ 1408,    5, -396, -597/
      DATA K(189),K(190),K(191),K(192)/   50, 2113, 1911, 1710/
      DATA K(193),K(194),K(195),K(196)/ 1309,  407,    6, -295/
      DATA K(197),K(198),K(199),K(200)/ -496, -597, -699, -701/
      DATA K(201),K(202),K(203),K(204)/ -602, -502, -401, -500/
      DATA K(205),K(206),K(207),K(208)/ -601,   50, 1404, 1414/
      DATA K(209),K(210),K(211),K(212)/ 5050,   20, 1417,   13/
      DATA K(213),K(214),K(215),K(216)/ -288, -590, -693, -696/
      DATA K(217),K(218),K(219),K(220)/ -598, -499, -399, -298/
      DATA K(221),K(222),K(223),K(224)/ -397, -498,   50, 1416/
      DATA K(225),K(226),K(227),K(228)/   12, -289, -591, -693/
      DATA K(229),K(230),K(231),K(232)/   50,  714, 1014, 1313/
      DATA K(233),K(234),K(235),K(236)/ 1411, 1409, 1306, 1004/
      DATA K(237),K(238),K(239),K(240)/  703,  403,  204,  105/
      DATA K(241),K(242),K(243),K(244)/    7,    9,  111,  413/
      DATA K(245),K(246),K(247),K(248)/  714,   50, 1409, 1307/
      DATA K(249),K(250),K(251),K(252)/ 1005,  704,  304,  105/
      DATA K(253),K(254),K(255),K(256)/ 5050,   21, 2108,    2/
      DATA K(257),K(258),K(259),K(260)/   50, 2109,    3,   50/
      DATA K(261),K(262),K(263),K(264)/  705, 1107, 1309, 1411/
      DATA K(265),K(266),K(267),K(268)/ 1413, 1315, 1216, 1016/
      DATA K(269),K(270),K(271),K(272)/  414,  114,   15,   50/
      DATA K(273),K(274),K(275),K(276)/ 1413, 1215, 1015,  413/
      DATA K(277),K(278),K(279),K(280)/  113,   14,   17,  219/
      DATA K(281),K(282),K(283),K(284)/  420,   50, 2105, 2109/
      DATA K(285),K(286),K(287),K(288)/ 5050,   13, 2109, 2008/
      DATA K(289),K(290),K(291),K(292)/ 1909, 2010, 2109,   50/
      DATA K(293),K(294),K(295),K(296)/ 1001, 1202, 1404, 1407/
      DATA K(297),K(298),K(299),K(300)/ 1308, 1008,  406,  106/
      DATA K(301),K(302),K(303),K(304)/    7,   50, 1406, 1307/
      DATA K(305),K(306),K(307),K(308)/ 1007,  405,  105,    6/
      DATA K(309),K(310),K(311),K(312)/    9,  211,  412, 5050/
      DATA K(313),K(314),K(315),K(316)/   13, 2110, 2009, 1910/
      DATA K(317),K(318),K(319),K(320)/ 2011, 2110,   50, 1002/
      DATA K(321),K(322),K(323),K(324)/ 1203, 1405, 1408, 1309/
      DATA K(325),K(326),K(327),K(328)/ 1009,    6, -295, -496/
      DATA K(329),K(330),K(331),K(332)/ -597, -699, -701, -602/
      DATA K(333),K(334),K(335),K(336)/ -502, -401, -500, -601/
      DATA K(337),K(338),K(339),K(340)/   50, 1407, 1308, 1008/
      DATA K(341),K(342),K(343),K(344)/    5, -296, -497, -699/
      DATA K(345),K(346),K(347),K(348)/ 5050,   20, 2108,    2/
      DATA K(349),K(350),K(351),K(352)/   50, 2109,    3,   50/
      DATA K(353),K(354),K(355),K(356)/ 1316, 1215, 1116, 1217/
      DATA K(357),K(358),K(359),K(360)/ 1317, 1416, 1415, 1313/
      DATA K(361),K(362),K(363),K(364)/  909,  807,  805,   50/
      DATA K(365),K(366),K(367),K(368)/  807,  709,  111,   12/
      DATA K(369),K(370),K(371),K(372)/   50,  807,  708,  110/
      DATA K(373),K(374),K(375),K(376)/   11,   13,  115,  417/
      DATA K(377),K(378),K(379),K(380)/   50, 2105, 2109, 5050/
      DATA K(381),K(382),K(383),K(384)/   12, 2108,  704,  303/
      DATA K(385),K(386),K(387),K(388)/  103,    4,    7,  209/
      DATA K(389),K(390),K(391),K(392)/  410,   50, 2109,  705/
      DATA K(393),K(394),K(395),K(396)/  304,  104,    5,   50/
      DATA K(397),K(398),K(399),K(400)/ 2105, 2109, 5050,   33/
      DATA K(401),K(402),K(403),K(404)/ 1001, 1202, 1404, 1407/
      DATA K(405),K(406),K(407),K(408)/ 1308, 1108,  707,    5/
      DATA K(409),K(410),K(411),K(412)/   50, 1406, 1307, 1107/
      DATA K(413),K(414),K(415),K(416)/  706,    4,   50,  707/
      DATA K(417),K(418),K(419),K(420)/ 1109, 1311, 1413, 1415/
      DATA K(421),K(422),K(423),K(424)/ 1317, 1218, 1018,   15/
      DATA K(425),K(426),K(427),K(428)/   50, 1415, 1217, 1017/
      DATA K(429),K(430),K(431),K(432)/   14,   50,  717, 1119/
      DATA K(433),K(434),K(435),K(436)/ 1321, 1423, 1425, 1327/
      DATA K(437),K(438),K(439),K(440)/ 1228, 1028,  426,  126/
      DATA K(441),K(442),K(443),K(444)/   27,   50, 1425, 1227/
      DATA K(445),K(446),K(447),K(448)/ 1027,  425,  125,   26/
      DATA K(449),K(450),K(451),K(452)/   29,  231,  432, 5050/
      DATA K(453),K(454),K(455),K(456)/   23, 1001, 1202, 1404/
      DATA K(457),K(458),K(459),K(460)/ 1407, 1308, 1108,  707/
      DATA K(461),K(462),K(463),K(464)/    5,   50, 1406, 1307/
      DATA K(465),K(466),K(467),K(468)/ 1107,  706,    4,   50/
      DATA K(469),K(470),K(471),K(472)/  707, 1109, 1311, 1413/
      DATA K(473),K(474),K(475),K(476)/ 1415, 1317, 1218, 1018/
      DATA K(477),K(478),K(479),K(480)/  416,  116,   17,   50/
      DATA K(481),K(482),K(483),K(484)/ 1415, 1217, 1017,  415/
      DATA K(485),K(486),K(487),K(488)/  115,   16,   19,  221/
      DATA K(489),K(490),K(491),K(492)/  422, 5050,   18, 1409/
      DATA K(493),K(494),K(495),K(496)/ 1306, 1004,  703,  403/
      DATA K(497),K(498),K(499),K(500)/  204,  105,    7,    9/
      DATA K(501),K(502),K(503),K(504)/  112,  414,  715, 1015/
      DATA K(505),K(506),K(507),K(508)/ 1214, 1313, 1411, 1409/
      DATA K(509),K(510),K(511),K(512)/   50, 1409, 1307, 1005/
      DATA K(513),K(514),K(515),K(516)/  704,  304,  105,   50/
      DATA K(517),K(518),K(519),K(520)/    9,  111,  413,  714/
      DATA K(521),K(522),K(523),K(524)/ 1114, 1313, 5050,   21/
      DATA K(525),K(526),K(527),K(528)/ 1001, 1202, 1404, 1407/
      DATA K(529),K(530),K(531),K(532)/ 1308, 1108,  707, -697/
      DATA K(533),K(534),K(535),K(536)/   50, 1406, 1307, 1107/
      DATA K(537),K(538),K(539),K(540)/  706, -698,   50,  707/
      DATA K(541),K(542),K(543),K(544)/ 1008, 1310, 1412, 1414/
      DATA K(545),K(546),K(547),K(548)/ 1316, 1217, 1018,  718/
      DATA K(549),K(550),K(551),K(552)/  417,  115,   12,   10/
      DATA K(553),K(554),K(555),K(556)/  108,  407,  707,   50/
      DATA K(557),K(558),K(559),K(560)/ 1316, 1117,  717,  416/
      DATA K(561),K(562),K(563),K(564)/  114,   12,   50, -701/
      DATA K(565),K(566),K(567),K(568)/ -694, 5050,   20, 1416/
      DATA K(569),K(570),K(571),K(572)/ -690,   50, 1417, -689/
      DATA K(573),K(574),K(575),K(576)/   50,  714, 1014, 1313/
      DATA K(577),K(578),K(579),K(580)/ 1411, 1409, 1306, 1004/
      DATA K(581),K(582),K(583),K(584)/  703,  403,  204,  105/
      DATA K(585),K(586),K(587),K(588)/    7,    9,  111,  413/
      DATA K(589),K(590),K(591),K(592)/  714,   50, 1409, 1307/
      DATA K(593),K(594),K(595),K(596)/ 1005,  704,  304,  105/
      DATA K(597),K(598),K(599),K(600)/   50, -693, -686, 5050/
      DATA K(601),K(602),K(603),K(604)/   17, 1001, 1202, 1404/
      DATA K(605),K(606),K(607),K(608)/ 1407, 1308, 1108,  707/
      DATA K(609),K(610),K(611),K(612)/    5,   50, 1406, 1307/
      DATA K(613),K(614),K(615),K(616)/ 1107,  706,    4,   50/
      DATA K(617),K(618),K(619),K(620)/  707, 1109, 1311, 1413/
      DATA K(621),K(622),K(623),K(624)/ 1415, 1316, 1216, 1115/
      DATA K(625),K(626),K(627),K(628)/ 1214, 1315, 5050,   17/
      DATA K(629),K(630),K(631),K(632)/ 1214, 1114, 1115, 1215/
      DATA K(633),K(634),K(635),K(636)/ 1314, 1411, 1408, 1305/
      DATA K(637),K(638),K(639),K(640)/ 1204, 1004,  905,  512/
      DATA K(641),K(642),K(643),K(644)/  413,   50, 1104, 1005/
      DATA K(645),K(646),K(647),K(648)/  612,  513,  213,  112/
      DATA K(649),K(650),K(651),K(652)/    9,    6,  103,  202/
      DATA K(653),K(654),K(655),K(656)/  302,  303,  203, 5050/
      DATA K(657),K(658),K(659),K(660)/   14, 2109,  705,  304/
      DATA K(661),K(662),K(663),K(664)/  104,    5,    8,  210/
      DATA K(665),K(666),K(667),K(668)/  411,   50, 2110,  706/
      DATA K(669),K(670),K(671),K(672)/  305,  105,    6,   50/
      DATA K(673),K(674),K(675),K(676)/ 1403, 1412, 5050,   23/
      DATA K(677),K(678),K(679),K(680)/ 1001, 1202, 1404, 1407/
      DATA K(681),K(682),K(683),K(684)/ 1308, 1008,  406,  206/
      DATA K(685),K(686),K(687),K(688)/    8,   50, 1406, 1307/
      DATA K(689),K(690),K(691),K(692)/ 1007,  405,  205,  106/
      DATA K(693),K(694),K(695),K(696)/    8,   10,  112,  314/
      DATA K(697),K(698),K(699),K(700)/  716,   50, 1418,  716/
      DATA K(701),K(702),K(703),K(704)/  315,  115,   16,   19/
      DATA K(705),K(706),K(707),K(708)/  221,  422,   50, 1419/
      DATA K(709),K(710),K(711),K(712)/  717,  316,  116,   17/
      DATA K(713),K(714),K(715),K(716)/ 5050,   20, 1001, 1202/
      DATA K(717),K(718),K(719),K(720)/ 1404, 1407, 1308, 1008/
      DATA K(721),K(722),K(723),K(724)/  406,  206,    8,   50/
      DATA K(725),K(726),K(727),K(728)/ 1406, 1307, 1007,  405/
      DATA K(729),K(730),K(731),K(732)/  205,  106,    8,    9/
      DATA K(733),K(734),K(735),K(736)/  112,  314,  616, 1017/
      DATA K(737),K(738),K(739),K(740)/ 1417, 1416, 1217, 5050/
      DATA K(741),K(742),K(743),K(744)/   29, 1001, 1202, 1404/
      DATA K(745),K(746),K(747),K(748)/ 1407, 1308, 1008,  406/
      DATA K(749),K(750),K(751),K(752)/  206,    8,   50, 1406/
      DATA K(753),K(754),K(755),K(756)/ 1307, 1007,  405,  205/
      DATA K(757),K(758),K(759),K(760)/  106,    8,   10,  112/
      DATA K(761),K(762),K(763),K(764)/  314,  515,   50, 1417/
      DATA K(765),K(766),K(767),K(768)/  515,  215,  116,   18/
      DATA K(769),K(770),K(771),K(772)/   20,  122,  324,  525/
      DATA K(773),K(774),K(775),K(776)/  926, 1426, 1425, 1226/
      DATA K(777),K(778),K(779),K(780)/   50, 1418,  516,  216/
      DATA K(781),K(782),K(783),K(784)/   18, 5050,   20, 1003/
      DATA K(785),K(786),K(787),K(788)/ 1305, 1407, 1410, 1211/
      DATA K(789),K(790),K(791),K(792)/  911,   50, 1409, 1210/
      DATA K(793),K(794),K(795),K(796)/  910,  509,  308,  106/
      DATA K(797),K(798),K(799),K(800)/    4,    3,  102,  202/
      DATA K(801),K(802),K(803),K(804)/  303,  204,  103,   50/
      DATA K(805),K(806),K(807),K(808)/  509,  209,   10,   13/
      DATA K(809),K(810),K(811),K(812)/  115,  417,   50, 1317/
      DATA K(813),K(814),K(815),K(816)/ 1216, 1117, 1218, 1318/
      DATA K(817),K(818),K(819),K(820)/ 1417, 1416, 1314, 1112/
      DATA K(821),K(822),K(823),K(824)/  911,  510,  210,   11/
      DATA K(825),K(826),K(827),K(828)/ 5050,   21, 1001, 1202/
      DATA K(829),K(830),K(831),K(832)/ 1404, 1407, 1308, 1008/
      DATA K(833),K(834),K(835),K(836)/  406,  206,    8,   50/
      DATA K(837),K(838),K(839),K(840)/ 1406, 1307, 1007,  405/
      DATA K(841),K(842),K(843),K(844)/  205,  106,    8,   10/
      DATA K(845),K(846),K(847),K(848)/  112,  314,  716,   50/
      DATA K(849),K(850),K(851),K(852)/ 1419,   15, -286, -588/
      DATA K(853),K(854),K(855),K(856)/ -691, -694, -596, -497/
      DATA K(857),K(858),K(859),K(860)/ -397, -296, -395, -496/
      DATA K(861),K(862),K(863),K(864)/   50, 1418,   14, -287/
      DATA K(865),K(866),K(867),K(868)/ -589, -691, 5050,   20/
      DATA K(869),K(870),K(871),K(872)/ 1417, 1216, 1014,  406/
      DATA K(873),K(874),K(875),K(876)/  204,    3,   50, 1004/
      DATA K(877),K(878),K(879),K(880)/ 1205, 1407, 1410, 1214/
      DATA K(881),K(882),K(883),K(884)/   50, 1205, 1307, 1310/
      DATA K(885),K(886),K(887),K(888)/ 1214, 1216,   50,  204/
      DATA K(889),K(890),K(891),K(892)/  206,  110,  113,  215/
      DATA K(893),K(894),K(895),K(896)/   50,  206,   10,   13/
      DATA K(897),K(898),K(899)       /  215,  416, 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  GITALI (J,KOORD)
C-------------------------------------------------------------------------------
C      GROSSE ITALICS
C      ABCDEFGHIJKLMNOPQRSTUVWXYZ
       parameter (istdim=27)
      DIMENSION KOORD(75),ISTART(istdim),K(729)
C
      SAVE
C
      DATA ISTART/  1, 20, 62, 97,128,151,172,215,243,256,278,306,321,
     &            352,374,417,445,507,550,586,603,629,645,670,692,713,
     &            730/
      DATA K(  1),K(  2),K(  3),K(  4)/   20, 2113,    0,   50/
      DATA K(  5),K(  6),K(  7),K(  8)/ 2113,   14,   50, 1912/
      DATA K(  9),K( 10),K( 11),K( 12)/   13,   50,  604,  613/
      DATA K( 13),K( 14),K( 15),K( 16)/   50,   -2,    4,   50/
      DATA K( 17),K( 18),K( 19),K( 20)/   10,   16, 5050,   24/
      DATA K( 21),K( 22),K( 23),K( 24)/ 2109,    3,   50, 2110/
      DATA K( 25),K( 26),K( 27),K( 28)/    4,   50, 2106, 2117/
      DATA K( 29),K( 30),K( 31),K( 32)/ 2020, 1821, 1621, 1320/
      DATA K( 33),K( 34),K( 35),K( 36)/ 1219, 1116,   50, 2117/
      DATA K( 37),K( 38),K( 39),K( 40)/ 2019, 1820, 1620, 1319/
      DATA K( 41),K( 42),K( 43),K( 44)/ 1218, 1116,   50, 1107/
      DATA K( 45),K( 46),K( 47),K( 48)/ 1116, 1018,  819,  619/
      DATA K( 49),K( 50),K( 51),K( 52)/  318,  116,   12,    0/
      DATA K( 53),K( 54),K( 55),K( 56)/   50, 1116, 1017,  818/
      DATA K( 57),K( 58),K( 59),K( 60)/  618,  317,  115,   12/
      DATA K( 61),K( 62),K( 63),K( 64)/ 5050,   21, 1918, 1919/
      DATA K( 65),K( 66),K( 67),K( 68)/ 2120, 1519, 1719, 1918/
      DATA K( 69),K( 70),K( 71),K( 72)/ 2017, 2115, 2112, 2009/
      DATA K( 73),K( 74),K( 75),K( 76)/ 1807, 1505, 1204,  803/
      DATA K( 77),K( 78),K( 79),K( 80)/  503,  204,  105,    8/
      DATA K( 81),K( 82),K( 83),K( 84)/   11,  113,  315,  516/
      DATA K( 85),K( 86),K( 87),K( 88)/   50, 2112, 2010, 1808/
      DATA K( 89),K( 90),K( 91),K( 92)/ 1506, 1205,  804,  504/
      DATA K( 93),K( 94),K( 95),K( 96)/  205,  106,    8, 5050/
      DATA K( 97),K( 98),K( 99),K(100)/   23, 2109,    3,   50/
      DATA K(101),K(102),K(103),K(104)/ 2110,    4,   50, 2106/
      DATA K(105),K(106),K(107),K(108)/ 2115, 2018, 1919, 1620/
      DATA K(109),K(110),K(111),K(112)/ 1220,  819,  417,  215/
      DATA K(113),K(114),K(115),K(116)/  113,    9,    0,   50/
      DATA K(117),K(118),K(119),K(120)/ 2115, 2017, 1918, 1619/
      DATA K(121),K(122),K(123),K(124)/ 1219,  818,  416,  214/
      DATA K(125),K(126),K(127),K(128)/  112,    9, 5050,   23/
      DATA K(129),K(130),K(131),K(132)/ 2109,    3,   50, 2110/
      DATA K(133),K(134),K(135),K(136)/    4,   50, 1514,  712/
      DATA K(137),K(138),K(139),K(140)/   50, 2106, 2121, 1520/
      DATA K(141),K(142),K(143),K(144)/ 2120,   50, 1107, 1113/
      DATA K(145),K(146),K(147),K(148)/   50,    0,   15,  517/
      DATA K(149),K(150),K(151),K(152)/   14, 5050,   22, 2109/
      DATA K(153),K(154),K(155),K(156)/    3,   50, 2110,    4/
      DATA K(157),K(158),K(159),K(160)/   50, 1514,  712,   50/
      DATA K(161),K(162),K(163),K(164)/ 2106, 2121, 1520, 2120/
      DATA K(165),K(166),K(167),K(168)/   50, 1107, 1113,   50/
      DATA K(169),K(170),K(171),K(172)/    0,    7, 5050,   22/
      DATA K(173),K(174),K(175),K(176)/ 1918, 1919, 2120, 1519/
      DATA K(177),K(178),K(179),K(180)/ 1719, 1918, 2017, 2115/
      DATA K(181),K(182),K(183),K(184)/ 2112, 2009, 1807, 1505/
      DATA K(185),K(186),K(187),K(188)/ 1204,  803,  503,  204/
      DATA K(189),K(190),K(191),K(192)/  105,    8,   10,  113/
      DATA K(193),K(194),K(195),K(196)/  315,  717,   50, 2112/
      DATA K(197),K(198),K(199),K(200)/ 2010, 1808, 1506, 1205/
      DATA K(201),K(202),K(203),K(204)/  804,  504,  205,  106/
      DATA K(205),K(206),K(207),K(208)/    8,   50,   10,  112/
      DATA K(209),K(210),K(211),K(212)/  314,  716,   50,  713/
      DATA K(213),K(214),K(215),K(216)/  720, 5050,   26, 2109/
      DATA K(217),K(218),K(219),K(220)/    3,   50, 2110,    4/
      DATA K(221),K(222),K(223),K(224)/   50, 2122,   16,   50/
      DATA K(225),K(226),K(227),K(228)/ 2123,   17,   50, 2106/
      DATA K(229),K(230),K(231),K(232)/ 2113,   50, 2119, 2126/
      DATA K(233),K(234),K(235),K(236)/   50, 1107, 1119,   50/
      DATA K(237),K(238),K(239),K(240)/    0,    7,   50,   13/
      DATA K(241),K(242),K(243),K(244)/   20, 5050,   13, 2109/
      DATA K(245),K(246),K(247),K(248)/    3,   50, 2110,    4/
      DATA K(249),K(250),K(251),K(252)/   50, 2106, 2113,   50/
      DATA K(253),K(254),K(255),K(256)/    0,    7, 5050,   18/
      DATA K(257),K(258),K(259),K(260)/ 2115,  410,  209,  108/
      DATA K(261),K(262),K(263),K(264)/    6,    4,  102,  301/
      DATA K(265),K(266),K(267),K(268)/  501,  602,  503,  402/
      DATA K(269),K(270),K(271),K(272)/   50, 2114,  409,  208/
      DATA K(273),K(274),K(275),K(276)/    6,   50, 2111, 2118/
      DATA K(277),K(278),K(279),K(280)/ 5050,   23, 2109,    3/
      DATA K(281),K(282),K(283),K(284)/   50, 2110,    4,   50/
      DATA K(285),K(286),K(287),K(288)/ 2123,  806,   50, 1213/
      DATA K(289),K(290),K(291),K(292)/   17,   50, 1212,   16/
      DATA K(293),K(294),K(295),K(296)/   50, 2106, 2113,   50/
      DATA K(297),K(298),K(299),K(300)/ 2119, 2125,   50,    0/
      DATA K(301),K(302),K(303),K(304)/    7,   50,   13,   19/
      DATA K(305),K(306),K(307),K(308)/ 5050,   20, 2109,    3/
      DATA K(309),K(310),K(311),K(312)/   50, 2110,    4,   50/
      DATA K(313),K(314),K(315),K(316)/ 2106, 2113,   50,    0/
      DATA K(317),K(318),K(319),K(320)/   15,  617,   14, 5050/
      DATA K(321),K(322),K(323),K(324)/   27, 2109,    3,   50/
      DATA K(325),K(326),K(327),K(328)/ 2109,   10,   50, 2110/
      DATA K(329),K(330),K(331),K(332)/  211,   50, 2123,   10/
      DATA K(333),K(334),K(335),K(336)/   50, 2123,   17,   50/
      DATA K(337),K(338),K(339),K(340)/ 2124,   18,   50, 2106/
      DATA K(341),K(342),K(343),K(344)/ 2110,   50, 2123, 2127/
      DATA K(345),K(346),K(347),K(348)/   50,    0,    6,   50/
      DATA K(349),K(350),K(351),K(352)/   14,   21, 5050,   25/
      DATA K(353),K(354),K(355),K(356)/ 2109,    3,   50, 2109/
      DATA K(357),K(358),K(359),K(360)/  316,   50, 1809,   16/
      DATA K(361),K(362),K(363),K(364)/   50, 2122,   16,   50/
      DATA K(365),K(366),K(367),K(368)/ 2106, 2109,   50, 2119/
      DATA K(369),K(370),K(371),K(372)/ 2125,   50,    0,    6/
      DATA K(373),K(374),K(375),K(376)/ 5050,   22, 2112, 2009/
      DATA K(377),K(378),K(379),K(380)/ 1807, 1505, 1204,  803/
      DATA K(381),K(382),K(383),K(384)/  503,  204,  105,    7/
      DATA K(385),K(386),K(387),K(388)/   10,  113,  315,  617/
      DATA K(389),K(390),K(391),K(392)/  918, 1319, 1619, 1918/
      DATA K(393),K(394),K(395),K(396)/ 2017, 2115, 2112,   50/
      DATA K(397),K(398),K(399),K(400)/ 2112, 2010, 1808, 1506/
      DATA K(401),K(402),K(403),K(404)/ 1205,  804,  504,  205/
      DATA K(405),K(406),K(407),K(408)/    7,   50,   10,  112/
      DATA K(409),K(410),K(411),K(412)/  314,  616,  917, 1318/
      DATA K(413),K(414),K(415),K(416)/ 1618, 1917, 2115, 5050/
      DATA K(417),K(418),K(419),K(420)/   23, 2109,    3,   50/
      DATA K(421),K(422),K(423),K(424)/ 2110,    4,   50, 2106/
      DATA K(425),K(426),K(427),K(428)/ 2118, 2021, 1822, 1622/
      DATA K(429),K(430),K(431),K(432)/ 1321, 1119, 1015, 1007/
      DATA K(433),K(434),K(435),K(436)/   50, 2118, 2020, 1821/
      DATA K(437),K(438),K(439),K(440)/ 1621, 1320, 1118, 1015/
      DATA K(441),K(442),K(443),K(444)/   50,    0,    7, 5050/
      DATA K(445),K(446),K(447),K(448)/   22, 2112, 2009, 1807/
      DATA K(449),K(450),K(451),K(452)/ 1505, 1204,  803,  503/
      DATA K(453),K(454),K(455),K(456)/  204,  105,    7,   10/
      DATA K(457),K(458),K(459),K(460)/  113,  315,  617,  918/
      DATA K(461),K(462),K(463),K(464)/ 1319, 1619, 1918, 2017/
      DATA K(465),K(466),K(467),K(468)/ 2115, 2112,   50, 2112/
      DATA K(469),K(470),K(471),K(472)/ 2010, 1808, 1506, 1205/
      DATA K(473),K(474),K(475),K(476)/  804,  504,  205,    7/
      DATA K(477),K(478),K(479),K(480)/   50,   10,  112,  314/
      DATA K(481),K(482),K(483),K(484)/  616,  917, 1318, 1618/
      DATA K(485),K(486),K(487),K(488)/ 1917, 2115,   50,  205/
      DATA K(489),K(490),K(491),K(492)/  305,  506,  608,  609/
      DATA K(493),K(494),K(495),K(496)/  511,  312, -388, -487/
      DATA K(497),K(498),K(499),K(500)/ -485, -284, -184,   50/
      DATA K(501),K(502),K(503),K(504)/  312, -287, -386, -385/
      DATA K(505),K(506),K(507),K(508)/ -284, 5050,   24, 2109/
      DATA K(509),K(510),K(511),K(512)/    3,   50, 2110,    4/
      DATA K(513),K(514),K(515),K(516)/   50, 2106, 2117, 2020/
      DATA K(517),K(518),K(519),K(520)/ 1821, 1621, 1320, 1219/
      DATA K(521),K(522),K(523),K(524)/ 1116, 1107,   50, 2117/
      DATA K(525),K(526),K(527),K(528)/ 2019, 1820, 1620, 1319/
      DATA K(529),K(530),K(531),K(532)/ 1218, 1116,   50, 1112/
      DATA K(533),K(534),K(535),K(536)/ 1014,  915,  116,   17/
      DATA K(537),K(538),K(539),K(540)/   19,  220,  320,   50/
      DATA K(541),K(542),K(543),K(544)/  915,  217,  118,  119/
      DATA K(545),K(546),K(547),K(548)/  220,   50,    0,    7/
      DATA K(549),K(550),K(551),K(552)/ 5050,   23, 1919, 1920/
      DATA K(553),K(554),K(555),K(556)/ 2121, 1520, 1720, 1919/
      DATA K(557),K(558),K(559),K(560)/ 2018, 2115, 2111, 2008/
      DATA K(561),K(562),K(563),K(564)/ 1806, 1606, 1407, 1308/
      DATA K(565),K(566),K(567),K(568)/  915,  717,   50, 1606/
      DATA K(569),K(570),K(571),K(572)/ 1408, 1015,  916,  717/
      DATA K(573),K(574),K(575),K(576)/  417,  216,  115,   12/
      DATA K(577),K(578),K(579),K(580)/    8,  105,  204,  403/
      DATA K(581),K(582),K(583),K(584)/  603,    2,  203,  204/
      DATA K(585),K(586),K(587),K(588)/ 5050,   21, 2113,    7/
      DATA K(589),K(590),K(591),K(592)/   50, 2114,    8,   50/
      DATA K(593),K(594),K(595),K(596)/ 2107, 1504, 2106, 2121/
      DATA K(597),K(598),K(599),K(600)/ 1520, 2120,   50,    4/
      DATA K(601),K(602),K(603),K(604)/   11, 5050,   25, 2108/
      DATA K(605),K(606),K(607),K(608)/ 1005,  604,  304,  105/
      DATA K(609),K(610),K(611),K(612)/    8,   12,  115,  317/
      DATA K(613),K(614),K(615),K(616)/  618, 2122,   50, 2109/
      DATA K(617),K(618),K(619),K(620)/ 1006,  605,  305,  106/
      DATA K(621),K(622),K(623),K(624)/    8,   50, 2105, 2112/
      DATA K(625),K(626),K(627),K(628)/   50, 2119, 2125, 5050/
      DATA K(629),K(630),K(631),K(632)/   20, 2106,    7,   50/
      DATA K(633),K(634),K(635),K(636)/ 2107,  208,   50, 2120/
      DATA K(637),K(638),K(639),K(640)/    7,   50, 2104, 2110/
      DATA K(641),K(642),K(643),K(644)/   50, 2116, 2122, 5050/
      DATA K(645),K(646),K(647),K(648)/   26, 2108,    6,   50/
      DATA K(649),K(650),K(651),K(652)/ 2109,  207,   50, 2116/
      DATA K(653),K(654),K(655),K(656)/    6,   50, 2116,   14/
      DATA K(657),K(658),K(659),K(660)/   50, 2117,  215,   50/
      DATA K(661),K(662),K(663),K(664)/ 2124,   14,   50, 2105/
      DATA K(665),K(666),K(667),K(668)/ 2112,   50, 2121, 2127/
      DATA K(669),K(670),K(671),K(672)/ 5050,   22, 2107,   14/
      DATA K(673),K(674),K(675),K(676)/   50, 2108,   15,   50/
      DATA K(677),K(678),K(679),K(680)/ 2121,    1,   50, 2105/
      DATA K(681),K(682),K(683),K(684)/ 2111,   50, 2117, 2123/
      DATA K(685),K(686),K(687),K(688)/   50,   -1,    5,   50/
      DATA K(689),K(690),K(691),K(692)/   11,   17, 5050,   21/
      DATA K(693),K(694),K(695),K(696)/ 2106, 1110,    7,   50/
      DATA K(697),K(698),K(699),K(700)/ 2107, 1111,    8,   50/
      DATA K(701),K(702),K(703),K(704)/ 2121, 1111,   50, 2104/
      DATA K(705),K(706),K(707),K(708)/ 2110,   50, 2117, 2123/
      DATA K(709),K(710),K(711),K(712)/   50,    4,   11, 5050/
      DATA K(713),K(714),K(715),K(716)/   22, 2120,    1,   50/
      DATA K(717),K(718),K(719),K(720)/ 2121,    2,   50, 2108/
      DATA K(721),K(722),K(723),K(724)/ 1505, 2107, 2121,   50/
      DATA K(725),K(726),K(727),K(728)/    1,   15,  617,   14/
      DATA K(729)                     / 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  KGREEK (J,KOORD)
C-------------------------------------------------------------------------------
C      KLEINE GREEK
C      A,B,G,D,E,Z,C,Q,I,K,L,M,N,X,O,P,R,S,T,U,F,H,Y,W
      parameter (istdim=25)
      DIMENSION KOORD(75), ISTART(istdim), K(801)
C
      SAVE
C
      DATA ISTART/  1, 42,100,129,174,207,239,272,317,333,363,387,
     &            416,441,487,520,543,575,611,628,660,698,722,757,802/
      DATA K(  1),K(  2),K(  3),K(  4)/   23, 1410, 1307, 1105/
      DATA K(  5),K(  6),K(  7),K(  8)/  904,  603,  303,  104/
      DATA K(  9),K( 10),K( 11),K( 12)/    7,    9,  111,  414/
      DATA K( 13),K( 14),K( 15),K( 16)/  716, 1118, 1419,   50/
      DATA K( 17),K( 18),K( 19),K( 20)/ 1410, 1308, 1106,  905/
      DATA K( 21),K( 22),K( 23),K( 24)/  604,  304,  105,    7/
      DATA K( 25),K( 26),K( 27),K( 28)/   50, 1410, 1412, 1314/
      DATA K( 29),K( 30),K( 31),K( 32)/ 1115,  317,  118,   19/
      DATA K( 33),K( 34),K( 35),K( 36)/   50, 1412, 1313, 1114/
      DATA K( 37),K( 38),K( 39),K( 40)/  316,  117,   19,   20/
      DATA K( 41),K( 42),K( 43),K( 44)/ 5050,   21, 2113, 2010/
      DATA K( 45),K( 46),K( 47),K( 48)/ 1808, 1406, 1105,  704/
      DATA K( 49),K( 50),K( 51),K( 52)/  103, -698,   50, 2113/
      DATA K( 53),K( 54),K( 55),K( 56)/ 2011, 1809, 1407, 1106/
      DATA K( 57),K( 58),K( 59),K( 60)/  705,  104, -697,   50/
      DATA K( 61),K( 62),K( 63),K( 64)/ 2113, 2115, 2017, 1918/
      DATA K( 65),K( 66),K( 67),K( 68)/ 1618, 1417, 1316, 1213/
      DATA K( 69),K( 70),K( 71),K( 72)/ 1209,   50, 2115, 1917/
      DATA K( 73),K( 74),K( 75),K( 76)/ 1617, 1416, 1315, 1213/
      DATA K( 77),K( 78),K( 79),K( 80)/   50, 1209, 1113,  915/
      DATA K( 81),K( 82),K( 83),K( 84)/  716,  416,  215,  114/
      DATA K( 85),K( 86),K( 87),K( 88)/   11,    9,  107,  206/
      DATA K( 89),K( 90),K( 91),K( 92)/  505,   50, 1209, 1112/
      DATA K( 93),K( 94),K( 95),K( 96)/  914,  715,  415,  214/
      DATA K( 97),K( 98),K( 99),K(100)/  113,   11, 5050,   20/
      DATA K(101),K(102),K(103),K(104)/ 1101, 1303, 1405, 1407/
      DATA K(105),K(106),K(107),K(108)/ 1309, 1210,  911,  511/
      DATA K(109),K(110),K(111),K(112)/  110, -693,   50, 1202/
      DATA K(113),K(114),K(115),K(116)/ 1304, 1308, 1210,   50/
      DATA K(117),K(118),K(119),K(120)/ 1418, 1117,  916,  211/
      DATA K(121),K(122),K(123),K(124)/ -292, -694,   50, 1417/
      DATA K(125),K(126),K(127),K(128)/ 1116,  915,  211, 5050/
      DATA K(129),K(130),K(131),K(132)/   19, 1313, 1411, 1409/
      DATA K(133),K(134),K(135),K(136)/ 1306, 1004,  703,  403/
      DATA K(137),K(138),K(139),K(140)/  204,  105,    7,    9/
      DATA K(141),K(142),K(143),K(144)/  112,  414,  715, 1015/
      DATA K(145),K(146),K(147),K(148)/ 1214, 1710, 1909, 2109/
      DATA K(149),K(150),K(151),K(152)/ 2210, 2212, 2114, 1916/
      DATA K(153),K(154),K(155),K(156)/   50, 1409, 1307, 1005/
      DATA K(157),K(158),K(159),K(160)/  704,  304,  105,   50/
      DATA K(161),K(162),K(163),K(164)/    9,  111,  413,  714/
      DATA K(165),K(166),K(167),K(168)/ 1114, 1313, 1611, 1810/
      DATA K(169),K(170),K(171),K(172)/ 2010, 2111, 2113, 1916/
      DATA K(173),K(174),K(175),K(176)/ 5050,   18, 1115, 1313/
      DATA K(177),K(178),K(179),K(180)/ 1411, 1407, 1305, 1105/
      DATA K(181),K(182),K(183),K(184)/  907,  810,   50, 1407/
      DATA K(185),K(186),K(187),K(188)/ 1306, 1106,  908,  810/
      DATA K(189),K(190),K(191),K(192)/   50,  810,  705,  503/
      DATA K(193),K(194),K(195),K(196)/  303,  104,    7,   10/
      DATA K(197),K(198),K(199),K(200)/  112,  314,   50,  810/
      DATA K(201),K(202),K(203),K(204)/  706,  504,  304,  105/
      DATA K(205),K(206),K(207),K(208)/    7, 5050,   18, 2111/
      DATA K(209),K(210),K(211),K(212)/ 2009, 1908, 1808, 1709/
      DATA K(213),K(214),K(215),K(216)/ 1612, 1617, 1717, 1614/
      DATA K(217),K(218),K(219),K(220)/ 1410, 1207,  904,  603/
      DATA K(221),K(222),K(223),K(224)/  403,  204,    7, -190/
      DATA K(225),K(226),K(227),K(228)/ -389, -589, -690, -692/
      DATA K(229),K(230),K(231),K(232)/ -593,   50, 1512, 1208/
      DATA K(233),K(234),K(235),K(236)/  905,  604,  404,  205/
      DATA K(237),K(238),K(239),K(240)/    7, 5050,   22, 1001/
      DATA K(241),K(242),K(243),K(244)/ 1202, 1404, 1407, 1308/
      DATA K(245),K(246),K(247),K(248)/ 1108,  707,    5,   50/
      DATA K(249),K(250),K(251),K(252)/ 1406, 1307, 1107,  706/
      DATA K(253),K(254),K(255),K(256)/    4,   50,  707, 1109/
      DATA K(257),K(258),K(259),K(260)/ 1311, 1413, 1415, 1317/
      DATA K(261),K(262),K(263),K(264)/ 1218,  918,  417, -686/
      DATA K(265),K(266),K(267),K(268)/   50, 1415, 1217,  917/
      DATA K(269),K(270),K(271),K(272)/  416, -687, 5050,   23/
      DATA K(273),K(274),K(275),K(276)/ 1001, 1202, 1404, 1407/
      DATA K(277),K(278),K(279),K(280)/ 1308, 1108,  607,  307/
      DATA K(281),K(282),K(283),K(284)/  108,    9,   50, 1406/
      DATA K(285),K(286),K(287),K(288)/ 1307, 1107,  606,  306/
      DATA K(289),K(290),K(291),K(292)/  107,    9,   11,  113/
      DATA K(293),K(294),K(295),K(296)/  315,  617,  918, 1419/
      DATA K(297),K(298),K(299),K(300)/ 1819, 2018, 2116, 2114/
      DATA K(301),K(302),K(303),K(304)/ 1912, 1712, 1413, 1115/
      DATA K(305),K(306),K(307),K(308)/  917,  720,   50,  113/
      DATA K(309),K(310),K(311),K(312)/  415,  616,  917, 1418/
      DATA K(313),K(314),K(315),K(316)/ 1818, 2017, 2116, 5050/
      DATA K(317),K(318),K(319),K(320)/   12, 1406,  704,  303/
      DATA K(321),K(322),K(323),K(324)/  103,    4,    7,  209/
      DATA K(325),K(326),K(327),K(328)/  410,   50, 1407,  705/
      DATA K(329),K(330),K(331),K(332)/  304,  104,    5, 5050/
      DATA K(333),K(334),K(335),K(336)/   20, 1406,    2,   50/
      DATA K(337),K(338),K(339),K(340)/ 1407,    3,   50, 1416/
      DATA K(341),K(342),K(343),K(344)/ 1317, 1318, 1417, 1415/
      DATA K(345),K(346),K(347),K(348)/ 1313,  909,  807,  805/
      DATA K(349),K(350),K(351),K(352)/   50,  807,  709,  111/
      DATA K(353),K(354),K(355),K(356)/   12,   50,  807,  708/
      DATA K(357),K(358),K(359),K(360)/  110,   11,   13,  115/
      DATA K(361),K(362),K(363),K(364)/  417, 5050,   20, 2103/
      DATA K(365),K(366),K(367),K(368)/ 2105, 2007, 1908, 1709/
      DATA K(369),K(370),K(371),K(372)/  315,  116,   17,   50/
      DATA K(373),K(374),K(375),K(376)/ 2105, 1907, 1708,  314/
      DATA K(377),K(378),K(379),K(380)/  115,   17,   18,   50/
      DATA K(381),K(382),K(383),K(384)/ 1410,    2,   50, 1410/
      DATA K(385),K(386),K(387),K(388)/    3, 5050,   23, 1407/
      DATA K(389),K(390),K(391),K(392)/ -699,   50, 1408, -698/
      DATA K(393),K(394),K(395),K(396)/   50, 1107,  506,  206/
      DATA K(397),K(398),K(399),K(400)/    8,   10,  112,  314/
      DATA K(401),K(402),K(403),K(404)/  616,   50, 1418,  315/
      DATA K(405),K(406),K(407),K(408)/  115,   16,   19,  221/
      DATA K(409),K(410),K(411),K(412)/  422,   50, 1419,  316/
      DATA K(413),K(414),K(415),K(416)/  116,   17, 5050,   20/
      DATA K(417),K(418),K(419),K(420)/ 1406,    4,   50, 1407/
      DATA K(421),K(422),K(423),K(424)/  806,  305,    4,   50/
      DATA K(425),K(426),K(427),K(428)/ 1417, 1016,  614,   50/
      DATA K(429),K(430),K(431),K(432)/ 1418, 1117,  916,  614/
      DATA K(433),K(434),K(435),K(436)/  412,  209,  107,    4/
      DATA K(437),K(438),K(439),K(440)/   50, 1403, 1407, 5050/
      DATA K(441),K(442),K(443),K(444)/   17, 2111, 2009, 1908/
      DATA K(445),K(446),K(447),K(448)/ 1808, 1709, 1612, 1615/
      DATA K(449),K(450),K(451),K(452)/   50, 1612, 1508, 1406/
      DATA K(453),K(454),K(455),K(456)/ 1205, 1005,  807,  710/
      DATA K(457),K(458),K(459),K(460)/  713,   50, 1612, 1509/
      DATA K(461),K(462),K(463),K(464)/ 1407, 1206, 1006,  808/
      DATA K(465),K(466),K(467),K(468)/  710,   50,  710,  606/
      DATA K(469),K(470),K(471),K(472)/  504,  303,  103,  -95/
      DATA K(473),K(474),K(475),K(476)/ -290, -389, -589, -691/
      DATA K(477),K(478),K(479),K(480)/ -693,   50,  710,  607/
      DATA K(481),K(482),K(483),K(484)/  505,  304,  104,  -94/
      DATA K(485),K(486),K(487),K(488)/ -290, 5050,   18, 1409/
      DATA K(489),K(490),K(491),K(492)/ 1306, 1004,  703,  403/
      DATA K(493),K(494),K(495),K(496)/  204,  105,    7,    9/
      DATA K(497),K(498),K(499),K(500)/  112,  414,  715, 1015/
      DATA K(501),K(502),K(503),K(504)/ 1214, 1313, 1411, 1409/
      DATA K(505),K(506),K(507),K(508)/   50, 1409, 1307, 1005/
      DATA K(509),K(510),K(511),K(512)/  704,  304,  105,   50/
      DATA K(513),K(514),K(515),K(516)/    9,  111,  413,  714/
      DATA K(517),K(518),K(519),K(520)/ 1114, 1313, 5050,   22/
      DATA K(521),K(522),K(523),K(524)/ 1309,    5,   50, 1309/
      DATA K(525),K(526),K(527),K(528)/    6,   50, 1315,   15/
      DATA K(529),K(530),K(531),K(532)/   50, 1315,   16,   50/
      DATA K(533),K(534),K(535),K(536)/ 1102, 1304, 1407, 1420/
      DATA K(537),K(538),K(539),K(540)/   50, 1102, 1204, 1307/
      DATA K(541),K(542),K(543),K(544)/ 1320, 5050,   19,  504/
      DATA K(545),K(546),K(547),K(548)/  205,  106,    8,   10/
      DATA K(549),K(550),K(551),K(552)/  113,  415,  716, 1016/
      DATA K(553),K(554),K(555),K(556)/ 1215, 1314, 1412, 1410/
      DATA K(557),K(558),K(559),K(560)/ 1307, 1005,  704, -700/
      DATA K(561),K(562),K(563),K(564)/   50,   10,  112,  414/
      DATA K(565),K(566),K(567),K(568)/  715, 1115, 1314,   50/
      DATA K(569),K(570),K(571),K(572)/ 1410, 1308, 1006,  705/
      DATA K(573),K(574),K(575),K(576)/ -699, 5050,   21, 1419/
      DATA K(577),K(578),K(579),K(580)/ 1409, 1306, 1004,  703/
      DATA K(581),K(582),K(583),K(584)/  403,  204,  105,    7/
      DATA K(585),K(586),K(587),K(588)/    9,  112,  414,  715/
      DATA K(589),K(590),K(591),K(592)/ 1015, 1214, 1313, 1411/
      DATA K(593),K(594),K(595),K(596)/   50, 1409, 1307, 1005/
      DATA K(597),K(598),K(599),K(600)/  704,  304,  105,   50/
      DATA K(601),K(602),K(603),K(604)/    9,  111,  413,  714/
      DATA K(605),K(606),K(607),K(608)/ 1114, 1313,   50, 1313/
      DATA K(609),K(610),K(611),K(612)/ 1319, 5050,   20, 1311/
      DATA K(613),K(614),K(615),K(616)/    8,   50, 1311,    9/
      DATA K(617),K(618),K(619),K(620)/   50, 1102, 1304, 1407/
      DATA K(621),K(622),K(623),K(624)/ 1418,   50, 1102, 1204/
      DATA K(625),K(626),K(627),K(628)/ 1307, 1318, 5050,   20/
      DATA K(629),K(630),K(631),K(632)/ 1001, 1202, 1404, 1407/
      DATA K(633),K(634),K(635),K(636)/ 1308, 1108,  506,  206/
      DATA K(637),K(638),K(639),K(640)/    8,   50, 1406, 1307/
      DATA K(641),K(642),K(643),K(644)/ 1107,  505,  205,  106/
      DATA K(645),K(646),K(647),K(648)/    8,    9,  112,  314/
      DATA K(649),K(650),K(651),K(652)/  616,  917, 1217, 1416/
      DATA K(653),K(654),K(655),K(656)/ 1315, 1216,  917,   50/
      DATA K(657),K(658),K(659),K(660)/  616, 1217, 5050,   22/
      DATA K(661),K(662),K(663),K(664)/ 1308, 1206, 1004,  703/
      DATA K(665),K(666),K(667),K(668)/  403,  204,  105,    7/
      DATA K(669),K(670),K(671),K(672)/   10,  113,  316,  618/
      DATA K(673),K(674),K(675),K(676)/  919, 1219, 1417, 1415/
      DATA K(677),K(678),K(679),K(680)/ 1213,  811,  309, -694/
      DATA K(681),K(682),K(683),K(684)/   50,  403,  205,  107/
      DATA K(685),K(686),K(687),K(688)/  110,  213,  416,  618/
      DATA K(689),K(690),K(691),K(692)/   50, 1219, 1317, 1315/
      DATA K(693),K(694),K(695),K(696)/ 1113,  811,  209, -693/
      DATA K(697),K(698),K(699),K(700)/ 5050,   18, 1402, 1404/
      DATA K(701),K(702),K(703),K(704)/ 1306, 1107, -388, -587/
      DATA K(705),K(706),K(707),K(708)/ -686,   50, 1404, 1305/
      DATA K(709),K(710),K(711),K(712)/ 1106, -389, -588, -686/
      DATA K(713),K(714),K(715),K(716)/ -684,   50, 1417, 1216/
      DATA K(717),K(718),K(719),K(720)/  914, -196, -498, -699/
      DATA K(721),K(722),K(723),K(724)/ 5050,   23, 2115, -691/
      DATA K(725),K(726),K(727),K(728)/   50, 2116, -692,   50/
      DATA K(729),K(730),K(731),K(732)/ 1001, 1202, 1404, 1407/
      DATA K(733),K(734),K(735),K(736)/ 1308, 1108,  607,  307/
      DATA K(737),K(738),K(739),K(740)/  109,  112,  214,  517/
      DATA K(741),K(742),K(743),K(744)/  819,   50, 1406, 1307/
      DATA K(745),K(746),K(747),K(748)/ 1107,  606,  306,  107/
      DATA K(749),K(750),K(751),K(752)/    9,   12,  114,  316/
      DATA K(753),K(754),K(755),K(756)/  618,  819, 1421, 5050/
      DATA K(757),K(758),K(759),K(760)/   23, 1004, 1206, 1309/
      DATA K(761),K(762),K(763),K(764)/ 1408, 1306, 1004,  703/
      DATA K(765),K(766),K(767),K(768)/  403,  104,    5,    7/
      DATA K(769),K(770),K(771),K(772)/  109,  411,  712,   50/
      DATA K(773),K(774),K(775),K(776)/  403,  204,  105,  107/
      DATA K(777),K(778),K(779),K(780)/  209,  411,   50,  711/
      DATA K(781),K(782),K(783),K(784)/  411,  112,   13,   15/
      DATA K(785),K(786),K(787),K(788)/  117,  419,  720, 1020/
      DATA K(789),K(790),K(791),K(792)/ 1319, 1418, 1317, 1219/
      DATA K(793),K(794),K(795),K(796)/ 1020,   50,  411,  212/
      DATA K(797),K(798),K(799),K(800)/  113,  115,  217,  419/
      DATA K(801)                     / 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
C-------------------------------------------------------------------------------
      SUBROUTINE  GGREEK (J,KOORD)
C-------------------------------------------------------------------------------
C      GROSSE GREEK
C      A,B,G,D,E,Z,C,Q,I,K,L,M,N,X,O,P,R,S,T,U,F,H,Y,W
      parameter (istdim=25)
       DIMENSION KOORD(75), ISTART(istdim), K(694)
C
      SAVE
C
      DATA ISTART/  1, 20, 66, 81, 97,120,137,165,222,235,263,279,
     &            310,332,369,414,436,466,487,504,538,587,609,651,695/
      DATA K(  1),K(  2),K(  3),K(  4)/   20, 2110,    3,   50/
      DATA K(  5),K(  6),K(  7),K(  8)/ 2110,   17,   50, 1810/
      DATA K(  9),K( 10),K( 11),K( 12)/   16,   50,  605,  614/
      DATA K( 13),K( 14),K( 15),K( 16)/   50,    1,    7,   50/
      DATA K( 17),K( 18),K( 19),K( 20)/   13,   19, 5050,   22/
      DATA K( 21),K( 22),K( 23),K( 24)/ 2105,    5,   50, 2106/
      DATA K( 25),K( 26),K( 27),K( 28)/    6,   50, 2102, 2114/
      DATA K( 29),K( 30),K( 31),K( 32)/ 2017, 1918, 1719, 1519/
      DATA K( 33),K( 34),K( 35),K( 36)/ 1318, 1217, 1114,   50/
      DATA K( 37),K( 38),K( 39),K( 40)/ 2114, 2016, 1917, 1718/
      DATA K( 41),K( 42),K( 43),K( 44)/ 1518, 1317, 1216, 1114/
      DATA K( 45),K( 46),K( 47),K( 48)/   50, 1106, 1114, 1017/
      DATA K( 49),K( 50),K( 51),K( 52)/  918,  719,  419,  218/
      DATA K( 53),K( 54),K( 55),K( 56)/  117,   14,    2,   50/
      DATA K( 57),K( 58),K( 59),K( 60)/ 1114, 1016,  917,  718/
      DATA K( 61),K( 62),K( 63),K( 64)/  418,  217,  116,   14/
      DATA K( 65),K( 66),K( 67),K( 68)/ 5050,   18, 2105,    5/
      DATA K( 69),K( 70),K( 71),K( 72)/   50, 2106,    6,   50/
      DATA K( 73),K( 74),K( 75),K( 76)/ 2102, 2117, 1517, 2116/
      DATA K( 77),K( 78),K( 79),K( 80)/   50,    2,    9, 5050/
      DATA K( 81),K( 82),K( 83),K( 84)/   20, 2110,    2,   50/
      DATA K( 85),K( 86),K( 87),K( 88)/ 2110,   18,   50, 1810/
      DATA K( 89),K( 90),K( 91),K( 92)/   17,   50,  103,  117/
      DATA K( 93),K( 94),K( 95),K( 96)/   50,    2,   18, 5050/
      DATA K( 97),K( 98),K( 99),K(100)/   21, 2105,    5,   50/
      DATA K(101),K(102),K(103),K(104)/ 2106,    6,   50, 1512/
      DATA K(105),K(106),K(107),K(108)/  712,   50, 2102, 2118/
      DATA K(109),K(110),K(111),K(112)/ 1518, 2117,   50, 1106/
      DATA K(113),K(114),K(115),K(116)/ 1112,   50,    2,   18/
      DATA K(117),K(118),K(119),K(120)/  618,   17, 5050,   20/
      DATA K(121),K(122),K(123),K(124)/ 2116,    3,   50, 2117/
      DATA K(125),K(126),K(127),K(128)/    4,   50, 2104, 1503/
      DATA K(129),K(130),K(131),K(132)/ 2103, 2117,   50,    3/
      DATA K(133),K(134),K(135),K(136)/   17,  617,   16, 5050/
      DATA K(137),K(138),K(139),K(140)/   24, 2105,    5,   50/
      DATA K(141),K(142),K(143),K(144)/ 2106,    6,   50, 2118/
      DATA K(145),K(146),K(147),K(148)/   18,   50, 2119,   19/
      DATA K(149),K(150),K(151),K(152)/   50, 2102, 2109,   50/
      DATA K(153),K(154),K(155),K(156)/ 2115, 2122,   50, 1106/
      DATA K(157),K(158),K(159),K(160)/ 1118,   50,    2,    9/
      DATA K(161),K(162),K(163),K(164)/   50,   15,   22, 5050/
      DATA K(165),K(166),K(167),K(168)/   22, 2110, 2007, 1805/
      DATA K(169),K(170),K(171),K(172)/ 1604, 1203,  903,  504/
      DATA K(173),K(174),K(175),K(176)/  305,  107,   10,   12/
      DATA K(177),K(178),K(179),K(180)/  115,  317,  518,  919/
      DATA K(181),K(182),K(183),K(184)/ 1219, 1618, 1817, 2015/
      DATA K(185),K(186),K(187),K(188)/ 2112, 2110,   50, 2110/
      DATA K(189),K(190),K(191),K(192)/ 2008, 1806, 1605, 1204/
      DATA K(193),K(194),K(195),K(196)/  904,  505,  306,  108/
      DATA K(197),K(198),K(199),K(200)/   10,   50,   12,  114/
      DATA K(201),K(202),K(203),K(204)/  316,  517,  918, 1218/
      DATA K(205),K(206),K(207),K(208)/ 1617, 1816, 2014, 2112/
      DATA K(209),K(210),K(211),K(212)/   50, 1408,  708,   50/
      DATA K(213),K(214),K(215),K(216)/ 1414,  714,   50, 1108/
      DATA K(217),K(218),K(219),K(220)/ 1114,   50, 1008, 1014/
      DATA K(221),K(222),K(223),K(224)/ 5050,   11, 2105,    5/
      DATA K(225),K(226),K(227),K(228)/   50, 2106,    6,   50/
      DATA K(229),K(230),K(231),K(232)/ 2102, 2109,   50,    2/
      DATA K(233),K(234),K(235),K(236)/    9, 5050,   22, 2105/
      DATA K(237),K(238),K(239),K(240)/    5,   50, 2106,    6/
      DATA K(241),K(242),K(243),K(244)/   50, 2119,  806,   50/
      DATA K(245),K(246),K(247),K(248)/ 1211,   19,   50, 1210/
      DATA K(249),K(250),K(251),K(252)/   18,   50, 2102, 2109/
      DATA K(253),K(254),K(255),K(256)/   50, 2115, 2121,   50/
      DATA K(257),K(258),K(259),K(260)/    2,    9,   50,   15/
      DATA K(261),K(262),K(263),K(264)/   21, 5050,   20, 2110/
      DATA K(265),K(266),K(267),K(268)/    3,   50, 2110,   17/
      DATA K(269),K(270),K(271),K(272)/   50, 1810,   16,   50/
      DATA K(273),K(274),K(275),K(276)/    1,    7,   50,   13/
      DATA K(277),K(278),K(279),K(280)/   19, 5050,   25, 2105/
      DATA K(281),K(282),K(283),K(284)/    5,   50, 2106,  312/
      DATA K(285),K(286),K(287),K(288)/   50, 2105,   12,   50/
      DATA K(289),K(290),K(291),K(292)/ 2119,   12,   50, 2119/
      DATA K(293),K(294),K(295),K(296)/   19,   50, 2120,   20/
      DATA K(297),K(298),K(299),K(300)/   50, 2102, 2106,   50/
      DATA K(301),K(302),K(303),K(304)/ 2119, 2123,   50,    2/
      DATA K(305),K(306),K(307),K(308)/    8,   50,   16,   23/
      DATA K(309),K(310),K(311),K(312)/ 5050,   23, 2105,    5/
      DATA K(313),K(314),K(315),K(316)/   50, 2106,  218,   50/
      DATA K(317),K(318),K(319),K(320)/ 1906,   18,   50, 2118/
      DATA K(321),K(322),K(323),K(324)/   18,   50, 2102, 2106/
      DATA K(325),K(326),K(327),K(328)/   50, 2115, 2121,   50/
      DATA K(329),K(330),K(331),K(332)/    2,    8, 5050,   22/
      DATA K(333),K(334),K(335),K(336)/ 2204, 1703,   50, 2219/
      DATA K(337),K(338),K(339),K(340)/ 1718,   50, 1308,  807/
      DATA K(341),K(342),K(343),K(344)/   50, 1315,  814,   50/
      DATA K(345),K(346),K(347),K(348)/  404,  -97,   50,  419/
      DATA K(349),K(350),K(351),K(352)/  -82,   50, 2004, 2018/
      DATA K(353),K(354),K(355),K(356)/   50, 1904, 1918,   50/
      DATA K(357),K(358),K(359),K(360)/ 1108, 1114,   50, 1008/
      DATA K(361),K(362),K(363),K(364)/ 1014,   50,  204,  218/
      DATA K(365),K(366),K(367),K(368)/   50,  104,  118, 5050/
      DATA K(369),K(370),K(371),K(372)/   22, 2110, 2007, 1805/
      DATA K(373),K(374),K(375),K(376)/ 1604, 1203,  903,  504/
      DATA K(377),K(378),K(379),K(380)/  305,  107,   10,   12/
      DATA K(381),K(382),K(383),K(384)/  115,  317,  518,  919/
      DATA K(385),K(386),K(387),K(388)/ 1219, 1618, 1817, 2015/
      DATA K(389),K(390),K(391),K(392)/ 2112, 2110,   50, 2110/
      DATA K(393),K(394),K(395),K(396)/ 2008, 1806, 1605, 1204/
      DATA K(397),K(398),K(399),K(400)/  904,  505,  306,  108/
      DATA K(401),K(402),K(403),K(404)/   10,   50,   12,  114/
      DATA K(405),K(406),K(407),K(408)/  316,  517,  918, 1218/
      DATA K(409),K(410),K(411),K(412)/ 1617, 1816, 2014, 2112/
      DATA K(413),K(414),K(415),K(416)/ 5050,   24, 2105,    5/
      DATA K(417),K(418),K(419),K(420)/   50, 2106,    6,   50/
      DATA K(421),K(422),K(423),K(424)/ 2118,   18,   50, 2119/
      DATA K(425),K(426),K(427),K(428)/   19,   50, 2102, 2122/
      DATA K(429),K(430),K(431),K(432)/   50,    2,    9,   50/
      DATA K(433),K(434),K(435),K(436)/   15,   22, 5050,   22/
      DATA K(437),K(438),K(439),K(440)/ 2105,    5,   50, 2106/
      DATA K(441),K(442),K(443),K(444)/    6,   50, 2102, 2114/
      DATA K(445),K(446),K(447),K(448)/ 2017, 1918, 1719, 1419/
      DATA K(449),K(450),K(451),K(452)/ 1218, 1117, 1014, 1006/
      DATA K(453),K(454),K(455),K(456)/   50, 2114, 2016, 1917/
      DATA K(457),K(458),K(459),K(460)/ 1718, 1418, 1217, 1116/
      DATA K(461),K(462),K(463),K(464)/ 1014,   50,    2,    9/
      DATA K(465),K(466),K(467),K(468)/ 5050,   21, 2103, 1110/
      DATA K(469),K(470),K(471),K(472)/    2,   50, 2102, 1109/
      DATA K(473),K(474),K(475),K(476)/   50, 2102, 2117, 1518/
      DATA K(477),K(478),K(479),K(480)/ 2116,   50,  103,  116/
      DATA K(481),K(482),K(483),K(484)/   50,    2,   17,  618/
      DATA K(485),K(486),K(487),K(488)/   16, 5050,   19, 2109/
      DATA K(489),K(490),K(491),K(492)/    9,   50, 2110,   10/
      DATA K(493),K(494),K(495),K(496)/   50, 2103, 1502, 2102/
      DATA K(497),K(498),K(499),K(500)/ 2117, 1517, 2116,   50/
      DATA K(501),K(502),K(503),K(504)/    6,   13, 5050,   19/
      DATA K(505),K(506),K(507),K(508)/ 1602, 1802, 2003, 2104/
      DATA K(509),K(510),K(511),K(512)/ 2106, 2007, 1808, 1409/
      DATA K(513),K(514),K(515),K(516)/    9,   50, 1802, 2004/
      DATA K(517),K(518),K(519),K(520)/ 2006, 1808,   50, 1617/
      DATA K(521),K(522),K(523),K(524)/ 1817, 2016, 2115, 2113/
      DATA K(525),K(526),K(527),K(528)/ 2012, 1811, 1410,   10/
      DATA K(529),K(530),K(531),K(532)/   50, 1817, 2015, 2013/
      DATA K(533),K(534),K(535),K(536)/ 1811,   50,    6,   13/
      DATA K(537),K(538),K(539),K(540)/ 5050,   21, 2110,   10/
      DATA K(541),K(542),K(543),K(544)/   50, 2111,   11,   50/
      DATA K(545),K(546),K(547),K(548)/ 1608, 1505, 1404, 1203/
      DATA K(549),K(550),K(551),K(552)/  903,  704,  605,  508/
      DATA K(553),K(554),K(555),K(556)/  513,  616,  717,  918/
      DATA K(557),K(558),K(559),K(560)/ 1218, 1417, 1516, 1613/
      DATA K(561),K(562),K(563),K(564)/ 1608,   50, 1608, 1506/
      DATA K(565),K(566),K(567),K(568)/ 1405, 1204,  904,  705/
      DATA K(569),K(570),K(571),K(572)/  606,  508,   50,  513/
      DATA K(573),K(574),K(575),K(576)/  615,  716,  917, 1217/
      DATA K(577),K(578),K(579),K(580)/ 1416, 1515, 1613,   50/
      DATA K(581),K(582),K(583),K(584)/ 2107, 2114,   50,    7/
      DATA K(585),K(586),K(587),K(588)/   14, 5050,   20, 2103/
      DATA K(589),K(590),K(591),K(592)/   16,   50, 2104,   17/
      DATA K(593),K(594),K(595),K(596)/   50, 2117,    3,   50/
      DATA K(597),K(598),K(599),K(600)/ 2101, 2107,   50, 2113/
      DATA K(601),K(602),K(603),K(604)/ 2119,   50,    1,    7/
      DATA K(605),K(606),K(607),K(608)/   50,   13,   19, 5050/
      DATA K(609),K(610),K(611),K(612)/   23, 2111,   11,   50/
      DATA K(613),K(614),K(615),K(616)/ 2112,   12,   50, 1402/
      DATA K(617),K(618),K(619),K(620)/ 1503, 1405, 1006,  807/
      DATA K(621),K(622),K(623),K(624)/  708,  610,   50, 1503/
      DATA K(625),K(626),K(627),K(628)/ 1404, 1005,  806,  707/
      DATA K(629),K(630),K(631),K(632)/  610,  613,  716,  817/
      DATA K(633),K(634),K(635),K(636)/ 1018, 1419, 1520,   50/
      DATA K(637),K(638),K(639),K(640)/  613,  715,  816, 1017/
      DATA K(641),K(642),K(643),K(644)/ 1418, 1520, 1421,   50/
      DATA K(645),K(646),K(647),K(648)/ 2108, 2115,   50,    8/
      DATA K(649),K(650),K(651),K(652)/   15, 5050,   22,  303/
      DATA K(653),K(654),K(655),K(656)/    4,    8,  406,  804/
      DATA K(657),K(658),K(659),K(660)/ 1103, 1503, 1804, 2006/
      DATA K(661),K(662),K(663),K(664)/ 2109, 2113, 2016, 1818/
      DATA K(665),K(666),K(667),K(668)/ 1519, 1119,  818,  416/
      DATA K(669),K(670),K(671),K(672)/   14,   18,  319,   50/
      DATA K(673),K(674),K(675),K(676)/  406,  705, 1104, 1504/
      DATA K(677),K(678),K(679),K(680)/ 1805, 2007, 2109,   50/
      DATA K(681),K(682),K(683),K(684)/ 2113, 2015, 1817, 1518/
      DATA K(685),K(686),K(687),K(688)/ 1118,  717,  416,   50/
      DATA K(689),K(690),K(691),K(692)/  104,  107,   50,  115/
      DATA K(693),K(694)              /  118, 5050/
      if(J+1.gt.istdim)then
        J=-J
        goto 20
      end if
      J1 = ISTART(J+1)
      J = ISTART(J)
      I = 0
   10 I = I + 1
      JJ = J + I - 1
      IF ( JJ.GE.J1 ) GO TO 20
      KOORD(I) = K(JJ)
      GO TO 10
   20 RETURN
      END
